%% THIS SCRIPT REPLICATES FIGURES 2-6 FROM THE MAIN TEXT
%% IN DOH AND SMITH (2021) "A NEW APPROACH TO INTEGRATING EXPECTATIONS INTO VAR MODELS"

close all;
clear;
clc;
clear legend;

cd Baseline/
baseline_var_setup
cd ..

% SET STRING BASE TO SAVE FIGURES
save_string = 'VARUhligFG';

%% Figure 2
plotIRF1(allIRs,CIperc,s_loc,d_loc,0,['Fig2_',save_string]);

%% Figure 3
plotIRF2(allIRs,CIperc,s_loc,d_loc,mm_best,mm_worst,['Fig3_',save_string, 'BestWorst']);

%% Figure 4
plotIRFOutput18mos(lambdasp,Output18mos,lambda_ml,['Fig4_',save_string]);

%% Figure 5
plotIRF1(allIRs_im,CIperc,s_loc,d_loc,lambda,['Fig5_',save_string,'IM']);

%% FIGURE 6
save_string_robustness  = 'Fig6_VARUhligFGRobustnessFigure';

cd FullSample/
var_setup
close(get(gcf,'Number'));

title_string = 'Full Sample';
fig_num		 = 5;
col_loc		 = 1;
leg_on		 = 0;
save_on		 = 0;
plotIRF5(allIRs,allIRs_im,CIperc,fig_num,col_loc,'Fig6_VARUhligFGRobustnessFigure',title_string,leg_on,save_on);

cd ..
cd CalibrateLambdaHF/
var_setup
close(get(gcf,'Number'));

title_string = 'Calibrate Lambda High-Frequency';
fig_num		 = 5;
col_loc		 = 2;
leg_on		 = 0;
save_on		 = 0;
plotIRF5(allIRs,allIRs_im,CIperc,fig_num,col_loc,'Fig6_VARUhligFGRobustnessFigure',title_string,leg_on,save_on);

cd ..
cd JointMCMCDraws/
var_setup
close(get(gcf,'Number'));
cd ..

title_string = 'Joint MCMC Draws';
fig_num		 = 5;
col_loc		 = 3;
leg_on		 = 1;
save_on		 = 1;

plotIRF5(allIRs,allIRs_im,CIperc,fig_num,col_loc,'Fig6_VARUhligFGRobustnessFigure',title_string,leg_on,save_on);



