%% Function to select lambda (tightness of forecast consistent prior)
%% based on observed forecast discrepancy

function [lambda] = get_lambda_discrepancy(allIRs,s_loc,d_loc);

NAccept = size(allIRs,4);
IRhoriz = size(allIRs,1);

ddraws = NaN(NAccept,1);
for dd = 1:1:NAccept;
	disc_dd = 0;
	for hh = 13:1:IRhoriz-1;
		disc_dd = (mean(allIRs(hh-1:hh+1,d_loc,1,dd)) - allIRs(hh-12,s_loc,1,dd)) + disc_dd;
	end
	ddraws(dd) = disc_dd/(IRhoriz-13);
end;

ddraws = ddraws/100;	% Undo data multiplication by 100 for computing lambda
var_disc = var(ddraws);

lambda = 1/var_disc;
