%% Function to select lambda (tightness of forecast consistent prior)
%% by maximizing the correlation between VAR-resids and high-frequency
%% forward guidance shocks

function [lambda,shock_corr] = get_lambda_highfrequency(allIRs,allSResids,s_loc,d_loc,hffg_shocks,lambda_guess);

if nargin == 6
	%lambda_guess = 1e8;
elseif lambda_guess == []
	lambda_guess = 1e8;
end;

log_lambda_guess = 1*log(lambda_guess);

neg_shock_corr = @(log_lambda_candidate) get_neg_shock_corr(log_lambda_candidate,allIRs,allSResids,s_loc,d_loc,hffg_shocks);
optionss=optimset('MaxFunEvals',1000,'MaxIter',1000,'TolX',1e-8,'TolFun',1e-8,'Display','off');
[log_lambda,min_neg_shock_corr] = fminsearch(neg_shock_corr,log_lambda_guess,optionss);

lambda = exp(log_lambda/1);
shock_corr = -min_neg_shock_corr;
