%% Function that calculates the correlation between VAR-resids and high-frequency
%% path factor shocks for a given value of (the log of) lambda (tightness of forecast consistent prior)

function [neg_shock_corr] = get_neg_shock_corr(log_lambda_candidate,allIRs,allSResids,s_loc,d_loc,hffg_shocks);

lambda_candidate = exp(log_lambda_candidate/1)

[allIRs_im, allSResids_im, mm_best, mm_worst, index_im, effective_sample] = WeakConsistencyPrior(allIRs,allSResids,lambda_candidate,s_loc,d_loc);

for tt=1:size(allSResids_im,1);
    for ss=1:1;
		sliceloc   		=  squeeze(allSResids_im(tt,ss,:)); 
		SSmed_im(tt,ss) = quantile(sliceloc,0.5);
    end
end

neg_shock_corr = -corr(hffg_shocks,SSmed_im)