%% THIS FUNCTION PLOTS MEDIAN IRFS AND CI

function plotIRF4(allIRs_im,s_loc,d_loc,cs,fig_num)
clear legend;

%% DEFINE PERIOD TO PLOT
IRhoriz = size(allIRs_im,1);	% Length of IRF
irflength = IRhoriz-13;			% Length of IRF to plot
t = 1:irflength;

%% GET MEDIAN IRF FROM SIMULATED DISTRIBUTION
for hh=1:size(allIRs_im,1);
    for ii=1:size(allIRs_im,2);
        for jj=1:1; %1:size(allIRs_im,3);
            sliceloc   =  squeeze(allIRs_im(hh,ii,jj,:));
            IRmed_im(hh,ii,jj) = quantile(sliceloc,0.5);
        end
    end
end


var1y_im 	    = NaN(irflength,1);
for hh = 13:1:IRhoriz-1;
	var1y_im(hh-12)   	   = mean(IRmed_im(hh-1:hh+1,d_loc,1));
end;

figure(fig_num);
subplot(4,2,1)
hold on
plot(t,-IRmed_im(1:irflength,1,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Output','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('Percent','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,2)
hold on
plot(t,-IRmed_im(1:irflength,2,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('CPI','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.25 1.25]);set(gca,'YTick',[-0.25:0.25:1.25],'FontSize',12);
ylabel('Percent','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,3)
hold on
plot(t,-IRmed_im(1:irflength,3,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Commodity Prices','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.2 0.6]);set(gca,'YTick',[-0.2:0.2:0.6],'FontSize',12);
ylabel('Percent','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,4)
hold on
plot(t,-IRmed_im(1:irflength,4,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Fed Funds','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('APR','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,5)
hold on
plot(t,-IRmed_im(1:irflength,5,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1);  
title('Non-Borrowed Reserves','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.08 0.02]);set(gca,'YTick',[-0.08:0.02:.02],'FontSize',12);
ylabel('Percent','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,6)
hold on
plot(t,-IRmed_im(1:irflength,6,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Reserves','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.1 0.05]);set(gca,'YTick',[-0.1:0.05:0.05],'FontSize',12);
ylabel('Percent','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(4,2,7)
hold on
plot(t,-IRmed_im(1:irflength,7,1),'Color',[cs, cs, cs],'LineWidth',1);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Blue Chip 4-Qtr Ahead Rate','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(12:12:end),'FontSize',12);
%ylim([-0.1 0.05]);set(gca,'YTick',[-0.1:0.05:0.05],'FontSize',12);
ylabel('APR','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)