function [discrepancy] = SignAndWeakConsistencyCrit(Q_parameters,Bcomp,VC_eps,R,IRhoriz,s_loc,d_loc);

%% 1) Unscale/Transform Q paramteres
[q1estimate,q2estimate,q3estimate,q4estimate] = get_unscaledparams(Q_parameters);

%% 2) Calculate IRFs
[Q,flag] = get_4d_orthonorm(q1estimate,q2estimate,q3estimate,q4estimate);
if flag == 1;
	display('Rotation Matrix May Not Be Accurate')
end;
Q(:,1);
Factor	= chol(VC_eps)'*Q;
IR 		= VAR_irf_factor(Bcomp, Factor, IRhoriz);

%% 3) Check Sign Restrictions
Nbig	 = length(VC_eps);
Nshocks  = size(R,3);
checkall = ones(Nbig,Nshocks);
checkall_flip = ones(Nbig,Nshocks);

for ss=1:Nshocks
	for ii = 1:Nbig
		if R(ii,1,ss) ~= 0
			if R(ii,3,ss) == 1
				check = IR((R(ii,1,ss)):R(ii,2,ss),ii,ss) > 0;
				checkall(ii,ss) = min(check);
				% Check flipped signs
				check_flip = IR((R(ii,1,ss)):R(ii,2,ss),ii,ss) < 0;
				checkall_flip(ii,ss) = min(check_flip);
			elseif R(ii,3,ss) == -1
				check = IR((R(ii,1,ss)):R(ii,2,ss),ii,ss) < 0;
				checkall(ii,ss) = min(check);
				% Check flipped signs
				check_flip = IR((R(ii,1,ss)):R(ii,2,ss),ii,ss) > 0;
				checkall_flip(ii,ss) = min(check_flip);
			end
		end
	end
end

%% 4) Calculate Forecast Discrepancy
if min(min(checkall))==1 | min(min(checkall_flip))==1
	discrepancy = get_forecast_discrepancy(IR,s_loc,d_loc);
else
	discrepancy = 1e12;
end