%% Posterior IRFs After Imposing Weak Consistency Prior
%% For Forward Guidance Application in
%% "Reconciling VAR-based Forecasts with Survey Forecasts"

function [forecast_discrepancy] = get_forecast_discrepancy_4period(IR,s_loc,d_loc);

IRhoriz = size(IR,1);

% Normalize shock size as to not penalize larger shocks
shock_size =  0.25/4;
IR = (shock_size/IR(1,s_loc,1))*IR(:,:,1);

for hh = 5:1:IRhoriz;
	gA(hh,1) = (IR(hh,d_loc,1) - IR(hh-4,s_loc,1));
end;

forecast_discrepancy = 400*sqrt(mean(diag(gA*gA')));