function [aic,bic,hqc] = get_lag_crit(Y,iscon,max_lag);

%% FIX SAMPLE SIZE ACROSS LAG SPECIFICATIONS
Y_truncated = Y(max_lag+1:end,:);
T = size(Y_truncated,1);

for vv = 1:1:max_lag
	Y_est = [Y(max_lag+1-vv,:); Y_truncated];
	
	%% ESTIMATE VAR
	[Bcomp, cvec, Bpl_ev, VC_eps, Residmat] = ...
									estim(Y_est, vv, iscon);
	k = size(Bcomp,1)*size(Y,2) + iscon*size(Y,2);
	
	%% CALCULATE INFROMATION CRITERIA
	aic(vv,1) = log(det(VC_eps)) + 2*k/T;
	bic(vv,1) = log(det(VC_eps)) + k*log(T)/T;
	hqc(vv,1) = log(det(VC_eps)) + 2*k*log(log(T))/T;
end