%% Posterior IRFs After Imposing Weak Consistency Prior
%% For Forward Guidance Application in
%% "Reconciling VAR-based Forecasts with Survey Foreccasts"

function [IRF_im, mm_best, mm_worst, index_im, effective_sample] = WeakConsistencyPrior1period_WolfCode(IRF,lambda,s_loc,d_loc);

[IRhoriz, Nbig, NAccept] = size(IRF);
IRhoriz = IRhoriz;

for mm = 1:1:NAccept;
	
		
		shock_size =  var(squeeze(IRF(1,s_loc,:)))^0.5;
		
		for hh = 2:1:IRhoriz;
			gA(hh,1) = (IRF(hh,d_loc,mm) - IRF(hh-1,s_loc,mm))/100;
		end;
		
		p_pdf 		 = -0.5*lambda*mean(diag(gA*gA'));
		allp_pdf(mm) = ((shock_size/IRF(1,s_loc,mm))^2)*p_pdf;
		
end;		

[weight_best,mm_best]   = max(allp_pdf);
[weight_worst,mm_worst] = min(allp_pdf);

%% Construct Importance Sampling Weights
w_im 	 = exp(allp_pdf-max(allp_pdf))./sum(exp(allp_pdf-max(allp_pdf)));
index_im = randsample(1:NAccept,NAccept,true,w_im'); 
index_im = index_im';

%% Report Sample Size
sample = NAccept;
effective_sample = 1/(sum(w_im.^2));

%% Calculate Reweighted IRFs
IRF_im = IRF(:,:,index_im);