% Implementation of Bayesian VAR with weak consisntency priors for survey
% foercasts 
clear
clc

% Load dataset 
load forecast_data

%%%% Generate Dummy Observation 

%% Set the values for hyperparameters 

%x1=Durables
%x2=Nondurables
%x3=Services
%x4=personal disposable income
%x5=real funds rate

%for	
 datatype=2;

	if datatype == 1;
        Data=data_level;
        label = 'level';
	elseif datatype == 2;
		Data=data_yryrrate;
		label = 'rate';
	end

tau=5; 
d=0.7; 
w=3; 
lambda=5;
mprior=vertcat(tau,d,w); mprior=vertcat(mprior,lambda); 
nv=size(Data,2); %% number of variables 


for nlag=48:1:60          %% lag length 
nobs=size(Data,1); 
k=1+nv*nlag; 
T0=29; %% training sample size 
nd=1+(nlag+w)*(nv); %% number of total dummy observation 
ydum=zeros(nd,nv); 
xdum=zeros(nd,1+nlag*nv); 

%%  Obtain mean and standard deviation from pre-sample data 

YY=Data(1:T0,:); 
ybar=mean(YY); 
sbar=std(YY,0,1); 
sprior=vertcat(ybar,sbar);

%% Call the function generating dummy observation 

[xdum,ydum,breaks]=vprior(nv,nlag,mprior,sprior); 
x0=xdum; y0=ydum; 
nobs
y1=Data(T0+nlag+1:nobs,:);
x1 =[];
for jj=1:nlag
x1=horzcat(x1,Data(T0+nlag+1-jj:nobs-jj,:));
end
x1=horzcat(x1,ones(nobs-T0-nlag,1));  
T1=size(y1,1); T0=size(y0,1); 
nobs=T0+T1; 

%% Calculate the posterior mean of coefficients 

xx=x0'*x0+x1'*x1; xxy=x0'*y0+x1'*y1; yy=y0'*y0+y1'*y1; 
coeff=inv(xx)*(xxy); 
c_hat=reshape(coeff,prod(size(coeff)),1); 
sig_hat=(yy-xxy'*coeff)/nobs; 

%% Calculate log-marginal data density 

xx0=inv(x0'*x0); 
phi0=xx0*(x0'*y0); 
S0=(y0-x0*phi0)'*(y0-x0*phi0); 
xx1=inv(x0'*x0+x1'*x1); 
S1=(yy-xxy'*inv(xx)*(xxy)); 
mddbv=matrictint(S1,xx1,T0+T1)-matrictint(S0,xx0,T0); 

%diary([label '_BVAR_forecast.txt'])

%disp('matrix of coefficients') 
%disp(coeff) 
disp('log marginal data density for BVAR') 
disp(mddbv)
%disp('forecast for next period') 
xf=[];
for jj=0:nlag-1
xf=horzcat(xf,Data(end-jj,:));
end
xf=horzcat(xf,ones(1,1)); 
disp(xf*coeff)

%diary off
end
