%% FIRST LOAD THE DATA
ts		= importdata('data_with_labels.xlsx');    
ts_data	= ts.data;
dates	= 1970.25:0.25:2017.75;
dates 	= dates';

%% DEFINE VARIABLES
pi10e	= ts_data(:,1); % 400*LN(1+CPI LONG-TERM FORWARD EXP/400)	 
pi1e	= ts_data(:,2);	% 400*LN(1+CPI 1 YEAR AHEAD EXP/400)
pi	 	= ts_data(:,3); % 400*LN(1+CPI QUARTERLY PRECENT CHANGE AT AN ANNUALZIED RATE /400)
act  	= ts_data(:,4); % CHICAGO FED NATIONAL ACTIVITY INDEX (QUARTERLY AVERAGE OF MONTHLY VALUES)
int  	= ts_data(:,5); % 400*LN(1+FED FUNDS RATE/400) NOTE: FROM 2009:Q1-2015:Q4 WU-XIA SHADOW RATE IS USED

figure;
subplot(3,2,1)
hold on
plot(dates,pi10e,'-k','LineWidth',2);
title('Long-Run Inflation Expectations','FontSize',16);
xlim([1970 2020]);set(gca,'XTick',1970:10:2020,'FontSize',11);
ylim([0 8]);set(gca,'YTick',[0:2:8],'FontSize',11);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,2)
hold on
plot(dates,pi1e,'-k','LineWidth',2);
title('Short-Run Inflation Expectations','FontSize',16);
xlim([1970 2020]);set(gca,'XTick',1970:10:2020,'FontSize',11);
ylim([0 12]);set(gca,'YTick',[0:2:12],'FontSize',11);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,3)
hold on
plot(dates,pi,'-k','LineWidth',2);
title('CPI Inflation','FontSize',16);
xlim([1970 2020]);set(gca,'XTick',1970:10:2020,'FontSize',11);
ylim([-10 20]);set(gca,'YTick',[-10:10:20],'FontSize',11);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,4)
hold on
plot(dates,act,'-k','LineWidth',2);
title('Chicago Fed National Activity Index','FontSize',16);
xlim([1970 2020]);set(gca,'XTick',1970:10:2020,'FontSize',11);
ylim([-4 4]);set(gca,'YTick',[-4:2:4],'FontSize',11);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,5)
hold on
plot(dates,int,'-k','LineWidth',2);
title('Wu-Xia Shadow Fed Funds Rate','FontSize',16);
xlim([1970 2020]);set(gca,'XTick',1970:10:2020,'FontSize',11);
ylim([-4 20]);set(gca,'YTick',[-4:4:20],'FontSize',11);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

set(gcf, 'renderer', 'painters');
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'inches');
set(gcf, 'PaperOrientation', 'landscape');
set(gcf, 'PaperPosition', [-0.9 -0.4 12.5 9]);
print(['TVP_VAR_data_formatted.pdf'],'-dpdf')

