function [g, badg] = numgrad(fcn,x,varargin)
% based on numgrad.m and numgrad.R by CAS
% modified by WYP, 6/14/2011
%
% works best when fcn is reparameterized so that it is unrestricted
% does not handle cases where fcn returns multiple values
% needs a column vector for x
%
f0 = feval(fcn,x,varargin{:});
delta = 1e-8;
n = length(x);
tvec = delta*eye(n);
g = zeros(n,1);
badg = 0;
for indxi=1:n
    scale = 1;
    tvecv = tvec(:,indxi);
%   g0 = (feval(fcn,x+scale*tvecv', varargin{:}) - feval(fcn,x-scale*tvecv', varargin{:}))/2/tvec(i,i);
%   double-sided gradient by WYP, 6/14/2011
       f1 = feval(fcn,x+scale*tvecv,varargin{:});
       f2 = feval(fcn,x-scale*tvecv,varargin{:});
        if (isinf(f1) && ~isinf(f2))
            disp('... [f+] is ignored]')
            g0 = (f0-f2)/(scale*delta);
        elseif (~isinf(f1) && isinf(f2))
            disp('... [f-] is ignored')
            g0 = (f1-f0)/(scale*delta); 
        elseif (isinf(f1) && isinf(f2))
            disp('... [f+] and [f-] are INFs. No good.')
            f2=1e+30; f1=-1e+30; 
            g0 = (f1-f2)/(2*scale*delta); 
        else 
            g0 = (f1-f2)/(2*scale*delta); 
        end



    if (abs(g0) < 1e15)
        indxi
      g(indxi)=g0;
    else
      disp('bad gradient ------------------------')
      disp('parameter values:')
      disp(x)
      badg=1;
      return
    end
end
