% % preliminary analysis 
% 
% % data loading : monthly data 
% % Dividend Growth and Price-dividend Ratio from Robert Shiller's dataset  
% dataraw = xlsread('FIN.xls'); 
% date0=1;
% date1=795; 
% data = [dataraw(date0:date1,[1 7 8 9 12 13 14])]; % 1947:M1=2014:M6 10 year nominal bond yield, real price, real dividend 
% nmd  = length(data);
% nq  =nmd/3; 
% 
% % transform monthly data to quarterly data 
% q0=1948.25; q1=2014.25; 
% pd = zeros(nq,1); 
% gd = zeros(nq,1); 
% for jj=1:nq
%     gd(jj) = 4*sum(data(3*jj-2:3*jj,5)); 
%     pd(jj) = mean(data(3*jj-2:3*jj,7)); 
% end 
% 
% 
% % Quarterly PCE growth 
% datapce= xlsread('PCE.xlsx'); 
% gc =zeros(nq,1);  
% con=datapce(:,5); 
% gc = 400*log(con(2:nq+1)./con(1:nq)); 
% 
% yy = [gc gd pd]; 
% save('qdata.mat','yy','q0','q1'); 
% subplot(2,1,1); plot([q0:0.25:q1],[gc gd]);
% subplot(2,1,2); plot([q0:0.25:q1],pd); 
% 
% % Summary Statistics 
% 
% disp('[mean;standard deviation;autocorrelation;correlation with consumption growth]');
% mean(yy)
% std(yy) 
% diag(corr(yy(2:end,:),yy(1:end-1,:)))
% [corr(gc,gd) corr(gc,pd)]

% data loading: annual data 

andata=xlsread('data2013.xlsx');   % 1871-2012 [real-stock_price real_dividend real_earnings real_return real_1-year_interest_rate real_per_capita_con]
                               % consumption data begins from 1889 
                               
                               
y0=1890; y1=2013;        
ny=y1-y0+1;
gda=andata(:,1); gca=andata(:,2); pda=andata(:,3); 
infa = andata(:,8); yield1 = andata(:,11); yield10=andata(:,12); 
yya = [gca gda infa pda yield1 yield10]; 
save('extdata.mat','yya','y0','y1'); 
figure; 
for j=1:6
subplot(3,2,j); 

 if j==4
plot([y0:1:y1],yya(:,j));
 else 
plot([y0:1:y1],100*yya(:,j)); 
 end 
 grid on; 
end

% Summary Statistics 

disp('[mean;standard deviation;autocorrelation]');
myy   =mean(yya);
volyy =std(yya); 
aryy  =diag(corr(yya(2:end,:),yya(1:end-1,:))); 

% Predictive Regression 

[bc,bcint,rc,rcint,rcstat]=regress(yya(2:end,1),[ones(ny-1,1) yya(1:end-1,4) yya(1:end-1,4).^2]); 
[bd,bdint,rd,rdint,rdstat]=regress(yya(2:end,2),[ones(ny-1,1) yya(1:end-1,4) yya(1:end-1,4).^2]); 
[bp,bpint,rp,rpint,rpstat]=regress(yya(2:end,3),[ones(ny-1,1) yya(1:end-1,4) yya(1:end-1,4).^2]); 
regc.b=bc; regc.bint=bcint; regc.r = rc; regc.rint=rcint; regc.rstat=rcstat;  
regd.b=bd; regd.bint=bdint; regd.r = rd; regd.rint=rdint; regd.rstat=rdstat;  
regp.b=bp; regp.bint=bpint; regp.r = rp; regp.rint=rpint; regp.rstat=rpstat;  
[bcl,bclint,rcl,rclint,rclstat]=regress(yya(2:end,1),[ones(ny-1,1) yya(1:end-1,4)]); 
[bdl,bdlint,rdl,rdlint,rdlstat]=regress(yya(2:end,2),[ones(ny-1,1) yya(1:end-1,4)]); 
[bpl,bplint,rpl,rplint,rplstat]=regress(yya(2:end,3),[ones(ny-1,1) yya(1:end-1,4)]);
regcl.b=bcl; regcl.bint=bclint; regcl.r = rcl; regcl.rint=rclint; regcl.rstat=rclstat;  
regdl.b=bdl; regdl.bint=bdlint; regdl.r = rdl; regdl.rint=rdlint; regdl.rstat=rdlstat;  
regpl.b=bpl; regpl.bint=bplint; regpl.r = rpl; regpl.rint=rplint; regpl.rstat=rplstat;  
% Calculation of ajdusted R2

adjR.cq = 1-(1-rcstat(1))*(ny-2)/(ny-4); 
adjR.cl = 1-(1-rclstat(1))*(ny-2)/(ny-3); 
adjR.dq = 1-(1-rdstat(1))*(ny-2)/(ny-4); 
adjR.dl = 1-(1-rdlstat(1))*(ny-2)/(ny-3); 
adjR.pq = 1-(1-rpstat(1))*(ny-2)/(ny-4); 
adjR.pl = 1-(1-rplstat(1))*(ny-2)/(ny-3); 

save('regress.mat','myy','volyy','aryy','regc','regd','regp','regcl','regdl','regpl','adjR'); 





