%  This file generates deflation probability forecasts as in Clark and Doh
%  (2011) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 500; 
N = 3; 
L = 2; 
% selection vectors 
spi = [0 0 1 ];
su =  [0 1 0 ];
sy =  [1 0 0 ];
% catalog of data files
DFILE(1,:) = ['\pce\newcore\output\var101'];
DFILE(2,:) = ['\pce\newcore\output\var102'];
DFILE(3,:) = ['\pce\newcore\output\var103'];
DFILE(4,:) = ['\pce\newcore\output\var104'];
DFILE(5,:) = ['\pce\newcore\output\var105'];
DFILE(6,:) = ['\pce\newcore\output\var106'];
DFILE(7,:) = ['\pce\newcore\output\var107'];
DFILE(8,:) = ['\pce\newcore\output\var108'];
DFILE(9,:) = ['\pce\newcore\output\var109'];
DFILE(10,:) = ['\pce\newcore\output\var110'];
DFILE(11,:) = ['\pce\newcore\output\var111'];
DFILE(12,:) = ['\pce\newcore\output\var112'];
DFILE(13,:) = ['\pce\newcore\output\var113'];
DFILE(14,:) = ['\pce\newcore\output\var114'];
DFILE(15,:) = ['\pce\newcore\output\var115'];
DFILE(16,:) = ['\pce\newcore\output\var116'];
DFILE(17,:) = ['\pce\newcore\output\var117'];
DFILE(18,:) = ['\pce\newcore\output\var118'];
DFILE(19,:) = ['\pce\newcore\output\var119'];
DFILE(20,:) = ['\pce\newcore\output\var120'];


NF = size(DFILE,1);
% load data
load './data/pcectpidoh.txt' -ascii
PCE = pcectpidoh(:,1);
T1 = 28;
infl1 = log(PCE(2:T1,:)./PCE(1:T1-1,:)); % 1953.Q2-1959.Q4
clear PCE pcectpidoh dp date1 T1
load './data/pcecoredoh.txt' -ascii
PCEc = pcecoredoh(:,1);
T1 = size(PCEc,1);
infl2 = log(PCEc(2:T1,:)./PCEc(1:T1-1,:)); % 1960.Q1-2010.Q4
clear PCE pcecoredoh dp date1 T1
infl=[infl1;infl2];
load './data/UNRATEdoh.txt' -ascii
TM = size(UNRATEdoh,1); % monthly
urq = UNRATEdoh(2:3:TM,1)/100; % quarterly is middle month of quarter
lur = .01*log(urq./(1-urq)); % logit transformation
clear UNRATEdoh TM urq 
load './data/TB10YR.txt' -ascii
TM = size(TB10YR,1); % monthly
p3 = 1 - TB10YR(1:3:TM,1)/400; % 1st month of quarter, price 
y3 = -log(p3); % yield to maturity
clear TB10YR TM TQ p3
y = [y3,lur,infl]; % ordered as in benchmark model for D&V
data=y(end-205:end,:); 
[ND1,ND2]=size(data);
% load SA
NB = 10;
load(DFILE(NB+1,:),'SD')    % time-varying parameters
load(DFILE(NB+1,:),'QD')    % covariance matrix for innovations to TVPs 
load(DFILE(NB+1,:),'HD')    % stochastic volatility 
load(DFILE(NB+1,:),'VD')    % standard deviations of innovations to log volatility  
load(DFILE(NB+1,:),'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol

randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
SQ = zeros(NQ,NQ,(NF-NB)*P);
SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
FH        = 4;  % forecast horizon 
TH        = 48; % deflation probability forecasts from 1999Q3 for one-year ahead four-quarter inflation 
SAF= zeros(NK,FH,(NF-NB)*P);
SAFA = zeros(NK,FH,(NF-NB)*P); 
SHF= zeros(FH,NH,(NF-NB)*P);
YYF= zeros(ND2,FH,(NF-NB)*P); 
YYFA=zeros(ND2,FH,(NF-NB)*P); 
infdata = zeros(TH-FH,1); 
clear SD QD HD VD CD 
for i = NB+2:NF,
    j = i - NB; 
    load(DFILE(i,:),'SD')
    load(DFILE(NB+1,:),'QD')   
    load(DFILE(NB+1,:),'HD')    
    load(DFILE(NB+1,:),'VD')    
    load(DFILE(NB+1,:),'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);



def_prob=zeros(TH,1); 
def_prob_a=zeros(TH,1); 
decompx=zeros(TH,4);
decompx_a = zeros(TH,4); 
for kk=1:TH-FH
    infdata(kk) = 100*sum(infl(end-TH+kk:end-TH+kk+3));
end 



for jj=1:TH
    ind = zeros(NMC,1); 
    decomp = zeros(NMC,4);
    ind_a = zeros(NMC,1); 
    decomp_a = zeros(NMC,4);
    
for i = 1:NMC,
   
    
    % Step 1: Innovations to time-varying coefficients 
    for tt=1:FH
        if tt==1   
     SAF(:,tt,i) = SA(:,T-TH+jj,i)+sqrtm(SQ(:,:,i))*randn(NQ,1); 
     SAFA(:,tt,i) = mean(SA(:,:,i),2);
%      SAF(2+(1+N*L),tt,i)=0; SAF(5+(1+N*L),tt,i)=0; SAF(2+2*(1+N*L),tt,i)=0; SAF(5+2*(1+N*L),tt,i)=0; 
%      SAFA(2+(1+N*L),tt,i)=0; SAFA(5+(1+N*L),tt,i)=0; SAFA(2+2*(1+N*L),tt,i)=0; SAFA(5+2*(1+N*L),tt,i)=0; 
        else 
     SAF(:,tt,i) = SAF(:,tt-1,i)+sqrtm(SQ(:,:,i))*randn(NQ,1);
     SAFA(:,tt,i) = SAFA(:,tt-1,i); 
%      SAF(2+(1+N*L),tt,i)=0; SAF(5+(1+N*L),tt,i)=0; SAF(2+2*(1+N*L),tt,i)=0; SAF(5+2*(1+N*L),tt,i)=0; 
%      SAFA(2+(1+N*L),tt,i)=0; SAFA(5+(1+N*L),tt,i)=0; SAFA(2+2*(1+N*L),tt,i)=0; SAFA(5+2*(1+N*L),tt,i)=0; 
        end 
    end 
    
    % Step 2: Innovations to stochastic volatility 
    for tt=1:FH
        if tt==1  
    SHF(tt,:,i) = log(SH(T-TH+jj,:,i))+(diag(SV(:,i))*randn(NV,1))'; 
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        else 
    SHF(tt,:,i) = log(SHF(tt-1,:,i))+(diag(SV(:,i))*randn(NV,1))';
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        end 
    end 
    
    % Step 3: Innovations to equation errors 
    for tt=1:FH 
        if tt==1 
            innov=chofac(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[data(T-TH+jj,:)';data(T-1-TH+jj,:)']+innov; 
    YYFA(:,tt,i)= [SAFA(1,tt,i);SAFA(1+(1+N*L),tt,i);SAFA(1+2*(1+N*L),tt,i)]+[SAFA(2:1+N*L,tt,i)';SAFA(2+(1+N*L):2*(1+N*L),tt,i)';SAFA(2+2*(1+N*L):3*(1+N*L),tt,i)']*[data(T-TH+jj,:)';data(T-1-TH+jj,:)']+innov;  
        decomp(i,1) = decomp(i,1)+SAF(1+2*(1+N*L),tt,i);
        decomp(i,2) = decomp(i,2)+SAF(2+2*(1+N*L),tt,i)*data(T-TH+jj,1)+SAF(5+2*(1+N*L),tt,i)*data(T-1-TH+jj,1);
        decomp(i,3) = decomp(i,3)+SAF(3+2*(1+N*L),tt,i)*(1+exp(100*data(T-TH+jj,2)))+SAF(6+2*(1+N*L),tt,i)*(1+exp(100*data(T-1-TH+jj,2)));
        decomp(i,4) = decomp(i,4)+SAF(4+2*(1+N*L),tt,i)*data(T-TH+jj,3)+SAF(7+2*(1+N*L),tt,i)*data(T-1-TH+jj,3); 
        
        decomp_a(i,1) = decomp_a(i,1)+SAFA(1+2*(1+N*L),tt,i);
        decomp_a(i,2) = decomp_a(i,2)+SAFA(2+2*(1+N*L),tt,i)*data(T-TH+jj,1)+SAFA(5+2*(1+N*L),tt,i)*data(T-1-TH+jj,1);
        decomp_a(i,3) = decomp_a(i,3)+SAFA(3+2*(1+N*L),tt,i)*(1+exp(100*data(T-TH+jj,2)))+SAFA(6+2*(1+N*L),tt,i)*(1+exp(100*data(T-1-TH+jj,2)));
        decomp_a(i,4) = decomp_a(i,4)+SAFA(4+2*(1+N*L),tt,i)*data(T-TH+jj,3)+SAFA(7+2*(1+N*L),tt,i)*data(T-1-TH+jj,3); 
        elseif tt==2 
            innov=chofac(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYF(:,tt-1,i);data(T-TH+jj,:)']+innov;     
    YYFA(:,tt,i)= [SAFA(1,tt,i);SAFA(1+(1+N*L),tt,i);SAFA(1+2*(1+N*L),tt,i)]+[SAFA(2:1+N*L,tt,i)';SAFA(2+(1+N*L):2*(1+N*L),tt,i)';SAFA(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYFA(:,tt-1,i);data(T-TH+jj,:)']+innov;  
        decomp(i,1) = decomp(i,1)+SAF(1+2*(1+N*L),tt,i);
        decomp(i,2) = decomp(i,2)+SAF(2+2*(1+N*L),tt,i)*YYF(1,tt-1,i)+SAF(5+2*(1+N*L),tt,i)*data(T-TH+jj,1);
        decomp(i,3) = decomp(i,3)+SAF(3+2*(1+N*L),tt,i)*(1+exp(100*YYF(2,tt-1,i)))+SAF(6+2*(1+N*L),tt,i)*(1+exp(100*data(T-TH+jj,2)));
        decomp(i,4) = decomp(i,4)+SAF(4+2*(1+N*L),tt,i)*YYF(3,tt-1,i)+SAF(7+2*(1+N*L),tt,i)*data(T-TH+jj,3);      
        
        decomp_a(i,1) = decomp_a(i,1)+SAFA(1+2*(1+N*L),tt,i);
        decomp_a(i,2) = decomp_a(i,2)+SAFA(2+2*(1+N*L),tt,i)*YYFA(1,tt-1,i)+SAFA(5+2*(1+N*L),tt,i)*data(T-TH+jj,1);
        decomp_a(i,3) = decomp_a(i,3)+SAFA(3+2*(1+N*L),tt,i)*(1+exp(100*YYFA(2,tt-1,i)))+SAFA(6+2*(1+N*L),tt,i)*(1+exp(100*data(T-TH+jj,2)));
        decomp_a(i,4) = decomp_a(i,4)+SAFA(4+2*(1+N*L),tt,i)*YYFA(3,tt-1,i)+SAFA(7+2*(1+N*L),tt,i)*data(T-TH+jj,3);    
        else

    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYF(:,tt-1,i);YYF(:,tt-2,i)]+innov;          
    YYFA(:,tt,i)= [SAFA(1,tt,i);SAFA(1+(1+N*L),tt,i);SAFA(1+2*(1+N*L),tt,i)]+[SAFA(2:1+N*L,tt,i)';SAFA(2+(1+N*L):2*(1+N*L),tt,i)';SAFA(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYFA(:,tt-1,i);YYFA(:,tt-2,i)]+innov;   
        decomp(i,1) = decomp(i,1)+SAF(1+2*(1+N*L),tt,i);
        decomp(i,2) = decomp(i,2)+SAF(2+2*(1+N*L),tt,i)*YYF(1,tt-1,i)+SAF(5+2*(1+N*L),tt,i)*YYF(1,tt-2,i);
        decomp(i,3) = decomp(i,3)+SAF(3+2*(1+N*L),tt,i)*(1+exp(100*YYF(2,tt-1,i)))+SAF(6+2*(1+N*L),tt,i)*(1+exp(100*YYF(2,tt-2,i)));
        decomp(i,4) = decomp(i,4)+SAF(4+2*(1+N*L),tt,i)*YYF(3,tt-1,i)+SAF(7+2*(1+N*L),tt,i)*YYF(3,tt-2,i); 
        
        decomp_a(i,1) = decomp_a(i,1)+SAFA(1+2*(1+N*L),tt,i);
        decomp_a(i,2) = decomp_a(i,2)+SAFA(2+2*(1+N*L),tt,i)*YYFA(1,tt-1,i)+SAFA(5+2*(1+N*L),tt,i)*YYFA(1,tt-2,i);
        decomp_a(i,3) = decomp_a(i,3)+SAFA(3+2*(1+N*L),tt,i)*(1+exp(100*YYFA(2,tt-1,i)))+SAFA(6+2*(1+N*L),tt,i)*(1+exp(100*YYFA(2,tt-2,i)));
        decomp_a(i,4) = decomp_a(i,4)+SAFA(4+2*(1+N*L),tt,i)*YYFA(3,tt-1,i)+SAFA(7+2*(1+N*L),tt,i)*YYFA(3,tt-2,i); 
        end 
    end 
    
    % Step 4: Decomposing the main driver of deflation probability
    ind(i) = sum(YYF(3,1:FH,i)); 
   % if ind(i)==1
        decompx(jj,1)=decompx(jj,1)+decomp(i,1);
        decompx(jj,2)=decompx(jj,2)+decomp(i,2); 
        decompx(jj,3)=decompx(jj,3)+decomp(i,3);
        decompx(jj,4)=decompx(jj,4)+decomp(i,4);
   % end 
    
    
    ind_a(i) = sum(YYFA(3,1:FH,i));
   % if ind_a(i)==1
        decompx_a(jj,1)=decompx_a(jj,1)+decomp_a(i,1);
        decompx_a(jj,2)=decompx_a(jj,2)+decomp_a(i,2); 
        decompx_a(jj,3)=decompx_a(jj,3)+decomp_a(i,3);
        decompx_a(jj,4)=decompx_a(jj,4)+decomp_a(i,4);
   % end
    
    
end
def_prob(jj)=sum(ind)/NMC; 
def_prob_a(jj)=sum(ind_a)/NMC; 
decompx(jj,:)=decompx(jj,:)/NMC;
decompx_a(jj,:)=decompx_a(jj,:)/NMC;
end
clear SA
clear core
date = 1999.5:0.25:2011.25;

plot(1999.5:0.25:2010.25,infdata,':b','LineWidth',2); hold on; 
plot(date,100*def_prob,'--k','LineWidth',2); hold on; 
plot(date,100*def_prob_a,'-r','LineWidth',2); hold off; 
title('Inflation Forecasts: Core PCE','Fontsize',14)
axis([1999 2011 0 0.1])
set(gca,'Fontsize',14)

