function SIGnew=doubling(SIG,A,tolr)
% solve for unconditional variance using the doubling algorithm
% SIG  starting matrix
% A    coefficient matrix
% tolr tolerance to stop doubling

SIGold = SIG;
incrmt = 1;
while incrmt>tolr;
    SIGnew = SIGold + A*SIGold*A';
    incrmt = sum(abs(SIGold-SIGnew));
    SIGold = SIGnew;
    A = A*A;
end;