% fn_inv_nrstr_mining.m
% Function to compute forecasts for nonresidential investment in mining.
	
function [f_g_inv_nrstr_mining,f_g_inv_nrstr_mining_next_q, f_g_rigs2_q]=fn_inv_nrstr_mining(date_q,g_inv_nrstr_mining,inv_nrstr,inv_nrstr_ex_mining, ...
	date_m,ff,g_rigs2,rigs2);	
	
global junk_nos;

% make monthly forecasts to fill in missing data
f_g_rigs2=g_rigs2;
f_rigs2=rigs2;
for i1=1:2;
	f_g_rigs2(:,i1)=fn_make_forecast(g_rigs2(:,i1));
	for i2=max(find(f_rigs2(:,i1)~=junk_nos))+1:ff+5;
		f_rigs2(i2,i1)=f_rigs2(i2-1,i1)*(1+f_g_rigs2(i2,i1)/100);
	end;
end;

% convert to quarterly levels and growth rates
for i1=1:2;
	[f_rigs2_q(:,i1),f_g_rigs2_q(:,i1)]=fn_convert_mtoqavg(f_rigs2(:,i1),date_m,date_q);
end;


% extend the mining sample backwards
% it is entirely unclear why we do this

w = 36;
s1=find(date_q==1985.1);
f_g_inv_nrstr_mining=g_inv_nrstr_mining;
for i1=s1-w:min(find(g_inv_nrstr_mining~=junk_nos))-1;
	if inv_nrstr(i1)~=junk_nos & inv_nrstr(i1-1)~=junk_nos & inv_nrstr_ex_mining(i1)~=junk_nos & inv_nrstr_ex_mining(i1-1)~=junk_nos;
		f_g_inv_nrstr_mining(i1)=100*(((inv_nrstr(i1)-inv_nrstr_ex_mining(i1))/(inv_nrstr(i1-1)-inv_nrstr_ex_mining(i1-1)))^4-1);
	end;
end;

% Initially, we will look back 10 quarters. As we get more data, we want to look further back with the regression.
% We will stop adding more data when we get to 36 quarters. This will be in 2023.

% first month of drilled wells data is always 2014Q2 for growth
w1 = min(find(f_g_rigs2_q(:,2) ~= junk_nos));
wlast = max(find(f_g_rigs2_q(:,2) ~= junk_nos));
wreg = min(wlast - w1, 36);

% run regression
y=f_g_inv_nrstr_mining;
o=ones(size(date_q));
x=[o,f_g_rigs2_q];
e1=length(date_q);
f_g_inv_nrstr_mining=junk_nos*ones(size(date_q));
for i1=s1:e1;
	yy=y(i1-wreg:i1-1);
	xx=x(i1-wreg:i1-1,:);
	if sum(yy==junk_nos)==0 & sum(sum(xx==junk_nos))==0;
		b=regress(yy,xx);
		f_g_inv_nrstr_mining(i1)=b'*x(i1,:)';
	end;
end;
%

% check
if length(date_q)==length(g_inv_nrstr_mining);
zout=[date_q,g_inv_nrstr_mining,f_g_inv_nrstr_mining];
end;
%

% the final b can be used to forecast the next quarter as well
for i1=1:2;
	f_g_rigs2_next_q(1,i1)=100*((mean(f_rigs2(ff+3:ff+5,i1))/mean(f_rigs2(ff:ff+2)))^4-1);
end;
f_g_inv_nrstr_mining_next_q=b'*[1,f_g_rigs2_next_q]';