%% importance sampling weight for deviations from cross-equation restrictions 


function [weight,gA] = im_weight(S,N,L,W,qindex,lambda); 

% Translate S into a Companion Form 
lq		= length(qindex);
[s1,s2]	= size(S); % s1 = number of coeffs s2 = time
theta0 	= zeros(N*L,s2); 
theta1 	= zeros(N*L,N*L,s2); 
weight 	= zeros(s2,1); 
gA     	= zeros(s2,2*(1+N*L)); 

for jj=1:s2 
	AS	= reshape(S(:,jj),1+N*L,N);
	if L == 1
		theta0(:,jj)	 = AS(1,:)';
		theta1(:,:,jj)	 = AS(2:end,:)';
	else
		theta0(:,jj)	 = [AS(1,:)'; zeros(N*(L-1),1)];
		theta1(:,:,jj)	 = [AS(2:end,:)'; eye(N*(L-1)), zeros(N*(L-1),N)];
	end
end 

% Selection Vectors
e1 = zeros(1,N*L);
e2 = e1;
e3 = e1;

e1(1,1) = 1;
e2(1,2) = 1;
e3(1,3) = 1;  

for i=1:s2
	gA(i,1) 	  = e3*(4*eye(N*L)+3*theta1(:,:,i)+2*theta1(:,:,i)^2+theta1(:,:,i)^3)*theta0(:,i)/4;
	gA(i,2:N*L+1) = e3*(theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)/4-e2;   
	if qindex(lq-s2+i) == 1    % first quarter of the year 
		gAL0 = (eye(N*L)+theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)*theta0(:,i); 
		gAL1 = theta1(:,:,1)^5; 
		for kk=1:34
			gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
			gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
		end 
		gAL0 = gAL0/35;   gAL1 = gAL1/35;   
	elseif qindex(lq-s2+i) == 2  % second quarter of the year 
		gAL0 = (eye(N*L)+theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)*theta0(:,i); 
		gAL1 = theta1(:,:,1)^5; 
		for kk=1:33
			gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
			gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
		end 
		gAL0 = gAL0/34;   gAL1 = gAL1/34; 
	elseif qindex(lq-s2+i) == 3  % third quarter of the year 
		gAL0 = (eye(N*L)+theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)*theta0(:,i); 
		gAL1 = theta1(:,:,1)^5; 
		for kk=1:32
			gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
			gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
		end 
		gAL0 = gAL0/33;   gAL1 = gAL1/33; 
	elseif qindex(lq-s2+i) == 4  % fourth quarter of the year 
		gAL0 = (eye(N*L)+theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)*theta0(:,i); 
		gAL1 = theta1(:,:,1)^5; 
		for kk=1:31
			gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
			gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
		end 
		gAL0 = gAL0/32;   gAL1 = gAL1/32; 
	end 
	gA(i,N*L+2)  		= e3*gAL0 ; 
	gA(i,N*L+3:2+2*N*L) = e3*gAL1-e1;
	weight(i) = -0.5*lambda*gA(i,:)*W*gA(i,:)'; 
end 
































