%% importance sampling weight for deviations from cross-equation restrictions 


function [weights,gA] = im_weight_CP(S,N,L,qindex,W,lambda); 

% Translate S into a Companion Form 
  


gA     	= zeros(4,2*(1+N*L)); 
	AS	= reshape(S,1+N*L,N);
	if L == 1
		theta0	 = AS(1);
		theta1(:,:)	 = AS(2:end,:)';
	else
		theta0	 = [AS(1,:)'; zeros(N*(L-1),1)];
		theta1(:,:)	 = [AS(2:end,:)'; eye(N*(L-1)), zeros(N*(L-1),N)];
	end
 

% Selection Vectors
e1 = zeros(1,N*L);
e2 = e1;
e3 = e1;

e1(1,1) = 1;
e2(1,2) = 1;
e3(1,3) = 1;  
for jj=1:4

	gA(jj,1) 	  = e3*(4*eye(N*L)+3*theta1+2*theta1^2+theta1^3)*theta0/4;
	gA(jj,2:N*L+1) = e3*(theta1+theta1^2+theta1^3+theta1^4)/4-e2;   
	if qindex(jj) == 1    % first quarter of the year 
		gAL0 = (eye(N*L)+theta1+theta1^2+theta1^3+theta1^4)*theta0; 
		gAL1 = theta1^5; 
		for kk=1:34
			gAL0   = theta0+theta1*gAL0; 
			gAL1   = gAL1 + theta1*gAL1; 
		end 
		gAL0 = gAL0/35;   gAL1 = gAL1/35;   
	elseif qindex(jj) == 2  % second quarter of the year 
		gAL0 = (eye(N*L)+theta1+theta1^2+theta1^3+theta1^4+theta1^5)*theta0; 
		gAL1 = theta1^6; 
		for kk=1:33
			gAL0   = theta0+theta1*gAL0; 
			gAL1   = gAL1 + theta1*gAL1; 
		end 
		gAL0 = gAL0/34;   gAL1 = gAL1/34; 
	elseif qindex(jj) == 3  % third quarter of the year 
		gAL0 = (eye(N*L)+theta1+theta1^2+theta1^3+theta1^4+theta1^5+theta1^6)*theta0; 
		gAL1 = theta1^7; 
		for kk=1:32
			gAL0   = theta0+theta1*gAL0; 
			gAL1   = gAL1 + theta1*gAL1; 
		end 
		gAL0 = gAL0/33;   gAL1 = gAL1/33; 
	elseif qindex(jj) == 4  % fourth quarter of the year 
		gAL0 = (eye(N*L)+theta1+theta1^2+theta1^3+theta1^4+theta1^5+theta1^6+theta1^7)*theta0; 
		gAL1 = theta1^8; 
		for kk=1:31
			gAL0   = theta0+theta1*gAL0; 
			gAL1   = gAL1 + theta1*gAL1; 
		end 
		gAL0 = gAL0/32;   gAL1 = gAL1/32; 
	end 
	gA(jj,N*L+2)  		= e3*gAL0 ; 
	gA(jj,N*L+3:2+2*N*L) = e3*gAL1-e1;
	
end 

weights = -0.5*lambda*diag(gA*W*gA');
weights = mean(weights);  
 































