%% importance sampling weight for deviations from cross-equation restrictions 


function weight = im_weight_alt(S,N,L,W,lambda); 

% Translate S into a Companion Form 
[s1,s2]	= size(S); % s1 = number of coeffs s2 = time
theta0 	= zeros(N*L,s2); 
theta1 	= zeros(N*L,N*L,s2); 
weight 	= zeros(s2,1); 
gA     	= zeros(s2,2*(1+N*L)); 

for jj=1:s2 
	AS	= reshape(S(:,jj),1+N*L,N);
	if L == 1
		theta0(:,jj)	 = AS(1,:)';
		theta1(:,:,jj)	 = AS(2:end,:)';
	else
		theta0(:,jj)	 = [AS(1,:)'; zeros(N*(L-1),1)];
		theta1(:,:,jj)	 = [AS(2:end,:)'; eye(N*(L-1)), zeros(N*(L-1),N)];
	end
end 

% Selection Vectors
e1 = zeros(1,N*L);
e2 = e1;
e3 = e1;

e1(1,1) = 1;
e2(1,2) = 1;
e3(1,3) = 1;  

for i=1:s2
	gA(i,1) = e3*(8*eye(N*L)+7*theta1(:,:,i)+6*theta1(:,:,i)^2+5*theta1(:,:,i)^3+4*theta1(:,:,i)^4+3*theta1(:,:,i)^5+2*theta1(:,:,i)^6+theta1(:,:,i)^7)*theta0(:,i)/8;
	gA(i,2:N*L+1) = e3*(theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4+theta1(:,:,i)^5+theta1(:,:,i)^6+theta1(:,:,i)^7+theta1(:,:,i)^8)/8-e2;   
	gAL0 = (eye(N*L))*theta0(:,i); 
	gAL1 = theta1(:,:,1); 
	for kk=1:39
		gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
		gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
        if kk==19
         gAF0 =gAL0;
         gAF1 =gAL1; 
        end 
    end 
	gAL0 = (gAL0-gAF0)/20;   gAL1 = (gAL1-gAF1)/20; 
	gA(i,N*L+2)  = e3*gAL0;
	gA(i,N*L+3:2+2*N*L) = e3*gAL1-e1;  
	weight(i) = -0.5*lambda*gA(i,:)*W*gA(i,:)'; 
end 
































