%% No Resampling
irflength = size(IRmed(:,:,5),1);
t = 1:1:irflength;
clear legend;
figure;
subplot(3,2,1)
hold on
jbfill(t,IRup_2(:,1,5)',IRlo_2(:,1,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmed(:,1,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title({'\fontsize{14}No Resampling';'\fontsize{14}10-year Infl. Exp'});xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,2)
hold on
jbfill(t,IRup_2(:,2,5)',IRlo_2(:,2,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmed(:,2,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('1-year Infl. Exp','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.2 1.4]);set(gca,'YTick',[-0.2:0.2:1.4],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,3)
hold on
jbfill(t,IRup_2(:,3,5)',IRlo_2(:,3,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmed(:,3,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Inflation','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.6]);set(gca,'YTick',[-0.1:0.1:0.6],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,4)
hold on
jbfill(t,IRup_2(:,4,5)',IRlo_2(:,4,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmed(:,4,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('CFNAI','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('Index','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,5)
hold on
jbfill(t,IRup_2(:,5,5)',IRlo_2(:,5,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmed(:,5,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1);  
title('Federal Funds Rate','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.07 0.01]);set(gca,'YTick',[-0.07:0.02:.01],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
plot(t,zeros(t(end),1), '-k', 'LineWidth', 1); 
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

%% With Resampling
clear legend;
figure;
subplot(3,2,1)
hold on
jbfill(t,IRup_2im(:,1,5)',IRlo_2im(:,1,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmedim(:,1,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title({'\fontsize{14}Resampling';'\fontsize{14}10-year Infl. Exp'});xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,2)
hold on
jbfill(t,IRup_2im(:,2,5)',IRlo_2im(:,2,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmedim(:,2,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('1-year Infl. Exp','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.2 1.4]);set(gca,'YTick',[-0.2:0.2:1.4],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,3)
hold on
jbfill(t,IRup_2im(:,3,5)',IRlo_2im(:,3,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmedim(:,3,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('Inflation','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.6]);set(gca,'YTick',[-0.1:0.1:0.6],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,4)
hold on
jbfill(t,IRup_2im(:,4,5)',IRlo_2im(:,4,5)',[.8, .8, .8],[1 1 1],0,0.6);
plot(t,IRmedim(:,4,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1); 
title('CFNAI','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.1 0.4]);set(gca,'YTick',[-0.1:0.1:0.4],'FontSize',12);
ylabel('Index','FontSize',12);
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)

subplot(3,2,5)
hold on
h1=jbfill(t,IRup_2im(:,5,5)',IRlo_2im(:,5,5)',[.8, .8, .8],[1 1 1],0,0.6);
h2=plot(t,IRmedim(:,5,5),'-b','LineWidth',3);
plot(t,zeros(irflength,1), '-k', 'LineWidth', 1);  
title('Federal Funds Rate','FontSize',16);xlim([t(1) t(end)]);set(gca,'XTick',t(4:4:end),'FontSize',12);
%ylim([-0.07 0.01]);set(gca,'YTick',[-0.07:0.02:.01],'FontSize',12);
ylabel('Percentage Points','FontSize',12);
hleglines = [h2(1) h1(1)];
legend = legend(hleglines, 'Impulse Response','90% Probability Interval');
set(legend,'Location','NorthEast');
h4=plot(t,zeros(t(end),1), '-k', 'LineWidth', 1); 
box on; grid on;
set(gca, 'Layer', 'top','GridLineStyle',':','GridColor',[.4, .4, .4],'GridAlpha',1)