%  This file generates deflation probability forecasts as in Clark and Doh
%  (2011) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 500; 
N = 3; 
L = 2; 
% selection vectors 
spi = [0 0 1 ];
su =  [0 1 0 ];
sy =  [1 0 0 ];
% catalog of data files
DFILE(1,:) = ['\pce\newcore2\output\var101'];
DFILE(2,:) = ['\pce\newcore2\output\var102'];
DFILE(3,:) = ['\pce\newcore2\output\var103'];
DFILE(4,:) = ['\pce\newcore2\output\var104'];
DFILE(5,:) = ['\pce\newcore2\output\var105'];
DFILE(6,:) = ['\pce\newcore2\output\var106'];
DFILE(7,:) = ['\pce\newcore2\output\var107'];
DFILE(8,:) = ['\pce\newcore2\output\var108'];
DFILE(9,:) = ['\pce\newcore2\output\var109'];
DFILE(10,:) = ['\pce\newcore2\output\var110'];
DFILE(11,:) = ['\pce\newcore2\output\var111'];
DFILE(12,:) = ['\pce\newcore2\output\var112'];
DFILE(13,:) = ['\pce\newcore2\output\var113'];
DFILE(14,:) = ['\pce\newcore2\output\var114'];
DFILE(15,:) = ['\pce\newcore2\output\var115'];
DFILE(16,:) = ['\pce\newcore2\output\var116'];
DFILE(17,:) = ['\pce\newcore2\output\var117'];
DFILE(18,:) = ['\pce\newcore2\output\var118'];
DFILE(19,:) = ['\pce\newcore2\output\var119'];
DFILE(20,:) = ['\pce\newcore2\output\var120'];


NF = size(DFILE,1);
% load data
load '/data/kc/j1gxc03/Inf_TVP_VAR_2/data/11_12_2014/pcectpi.txt' -ascii
PCE = pcectpi(:,1);
T1 = 28;
infl1 = log(PCE(2:T1,:)./PCE(1:T1-1,:)); % 1953.Q2-1959.Q4
clear PCE pcectpi dp date1 T1
load '/data/kc/j1gxc03/Inf_TVP_VAR_2/data/11_12_2014/pcecore.txt' -ascii
PCEc = pcecore(:,1);
T1 = size(PCEc,1);
infl2 = log(PCEc(2:T1,:)./PCEc(1:T1-1,:)); % 1960.Q1-2014.Q3
clear PCE pcecore dp date1 T1
infl=[infl1;infl2];
load '/data/kc/j1gxc03/Inf_TVP_VAR_2/data/11_12_2014/UNRATE.txt' -ascii
TM = size(UNRATE,1); % monthly
urq = UNRATE(2:3:TM,1)/100; % quarterly is middle month of quarter
lur = .01*log(urq./(1-urq)); % logit transformation
clear UNRATE TM urq 
load '/data/kc/j1gxc03/Inf_TVP_VAR_2/data/11_12_2014/TB10YR.txt' -ascii
TM = size(TB10YR,1); % monthly
p3 = 1 - TB10YR(1:3:TM,1)/400; % 1st month of quarter, price 
y3 = -log(p3); % yield to maturity
clear TB10YR TM TQ p3
y = [y3,lur,infl]; % ordered as in benchmark model for D&V
Td = 199; 
data=y(end-Td:end,:);  % the most recent 50 years 
[ND1,ND2]=size(data);
% load SA
NB = 10;
load(DFILE(NB+1,:),'SD')    % time-varying parameters
load(DFILE(NB+1,:),'QD')    % covariance matrix for innovations to TVPs 
load(DFILE(NB+1,:),'HD')    % stochastic volatility 
load(DFILE(NB+1,:),'VD')    % standard deviations of innovations to log volatility  
load(DFILE(NB+1,:),'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol

randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
SQ = zeros(NQ,NQ,(NF-NB)*P);
SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
FH        = 8;  % forecast horizon 
TH        = 80; % predictive forecast in the past 20 years
SAF= zeros(NK,FH,(NF-NB)*P);

SHF= zeros(FH,NH,(NF-NB)*P);
YYF= zeros(ND2,FH,(NF-NB)*P); 

clear SD QD HD VD CD 
for i = NB+2:NF,
    j = i - NB; 
    load(DFILE(i,:),'SD')
    load(DFILE(NB+1,:),'QD')   
    load(DFILE(NB+1,:),'HD')    
    load(DFILE(NB+1,:),'VD')    
    load(DFILE(NB+1,:),'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);

predy=zeros(ND2,FH,(NF-NB)*P,TH);    % prediction output 




for jj=1:TH
   
    
for i = 1:NMC,
   
    
    % Step 1: Innovations to time-varying coefficients 
    for tt=1:FH
        if tt==1   
     SAF(:,tt,i) = SA(:,T-TH+jj,i)+sqrtm(SQ(:,:,i))*randn(NQ,1); 
        else 
     SAF(:,tt,i) = SAF(:,tt-1,i)+sqrtm(SQ(:,:,i))*randn(NQ,1);
    
        end 
    end 
    
    % Step 2: Innovations to stochastic volatility 
    for tt=1:FH
        if tt==1  
    SHF(tt,:,i) = log(SH(T-TH+jj,:,i))+(diag(SV(:,i))*randn(NV,1))'; 
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        else 
    SHF(tt,:,i) = log(SHF(tt-1,:,i))+(diag(SV(:,i))*randn(NV,1))';
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        end 
    end 
    
    % Step 3: Innovations to equation errors 
    for tt=1:FH 
        if tt==1 
            innov=CHOFAC(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[data(200-TH+jj,:)';data(200-1-TH+jj,:)']+innov; 
  
       
        elseif tt==2 
            innov=CHOFAC(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYF(:,tt-1,i);data(200-TH+jj,:)']+innov;     
   
        else

    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)']*[YYF(:,tt-1,i);YYF(:,tt-2,i)]+innov;          
   
    end 
    
 
     
end
predy(:,:,:,jj)= YYF; 
end
end
clear SA
sfile='prediction.mat'; 
save(sfile,'predy');     

variance = zeros(3,FH,TH);
skew = zeros(3,FH,TH);

for j = 1:3
    for i = 1:FH
        for date = 1:TH
   
        variance(j,i,date)=var(squeeze(predy(j,i,:,date)));
        skew(j,i,date) = skewness(squeeze(predy(j,i,:,date)));
        end
    end
end

%plotting
t = datetime(1995,01,01):calmonths(3):datetime(2014,12,01);
variable = cellstr(['Inflation   '; 'Unemployment'; 'Yields      ']);
moments = cellstr([' Uncertainty (Variance)';' Risk (Skewness)       ']);


for j = 1:3
    for jj = 1:2
        figurename = char(strcat(variable(j),'-',moment(jj)));
        h=figure('Name',figurename, 'NumberTitle','off');

        for i = 1:FH
            if jj ==1
                subplot(2,4,i)
                plot(t,squeeze(variance(j,i,:)));
            else
                subplot(2,4,i)
                plot(t,squeeze(skew(j,i,:)));
            end
                datetick('x','yy');
                horizon = strcat(num2str(i),' Qtr');
                title(horizon);               
        end
        print(h,'-djpeg',figurename);
    end
end


% summary plot

inf = zeros(2,2,8);
unemploy = zeros(2,2,8);
for j = 1:2 %considner only inflation and unemployment
       
            if j ==1
                inf(1,:,:) = [variance(j,:,end); mean(variance(j,:,:),3)]; %first column is the latest variance for each variable for each horizon; second column is the average variance for each variable for each horizon.
                inf(2,:,:) = [skew(j,:,end); mean(skew(j,:,:),3)]; 
            else
                unemploy(1,:,:) = [variance(j,:,end); mean(variance(j,:,:),3)];
                unemploy(2,:,:) = [skew(j,:,end); mean(skew(j,:,:),3)];
            end
end
 

h=figure('Name','Summary','NumberTitle','off');

for j = 1:2
    for jj = 1:2 %variance or skewness
        if j ==1 
             subplot(2,2,jj)
             bar(1:8,squeeze(inf(jj,2,:)),'y');hold on %average
             scatter(1:8,squeeze(inf(jj,1,:))) %latest
        else
             subplot(2,2,jj+2)
             bar(1:8,squeeze(unemploy(jj,2,:)),'y');hold on %average
             scatter(1:8,squeeze(unemploy(jj,1,:))) %latest
        end
         title(strcat(char(variable(j)),char(moments(jj))));
         legend('20-Year Average','Current','Location','Best');             
        if jj ==2
           set(h,'YDir','Reverse');
        end
   
    end
    
end

set(h,'PaperPositionMode','manual');
set(h,'PaperUnits','inches');
set(h,'PaperPosition',[0.25 0.25 11.2 7.8]);
set(h, 'PaperOrientation','landscape');
set(h,'PaperType','A4');
print(h,'-dpdf','Summary_01212015');
     

