%  This file generates deflation probability forecasts as in Clark and Doh
%  (2011) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 500; 
N = 4; 
L = 1; 
% selection vectors 
sgc =  [1 0 0 0];
sgd =  [0 1 0 0];
srr =  [0 0 1 0];
spd =  [0 0 0 1]; 
% catalog of data files
DFILE(1,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var101'];
DFILE(2,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var102'];
DFILE(3,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var103'];
DFILE(4,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var104'];
DFILE(5,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var105'];
DFILE(6,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var106'];
DFILE(7,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var107'];
DFILE(8,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var108'];
DFILE(9,:) =   ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var109'];
DFILE(10,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var110'];
DFILE(11,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var111'];
DFILE(12,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var112'];
DFILE(13,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var113'];
DFILE(14,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var114'];
DFILE(15,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var115'];
DFILE(16,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var116'];
DFILE(17,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var117'];
DFILE(18,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var118'];
DFILE(19,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var119'];
DFILE(20,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var120'];

NF = size(DFILE,1);
% load data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%% FIRST LOAD THE DATA
new_data	= importdata('data2013.xlsx');
%% DEFINE VARIABLES
gc	= new_data.data.Sheet1(:,2);	        % 
gd	        = new_data.data.Sheet1(:,3);	% 
% inf	        = new_data.data.Sheet1(:,8);  % 
pd          = new_data.data.Sheet1(:,4); 
% yd1          = new_data.data.Sheet1(:,11); 
% yd10         = new_data.data.Sheet1(:,12); 
r1     =new_data.data.Sheet1(:,15); 
y = [gc, gd, r1, pd]; % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L = 1; % VAR lag order 
[T,N] = size(y);
% adjust for lags, create rh variables
% lagged dependent variables: X1 = [y(t-1) y(t-1) ... y(t-L)]
X1 = zeros(T-L,1+(N*L));
X1(1:T-L,1) = ones(T-L,1);
for i = 1:L,
   X1(1:T-L,2+(N*(i-1)):1+(i*N)) = y(1+L-i:T-i,:);
end
Y = y(1+L:T,:)'; % Third row to the end, then transpose
X = XMAT2(X1',X1',X1',X1'); 
% partitioning the data
% initial estimates through T0
T0 = 25-L; %adjust for training sample
Y0 = Y(:,1:T0);  
YS = Y(:,1+T0:T-L);
X0 = X(:,:,1:T0);
XS = X(:,:,1+T0:T-L);
X01 = X1(1:T0,:);
XS1 = X1(1+T0:T-L,:);
date = 1915 + [0:1:size(YS,2)-1]'; % sample runs from 1920 to 2013


data = YS; % ordered as in benchmark model for D&V

[ND1,ND2]=size(data');
% load SA
NB = 10;
load(DFILE(NB+1,:),'SD')    % time-varying parameters
load(DFILE(NB+1,:),'QD')    % covariance matrix for innovations to TVPs 
load(DFILE(NB+1,:),'HD')    % stochastic volatility 
load(DFILE(NB+1,:),'VD')    % standard deviations of innovations to log volatility  
load(DFILE(NB+1,:),'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol

randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
SQ = zeros(NQ,NQ,(NF-NB)*P);
SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
FH        = 5;  % forecast horizon 
TH        = ND1; % predictive forecast 
SAF= zeros(NK,FH,(NF-NB)*P);

SHF= zeros(FH,NH,(NF-NB)*P);
YYF= zeros(ND2,FH,(NF-NB)*P); 

clear SD QD HD VD CD 
for i = NB+2:NF,
    j = i - NB; 
    load(DFILE(i,:),'SD')
    load(DFILE(NB+1,:),'QD')   
    load(DFILE(NB+1,:),'HD')    
    load(DFILE(NB+1,:),'VD')    
    load(DFILE(NB+1,:),'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);

predy=zeros(ND2,FH,(NF-NB)*P,TH);    % prediction output 




for jj=1:TH
   
    
for i = 1:NMC,
   
    
    % Step 1: Innovations to time-varying coefficients 
    for tt=1:FH
        if tt==1   
     SAF(:,tt,i) = SA(:,T-TH+jj,i)+sqrtm(SQ(:,:,i))*randn(NQ,1); 
        else 
     SAF(:,tt,i) = SAF(:,tt-1,i)+sqrtm(SQ(:,:,i))*randn(NQ,1);
    
        end 
    end 
    
    % Step 2: Innovations to stochastic volatility 
    for tt=1:FH
        if tt==1  
    SHF(tt,:,i) = log(SH(T-TH+jj,:,i))+(diag(SV(:,i))*randn(NV,1))'; 
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        else 
    SHF(tt,:,i) = log(SHF(tt-1,:,i))+(diag(SV(:,i))*randn(NV,1))';
    SHF(tt,:,i) = exp(SHF(tt,:,i)); 
        end 
    end 
    
    % Step 3: Innovations to equation errors 
    for tt=1:FH 
        if tt==1 
            innov=CHOFAC(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i);SAF(1+3*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)';SAF(2+3*(1+N*L):4*(1+N*L),tt,i)']*[data(:,ND1-TH+jj)]+innov; 
       
        elseif tt==2 
            innov=CHOFAC(ND2,SC(:,i))*diag(sqrt(SHF(tt,:,i)))*randn(ND2,1);
    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i);SAF(1+3*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)';SAF(2+3*(1+N*L):4*(1+N*L),tt,i)']*[YYF(:,tt-1,i)]+innov;     
   
        else

    YYF(:,tt,i) = [SAF(1,tt,i);SAF(1+(1+N*L),tt,i);SAF(1+2*(1+N*L),tt,i);SAF(1+3*(1+N*L),tt,i)]+[SAF(2:1+N*L,tt,i)';SAF(2+(1+N*L):2*(1+N*L),tt,i)';SAF(2+2*(1+N*L):3*(1+N*L),tt,i)';SAF(2+3*(1+N*L):4*(1+N*L),tt,i)']*[YYF(:,tt-1,i)]+innov;          
   
    end 
    
 
     
end
predy(:,:,:,jj)= YYF; 
end
end
clear SA
sfile='prediction.mat'; 
save(sfile,'predy');     

variance = zeros(4,FH,TH);
skew = zeros(4,FH,TH);

for j = 1:4
    for i = 1:FH
        for date = 1:TH
   
        variance(j,i,date)=var(squeeze(predy(j,i,:,date)));
        skew(j,i,date) = skewness(squeeze(predy(j,i,:,date)));
        end
    end
end

%plotting
t = datetime(1916,01,01):calmonths(12):datetime(2013,01,01);
%variable = cellstr(['expected consumption growth'; 'expected dividend growth'; 'expected real interest rate';'expected price-dividend ratio ']);
predy1 = squeeze(mean(predy(:,1,:,:),3)); 
predy5 = squeeze(mean(predy(:,FH,:,:),3)); 

for j=1:4 
    subplot(2,2,j); plot(t,[data(j,2:end)' predy1(j,1:end-1)' predy5(j,1:end-1)']); 
end

sfile = ['predy.mat'];
save('sfile','predy','predy1','predy5','data'); 
%moments = cellstr([' Uncertainty (Variance)';' Risk (Skewness)       ']);

% 
% for j = 1:4
%     for jj = 1:2
%         figurename = char(strcat(variable(j),'-',moment(jj)));
%         h=figure('Name',figurename, 'NumberTitle','off');
% 
%         for i = 1:FH
%             if jj ==1
%                 subplot(2,4,i)
%                 plot(t,squeeze(variance(j,i,:)));
%             else
%                 subplot(2,4,i)
%                 plot(t,squeeze(skew(j,i,:)));
%             end
%                 datetick('x','yy');
%                 horizon = strcat(num2str(i),' Qtr');
%                 title(horizon);               
%         end
%         print(h,'-djpeg',figurename);
%     end
% end


% summary plot

% inf = zeros(2,2,8);
% unemploy = zeros(2,2,8);
% for j = 1:2 %considner only inflation and unemployment
%        
%             if j ==1
%                 inf(1,:,:) = [variance(j,:,end); mean(variance(j,:,:),3)]; %first column is the latest variance for each variable for each horizon; second column is the average variance for each variable for each horizon.
%                 inf(2,:,:) = [skew(j,:,end); mean(skew(j,:,:),3)]; 
%             else
%                 unemploy(1,:,:) = [variance(j,:,end); mean(variance(j,:,:),3)];
%                 unemploy(2,:,:) = [skew(j,:,end); mean(skew(j,:,:),3)];
%             end
% end
%  
% 
% h=figure('Name','Summary','NumberTitle','off');
% 
% for j = 1:2
%     for jj = 1:2 %variance or skewness
%         if j ==1 
%              subplot(2,2,jj)
%              bar(1:8,squeeze(inf(jj,2,:)),'y');hold on %average
%              scatter(1:8,squeeze(inf(jj,1,:))) %latest
%         else
%              subplot(2,2,jj+2)
%              bar(1:8,squeeze(unemploy(jj,2,:)),'y');hold on %average
%              scatter(1:8,squeeze(unemploy(jj,1,:))) %latest
%         end
%          title(strcat(char(variable(j)),char(moments(jj))));
%          legend('20-Year Average','Current','Location','Best');             
%         if jj ==2
%            set(h,'YDir','Reverse');
%         end
%    
%     end
%     
% end
% 
% set(h,'PaperPositionMode','manual');
% set(h,'PaperUnits','inches');
% set(h,'PaperPosition',[0.25 0.25 11.2 7.8]);
% set(h, 'PaperOrientation','landscape');
% set(h,'PaperType','A4');
% print(h,'-dpdf','Summary_01212015');
     

