%  This file generates deflation probability forecasts as in Clark and Doh
%  (2011) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 5000; 
N = 5; 
L = 1; 
% selection vectors %y = [gc, gd, inf, yd1, yd10, pd];
sgc =  [1 0 0 0 0];
sgd =  [0 1 0 0 0];
spi =  [0 0 1 0 0];
%sy1 =  [0 0 0 1 0 0]; 
sy10=  [0 0 0 1 0];  
spd =  [0 0 0 0 1];

% catalog of data files
% DFILE(1,:) = ['\output_stat\var101'];
% DFILE(2,:) = ['\output_stat\var102'];
% DFILE(3,:) =  ['\output_stat\var103'];
% DFILE(4,:) =  ['\output_stat\var104'];
% DFILE(5,:) =  ['\output_stat\var105'];
% DFILE(6,:) =  ['\output_stat\var106'];
% DFILE(7,:) =  ['\output_stat\var107'];
% DFILE(8,:) =  ['\output_stat\var108'];
% DFILE(9,:) =   ['\output_stat\var109'];
% DFILE(10,:) =  ['\output_stat\var110'];
% DFILE(11,:) =  ['\output_stat\var111'];
% DFILE(12,:) =  ['\output_stat\var112'];  
% DFILE(13,:) =  ['\output_stat\var113'];
% DFILE(14,:) =  ['\output_stat\var114'];
% DFILE(15,:) =  ['\output_stat\var115'];
% DFILE(16,:) =  ['\output_stat\var116'];
% DFILE(17,:) = ['\output_stat\var117'];
% DFILE(18,:) = ['\output_stat\var118'];
% DFILE(19,:) = ['\output_stat\var119'];
% DFILE(20,:) = ['\output_stat\var120'];
% DFILE(1,:) = ['\output_stat2\var101_stoch'];
% DFILE(2,:) = ['\output_stat2\var102_stoch'];
% DFILE(3,:) =  ['\output_stat2\var103_stoch'];
% DFILE(4,:) =  ['\output_stat2\var104_stoch'];
% DFILE(5,:) =  ['\output_stat2\var105_stoch'];
% DFILE(6,:) =  ['\output_stat2\var106_stoch'];
% DFILE(7,:) =  ['\output_stat2\var107_stoch'];
% DFILE(8,:) =  ['\output_stat2\var108_stoch'];
% DFILE(9,:) =   ['\output_stat2\var109_stoch'];
% DFILE(10,:) =  ['\output_stat2\var110_stoch'];
% DFILE(11,:) =  ['\output_stat2\var111_stoch'];
% DFILE(12,:) =  ['\output_stat2\var112_stoch'];
% DFILE(13,:) =  ['\output_stat2\var113_stoch'];
% DFILE(14,:) =  ['\output_stat2\var114_stoch'];
% DFILE(15,:) =  ['\output_stat2\var115_stoch'];
% DFILE(16,:) =  ['\output_stat2\var116_stoch'];
% DFILE(17,:) = ['\output_stat2\var117_stoch'];
% DFILE(18,:) = ['\output_stat2\var118_stoch'];
% DFILE(19,:) = ['\output_stat2\var119_stoch'];
% DFILE(20,:) = ['\output_stat2\var120_stoch'];
NF = 20;
% load data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%% FIRST LOAD THE DATA
new_data	= importdata('data_TVPVAR.xlsx');
%% DEFINE VARIABLES
gc	 = new_data.data.data(:,2);	       
gd	 = new_data.data.data(:,3);	
inf	 = new_data.data.data(:,4);  
%yd1  = new_data.data.data(:,5); 
yd10 = new_data.data.data(:,6); 
pd   = new_data.data.data(:,7);
%y = [gc, gd, inf, yd1, yd10, pd]; % 
y = [gc, gd, inf, yd10, pd]; % 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L = 1; % VAR lag order 
[T,N] = size(y);
% adjust for lags, create rh variables
% lagged dependent variables: X1 = [y(t-1) y(t-1) ... y(t-L)]
X1 = zeros(T-L,1+(N*L));
X1(1:T-L,1) = ones(T-L,1);
for i = 1:L,
   X1(1:T-L,2+(N*(i-1)):1+(i*N)) = y(1+L-i:T-i,:);
end
Y = y(1+L:T,:)'; % Third row to the end, then transpose
%X = XMAT2(X1',X1',X1',X1'); 
X = XMAT_5(X1',X1',X1',X1',X1'); 

% partitioning the data
% initial estimates through T0
T0 = 24-L; %adjust for training sample
Y0 = Y(:,1:T0);  
YS = Y(:,1+T0:T-L);
X0 = X(:,:,1:T0);
XS = X(:,:,1+T0:T-L);
X01 = X1(1:T0,:);
XS1 = X1(1+T0:T-L,:);
date = 1915 + [0:1:size(YS,2)-1]'; % sample runs from 1920 to 2016


data = YS; % ordered as in benchmark model for D&V

[ND1,ND2]=size(data');
% load SA
NB =10;


DFILE = 'var111.mat'; 
load(DFILE,'SD')    % time-varying parameters
load(DFILE,'QD')    % covariance matrix for innovations to TVPs 
load(DFILE,'HD')    % stochastic volatility 
load(DFILE,'VD')    % standard deviations of innovations to log volatility  
load(DFILE,'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol


randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
%SQ = zeros(NQ,NQ,(NF-NB)*P);
%SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
% FH        = 5;  % forecast horizon 
% TH        = ND1; % predictive forecast 
% SAF= zeros(NK,FH,(NF-NB)*P);
% 
% SHF= zeros(FH,NH,(NF-NB)*P);
% YYF= zeros(ND2,FH,(NF-NB)*P); 

clear SD QD HD VD CD 
for i = NB+2:NF,
    j = i - NB; 
    DFILE = ['var1' num2str(i,'%02.0f')  '.mat']; 
    load(DFILE,'SD')
    load(DFILE,'QD')   
    load(DFILE,'HD')    
    load(DFILE,'VD')    
    load(DFILE,'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);


% Trend Consumption

mm  = zeros(N,T);
gc = zeros(T,NMC);
mgc=zeros(NMC,1);
gd = zeros(T,NMC); 
mgd = zeros(NMC,1); 
inf =zeros(T,NMC);
minf = zeros(NMC,1);
pd = zeros(T,NMC); 
mpd = zeros(NMC,1); 
%y1 = zeros(T,NMC); 
%my1 = zeros(NMC,1); 
rr = zeros(T,NMC); 
mrr = zeros(NMC,1); 
y10 = zeros(T,NMC);
my10 = zeros(NMC,1); 

for i = 1:NMC,
    for t = 1:T,
       A = [SA(2:1+N*L,t,i)'; SA(2+(1+N*L):2*(1+N*L),t,i)'; SA(2+2*(1+N*L):3*(1+N*L),t,i)'; SA(2+3*(1+N*L):4*(1+N*L),t,i)';SA(2+4*(1+N*L):5*(1+N*L),t,i)'];
       M = inv(eye(N*L) - A)*[SA(1,t,i); SA(2+N*L,t,i); SA(3+2*N*L,t,i);SA(4+3*N*L,t,i);SA(5+4*N*L,t,i)];
       mm(:,t) = M(1:N,:); 
    end
    gc(:,i) = (sgc*mm)';
    mgc(i) = mean(gc(:,i)); 
    gd(:,i) = (sgd*mm)'; 
    mgd(i)=mean(gd(:,i)); 
    inf(:,i)=(spi*mm)';
    minf(i)=mean(inf(:,i));  
    pd(:,i)= (spd*mm)';
    mpd(i) =mean(pd(:,i)); 
    rr(:,i)=(sy10*mm-spi*mm)'; 
    mrr(i)=mean(rr(:,i)); 
    y10(:,i)=(sy10*mm)';
    my10(i)=mean(y10(:,i)); 
end

ssgc = sort(gc,2);
smgc=median(mgc); 
ssgd = sort(gd,2);
smgd = median(mgd);  
ssinf = sort(inf,2);
sminf = median(minf);
sspd = sort(pd,2); 
smpd = median(mpd); 
%ssy1 = sort(y1,2);
%smy1 = median(my1);
ssrr = sort(rr,2);
smrr = median(mrr); 
ssy10 = sort(y10,2);
smy10 =median(my10); 


clear core
IQR1 = [ssgc(:,.25*NMC),ssgc(:,.5*NMC),ssgc(:,.75*NMC)];   

IQR2 = [ssgd(:,.25*NMC),ssgd(:,.5*NMC),ssgd(:,.75*NMC)];

IQR3 = [ssinf(:,.25*NMC),ssinf(:,.5*NMC),ssinf(:,.75*NMC)];

%IQR4 = [ssy1(:,.15*NMC),ssy1(:,.5*NMC),ssy1(:,.85*NMC)];
IQR4 = [ssrr(:,.25*NMC),ssrr(:,.5*NMC),ssrr(:,.75*NMC)];

IQR5 = [ssy10(:,.25*NMC),ssy10(:,.5*NMC),ssy10(:,.75*NMC)]; 

IQR6 = [sspd(:,.25*NMC),sspd(:,.5*NMC),sspd(:,.75*NMC)]; 

figure;
grid on; 
plot(date(:),100*(IQR1(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR1(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR1(:,3)),'--k','LineWidth',1); hold on;
grid off;
%set(gca,'YLim',[-4 6])
title('Consumption Growth Trend','Fontsize',14)
%axis([1915 2016 -4 6])
%set(gca,'Fontsize',14,'YTick',[-4:2:6])  
figure;
grid on;
plot(date(:),100*(IQR2(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR2(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR2(:,3)),'--k','LineWidth',1); hold on;
grid off;
%set(gca,'YLim',[-4 12])
title('Dividend Growth Trend','Fontsize',14)
%axis([1915 2016 -4 12])
%set(gca,'Fontsize',14,'YTick',[-4:4:16])
figure;
grid on;
plot(date(:),100*(IQR3(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR3(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR3(:,3)),'--k','LineWidth',1); hold on;
%set(gca,'YLim',[-4 6])
grid off;
title('inflation rate','Fontsize',14)
%axis([1915 2016 -4 6])
%set(gca,'Fontsize',14,'YTick',[-4:2:6])
figure;
grid on;
plot(date(:),100*(IQR4(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR4(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR4(:,3)),'--k','LineWidth',1); hold on;
%set(gca,'YLim',[-4 6])
grid off;
title('Real Rate','Fontsize',14)
%axis([1915 2016 -4 6])
%set(gca,'Fontsize',14,'YTick',[-4:2:6])
figure;
grid on;
plot(date(:),100*(IQR5(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR5(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR5(:,3)),'--k','LineWidth',1); hold on;
%set(gca,'YLim',[-2 6])
grid off;
title('10 year nominal bond yield rate','Fontsize',14)
%axis([1915 2016 -2 6])
%set(gca,'Fontsize',14,'YTick',[-2:2:6])
figure;
grid on;
plot(date(:),(IQR6(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),(IQR6(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),(IQR6(:,3)),'--k','LineWidth',1); hold on;
grid off; 
%set(gca,'YLim',[2 5])
title('Log Price-Dividend Ratio Trend','Fontsize',14)
%axis([1915 2016 2 5])
%set(gca,'Fontsize',14,'YTick',[2:1:5])

%print('-dpdf','trendcdpry1y10.pdf')

% Obtain Estimated Shocks to TVP 

parameter_innov = SA(:,2:end,:)-SA(:,1:end-1,:);  
sfile =['trend_estimate.mat']; 
save(sfile,'ssgc','ssgd','ssinf','ssrr','ssy10','sspd','date'); 
