%  This file generates deflation probability forecasts as in Clark and Doh
%  (2011) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 500; 
N = 4; 
L = 1; 
% selection vectors 
sgc =  [1 0 0 0];
sgd =  [0 1 0 0];
srr =  [0 0 1 0];
spd =  [0 0 0 1]; 
% catalog of data files
DFILE(1,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var101'];
DFILE(2,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var102'];
DFILE(3,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var103'];
DFILE(4,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var104'];
DFILE(5,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var105'];
DFILE(6,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var106'];
DFILE(7,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var107'];
DFILE(8,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var108'];
DFILE(9,:) =   ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var109'];
DFILE(10,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var110'];
DFILE(11,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var111'];
DFILE(12,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var112'];
DFILE(13,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var113'];
DFILE(14,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var114'];
DFILE(15,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var115'];
DFILE(16,:) =  ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var116'];
DFILE(17,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var117'];
DFILE(18,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var118'];
DFILE(19,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var119'];
DFILE(20,:) = ['\Shu_Pred\TVP_var\tvp_var_stat\output_stat\4var120'];

NF = size(DFILE,1);
% load data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%% FIRST LOAD THE DATA
new_data	= importdata('data2013.xlsx');
%% DEFINE VARIABLES
gc	= new_data.data.Sheet1(:,2);	        % 
gd	        = new_data.data.Sheet1(:,3);	% 
% inf	        = new_data.data.Sheet1(:,8);  % 
pd          = new_data.data.Sheet1(:,4); 
% yd1          = new_data.data.Sheet1(:,11); 
% yd10         = new_data.data.Sheet1(:,12); 
r1     =new_data.data.Sheet1(:,15); 
y = [gc, gd, r1, pd]; % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L = 1; % VAR lag order 
[T,N] = size(y);
% adjust for lags, create rh variables
% lagged dependent variables: X1 = [y(t-1) y(t-1) ... y(t-L)]
X1 = zeros(T-L,1+(N*L));
X1(1:T-L,1) = ones(T-L,1);
for i = 1:L,
   X1(1:T-L,2+(N*(i-1)):1+(i*N)) = y(1+L-i:T-i,:);
end
Y = y(1+L:T,:)'; % Third row to the end, then transpose
X = XMAT2(X1',X1',X1',X1'); 
% partitioning the data
% initial estimates through T0
T0 = 25-L; %adjust for training sample
Y0 = Y(:,1:T0);  
YS = Y(:,1+T0:T-L);
X0 = X(:,:,1:T0);
XS = X(:,:,1+T0:T-L);
X01 = X1(1:T0,:);
XS1 = X1(1+T0:T-L,:);
date = 1915 + [0:1:size(YS,2)-1]'; % sample runs from 1920 to 2013


data = YS; % ordered as in benchmark model for D&V

[ND1,ND2]=size(data');
% load SA
NB = 10;
load(DFILE(NB+1,:),'SD')    % time-varying parameters
load(DFILE(NB+1,:),'QD')    % covariance matrix for innovations to TVPs 
load(DFILE(NB+1,:),'HD')    % stochastic volatility 
load(DFILE(NB+1,:),'VD')    % standard deviations of innovations to log volatility  
load(DFILE(NB+1,:),'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol

randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
SQ = zeros(NQ,NQ,(NF-NB)*P);
SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
FH        = 5;  % forecast horizon 
TH        = ND1; % predictive forecast 
SAF= zeros(NK,FH,(NF-NB)*P);

SHF= zeros(FH,NH,(NF-NB)*P);
YYF= zeros(ND2,FH,(NF-NB)*P); 

clear SD QD HD VD CD 
for i = NB+2:NF,
    j = i - NB; 
    load(DFILE(i,:),'SD')
    load(DFILE(NB+1,:),'QD')   
    load(DFILE(NB+1,:),'HD')    
    load(DFILE(NB+1,:),'VD')    
    load(DFILE(NB+1,:),'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);


% Trend Consumption

mm  = zeros(N,T);
gc = zeros(T,NMC);
mgc=zeros(NMC,1);
gd = zeros(T,NMC); 
mgd = zeros(NMC,1); 
pd = zeros(T,NMC); 
mpd = zeros(NMC,1); 
rr = zeros(T,NMC); 
mrr = zeros(NMC,1); 


for i = 1:NMC,
    for t = 1:T,
       A = [SA(2:1+N*L,t,i)'; SA(2+(1+N*L):2*(1+N*L),t,i)'; SA(2+2*(1+N*L):3*(1+N*L),t,i)'; SA(2+3*(1+N*L):4*(1+N*L),t,i)'];
       M = inv(eye(N*L) - A)*[SA(1,t,i); SA(2+N*L,t,i); SA(3+2*N*L,t,i);SA(4+3*N*L,t,i)];
       mm(:,t) = M(1:N,:); 
    end
    gc(:,i) = (sgc*mm)';
    mgc(i) = mean(gc(:,i)); 
    gd(:,i) = (sgd*mm)'; 
    mgd(i)=mean(gd(:,i));
    rr(:,i) = (srr*mm)'; 
    mrr(i)=mean(rr(:,i));    
    pd(:,i)= (spd*mm)';
    mpd(i) =mean(pd(:,i)); 
end

ssgc = sort(gc,2);
smgc=median(mgc); 
ssgd = sort(gd,2);
smgd = median(mgd);  
ssrr = sort(rr,2);
smrr = median(mrr);
sspd = sort(pd,2); 
smpd = median(mpd); 

clear core
IQR1 = [ssgc(:,.15*NMC),ssgc(:,.5*NMC),ssgc(:,.85*NMC)];   

IQR2 = [ssgd(:,.15*NMC),ssgd(:,.5*NMC),ssgd(:,.85*NMC)];

IQR3 = [ssrr(:,.15*NMC),ssrr(:,.5*NMC),ssrr(:,.85*NMC)];

IQR4 = [sspd(:,.15*NMC),sspd(:,.5*NMC),sspd(:,.85*NMC)]; 
figure(3);
subplot(2,2,1)
plot(date(:),100*(IQR1(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR1(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR1(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[-2 6])
title('Consumption Growth Trend','Fontsize',14)
axis([1915 2013 -2 6])
set(gca,'Fontsize',14,'YTick',[-2:2:6])  
subplot(2,2,2)
plot(date(:),100*(IQR2(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR2(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR2(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[-16 12])
title('Dividend Growth Trend','Fontsize',14)
axis([1915 2013 -16 12])
set(gca,'Fontsize',14,'YTick',[-16:4:12])
subplot(2,2,3)
plot(date(:),100*(IQR3(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR3(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR3(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[-4 4])
title('Real Interest Rate Trend','Fontsize',14)
axis([1915 2013 -4 4])
set(gca,'Fontsize',14,'YTick',[-4:2:4])
subplot(2,2,4)
plot(date(:),(IQR4(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),(IQR4(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),(IQR4(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[2 6])
title('Log Price-Dividend Ratio Trend','Fontsize',14)
axis([1915 2013 2 6])
set(gca,'Fontsize',14,'YTick',[2:1:6])
print(figure(3),'-dpdf','trendcdrpd.pdf')


