%  This file generates long-run (10 year ahead) forecasts


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation

%clear


NG = 5000; % number of draws from Gibbs sampler per data file %5000
D  = 10; % sampling interval from markov chain (memory constraint, mixing) %20

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% catalog of data files
DFILE(1,:) = ['var101_stab.mat'];
DFILE(2,:) = ['var102_stab.mat'];
DFILE(3,:) = ['var103_stab.mat'];
DFILE(4,:) = ['var104_stab.mat'];
DFILE(5,:) = ['var105_stab.mat'];
DFILE(6,:) = ['var106_stab.mat'];
DFILE(7,:) = ['var107_stab.mat'];
DFILE(8,:) = ['var108_stab.mat'];
DFILE(9,:) = ['var109_stab.mat'];
DFILE(10,:) = ['var110_stab.mat'];
DFILE(11,:) = ['var111_stab.mat'];
DFILE(12,:) = ['var112_stab.mat'];
DFILE(13,:) = ['var113_stab.mat'];
DFILE(14,:) = ['var114_stab.mat'];
DFILE(15,:) = ['var115_stab.mat'];
DFILE(16,:) = ['var116_stab.mat'];
DFILE(17,:) = ['var117_stab.mat'];
DFILE(18,:) = ['var118_stab.mat'];
DFILE(19,:) = ['var119_stab.mat'];
DFILE(20,:) = ['var120_stab.mat'];
NF = size(DFILE,1);
%NF=20;

% variables to be saved
% varname(1,:) = ['SD'];  % states
% varname(2,:) = ['QD'];  % variance of state innovation
% varname(3,:) = ['HD'];  % svol for measurement innovation
% varname(4,:) = ['CD'];  % loadings for measurement innovation variance
% varname(5,:) = ['VD'];  % standard deviation of volatility innovations
% varname(6,:) = ['NP'];  % number of not positive definite matrices in Gibbs1fortran
% varname(7,:) = ['EP'];  % size of epsilon necessary to render the matrix positive definite
% varname(8,:) = ['LD'];  % Cholesky factorization (Lower-Triangular)
% varname(9,:) = ['SS'];  % structural shocks

NB = 10; % burn-in 50K draws. 
DFILE = 'var111_stab.mat'; 
load(DFILE,'SD')    % time-varying parameters
load(DFILE,'QD')    % covariance matrix for innovations to TVPs 
load(DFILE,'HD')    % stochastic volatility 
load(DFILE,'VD')    % standard deviations of innovations to log volatility  
load(DFILE,'CD')    % Cholesky matrix for innovations to equation errors; Take the inverse of this matrix and multiply this by stochastic vol

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L = 1; % VAR lag order 

randn('state',100)

[NK,T,P] = size(SD);
[NQ,NQ,P]= size(QD);
[HT,NH,P]=size(HD);
[NV,P]=size(VD);
[NC,P]=size(CD);
%  FIRST LOAD THE DATA
new_data	= importdata('data_TVPVAR.xlsx');
%% DEFINE VARIABLES
gc	 = new_data.data.data(:,2);	       
gd	 = new_data.data.data(:,3);	
inf	 = new_data.data.data(:,4);  
%yd1  = new_data.data.data(:,5); 
yd10 = new_data.data.data(:,6); 
pd   = new_data.data.data(:,7);
inf_exp = new_data.data.data(:,8);
inf_exp_v = new_data.data.data(:,9);
int_exp = new_data.data.data(:,10);
int_exp_v = new_data.data.data(:,11); 
inf_len = length(find(isnan(inf_exp)==0));
int_len = length(find(isnan(int_exp)==0)); 
inf_start = T-inf_len+1; 
int_start = T-int_len+1; 
inf_exp = inf_exp(end-inf_len+1:end);
inf_exp_v = inf_exp_v(end-inf_len+1:end);
int_exp = int_exp(end-int_len+1:end); 
int_exp_v = int_exp_v(end-int_len+1:end); 
y = [gc, gd, inf, yd10, pd]; % 
data = y(end-T-L+1:end,:); % 
[ND1,ND2]=size(data);

SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
SQ = zeros(NQ,NQ,(NF-NB)*P);
SQ(:,:,1:P) = QD;
SH = zeros(HT,NH,(NF-NB)*P);
SH(:,:,1:P)=HD;
SV = zeros(NV,(NF-NB)*P);
SV(:,1:P)=VD;
SC = zeros(NC,(NF-NB)*P); 
SC(:,1:P)=CD;
 
FH         = 20;  % forecast horizon  
TH         = 102;  % the recent 50 years 
SAF= zeros(NK,FH,(NF-NB)*P);
SAFA = zeros(NK,FH,(NF-NB)*P); 
SHF= zeros(FH,NH,(NF-NB)*P);
YYF= zeros(ND2,FH,(NF-NB)*P); 
YYFA=zeros(ND2,FH,(NF-NB)*P); 
Y50S =zeros(ND2,TH); 
Y25S =zeros(ND2,TH);
Y75S =zeros(ND2,TH); 


rintS=zeros(3,TH); 
clear SD QD HD VD CD 
for i = NB+2:NF
    j = i - NB; 
    DFILE = ['var1' num2str(i,'%02.0f')  '_stab.mat']; 
    load(DFILE,'SD')
    load(DFILE,'QD')   
    load(DFILE,'HD')    
    load(DFILE,'VD')    
    load(DFILE,'CD')        
    SA(:,:,(j-1)*P+1:j*P) = SD;
    SQ(:,:,(j-1)*P+1:j*P) = QD;
    SH(:,:,(j-1)*P+1:j*P) = HD;
    SV(:,(j-1)*P+1:j*P)   = VD;
    SC(:,(j-1)*P+1:j*P)   = CD;
clear SD QD HD VD CD 
end
[NK,T,NMC] = size(SA);

N = ND2; 




sfile =['trend_forecast_average.mat']; 
load(sfile); 

% Conditional forecasts with observed expectations data 

nit = 5000;
crit = 1e-8; 


pstar = ones(NMC,T)/(NMC); 

para0=zeros(2,1); 

infints =zeros(TH,NMC); 
YYS = zeros(N,FH+10,T,NMC);  
 mms = mm;
for kk=inf_start:T


% datasim: model-generated forecasts
% mom    : observed expectations 

options = optimset('TolX',1e-12,'TolFun',1e-12,'Display','final','MaxFunEvals',nit,'MaxIter',nit);  
if kk<int_start 
Hinit = 1e-10;
datasim = [squeeze(mean(YYY(3,1:10,kk,:),2)) ];        % forecast averaged over 10 years 
mom = [inf_exp(kk-inf_start+1)]; 
[c0,FVAL, EXITFLAG]=fminsearch(@dist_exp_mean,para0(1),options,datasim,mom);         
 if EXITFLAG~=1 
  [c0,FVAL, EXITFLAG]=fminunc(@dist_exp_mean,c0,options,datasim,mom);
end 

[l1,l2]=dist_exp_mean(c0,datasim,mom); 
pstar(:,kk) =l2;
else
Hinit = 1e-10*eye(2); 
datasim =[squeeze(mean(YYY(3,1:10,kk,:),2)) squeeze(mean(YYY(4,1:10,kk,:),2)) ];
 mom = [inf_exp(kk-inf_start+1);int_exp(kk-int_start+1)]; 
[c0,FVAL, EXITFLAG]=fminsearch(@dist_exp_mean,para0(1:2),options,datasim,mom);
 if EXITFLAG~=1 
[c0,FVAL, EXITFLAG]=fminunc(@dist_exp_mean,c0,options,datasim,mom);
 end
[l1,l2]=dist_exp_mean(c0,datasim,mom); 
pstar(:,kk) =l2;
end 
index = randsample(NMC,NMC,true,pstar(:,kk));
YYS(:,:,kk,:) = YYY(:,:,kk,index);
mms(:,:,kk) = mm(:,index,kk); 
infints(kk,:) = infint(kk,index);
for jj=1:ND2
 Y50S(jj,kk) = quantile(mean(YYS(jj,11:FH,kk,:),2),0.5); 
 Y25S(jj,kk) = quantile(mean(YYS(jj,11:FH,kk,:),2),0.25);
 Y75S(jj,kk) = quantile(mean(YYS(jj,11:FH,kk,:),2),0.75);
 end
 rintS(1,kk) = quantile(squeeze(mean(YYS(4,11:FH,kk,:),2))-infints(kk,:)',0.5);
 rintS(2,kk) = quantile(squeeze(mean(YYS(4,11:FH,kk,:),2))-infints(kk,:)',0.25); 
 rintS(3,kk) = quantile(squeeze(mean(YYS(4,11:FH,kk,:),2))-infints(kk,:)',0.75); 

end 
date = 1915:2016;
% model implied mean with tilting 

MS50 = zeros(N+1,T); 
MS25 = zeros(N+1,T);
MS75 = zeros(N+1,T);
for kk=1:N+1
    if kk<=N
    for jj=1:T
    MS50(kk,jj) = quantile(mms(kk,:,jj),0.5); 
    MS25(kk,jj) = quantile(mms(kk,:,jj),0.25);
    MS75(kk,jj) = quantile(mms(kk,:,jj),0.75);
    end
    else 
     for jj=1:T   
    MS50(kk,jj) = quantile(mms(4,:,jj)-mm(3,:,jj),0.5); 
    MS25(kk,jj) = quantile(mms(4,:,jj)-mm(3,:,jj),0.25);
    MS75(kk,jj) = quantile(mms(4,:,jj)-mm(3,:,jj),0.75);  
     end
     end
end 

for kk=1:6
figure;
if kk==5 
    fill([date fliplr(date)], [MS75(kk,:) fliplr(MS25(kk,:))],[0.5 0.5 0.5] );
    hold on; 
plot(date,MS50(kk,:),'k',date,MS25(kk,:),'b--',date,MS75(kk,:),'b--','LineWidth',4);     
grid on;
    hold off; 
else
    fill([date fliplr(date)], 100*[MS75(kk,:) fliplr(MS25(kk,:))],[0.5 0.5 0.5]  );
hold on; 
    plot(date,100*MS50(kk,:),'k',date,100*MS25(kk,:),'b--',date,100*MS75(kk,:),'b--','LineWidth',4);     
grid on; 
hold off; 
end
%xlabel('\psi_{b}','Fontsize',14)
ylabel('% percent')
legend('IQR','Median')
xlim([date(1) date(end)])
if kk==1 title('Consumption Growth')
elseif kk==2 title ('Dividend Growth')
elseif kk==3 title ('CPI Inflation')
elseif kk==4 title ('Nominal 10-Year Rate')
elseif kk==5 title ('Log Price-Dividend Ratio')
elseif kk==6 title ('Real 10-Year Rate')
end
end 



Y50S(:,1:inf_start-1)=Y50(1:5,1:inf_start-1); 
Y25S(:,1:inf_start-1)=Y25(1:5,1:inf_start-1); 
Y75S(:,1:inf_start-1)=Y75(1:5,1:inf_start-1); 
rintS(1,1:inf_start-1)=Y50(6,1:inf_start-1); 
rintS(2,1:inf_start-1)=Y25(6,1:inf_start-1); 
rintS(3,1:inf_start-1)=Y75(6,1:inf_start-1); 
Y50S =[Y50S;rintS(1,:)];
Y25S =[Y25S;rintS(2,:)];
Y75S =[Y75S;rintS(3,:)]; 

Y25(1:4,:) = 100*Y25(1:4,:); Y25(6,:) = 100*Y25(6,:); 
Y50(1:4,:) = 100*Y50(1:4,:); Y50(6,:) = 100*Y50(6,:); 
Y75(1:4,:) = 100*Y75(1:4,:); Y75(6,:) = 100*Y75(6,:); 

Y25S(1:4,:) = 100*Y25S(1:4,:); Y25S(6,:) = 100*Y25S(6,:); 
Y50S(1:4,:) = 100*Y50S(1:4,:); Y50S(6,:) = 100*Y50S(6,:); 
Y75S(1:4,:) = 100*Y75S(1:4,:); Y75S(6,:) = 100*Y75S(6,:); 


date2=date(inf_start):date(end); 
figure; 
subplot(2,2,1);  plot(date2,inf_exp,'k','LineWidth',4); 
grid on;
xlabel('year')  
ylabel('% percent')
xlim([date2(1) date2(end)])
title('Mean Forecast of 10-year CPI Inflation: Survey') 

subplot(2,2,2);  plot(date2,inf_exp_v,'k','LineWidth',4); 
grid on;
xlabel('year')  
ylabel('% percent')
xlim([date2(1) date2(end)])
title('Variance of Forecasts of 10-year CPI Inflation: Survey') 
date3 = date(int_start):2016; 


subplot(2,2,3); plot(date3,int_exp,'k','LineWidth',4); 
grid on; 
xlabel('year')
ylabel('% percent')
xlim([date3(1) date3(end)])
title('Mean Forecast of the Average of 10-year Nominal Bond Yield over 10 years: Survey')

subplot(2,2,4);  plot(date3,int_exp_v,'k','LineWidth',4); 
grid on;
xlabel('year')  
ylabel('% percent')
xlim([date3(1) date3(end)])
title('Variance of Forecasts of the Average of 10-year Nominal Bond Yield over 10 years: Survey') 


 figure; 
  real_exp = zeros(length(data)-4,1); 
  for jj=5:length(data)
  real_exp(jj-4) = 100*(data(jj,4)-mean(data(jj-4:jj,3))); 
  end    
  date4 = date(4):2016; 
  plot(date4,real_exp,'k',date4,rmw,'c--',date4, Y50(6,4:end)','bx', date4, Y50S(6,4:end)','r+','LineWidth',4); 
 grid on; 
  xlabel('year')
  ylabel('% percent')
  legend('Ex-post Measure: CEA (2015)','Ex-post Measure: Low-frequency', 'Median Trend: Without Survey', 'Median Trend: With Survey'); 
 xlim([date4(1) date4(end)])
 title('Real 10-year Interest Rate')

figure; 
real_exp = zeros(length(data)-4,1); 
for jj=5:length(data)
real_exp(jj-4) = 100*(data(jj,4)-mean(data(jj-4:jj,3))); 
end    
date4 = date(4):2016; 
plot(date4,real_exp,'k',date4, Y50(6,4:end)','bx', date4, Y50S(6,4:end)','r+','LineWidth',4); 
grid on; 
xlabel('year')
ylabel('% percent')
legend('Ex-post Measure: CEA (2015)', 'Median Trend: Without Survey', 'Median Trend: With Survey'); 
xlim([date4(1) date4(end)])
title('Real 10-year Interest Rate')

sfile =['trend_forecast_tweak_mean.mat']; 
save(sfile,'Y50S','Y75S','Y25S','YYS','infint','rintS'); 

figure;
subplot(2,2,1);
 fill([date2 fliplr(date2)], [Y75(1,inf_start:end) fliplr(Y25(1,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(1,inf_start:end)','k',date2, Y25(1,inf_start:end)','b--', date2,Y75(1,inf_start:end)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('IQR','Median')
xlim([date2(1) date2(end)])
title('Consumption Growth Trend Estimate: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [Y75S(1,inf_start:end) fliplr(Y25S(1,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(1,inf_start:end)','k',date2, Y25S(1,inf_start:end)','b--',date2, Y75S(1,inf_start:end)','b-.','LineWidth',4);
grid on;
    hold off; 
xlabel('year')
legend('IQR','Median')
xlim([date2(1) date2(end)])
title('Consumption Growth Trend Estimate: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [Y75(2,inf_start:end) fliplr(Y25(2,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(2,inf_start:end)','k',date2,Y25(2,inf_start:end)','b--',date2, Y75(2,inf_start:end)','b-.','LineWidth',4);
grid on;
    hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Dividend Growth Trend Estimate: Without Survey Data')

subplot(2,2,4);
fill([date2 fliplr(date2)], [Y75S(2,inf_start:end) fliplr(Y25S(2,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(2,inf_start:end)','k', date2, Y25S(2,inf_start:end)','b--', date2, Y75S(2,inf_start:end)','b-.','LineWidth',4);
grid on;
    hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Dividend Growth Trend Estimate: With Survey Data')

figure;
subplot(2,2,1);
 fill([date2 fliplr(date2)], [Y75(3,inf_start:end) fliplr(Y25(3,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(3,inf_start:end)','k', date2, Y25(3,inf_start:end)','b--', date2, Y75(3,inf_start:end)','b-.','LineWidth',4);
grid on;
    hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('CPI Inflation Trend Estimate: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [Y75S(3,inf_start:end) fliplr(Y25S(3,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(3,inf_start:end)','k', date2, Y25S(3,inf_start:end)','b--', date2, Y75S(3,inf_start:end)','b-.','LineWidth',4);
    hold off; 
grid on;
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('CPI Inflation Trend Estimate: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [Y75(4,inf_start:end) fliplr(Y25(4,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(4,inf_start:end)','k', date2, Y25(4,inf_start:end)','b--', date2, Y75(4,inf_start:end)','b-.','LineWidth',4);
grid on;
   hold off;
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Nominal 10 Year Bond Yield Trend Estimate: Without Survey Data'); 

subplot(2,2,4);
fill([date2 fliplr(date2)], [Y75S(4,inf_start:end) fliplr(Y25S(4,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(4,inf_start:end)','k', date2, Y25S(4,inf_start:end)','b--', date2, Y75S(4,inf_start:end)','b-.','LineWidth',4);
grid on;
    hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Nominal 10 Year Bond Yield Trend Estimate: With Survey Data')

figure;
subplot(2,2,1);
fill([date2 fliplr(date2)], [Y75(5,inf_start:end) fliplr(Y25(5,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(5,inf_start:end)','k', date2, Y25(5,inf_start:end)','b--', date2, Y75(5,inf_start:end)','b-.','LineWidth',4);
grid on;
   hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Price-dividend Ratio Trend Estimate: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [Y75S(5,inf_start:end) fliplr(Y25S(5,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(5,inf_start:end)','k',date2,  Y25S(5,inf_start:end)','b--', date2, Y75S(5,inf_start:end)','b-.','LineWidth',4);
grid on;
   hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Price-dividend Ratio Trend Estimate: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [Y75(6,inf_start:end) fliplr(Y25(6,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50(6,inf_start:end)','k', date2, Y25(6,inf_start:end)','b--', date2, Y75(6,inf_start:end)','b-.','LineWidth',4);
grid on;
  hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Real 10 Year Bond Yield Trend Estimate: Without Survey Data')

subplot(2,2,4);
fill([date2 fliplr(date2)], [Y75S(6,inf_start:end) fliplr(Y25S(6,inf_start:end))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, Y50S(6,inf_start:end)','k',date2,  Y25S(6,inf_start:end)','b--', date2, Y75S(6,inf_start:end)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('IQR' , 'Median')
xlim([date2(1) date2(end)])
title('Real 10 Year Bond Yield Trend Estimate: With Survey Data')


sfile =['trend_forecast_tweak_mean.mat']; 
save(sfile,'Y50S','Y75S','Y25S','YYS','infint','rintS'); 

% Bootstrapping 
nboot = 100; 
skew = zeros(6,T,nboot); 
skews = zeros(6,T,nboot); 
skewt  = zeros(6,T,3);
skewts = zeros(6,T,3);  
skewp  = zeros(6,T);
skewps = zeros(6,T);  

for kk=1:T
  for ii=1:6 
      skewp(ii,kk) = (Y75(ii,kk)+Y25(ii,kk)-2*Y50(ii,kk))/(Y75(ii,kk)-Y25(ii,kk)); 
      skewps(ii,kk) = (Y75S(ii,kk)+Y25S(ii,kk)-2*Y50S(ii,kk))/(Y75S(ii,kk)-Y25S(ii,kk));
  end 
    
    
tic;
for jj=1:nboot 
  
 index = floor(NMC*rand(NMC,1))+1;
 for jjj=1:NMC 
     if index(jjj) >NMC 
         index(jjj) = NMC;
     end 
 end 
 
YYYB = squeeze(YYY(:,:,kk,index));
YYSB = squeeze(YYS(:,:,kk,index)); 
    for i = 1:6  
        if i<6 
           skew(i,kk,jj)=(quantile(mean(YYYB(i,11:FH,:),2),0.75)+quantile(mean(YYYB(i,11:FH,:),2),0.25)-2*quantile(mean(YYYB(i,11:FH,:),2),0.5))/(quantile(mean(YYYB(i,11:FH,:),2),0.75)-quantile(mean(YYYB(i,11:FH,:),2),0.25));  
           skews(i,kk,jj)=(quantile(mean(YYSB(i,11:FH,:),2),0.75)+quantile(mean(YYSB(i,11:FH,:),2),0.25)-2*quantile(mean(YYSB(i,11:FH,:),2),0.5))/(quantile(mean(YYSB(i,11:FH,:),2),0.75)-quantile(mean(YYSB(i,11:FH,:),2),0.25));
        else    
           skew(i,kk,jj)=(quantile(squeeze(mean(YYYB(4,11:FH,:),2))-infint(kk,index)',0.75)+quantile(squeeze(mean(YYYB(4,11:FH,:),2))-infint(kk,index)',0.25)-2*quantile(squeeze(mean(YYYB(4,11:FH,:),2))-infint(kk,index)',0.5))/(quantile(squeeze(mean(YYYB(4,11:FH,:),2))-infint(kk,index)',0.75)-quantile(squeeze(mean(YYYB(4,11:FH,:),2))-infint(kk,index)',0.25)); 
           skews(i,kk,jj)=(quantile(squeeze(mean(YYSB(4,11:FH,:),2))-infints(kk,index)',0.75)+quantile(squeeze(mean(YYSB(4,11:FH,:),2))-infints(kk,index)',0.25)-2*quantile(squeeze(mean(YYSB(4,11:FH,:),2))-infints(kk,index)',0.5))/(quantile(squeeze(mean(YYSB(4,11:FH,:),2))-infints(kk,index)',0.75)-quantile(squeeze(mean(YYSB(4,11:FH,:),2))-infints(kk,index)',0.25));          
        end 
    end 
end
 for jx =1:6   % bias-corrected bootstrap statistics 
   skewt(jx,kk,1) = quantile(skew(jx,kk,:)-mean(skew(jx,kk,:))+skewp(jx,kk),0.95); 
   skewt(jx,kk,2) = quantile(skew(jx,kk,:)-mean(skew(jx,kk,:))+skewp(jx,kk),0.5); 
   skewt(jx,kk,3) = quantile(skew(jx,kk,:)-mean(skew(jx,kk,:))+skewp(jx,kk),0.05); 
   skewts(jx,kk,1) = quantile(skews(jx,kk,:)-mean(skews(jx,kk,:))+skewps(jx,kk),0.95); 
   skewts(jx,kk,2) = quantile(skews(jx,kk,:)-mean(skews(jx,kk,:))+skewps(jx,kk),0.5);
   skewts(jx,kk,3) = quantile(skews(jx,kk,:)-mean(skews(jx,kk,:))+skewps(jx,kk),0.05); 
 end 
toc; 
end 



figure;
subplot(2,2,1);
fill([date2 fliplr(date2)], [skewt(1,inf_start:end,1) fliplr(skewt(1,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(1,inf_start:end,2)','k',date2,  skewt(1,inf_start:end,3)','b--', date2, skewt(1,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Consumption Growth: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [skewts(1,inf_start:end,1) fliplr(skewts(1,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(1,inf_start:end,2)','k',date2,  skewts(1,inf_start:end,3)','b--', date2, skewts(1,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Consumption Growth: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [skewt(2,inf_start:end,1) fliplr(skewt(2,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(2,inf_start:end,2)','k',date2,  skewt(2,inf_start:end,3)','b--', date2, skewt(2,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Dividend Growth: Without Survey Data')

subplot(2,2,4);
fill([date2 fliplr(date2)], [skewts(2,inf_start:end,1) fliplr(skewts(2,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(2,inf_start:end,2)','k',date2,  skewts(2,inf_start:end,3)','b--', date2, skewts(2,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Dividend Growth: With Survey Data')

figure;
subplot(2,2,1);
fill([date2 fliplr(date2)], [skewt(3,inf_start:end,1) fliplr(skewt(3,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(3,inf_start:end,2)','k',date2,  skewt(3,inf_start:end,3)','b--', date2, skewt(3,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for CPI Inflation: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [skewts(3,inf_start:end,1) fliplr(skewts(3,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(3,inf_start:end,2)','k',date2,  skewts(3,inf_start:end,3)','b--', date2, skewts(3,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for CPI Inflation: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [skewt(4,inf_start:end,1) fliplr(skewt(4,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(4,inf_start:end,2)','k',date2,  skewt(4,inf_start:end,3)','b--', date2, skewt(4,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for 10 Year Bond Yield: Without Survey Data')

subplot(2,2,4);
fill([date2 fliplr(date2)], [skewts(4,inf_start:end,1) fliplr(skewts(4,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(4,inf_start:end,2)','k',date2,  skewts(4,inf_start:end,3)','b--', date2, skewts(4,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for 10 Year Bond Yield: With Survey Data')

figure;
subplot(2,2,1);
fill([date2 fliplr(date2)], [skewt(5,inf_start:end,1) fliplr(skewt(5,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(5,inf_start:end,2)','k',date2,  skewt(5,inf_start:end,3)','b--', date2, skewt(5,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Price-dividend Ratio: Without Survey Data')

subplot(2,2,2);
fill([date2 fliplr(date2)], [skewts(5,inf_start:end,1) fliplr(skewts(5,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(5,inf_start:end,2)','k',date2,  skewts(5,inf_start:end,3)','b--', date2, skewts(5,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Price-dividend Ratio: With Survey Data')

subplot(2,2,3);
fill([date2 fliplr(date2)], [skewt(6,inf_start:end,1) fliplr(skewt(6,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewt(6,inf_start:end,2)','k',date2,  skewt(6,inf_start:end,3)','b--', date2, skewt(6,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Real Interest Rate: Without Survey Data')

subplot(2,2,4);
fill([date2 fliplr(date2)], [skewts(6,inf_start:end,1) fliplr(skewts(6,inf_start:end,3))],[0.5 0.5 0.5] );
    hold on; 
plot(date2, skewts(6,inf_start:end,2)','k',date2,  skewts(6,inf_start:end,3)','b--', date2, skewts(6,inf_start:end,1)','b-.','LineWidth',4);
grid on;
 hold off; 
xlabel('year')
legend('90% Band' , 'Median')
xlim([date2(1) date2(end)])
title('Bowley (1920) Measures of Skewness for Real Interest Rate: With Survey Data')


sfile =['trend_forecast_tweak_mean.mat']; 
save(sfile,'Y50S','Y75S','Y25S','YYS','infint','rintS','skew','skews','skewt','skewts','skewp','skewps'); 







