%  This file generates graphs for trend inflation, unemployment, and 10yr bond yield

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% VAR, Core PCE Inflation
clear
NG = 5000; 
N = 3; 
L = 2; 
% selection vectors 
spi = [0 0 1 ];
su =  [0 1 0 ];
sy =  [1 0 0 ];
% catalog of data files
DFILE(1,:) = ['\pce\newcore2\output\var101'];
DFILE(2,:) = ['\pce\newcore2\output\var102'];
DFILE(3,:) = ['\pce\newcore2\output\var103'];
DFILE(4,:) = ['\pce\newcore2\output\var104'];
DFILE(5,:) = ['\pce\newcore2\output\var105'];
DFILE(6,:) = ['\pce\newcore2\output\var106'];
DFILE(7,:) = ['\pce\newcore2\output\var107'];
DFILE(8,:) = ['\pce\newcore2\output\var108'];
DFILE(9,:) = ['\pce\newcore2\output\var109'];
DFILE(10,:) = ['\pce\newcore2\output\var110'];
% DFILE(11,:) = ['\pce\newcore2\output\var111'];
% DFILE(12,:) = ['\pce\newcore2\output\var112'];
% DFILE(13,:) = ['\pce\newcore2\output\var113'];
% DFILE(14,:) = ['\pce\newcore2\output\var114'];
% DFILE(15,:) = ['\pce\newcore2\output\var115'];
% DFILE(16,:) = ['\pce\newcore2\output\var116'];
% DFILE(17,:) = ['\pce\newcore2\output\var117'];
% DFILE(18,:) = ['\pce\newcore2\output\var118'];
% DFILE(19,:) = ['\pce\newcore2\output\var119'];
% DFILE(20,:) = ['\pce\newcore2\output\var120'];
% DFILE(21,:) = ['\pce\newcore2\output\var121'];
% DFILE(22,:) = ['\pce\newcore2\output\var122'];
% DFILE(23,:) = ['\pce\newcore2\output\var123'];
% DFILE(24,:) = ['\pce\newcore2\output\var124'];
% DFILE(25,:) = ['\pce\newcore2\output\var125'];
% DFILE(26,:) = ['\pce\newcore2\output\var126'];
% DFILE(27,:) = ['\pce\newcore2\output\var127'];
% DFILE(28,:) = ['\pce\newcore2\output\var128'];
% DFILE(29,:) = ['\pce\newcore2\output\var129'];
% DFILE(30,:) = ['\pce\newcore2\output\var130'];
% DFILE(31,:) = ['\pce\newcore2\output\var131'];
% DFILE(32,:) = ['\pce\newcore2\output\var132'];
% DFILE(33,:) = ['\pce\newcore2\output\var133'];
% DFILE(34,:) = ['\pce\newcore2\output\var134'];
% DFILE(35,:) = ['\pce\newcore2\output\var135'];
% DFILE(36,:) = ['\pce\newcore2\output\var136'];
% DFILE(37,:) = ['\pce\newcore2\output\var137'];
% DFILE(38,:) = ['\pce\newcore2\output\var138'];
% DFILE(39,:) = ['\pce\newcore2\output\var139'];
% DFILE(40,:) = ['\pce\newcore2\output\var140'];
% DFILE(41,:) = ['\pce\newcore2\output\var141'];
% DFILE(42,:) = ['\pce\newcore2\output\var142'];
% DFILE(43,:) = ['\pce\newcore2\output\var143'];
% DFILE(44,:) = ['\pce\newcore2\output\var144'];
% DFILE(45,:) = ['\pce\newcore2\output\var145'];
% DFILE(46,:) = ['\pce\newcore2\output\var146'];
% DFILE(47,:) = ['\pce\newcore2\output\var147'];
% DFILE(48,:) = ['\pce\newcore2\output\var148'];
% DFILE(49,:) = ['\pce\newcore2\output\var149'];
% DFILE(50,:) = ['\pce\newcore2\output\var150'];



NF = size(DFILE,1);
% load data
load '/data/guest/init_pop/simulate/michael/michael.undirected/Inf_TVP_VAR/Inf_TVP_VAR/data_updated/pcectpidoh.txt' -ascii
PCE = pcectpidoh(:,1);
T1 = 28;
infl1 = log(PCE(2:T1,:)./PCE(1:T1-1,:)); % 1953.Q2-1959.Q4
clear PCE pcectpidoh dp date1 T1
load '/data/guest/init_pop/simulate/michael/michael.undirected/Inf_TVP_VAR/Inf_TVP_VAR/data_updated/pcecoredoh.txt' -ascii
PCEc = pcecoredoh(:,1);
T1 = size(PCEc,1);
infl2 = log(PCEc(2:T1,:)./PCEc(1:T1-1,:)); % 1960.Q1-2010.Q4
clear PCE pcecoredoh dp date1 T1
infl=[infl1;infl2];
load '/data/guest/init_pop/simulate/michael/michael.undirected/Inf_TVP_VAR/Inf_TVP_VAR/data_updated/UNRATEdoh.txt' -ascii
TM = size(UNRATEdoh,1); % monthly
urq = UNRATEdoh(2:3:TM,1)/100; % quarterly is middle month of quarter
lur = .01*log(urq./(1-urq)); % logit transformation
clear UNRATEdoh TM urq 
load '/data/guest/init_pop/simulate/michael/michael.undirected/Inf_TVP_VAR/Inf_TVP_VAR/data_updated/TB10YR.txt' -ascii
TM = size(TB10YR,1); % monthly
p3 = 1 - TB10YR(1:3:TM,1)/400; % 1st month of quarter, price 
y3 = -log(p3); % yield to maturity
clear TB10YR TM TQ p3
y = [y3,lur,infl]; % ordered as in benchmark model for D&V
data=y(end-210:end,:); 
data(:,2)=exp(100*data(:,2))./(1+exp(100*data(:,2))); 
% load SA
NB = 4;
load(DFILE(NB+1,:),'SD')
[NK,T,P] = size(SD);
SA = zeros(NK,T,(NF-NB)*P);
SA(:,:,1:P) = SD;
clear SD
for i = NB+2:NF,
    j = i - NB; 
    load(DFILE(i,:),'SD')
    SA(:,:,(j-1)*P+1:j*P) = SD;
    clear SD
end
[NK,T,NMC] = size(SA);
% core inflation 
S = [eye(N*(L-1)),zeros(N*(L-1),N)]; 
mm  = zeros(N,T);
core = zeros(T,NMC);
mcore=zeros(NMC,1);
unrate = zeros(T,NMC); 
munrate = zeros(NMC,1); 
bndyld = zeros(T,NMC); 
mbndyld = zeros(NMC,1); 
slope_core = zeros(T,NMC);  
for i = 1:NMC,
    for t = 1:T,
       A = [SA(2:1+N*L,t,i)'; SA(2+(1+N*L):2*(1+N*L),t,i)'; SA(2+2*(1+N*L):3*(1+N*L),t,i)'; S];
       M = inv(eye(N*L) - A)*[SA(1,t,i); SA(2+N*L,t,i); SA(3+2*N*L,t,i); zeros(N*(L-1),1)];
       mm(:,t) = M(1:N,:);
       slope_core(t,i)=SA(4+2*(1+N*L),t,i)+SA(7+2*(1+N*L),t,i); 
    end
    core(:,i) = (spi*mm)';
    mcore(i) = mean(core(:,i)); 
    unrate(:,i) = (su*mm)'; 
    unrate(:,i) = exp(100*unrate(:,i))./(1+exp(100*unrate(:,i))); 
    munrate(i)=mean(unrate(:,i));
    bndyld(:,i) = (sy*mm)'; 
    bndyld(:,i) = 1-exp(-bndyld(:,i));
    mbndyld(i)=mean(bndyld(:,i));    
end
clear SA
score = sort(core,2);
smcore=median(mcore); 
scoreu = sort(unrate,2);
smcoreu= quantile(munrate,0.5); 
score3core = sort(slope_core,2); 
sbndyld = sort(bndyld,2);
smbndyld = median(mbndyld,2);
clear core
IQR = [score(:,.15*NMC),score(:,.5*NMC),score(:,.85*NMC)];   
date = 1960 + [0:1:T-1]'/4;
%   figure(3);
%   barg = bar([date(190) date(192)],[0 16]); hold on;
%   set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
%   plot(date(:),400*(IQR(:,1)),'--k','LineWidth',1); hold on;
%   plot(date(:),400*(IQR(:,2)),'-k','LineWidth',1); hold on; 
%   plot(date(:),400*(IQR(:,3)),'--k','LineWidth',1); hold on;
%   set(gca,'YLim',[0 16])
%   title('Trend Inflation: Core PCE','Fontsize',14)
%   axis([1960 2011 0 16])
%   set(gca,'Fontsize',14,'YTick',[0:2:16])  
%   print(figure(3),'-dpdf','figure3a.pdf')     
IQR2 = [scoreu(:,.15*NMC),scoreu(:,.5*NMC),scoreu(:,.85*NMC)];
%   figure(4)
%   barg = bar([date(190) date(192)],[0 16]); hold on;
%   set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
%   plot(date(:),100*(IQR2(:,1)),'--k','LineWidth',1); hold on;
%   plot(date(:),100*(IQR2(:,2)),'-k','LineWidth',1); hold on; 
%   plot(date(:),100*(IQR2(:,3)),'--k','LineWidth',1); hold on;
%   line([date(191) date(191)],[0 16],'Color',[.7 .7 .7])
%   set(gca,'YLim',[0 16])
%   title('Trend Unemployment','Fontsize',14)
%   axis([1960 2011 0 16])
%   set(gca,'Fontsize',14,'YTick',[0:2:16])
%   print(figure(4),'-dpdf','figure4a.pdf')     
IQR3 = [sbndyld(:,.15*NMC),sbndyld(:,.5*NMC),sbndyld(:,.85*NMC)];
%   figure(5)
%   barg = bar([date(190) date(192)],[0 18]); hold on;
%   set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
%   plot(date(:),400*(IQR3(:,1)),'--k','LineWidth',1); hold on;
%   plot(date(:),400*(IQR3(:,2)),'-k','LineWidth',1); hold on; 
%   plot(date(:),400*(IQR3(:,3)),'--k','LineWidth',1); hold on;
%   line([date(191) date(191)],[0 18],'Color',[.7 .7 .7])
%   set(gca,'YLim',[0 18])
%   title('Trend Bond Yield: 10-YR Treasury','Fontsize',14)
%   axis([1960 2011 0 18])
%   set(gca,'Fontsize',14,'YTick',[0:2:18])
%   print(figure(5),'-dpdf','figure5a.pdf')     

figure(29)
subplot(3,1,1)
barg = bar([date(191) date(192)],[-12 16]); hold on;
set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
plot(date(:),400*(IQR(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),400*(IQR(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),400*(IQR(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[0 16])
title('Inflation','Fontsize',14)
axis([1960 2011 0 16])
set(gca,'Fontsize',14,'YTick',[0:4:16])  
subplot(3,1,2)
barg = bar([date(191) date(192)],[0 16]); hold on;
set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
plot(date(:),100*(IQR2(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),100*(IQR2(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),100*(IQR2(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[0 16])
title('Unemployment','Fontsize',14)
axis([1960 2011 0 16])
set(gca,'Fontsize',14,'YTick',[0:4:16])
subplot(3,1,3)
barg = bar([date(191) date(192)],[0 20]); hold on;
set(barg,'FaceColor',[.7 .7 .7],'EdgeColor',[.7 .7 .7])
plot(date(:),400*(IQR3(:,1)),'--k','LineWidth',1); hold on;
plot(date(:),400*(IQR3(:,2)),'-k','LineWidth',1); hold on; 
plot(date(:),400*(IQR3(:,3)),'--k','LineWidth',1); hold on;
set(gca,'YLim',[0 20])
title('10-yr Bond Yield','Fontsize',14)
axis([1960 2011 0 20])
set(gca,'Fontsize',14,'YTick',[0:4:20])
print(figure(3),'-dpdf','trendfigure.pdf')

