% Creat a prior weighting matrix for cross-equation restrictions
% Simulate time-varying parameters from the prior distribution of theta(0) M times and calculate the covariance matrix 

function W = var_weight(S,P,N,L); 


M = 500; 

SS = zeros(length(S),M); 
[s1,s2]= size(SS);
theta0 = zeros(N*L,s2); 
theta1 = zeros(N*L,N*L,s2); 
gA     = zeros(s2,2*(1+N*L));

for jj=1:s2 
    %tic;
	%emax = 2;
	%while emax >= 1
		SS(:,jj) = S + chol(P,'lower')*randn(length(S),1);
		ASS		 = reshape(SS(:,jj),1+N*L,N);
		if L == 1
			theta0(:,jj)	 = ASS(1,:)';
			theta1(:,:,jj)	 = ASS(2:end,:)';
		%	rr 		 = max(abs(eig(theta1(:,:,jj))));
		%	if rr < 1
		%		emax = rr;
		%	end
		else
			theta0(:,jj)	 = [ASS(1,:)'; zeros(N*(L-1),1)];
			theta1(:,:,jj)	 = [ASS(2:end,:)'; eye(N*(L-1)), zeros(N*(L-1),N)];
			%rr 		 = max(abs(eig(theta1(:,:,jj))));
			%if rr < 1
		%		emax = rr;
		%	end
        end
    %end
    %toc;
end 

% Selection Vectors
e1 = zeros(1,N*L);
e2 = e1;
e3 = e1;

e1(1,1) = 1;
e2(1,2) = 1;
e3(1,3) = 1;  

for i=1:s2
	gA(i,1) = e3*(4*eye(N*L)+3*theta1(:,:,i)+2*theta1(:,:,i)^2+theta1(:,:,i)^3)*theta0(:,i)/4;
	gA(i,2:N*L+1) = e3*(theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)/4-e2;   
	gAL0 = (eye(N*L)+theta1(:,:,i)+theta1(:,:,i)^2+theta1(:,:,i)^3+theta1(:,:,i)^4)*theta0(:,i); 
	gAL1 = theta1(:,:,1)^5; 
	for kk=1:34
		gAL0   = theta0(:,i)+theta1(:,:,i)*gAL0; 
		gAL1   = gAL1 + theta1(:,:,i)*gAL1; 
	end 
	gAL0 = gAL0/35;   gAL1 = gAL1/35; 
	gA(i,N*L+2)  = e3*gAL0;
	gA(i,N*L+3:2+2*N*L) = e3*gAL1-e1;  
end 
%W = inv(cov(gA)); 
 W = diag(cov(gA));
% W(N*L+2:2+2*N*L) = (min(W(1:1+N*L))/min(W(N*L+2:2+2*N*L)))*W(N*L+2:2+2*N*L);
 W = diag(1./W);
 