%%%% The procedure for generating dummy observations 
%%%% Generate dummy observations for the prior distribution
%% Input 
%% a : number of equations, b : lag length 
%% c : tuning parameters,   e : mean and standard deviation 
%% Output 
%% re1 : xdummy, re2 : ydummy, re3 : observation 


function [re1,re2,re3]=vprior(a,b,c,e) 

%% Decoding hyperparameters 
ta=c(1); dd=c(2); ww=c(3); lam=c(4);  
dsize=1+(b+ww)*a; 
re1=zeros(dsize,1+a*b);
re2=zeros(dsize,a); 
re3=zeros(3,1); re3(1)=a; 

%% Dummies for the coefficients of the first lag 

sig=e(2,:); sig=diag(sig); re2(2:a+1,:)=ta*sig; re1(2:a+1,2:end)=horzcat(ta*sig,zeros(a,(b-1)*a)); re3(1)=b*a; 

%% Dummies for the coefficients of the remaining lags 
for jj=2:b 
    re1((jj-1)*a+2:jj*a+1,1:jj*a+1)=horzcat(zeros(a,(jj-1)*a+1),ta*sig*(jj^dd));
end
%% Dummies for the covariance matrix of error term  

j=1; 
 while j<=ww 
 re2(re3(1)+(j-1)*a+2:re3(1)+j*a+1,:)=sig; 
 j=j+1; 
 end
re3(2)=re3(1)+ww*a; 

%% Dummies for the coefficients of the constant term : co-persistence prior

lammean=lam*e(1,:); 
re2(1,:)=lammean; 
re1(1,:)=horzcat(lam,repmat(lammean,1,b));
re3(3)=re3(2)+1; 





