% data_tracking.m test 
%%test%%
cd '/data/kc/Tracking_Model/tracking-model'
addpath '/data/kc/Tracking_Model/tracking-model/codes'
clc;
close all;
clear all;
warning('off', 'all');

global junk_nos current_quarter inv_ch_inv_last_q_revision;

% determine whether want to run the program quietly or not
run_quietly='on ';
%run_quietly='off';

% set the current quarter
% format: current_quarter=yyyy.q;
%current_quarter=2018.3; % specify a single quarter
current_quarter=[]; % the program selects the current and last quarter

% enter current outside forecast for government spending--the program takes 
% either total government spending or separate estimates for state/local and federal
% and converts those to total
%f_g_govt_outside=[];
f_g_govt_outside =1.9; % total government spending, if have it; else comment out this line % Macroeocnomic Adviser's latest number 
%f_g_govt_fed_r_outside= ; % outside forecast of federal government spending
%f_g_govt_sl_r_outside= ; % outside forecast of state and local government
%spendingwww

% date for saving
save_date_dummy=2; % save data using today's date
%save_date_dummy=1; % load data from a past date--enter the date into date_to_load in yyyy_mm_dd format
%save_date_dummy=0; % neither load nor save data
%
if save_date_dummy==1;
	% format: date_to_load='yyyy_mm_dd';
	date_to_load='2015_04_30';
end;








%---------------------------------------------------------------------
% Set current path
%---------------------------------------------------------------------
%path1=path;
%% add to current path
%path(path,'/data/kc/j1esk01/data_releases');

%---------------------------------------------------------------------
% Clock and junk numbers
%---------------------------------------------------------------------
date1=clock;
date1=round(date1(1:3));
if date1(3)<10; date_txt_d=['_0',num2str(date1(3))]; else; date_txt_d=['_',num2str(date1(3))]; end;
if date1(2)<10; date_txt_m=['_0',num2str(date1(2))]; else; date_txt_m=['_',num2str(date1(2))]; end;
date_txt=[num2str(date1(1)),date_txt_m,date_txt_d];
date_nos=date1(1)*10000+date1(2)*100+date1(3);
disp('----------------------------------------------------------------------------------');
if save_date_dummy==2 | save_date_dummy==0;
disp(date);
end;
if save_date_dummy==1;
disp('Loading data from a past date:');
disp(datestr([str2num(date_to_load(1:4)),str2num(date_to_load(6:7)),str2num(date_to_load(9:10)),0,0,0],'dd-mmm-yyyy'));
end;
%
% number instead of NaNs
junk_nos=1e10;
%
% run_quietly
if run_quietly=='on '; run_quietly=1; else; run_quietly=0; end;

%---------------------------------------------------------------------
% Save entire output of program
%---------------------------------------------------------------------
archive_qtxt=['data_tracking',num2str(date_txt(5:end))];
diary([archive_qtxt '.txt'])








%---------------------------------------------------------------------
% Set forecast_all_last_q to empty to start
%---------------------------------------------------------------------
forecast_all_last_q=[];
%---------------------------------------------------------------------
% Determine the current quarter, if necessary
%---------------------------------------------------------------------
if isempty(current_quarter); 
	% compute GDP for the current quarter and the previous quarter
	run_last_q_and_this_q=2; 
else; 
	% only working with one quarter that is specified by the user
	run_last_q_and_this_q=1;
	disp('----------------------------------------------------------------------------------');
	disp('----------------------------------------------------------------------------------');
	disp(['Running the tracking model for the current quarter, ',num2str(current_quarter),'.']);
end;
%---------------------------------------------------------------------
% Loop over the number of quarters to run the model
%---------------------------------------------------------------------
for loop_no_last_q_and_this_q=1:run_last_q_and_this_q;
disp('----------------------------------------------------------------------------------');
disp('----------------------------------------------------------------------------------');
%
display_text=1;
if run_last_q_and_this_q==2 & save_date_dummy==2;
	%
	% FAME version
	%	load data_quarterly_all_matlab.txt;
	%	a=data_quarterly_all_matlab(:,1:2);
	% clear data_quarterly_all_matlab;	
	%
	% Haver version
	load /data/kc/Tracking_Model/tracking-model/quarterly.csv;
	a=quarterly;
	clear quarterly;
	%
	aa=zeros(size(a,1),1);
	yr=1900;
	for i1=1:size(a,1);
		if yr==1900 & a(i1,2)==0;
			yr=2000;
		end;
		aa(i1)=yr+a(i1,2)+a(i1,1)/10;
	end;
	q_year=round(aa(i1));
	q_no=round(10*aa(i1))-10*round(aa(i1));
	clear a aa;
	if loop_no_last_q_and_this_q==run_last_q_and_this_q;
		if q_no==4; 
			current_quarter=(q_year+1)+1/10;
		else;
			current_quarter=q_year+(q_no+1)/10;
		end;
		disp(['Running the tracking model for the current quarter, ',num2str(current_quarter),'.']);
		display_text=1;
	else;
		current_quarter=q_year+q_no/10;
		disp(['Running the tracking model for the previous quarter, ',num2str(current_quarter),'.']);
		disp([' Results saved in forecast_all_last_q.']);
		display_text=[];
%		display_text=1;
	end;
	clear q_year q_no;
end;
%












%---------------------------------------------------------------------
% Determine whether using new data or old data
%---------------------------------------------------------------------
if save_date_dummy==1; % load data from a past date
	qtxt=['data_',num2str(date_to_load)];
	run_quietly_temp=run_quietly;
	current_quarter_temp=current_quarter;
	loop_no_last_q_and_this_q_temp=loop_no_last_q_and_this_q;
	run_last_q_and_this_q_temp=run_last_q_and_this_q;
	save_date_dummy_temp=save_date_dummy;
	forecast_all_last_q_temp=forecast_all_last_q;
	display_text_temp=display_text;
	eval(['load ',qtxt,';']);
	run_quietly=run_quietly_temp;
	current_quarter=current_quarter_temp;
	loop_no_last_q_and_this_q=loop_no_last_q_and_this_q_temp;
	run_last_q_and_this_q=run_last_q_and_this_q_temp;
	save_date_dummy=save_date_dummy_temp;
	forecast_all_last_q=forecast_all_last_q_temp;
	display_text=display_text_temp;
	%
	if run_last_q_and_this_q==2
		if loop_no_last_q_and_this_q==1;
			date_q=date_q(1:length(date_q)-1);
			current_quarter=date_q(length(date_q));
			disp(['Running the tracking model for the previous quarter, ',num2str(current_quarter),'.']);
			disp([' Results saved in forecast_all_last_q.']);
			display_text=[];
%			display_text=1;
			no_quarters_for_weights=no_quarters_for_weights-1;
		else;
			current_quarter=date_q(length(date_q));
			disp(['Running the tracking model for the current quarter, ',num2str(current_quarter),'.']);
			display_text=1;			
		end;
	end;
	%
else; % load current data from distfame







%---------------------------------------------------------------------
% Quarterly data
%---------------------------------------------------------------------
if display_text;
disp(' ');
disp('Loading quarterly data.');
end;
%
% If from internet FAME:
%load data_quarterly.csv;
%a=data_quarterly;
%
% If from distfame:
%load data_quarterly_all_matlab.txt;
%a=data_quarterly_all_matlab;
%
% If from Haver:
load /data/kc/Tracking_Model/tracking-model/quarterly.csv;
a=quarterly;

% jbae
load /data/kc/Tracking_Model/tracking-model/quarterly_old.csv;
a_old = quarterly_old;

[row_a, col_a] = size(a);
[row_a_old, col_a_old] = size(a_old);

% start iterating from the third column
counter_q = 0;
for i = 3:col_a
    
    % different number of rows
    if row_a ~= row_a_old
        if a(row_a,i) ~= 1.0000e+10
            counter_q = counter_q + 1;
            quarterly_change_list(counter_q,1) = i;
        end
        

    % same number of rows    
    else 
        if a(row_a,i) ~= a_old(row_a_old,i) || a(row_a - 1,i) ~= a_old(row_a_old - 1,i)
            counter_q = counter_q + 1;
            quarterly_change_list(counter_q,1) = i;
        end
        
    end
    
end


    
    

%
aa=zeros(size(a,1),1);
yr=1900;
for i1=1:size(a,1);
	if yr==1900 & a(i1,2)==0;
		yr=2000;
	end;
	aa(i1)=yr+a(i1,2)+a(i1,1)/10;
end;
a=[aa,a(:,3:size(a,2))];
%
if aa(i1)<current_quarter;
	a=[a;[current_quarter,junk_nos*ones(1,size(a,2)-1)]];
	no_quarters=size(a,1)-1;
	no_quarters_for_weights=no_quarters;
else;
	no_quarters=size(a,1);
	no_quarters_for_weights=no_quarters-1;
end;







% jbae
% Jan 14, 2019 - added: nominal changein private inventories (cipi_n) and real level in private inventories, also
% in the data spreadsheet
data_names=char('date_q','pce','nx','imports','exports','gdp','govt','inv_es','inv_nrstr','inv_bfi','inv_res','inv_ch_inv', ...
	'pcep','pcep_core', ...
	'inv_es_n','inv_es_in_n','inv_es_in','inv_es_ip_n','inv_es_ip','inv_es_ip_software_n','inv_es_ip_software','inv_es_ot_n', ...
	'inv_es_ot','inv_es_tn_n','inv_es_tn','inv_es_tn_air_n','inv_es_tn_air','inv_es_tn_rr_n','inv_es_tn_rr', ...
	'inv_es_tn_sb_n','inv_es_tn_sb','inv_es_tn_mv_n','inv_es_tn_mv','inv_es_tn_autos_n','inv_es_tn_autos','inv_es_tn_lt_n', ...
	'inv_es_tn_lt','inv_es_tn_heavy_n','inv_es_tn_heavy', ...	
	'inv_nrstr_n', 'inv_nrstr_ex_mining_n', 'inv_nrstr_commercial_health_office_n', 'inv_nrstr_mining_n', 'inv_nrstr_man_n', ...
	'inv_nrstr_other_n', 'inv_nrstr_power_comm_n', 'inv_nrstr_commercial_health_office', 'inv_nrstr_mining', 'inv_nrstr_man', ...
	'inv_nrstr_power_comm', 'inv_nrstr_other', 'inv_nrstr_ex_mining', ...	
	'inv_res_n', 'inv_res_eq_n', 'inv_res_struc_n', 'inv_res_struc_other_n', 'inv_res_struc_other_comm_n', ...
	'inv_res_struc_other_dorm_n', 'inv_res_struc_other_improve_n', 'inv_res_struc_other_man_n', 'inv_res_struc_other_used_n', ...
	'inv_res_struc_perm_n', 'inv_res_struc_perm_mult_n', 'inv_res_struc_perm_1fam_n', 'inv_res_struc_other_comm', ...
	'inv_res_struc_other_improve', 'inv_res_struc_perm_1fam', 'inv_res_struc_perm_mult', ...
	'inv_ch_inv_wholesale', 'inv_ch_inv_retail_mv', 'inv_ch_inv_mfg', 'inv_ch_inv_retail', 'inv_ch_inv', ...
	'govt_sl_n', 'govt_sl_cons_n', 'govt_sl_cons_r', 'govt_sl_inv_n', 'govt_sl_inv_r', 'govt_sl_r', 'govt_fed_n', ...
	'govt_fed_df_n', 'govt_fed_df_r', 'govt_fed_nondf_n', 'govt_fed_nondf_cons_n', 'govt_fed_nondf_cons_r', ...
	'govt_fed_nondf_inv_n', 'govt_fed_nondf_inv_r', 'govt_fed_nondf_r', 'govt_fed_cons_n', 'govt_fed_cons_r', 'govt_fed_inv_n', ...
	'govt_fed_inv_r', 'govt_fed_r', 'wages_govt_fed_nondf_n', 'wages_govt_fed_nondf_r', 'govt_n', ...	
	'imports_n', 'imports_goods_n', 'imports_goods_r', 'imports_serv_n', 'imports_serv_r', ...
	'imports_goods_oil_n', 'imports_goods_oil_r', 'imports_goods_exoil_n', 'imports_goods_exoil_r', ...
	'exports_n', 'exports_goods_n', 'exports_goods_r', 'exports_serv_n', 'exports_serv_r', ...
	'inv_bfi_p','inv_es_p','inv_nrstr_p','inv_res_p','inv_ch_inv_n','govt_p','nx_n','imports_p','exports_p', ...
	'gdp_p', 'gdp_n', 'pce_n', 'inv_bfi_n', ...
	'imports_goods_dur_ind_exoil_n', 'imports_goods_nondur_ind_exoil_n', 'imports_goods_cap_exauto_n', ...
	'imports_goods_dur_ind_exoil_p', 'imports_goods_nondur_ind_exoil_p', 'imports_goods_cap_exauto_p', 'imports_goods_exoil_p', ...
	'gdi', 'inv_ipp', 'inv_ipp_n','inv_ipp_rd','inv_ipp_ela','inv_ipp_rd_n','inv_ipp_ela_n','inv_ipp_p', 'cipi_n', 'real_inv_level'...
	);



% jbae 

data_names_q = data_names;
    


    


%
for i1=1:size(a,2);
	eval([data_names(i1,:),'=a(:,',num2str(i1),');']);
end;


% jbae (list for contribution calculation)

% order:
% 1. GDP
% 2. PCE
% 3. Nonres
% 4. Equipment 
% 5. IPP
% 6. Residential
% 7. CIPI
% 8. Exports
% 9. Imports
% 10. Government

gdp_cont = gdp_n(end-1);
pce_cont = pce_n(end-1); 
bfi_cont = inv_bfi_n(end-1);
nonres_cont = inv_nrstr_n(end-1);
equip_cont = inv_es_n(end-1);
ipp_cont = inv_ipp_n(end-1);
res_cont = inv_res_n(end-1);
cipi_cont = cipi_n(end-1);
exports_cont = exports_n(end-1);
imports_cont = imports_n(end-1);
govt_cont = govt_n(end-1);

gdp_cont = gdp_n(end);
pce_cont = pce_n(end); 
bfi_cont = inv_bfi_n(end);
nonres_cont = inv_nrstr_n(end);
equip_cont = inv_es_n(end);
ipp_cont = inv_ipp_n(end);
res_cont = inv_res_n(end);
cipi_cont = cipi_n(end);
exports_cont = exports_n(end);
imports_cont = imports_n(end);
govt_cont = govt_n(end);






% compute annualized growth rates
g_a=junk_nos*ones(size(a));
for i1=2:size(g_a,2);
	for i2=2:size(g_a,1);
		if (a(i2,i1)~=junk_nos & a(i2-1,i1)~=junk_nos);
			g_a(i2,i1)=100*((a(i2,i1)/a(i2-1,i1))^4-1);
		end;
	end;
end;
for i1=2:size(g_a,2);
	eval(['g_',data_names(i1,:),'=g_a(:,',num2str(i1),');']);
end;
% set up table
q_data=zeros(14,no_quarters);
q_data=[date_q,g_gdp,g_pce,g_inv_bfi,g_inv_nrstr,g_inv_es,g_inv_res,inv_ch_inv,nx,g_exports,g_imports,g_govt,g_pcep,g_pcep_core]';
q_data_labels=char('Date','GDP','Personal consumption expenditures','Business fixed investment',...
	'   Structures','   Equipment and software','Residential investment','Change in inventories (level)',...
	'Net exports (level)','   Exports','   Imports','Government purchases',...
	'PCE inflation','Core PCE inflation');

%---------------------------------------------------------------------
% Monthly data
%---------------------------------------------------------------------
if display_text;
disp('Loading monthly data.');
end;
%
% If from internet FAME:
%load data_monthly.csv;
%a=data_monthly;
%
% If from distfame:
%load data_monthly_all_matlab.txt;
%a=data_monthly_all_matlab;
%
% If from Haver:
load /data/kc/Tracking_Model/tracking-model/monthly.csv;
a=monthly;

% jbae
load /data/kc/Tracking_Model/tracking-model/monthly_old.csv;
a_old = monthly_old;

[row_a, col_a] = size(a);
[row_a_old, col_a_old] = size(a_old);

% start iterating from the third column
counter_m = 0;
for i = 3:col_a
    
    % different number of rows
    if row_a ~= row_a_old
        if a(row_a,i) ~= 1.0000e+10 || a(row_a-1,i)~=a_old(row_a_old,i) || a(row_a-2,i)~=a_old(row_a_old-1,i) 
            counter_m = counter_m + 1;
            monthly_change_list(counter_m,1) = i;
        end
        

    % same number of rows    
    else 
        if a(row_a,i) ~= a_old(row_a_old,i) || a(row_a - 1,i) ~= a_old(row_a_old - 1,i) || a(row_a - 2,i) ~= a_old(row_a_old - 2,i) || a(row_a - 3,i) ~= a_old(row_a_old - 3,i) % 3 addded to account for delay in monthly data release
            counter_m = counter_m + 1;
            monthly_change_list(counter_m,1) = i;
        end
        
    end
    
end




%
aa=zeros(size(a,1),1);
yr=1900;
for i1=1:size(a,1);
	if yr==1900 & a(i1,2)==0;
		yr=2000;
	end;
	aa(i1)=yr+a(i1,2)+a(i1,1)/100;
end;
a=[aa,a(:,3:size(a,2))];
a_temp = a;

%
% pad data with 6 junk_nos
pad_nos=6;
a=[a;junk_nos*ones(pad_nos,size(a,2))];







%
data_names=char('date_m', ...
	'pce_nom','pce_nom_goods','pce_nom_goods_dur','pce_real_goods_dur_ex_mv','pce_nom_goods_dur_mv', ...
	'pce_real_goods_dur_mv','pce_real_goods_dur_mv_new','pce_real_goods_dur','pce_nom_goods_nondur','pce_real_goods_nondur','pce_real_goods', ...
	'pce_nom_serv','pce_real_serv','pce_real','pce_real_goods_nondur_fuel','pce_real_goods_nondur_mfuel','dpi_real', ...
	'retail_total','retail_trade','retail_core','retail_ex_mv','retail_software','retail_building_mats', ...
	'retail_mv','retail_food_serv','retail_less_bldg', ...
	'mv_sales','mv_sales_autos','mv_sales_autos_bus','mv_sales_autos_cons','mv_sales_lt','mv_sales_lt_cons','mv_sales_heavy', ...
	'cpi','cpi_core','cpi_ex_energy','cpi_food_bev','cpi_food','cpi_food_nsa','cpi_nsa','cpi_core_nsa', ...
	'cpi_energy','cpi_energy_nsa','cpi_gasoline','cpi_trimmed_mean','cpi_weighted_median', ...
	'cpi_software_nsa','cpi_new_mv','cpi_mv','cpi_food_away_home', ...
	'cpi_housing','cpi_apparel','cpi_transportation','cpi_medical','cpi_commodities', ...
	'cpi_durables','cpi_services','cpi_ex_food','cpi_ex_shelter','cpi_ex_medical', ...	
	'pcepm','pcepm_core','pcepm_trimmed_mean_1mo','pcepm_trimmed_mean_6mo','pcepm_trimmed_mean_1yr', ...
	'pcepm_core_market','pcepm_goods','pcepm_goods_dur','pcepm_goods_nondur', ...
	'pcepm_goods_gas_energy','pcepm_goods_food','pcepm_serv_energy', ...
	'pcepm_food_energy','pcepm_serv','pcepm_market', ...
	'ppi_nsa','ppi','ppi_int_nsa','ppi_int','ppi_crude_nsa','ppi_crude','ppi_core', ...
	'ppi_ex_food','ppi_crude_core','ppi_crude_ex_energy','ppi_cap_equipment', ...
	'ppi_man_nsa','ppi_aircraft_nsa','ppi_repair_const_nsa','ppi_brokerage_fees_nsa', ...
	'ppi_mfg','ppi_mfg_ind_nsa','ppi_consumer_goods','ppi_trans_mv','ppi_constr_inputs', ...
	'ppi_nonres','ppi_industrial_bldg','ppi_warehouse_bldg','ppi_office_bldg', ...
	'ship_dur','ship_nondur', ...
	'ship_cap_goods_nondef','ship_core_cap_goods','ship_fab_metal','ship_machinery', ...
	'ship_machinery_farm','ship_machinery_const','ship_machinery_mining','ship_machinery_ind', ...
	'ship_machinery_metal','ship_machinery_power','ship_machinery_mat','ship_comp','ship_comp_comp', ...
	'ship_comp_comm_nondef','ship_comp_elec','ship_comp_electromed','ship_elec_wiring','ship_elec_equip', ...
	'ship_trans','ship_trans_auto','ship_trans_lt','ship_trans_heavy','ship_trans_mv_parts','ship_trans_air', ...
	'ship_trans_air_def','ship_trans_air_nondef','ship_trans_air_parts_nondef','ship_trans_boats','ship_furn', ...
	'ship_misc_dur','ship_it', ...
	'orders_cap_goods_nondef','orders_core_cap_goods','orders_mfg','orders_mfg_w_unfilled', ...
	'orders_mfg_dur','orders_mfg_nondur','orders_unfilled_mfg', ...
	'sales_total_real','sales_mfg_real','sales_mfg_dur_real','sales_mfg_nondur_real', ...
	'sales_wholesale_real','sales_wholesale_dur_real','sales_wholesale_nondur_real','sales_retail_real','sales_wholesale_software_real', ...	
	'housing_starts','housing_starts_1fam','housing_permits','housing_permits_1fam','housing_ship_mobile', ...
	'house_sales_1fam_ex','house_p_ex_nsa', ...
	'house_month_supply_1fam_ex','house_supply_1fam_ex','house_sales_ex','house_month_supply_ex','house_supply_ex', ...	
	'house_sales_1fam_new','house_p_new_nsa','house_month_supply_1fam_new','house_supply_1fam_new', ...
	'const_put_in_place_res','const_put_in_place_1fam','const_put_in_place_mult','const_nonres', ...
	'const_nonres_amus','const_nonres_commercial','const_nonres_comm','const_nonres_educ','const_nonres_health', ...
	'const_nonres_rel','const_nonres_lodg','const_nonres_man','const_nonres_office','const_nonres_power', ...
	'const_nonres_trans','const_put_in_place_state_local_govt','const_put_in_place_fed_govt','const_put_in_place_total','const_put_in_place_pvt', ...
	'rigs_m_bridge_nsa', ...
	'inv_census_mfg','inv_census_mfg_dur','inv_census_mfg_nondur', ...
	'inv_census_wholesale','inv_census_retail_mv','inv_census_retail','inv_census_retail_exmv', ...
	'ch_inv_bea_wholesale_nonmerchant_real_est','ch_inv_bea_wholesale_real_est','ch_inv_bea_retail_mv_real_est', ...
	'ch_inv_bea_mfg_real_est','ch_inv_bea_retail_real_est', ...
	'inv_bea_total_real','inv_bea_wholesale_merchant_real','inv_bea_retail_mv_real', ...
	'inv_bea_mfg_real','inv_bea_mfg_dur_real','inv_bea_mfg_nondur_real','inv_bea_retail_real', ...
	'fed_expend_ag_nsa','fed_expend_ch_nsa','fed_expend_cr_nsa','fed_expend_df_nsa','fed_expend_en_nsa','fed_expend_es_nsa', ...
	'fed_expend_gg_nsa','fed_expend_he_nsa','fed_expend_hm_nsa','fed_expend_ia_nsa','fed_expend_in_nsa','fed_expend_js_nsa', ...
	'fed_expend_oa_nsa','fed_expend_re_nsa','fed_expend_si_nsa','fed_expend_ss_nsa','fed_expend_tn_nsa','fed_expend_ur_nsa', ...
	'fed_expend_vt_nsa','fed_expend_ys_nsa','fed_expend_nsa','fed_deficit_nsa', ...
	'im_bop','im_goods_bop', ...
	'im_petrol_value_census','im_petrol_volume_nsa','im_petrol_value_nsa','impi_oil_price_per_unit_nsa', ...	
	'im_oil_volume_nsa','im_serv_bop','im_census','im_goods_bop_nsa', ...
	'ex_bop','ex_goods_bop','ex_serv_bop','ex_census', ...
	'nom_broad_dollar_nsa','nom_major_dollar_nsa', ...
	'impi_total_nsa','impi_oil_nsa','impi_exoil_nsa','expi_total_nsa', ...
	'impi_ind_exoil_nsa','impi_cap_nsa', ...
	'unemp','unemp_no','labor_force_no','lfpr', ...
	'weeks_unemp_avg','weeks_unemp_no_u5','weeks_unemp_no_5to14','weeks_unemp_no_15to26','weeks_unemp_no_o15','initial_claims_m', ...
	'payrolls_total_nonfarm','payrolls_mining','payrolls_mining_nr','payrolls_constr', ...
	'payrolls_total_private','payrolls_mfg','payrolls_mfg_dur','payrolls_mfg_nondur','payrolls_goods', ...
	'payrolls_serv','payrolls_private_services','payrolls_govt','payrolls_local_govt', ...
	'payrolls_state_govt','payrolls_state_local_govt','payrolls_fed_govt','payrolls_const_hours','payrolls_res_building', ...
	'payrolls_oil_gas','payrolls_trans_wh','payrolls_util','payrolls_retail_trade','payrolls_wholesale_trade', ...
	'payrolls_finance','payrolls_prof_bus_serv','payrolls_educ_health','payrolls_leis_hosp','payrolls_other_serv', ...
	'avghrs_prod_wkrs_tot_pvt','avghrs_prod_wkrs_mfg','avghrs_prod_wkrs_mfg_overtime', ...
	'avghrs_all_tot_pvt','agghrs_index_tot_pvt','hrly_earn_prod_total_pvt', ...	
	'hrly_earn_prod_const','hrly_earn_prod_mfg','hrly_earn_prod_trans','hrly_earn_prod_retail', ...
	'hrly_earn_prod_wholesale','hrly_earn_prod_fin','hrly_earn_prod_prof_bus_serv', ...
	'hrly_earn_prod_educ_health','hrly_earn_prod_other_serv', ...
	'ip','ip_mfg','ip_mining','ip_util','ip_mv','ip_oil_gas','ip_computers', ...
	'ip_total_products','ip_final_products','ip_consumer_goods','ip_consumer_goods_dur', ...
	'ip_consumer_goods_nondur','ip_bus_equip','ip_mat','ip_mat_dur', ...
	'ip_mat_nondur','ip_mfg_naics','ip_mfg_dur','ip_mfg_nondur', ...
	'ip_tot_energy','ip_tot_nonenergy','ip_computers_parts','ip_nonenergy_ex_comp', ...
	'ip_nonenergy_ex_mv_comp', ...
	'cap_util','cap_util_mfg','cap_util_mfg_naics','cap_util_mfg_dur', ...
	'cap_util_mfg_nondur','cap_util_mining','cap_util_util','cap_util_computers_parts','cap_util_mfg_ex_comp', ...
	'weather_cooling_nsa','weather_heating_nsa', ...
	'ism_mfg','ism_mfg_prod','ism_mfg_supdel','ism_mfg_emp','ism_mfg_inv','ism_mfg_imports', ...
	'ism_mfg_orders','ism_mfg_exports','ism_mfg_prices','ism_mfg_custinv','ism_mfg_backlog', ...
	'ism_nonmfg','ism_nonmfg_supdel','ism_nonmfg_emp','ism_nonmfg_inv','ism_nonmfg_imports', ...
	'ism_nonmfg_orders','ism_nonmfg_exports','ism_nonmfg_prices','ism_nonmfg_activity', ...
	'ism_nonmfg_invsent','ism_nonmfg_backlog','ism_nonmfg_comp', ...
	'frbph_headline','frbph_new_orders','frbph_shipments','frbph_inventories', ...
	'frbph_unfilled_orders','frbph_prices_paid','frbph_prices_received', ...
	'frbph_employment','frbph_hours', ...
	'frbch_mfg', ...
	'djia_m','djutil_whole_m','djtotstkmkt_whole_m','nysecomp_whole_m','sp500_whole_m', ...
	'p_oil_whole_m', ...
	'sp500_div_p_ratio_m','sp500_pe_ratio_m', ...
	'dollar_euro_fx_m','swfranc_dollar_fx_m','yen_dollar_fx_m', ...
	'dollar_pound_fx_m','cadollar_dollar_fx_m', ...
	'cp_outstanding_m','cp_fin_30day_rate_whole_m', ...
	'ffr_m','treas_3mo_m','treas_6mo_m','treas_1yr_m','treas_5yr_m', ...
	'treas_7yr_m','treas_10yr_m','corp_bond_aaa_m','corp_bond_baa_m', ...
	'mtg_rate_30yr_m','p_gold_m', ...
	'm1_m','m2_m','monetary_base_m','reserves_total_m','reserves_nonbr_m', ...
	'bank_credit_m','bank_credit_securities_m','bank_credit_securities_treas_m', ...
	'bank_credit_loans_re_m','bank_credit_loans_ci_m','bank_credit_loans_cons_m', ...
 	'consumer_confidence','consumer_sentiment','pce_nom_serv_food','pce_nom_serv_house_util','pce_real_serv_house_util', ...	
 	'pi_res_improvements_q', 'eci_comp_constr','ppi_res_maint_input_nsa', 'pi_house_under_constr_nsa', 'res_improvements_q',...
 	'ahe_contractors','gg_res_improvements_q','gg_pi_res_improvements_q','gg_eci_comp_constr','ppi_res_maint_input_old_nsa','ppi_res_maint_input_combine_nsa',...
	'pi_mf_resid_struc','impi_serv','expi_serv','im_goods_exoil_bop','adv_ex_goods_bop','adv_im_goods_bop', 'drilled_wells_m', 'active_rigs_m',...
	'drilled_wells_m_nsa', 'active_rigs_m_nsa', 'hc_hours_worked', 'hc_earning', 'hc_employment', 'hc_expenditure', ...
    'retail_gasoline_other', 'retail_home_furn_appli', 'retail_recreation', 'retail_apparel', 'retail_food_bev_goods', 'cpi_home_furn_appli', 'cpi_recreation','cpi_gasoline_other',...
    'pce_real_gasoline_other', 'pce_real_home_furn_appli', 'pce_real_recreation', 'pce_real_food_bev', 'pce_real_apparel', 'pce_real_other_dur', 'pce_real_other_nondur',...
    'pce_nom_gasoline_other', 'pce_nom_home_furn_appli', 'pce_nom_recreation', 'pce_nom_food_bev', 'pce_nom_apparel', 'pce_nom_other_dur', 'pce_nom_other_nondur');


% jbae
data_names_m = data_names;


for i1=1:size(a,2);
	eval([data_names(i1,:),'=a(:,',num2str(i1),');']);
end;
% compute growth rates

% Modified by Linmei Amaya, May 15 - Data
% Originally modified April 15 2020 - COVID-19 Fix
% retail_core(1287) = 343260;
% a(1287,21) = 343260;

g_a=fn_compute_g_monthly(a);

%for i1=2:size(g_a,2)-3;
for i1=2:size(g_a,2);
	eval(['g_',data_names(i1,:),'=g_a(:,',num2str(i1),');']);
end;
% fix mv_sales_lt--recompute as mv_sales minus mv_sales_autos
i1=mv_sales~=junk_nos & mv_sales_autos~=junk_nos;
mv_sales_lt(i1)=mv_sales(i1)-mv_sales_autos(i1);
g_mv_sales_lt=fn_compute_g_monthly(mv_sales_lt);
% add entries to end of date_m
for i1=pad_nos-1:-1:0;
	i2=length(date_m)-i1;
	date_m(i2)=date_m(i2-1)+.01;
	dy=round(date_m(i2));
	dm=round(100*date_m(i2))-100*round(date_m(i2));
	if dm==13; date_m(i2)=dy+1+.01; end;
end;               

% make other changes as needed
euro_dollar_fx_m=dollar_euro_fx_m;
euro_dollar_fx_m(dollar_euro_fx_m~=junk_nos)=1./dollar_euro_fx_m(dollar_euro_fx_m~=junk_nos);
pound_dollar_fx_m=dollar_pound_fx_m;
pound_dollar_fx_m(dollar_pound_fx_m~=junk_nos)=1./dollar_pound_fx_m(dollar_pound_fx_m~=junk_nos);

%---------------------------------------------------------------------
% Weekly data
%---------------------------------------------------------------------
if display_text;
disp('Loading weekly data.');
end;
%
% If from Haver:
load /data/kc/Tracking_Model/tracking-model/weekly.csv;
a=weekly;

% jbae 
load /data/kc/Tracking_Model/tracking-model/weekly_old.csv;
a_old = weekly_old;

[row_a, col_a] = size(a);
[row_a_old, col_a_old] = size(a_old);

% start iterating from the third column
counter_w = 0;
for i = 2:col_a
    
    % different number of rows
    if row_a ~= row_a_old
        if a(row_a,i) ~= 1.0000e+10
            counter_w = counter_w + 1;
            weekly_change_list(counter_w,1) = i;
        end
        

    % same number of rows    
    else 
        if a(row_a,i) ~= a_old(row_a_old,i) || a(row_a - 1,i) ~= a_old(row_a_old - 1,i)
            counter_w = counter_w + 1;
            weekly_change_list(counter_w,1) = i;
        end
        
    end
    
end



%
data_names=char('date_w','rigs_w','rigs_gas_w', 'rigs_oil_w', 'rigs_other_w', ...
	'rigs_offshore_oil_w', 'rigs_vertical_w', 'rigs_horizontal_w', 'rigs_directional_w', ...
	'im_oil_eia_w_nsa','initial_claims_w','p_gasoline_w');

% jbae 
data_names_w = data_names;






for i1=1:size(a,2);
	eval([data_names(i1,:),'=a(:,',num2str(i1),');']);
end;
aa=zeros(size(a,1),3);
for i1=1:size(a,1);
	aa(i1,1)=floor(date_w(i1)/10000);
	aa(i1,2)=floor((date_w(i1)-10000*aa(i1,1))/100);
	aa(i1,3)=round(date_w(i1)-10000*aa(i1,1)-100*aa(i1,2));
end;
start_date=aa(1,1)+aa(1,2)/10;
end_date=aa(size(aa,1),1)+aa(size(aa,1),2)/100;
f1=find(date_m==start_date);
f2=find(date_m==end_date);
data_names1=char('junk','rigs_m_nsa','rigs_gas_m_nsa', 'rigs_oil_m_nsa', 'rigs_other_m_nsa', ...
	'rigs_offshore_oil_m_nsa', 'rigs_vertical_m_nsa', 'rigs_horizontal_m_nsa', 'rigs_directional_m_nsa', ...
	'im_oil_eia_wtom_nsa','temp','p_gasoline_m');



a_m=junk_nos*ones(length(date_m),size(data_names1,1));
g_a_m=junk_nos*ones(length(date_m),size(data_names1,1));
for i1=f1:f2;
	dy=round(date_m(i1));
	dm=round(100*date_m(i1))-100*round(date_m(i1));
	ff=find(aa(:,1)==dy & aa(:,2)==dm);
	for i2=2:size(data_names1,1);
		temp1=a(ff,i2);
		temp1=temp1(temp1~=junk_nos);
		if length(temp1)>0;
			a_m(i1,i2)=mean(temp1);
			if a_m(i1-1,i2)~=junk_nos;
				g_a_m(i1,i2)=100*(a_m(i1,i2)/a_m(i1-1,i2)-1);
			end;
		end;
	end;
end;
for i1=2:size(data_names1,1);
	eval([data_names1(i1,:),'=a_m(:,',num2str(i1),');']);
	eval(['g_',data_names1(i1,:),'=g_a_m(:,',num2str(i1),');']);
end;




% seasonally adjust as necessary
a=[ppi_aircraft_nsa,house_p_ex_nsa,house_p_new_nsa,ppi_repair_const_nsa,ppi_brokerage_fees_nsa,...
	ppi_mfg_ind_nsa,nom_broad_dollar_nsa,...
	impi_total_nsa,impi_oil_nsa,impi_exoil_nsa,expi_total_nsa,...
	impi_ind_exoil_nsa,impi_cap_nsa,ppi_man_nsa,fed_expend_nsa,...
	rigs_m_bridge_nsa,cpi_software_nsa,ppi_res_maint_input_nsa,pi_house_under_constr_nsa,ppi_res_maint_input_combine_nsa,...
	drilled_wells_m_nsa, rigs_m_nsa];
data_names=char('ppi_aircraft','house_p_ex','house_p_new','ppi_repair_const','ppi_brokerage_fees',...
	'ppi_mfg_ind','nom_broad_dollar',...
	'impi_total','impi_oil','impi_exoil','expi_total',...
	'impi_ind_exoil','impi_cap','ppi_man','fed_expend_sa',...
	'rigs_m_bridge','cpi_software','ppi_res_maint_input','pi_house_under_constr','ppi_res_maint_input_combine',...
	'drilled_wells_m_sa', 'rigs_m_sa');






for i1=1:size(a,2);
	a(:,i1)=fn_seasonal_adjust(a(:,i1));
end;
weather_cooling=fn_seasonal_adjust(weather_cooling_nsa,'additive');
weather_heating=fn_seasonal_adjust(weather_heating_nsa,'additive');
for i1=1:size(a,2);
	eval([data_names(i1,:),'=a(:,',num2str(i1),');']);
end;
g_a=fn_compute_g_monthly(a);
for i1=1:size(g_a,2);
	eval(['g_',data_names(i1,:),'=g_a(:,',num2str(i1),');']);
end;


%---------------------------------------------------------------------
% Daily data
%---------------------------------------------------------------------
if display_text;
disp('Loading daily data.');
end;
%
% If from Haver:
load /data/kc/Tracking_Model/tracking-model/daily.csv;
a=daily;

% jbae  
load /data/kc/Tracking_Model/tracking-model/daily_old.csv;
a_old = daily_old;

[row_a, col_a] = size(a);
[row_a_old, col_a_old] = size(a_old);

% start iterating from the third column
counter_d = 0;
for i = 2:col_a
    
    % different number of rows
    if row_a ~= row_a_old
        if a(row_a,i) ~= 1.0000e+10
            counter_d = counter_d + 1;
            daily_change_list(counter_d,1) = i;
        end
        

    % same number of rows    
    else 
        if a(row_a,i) ~= a_old(row_a_old,i) || a(row_a - 1,i) ~= a_old(row_a_old - 1,i)
            counter_d = counter_d + 1;
            daily_change_list(counter_d,1) = i;
        end
        
    end
    
end




%
data_names=char('date_d','p_oil_d','p_oil_brent_d','sp500_d');

% jbae 
data_names_d = data_names;


for i1=1:size(a,2);
	eval([data_names(i1,:),'=a(:,',num2str(i1),');']);
end;
aa=zeros(size(a,1),3);
for i1=1:size(a,1);
	aa(i1,1)=floor(date_d(i1)/10000);
	aa(i1,2)=floor((date_d(i1)-10000*aa(i1,1))/100);
	aa(i1,3)=round(date_d(i1)-10000*aa(i1,1)-100*aa(i1,2));
end;
start_date=aa(1,1)+aa(1,2)/100;
end_date=aa(size(aa,1),1)+aa(size(aa,1),2)/100;
f1=find(date_m==start_date);
f2=find(date_m==end_date);
p_oil_m=junk_nos*ones(length(date_m),1);
p_oil_brent_m=junk_nos*ones(length(date_m),1);
for i1=f1:f2;
	dy=round(date_m(i1));
	dm=round(100*date_m(i1))-100*round(date_m(i1));
	ff=find(aa(:,1)==dy & aa(:,2)==dm);
	temp1=p_oil_d(ff);
	temp1=temp1(temp1~=junk_nos);
	if isempty(temp1)==0;
		p_oil_m(i1)=mean(temp1);
	end;
	temp1=p_oil_brent_d(ff);
	temp1=temp1(temp1~=junk_nos);
	if isempty(temp1)==0;
		p_oil_brent_m(i1)=mean(temp1);
	end;
end;

%---------------------------------------------------------------------
% Use oil prices to forecast gasoline prices
%---------------------------------------------------------------------
% use random walk forecast for crude oil prices
f_p_oil_brent_m=p_oil_brent_m;
f1=max(find(p_oil_brent_d~=junk_nos)); % use last daily observation
last_p_oil_brent_d=p_oil_brent_d(f1);
f1=max(find(p_oil_brent_m~=junk_nos));
% for now, just add 1 extra month
f_p_oil_brent_m(f1+1:f1+1)=last_p_oil_brent_d;
% seasonally adjust gasoline price movements
g_p_gasoline_m_sa=junk_nos*ones(length(date_m),1);
g_p_gasoline_errors=g_p_gasoline_m_sa;
s1=min(find(g_p_gasoline_m~=junk_nos));
e1=max(find(g_p_gasoline_m~=junk_nos));
for i1=s1:e1;
	if g_cpi_gasoline(i1)~=junk_nos;
		g_p_gasoline_errors(i1)=g_p_gasoline_m(i1)-g_cpi_gasoline(i1);
	end;
end;
yrs_to_use=3;
for i1=s1+yrs_to_use*12:e1;
	g_p_gasoline_m_sa(i1)=g_p_gasoline_m(i1)-mean(g_p_gasoline_errors([i1-12*[1:yrs_to_use]]));
end;
% form forecasts for gasoline prices; use an error correction model, in which
% 1. p_gasoline_star(t)=a+b*p_oil_brent_m(t)
% 2. (p_gasoline_m(t)-p_gasoline_star(t))=c*(p_gasoline_m(t-1)-p_gasoline_star(t-1))
f_p_gasoline_m=p_gasoline_m;
f_g_p_gasoline_m=g_p_gasoline_m;
no_years=5;
f1=max(find(p_gasoline_m~=junk_nos));
f2=f1-no_years*12+1;
% estimate the first stage regression 
o=ones(no_years*12,1);
b=regress(p_gasoline_m(f2:f1),[o,f_p_oil_brent_m(f2:f1)]);
p_gasoline_star=junk_nos*ones(size(p_gasoline_m));
p_gasoline_star(f2:f1)=[o,f_p_oil_brent_m(f2:f1)]*b;
% estimate the second stage regression
bb=regress(p_gasoline_m(f2+1:f1)-p_gasoline_star(f2+1:f1),p_gasoline_m(f2:f1-1)-p_gasoline_star(f2:f1-1));
% use going forward
for i1=f1+1:max(find(f_p_oil_brent_m~=junk_nos));
	p_gasoline_star(i1)=b'*[1;f_p_oil_brent_m(i1)];
	f_p_gasoline_m(i1)=p_gasoline_star(i1)+bb*(f_p_gasoline_m(i1-1)-p_gasoline_star(i1-1));
	f_g_p_gasoline_m(i1)=100*(f_p_gasoline_m(i1)/f_p_gasoline_m(i1-1)-1);
end;
% seasonally adjust forecasts
f_g_p_gasoline_m_sa=g_p_gasoline_m_sa;
for i1=f1+1:max(find(f_g_p_gasoline_m~=junk_nos));
	f_g_p_gasoline_m_sa(i1)=f_g_p_gasoline_m(i1)-mean(g_p_gasoline_errors([i1-12*[1:yrs_to_use]]));
end;

%---------------------------------------------------------------------
% Last vintage data
%---------------------------------------------------------------------
if display_text;
disp('Loading last vintage data.');
end;
load data_last_vintage;
% update vintages
made_update=0;
% retail sales


f1=max(find(retail_core~=junk_nos));
f2=max(find(retail_core_old~=junk_nos));
f3=max(find(pce_real~=junk_nos));
if f3==f1;
	if f2<f1;
		retail_core_old=retail_core;
		made_update=1;
	end;
end;
% inventories
f1=max(find(inv_bea_retail_real~=junk_nos));
f2=max(find(inv_bea_retail_real_old~=junk_nos));
if f1~=f2; % BEA just updated the data, reset what constitutes old data
	inv_bea_retail_real_old=inv_bea_retail_real;
	inv_bea_retail_mv_real_old=inv_bea_retail_mv_real;
	inv_census_retail_old=inv_census_retail;
	inv_census_retail_mv_old=inv_census_retail_mv;
	inv_census_retail_exmv_old=inv_census_retail_exmv;
	cpi_new_mv_old=cpi_new_mv;
	pcepm_core_old=pcepm_core;
	made_update=1;
end;
f1=max(find(inv_bea_mfg_real~=junk_nos));
f2=max(find(inv_bea_mfg_real_old~=junk_nos));
if f1~=f2; % BEA just updated the data, reset what constitutes old data
	inv_bea_mfg_real_old=inv_bea_mfg_real;
	inv_census_mfg_old=inv_census_mfg;
	inv_census_mfg_dur_old=inv_census_mfg_dur;
	inv_census_mfg_nondur_old=inv_census_mfg_nondur;	
	ppi_cap_equipment_old=ppi_cap_equipment;
	made_update=1;
end;
f1=max(find(inv_bea_wholesale_merchant_real~=junk_nos));
f2=max(find(inv_bea_wholesale_merchant_real_old~=junk_nos));
if f1~=f2; % BEA just updated the data, resest what constitutes old data
	inv_bea_wholesale_merchant_real_old=inv_bea_wholesale_merchant_real;
	inv_census_wholesale_old=inv_census_wholesale;
	pcepm_old=pcepm;
	made_update=1;
end;
%
if made_update==1;
	save data_last_vintage retail_core_old inv_bea_retail_real_old inv_bea_retail_mv_real_old ...
		inv_census_retail_old inv_census_retail_mv_old inv_census_retail_exmv_old cpi_new_mv_old pcepm_core_old ...
		inv_bea_mfg_real_old inv_census_mfg_old inv_census_mfg_dur_old inv_census_mfg_nondur_old ppi_cap_equipment_old ...
		inv_bea_wholesale_merchant_real_old inv_census_wholesale_old pcepm_old;
end;
%

%---------------------------------------------------------------------
% Create factor model data matrix
%---------------------------------------------------------------------
% repeat GDP reading three times to "convert" to monthly
fm_gdp=junk_nos*ones(length(date_m),1);
fm_pce=junk_nos*ones(length(date_m),1);
fm_inv_nrstr = junk_nos*ones(length(date_m),1); 
fm_inv_es  = junk_nos*ones(length(date_m),1);
fm_inv_ipp = junk_nos*ones(length(date_m),1); 
fm_inv_res = junk_nos*ones(length(date_m),1);
fm_ch_inv  = junk_nos*ones(length(date_m),1); 
fm_exports = junk_nos*ones(length(date_m),1); 
fm_imports = junk_nos*ones(length(date_m),1); 
fm_govt    = junk_nos*ones(length(date_m),1); 

date_q_conv=round(date_q)+3*(round(10*(date_q-round(date_q)))/10)/10;
for i1=1:length(date_q);
	if g_gdp(i1)~=junk_nos;        
		i2=find(date_q_conv(i1)==date_m);
		fm_gdp(i2-2:i2)=g_gdp(i1);
	end;
    if g_pce(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_pce(i2-2:i2)=g_pce(i1); 
    end; 
    if g_inv_nrstr(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_inv_nrstr(i2-2:i2)=g_inv_nrstr(i1); 
    end; 
    if g_inv_es(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_inv_es(i2-2:i2)=g_inv_es(i1); 
    end; 
    if g_inv_ipp(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_inv_ipp(i2-2:i2)=g_inv_ipp(i1); 
    end; 
    if g_inv_res(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_inv_res(i2-2:i2)=g_inv_res(i1); 
    end; 
    if inv_ch_inv(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_ch_inv(i2-2:i2)=inv_ch_inv(i1); 
    end; 
    if g_exports(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_exports(i2-2:i2)=g_exports(i1); 
    end; 
    if g_imports(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_imports(i2-2:i2)=g_imports(i1); 
    end;    
    if g_govt(i1)~=junk_nos;
       i2=find(date_q_conv(i1)==date_m); 
       fm_govt(i2-2:i2)=g_govt(i1); 
    end;    
end;
fm_data=[date_m,ip, ip_total_products, ip_final_products, ip_consumer_goods, ip_consumer_goods_dur, ip_consumer_goods_nondur, ip_bus_equip, ...
	ip_mat, ip_mat_dur, ip_mat_nondur, ip_mfg_naics, ip_mfg_dur, ip_mfg_nondur, ip_mining, ip_util, ip_tot_energy, ip_tot_nonenergy, ...
	ip_mv, ip_computers_parts, ip_nonenergy_ex_comp, ip_nonenergy_ex_mv_comp, cap_util, cap_util_mfg_naics, cap_util_mfg_dur, ...
	cap_util_mfg_nondur, cap_util_mining, cap_util_util, cap_util_computers_parts, cap_util_mfg_ex_comp, ism_mfg, ism_mfg_prod, ...
	dpi_real, unemp, lfpr, weeks_unemp_avg, weeks_unemp_no_u5, weeks_unemp_no_5to14, weeks_unemp_no_15to26, weeks_unemp_no_o15, ...
	initial_claims_m, payrolls_total_nonfarm, payrolls_total_private, payrolls_goods, payrolls_mining_nr, payrolls_constr, payrolls_mfg, ...
	payrolls_mfg_dur, payrolls_mfg_nondur, payrolls_serv, payrolls_trans_wh, payrolls_util, payrolls_retail_trade, payrolls_wholesale_trade, ...
	payrolls_finance, payrolls_prof_bus_serv, payrolls_educ_health, payrolls_leis_hosp, payrolls_other_serv, payrolls_govt, ...
	avghrs_prod_wkrs_tot_pvt, avghrs_prod_wkrs_mfg, avghrs_prod_wkrs_mfg_overtime, ism_mfg_emp, sales_total_real, sales_mfg_real, ...
	sales_mfg_dur_real, sales_mfg_nondur_real, sales_wholesale_real, sales_wholesale_dur_real, sales_wholesale_nondur_real, ...
	sales_retail_real, pce_real, pce_real_goods_dur, pce_real_goods_nondur, pce_real_serv, pce_real_goods_dur_mv_new, housing_starts, ...
	housing_permits, house_sales_1fam_new, house_month_supply_1fam_new, house_supply_1fam_new, housing_ship_mobile, const_put_in_place_total, ...
	const_put_in_place_pvt, inv_bea_total_real, inv_bea_mfg_real, inv_bea_mfg_dur_real , inv_bea_mfg_nondur_real, ...
	inv_bea_wholesale_merchant_real, inv_bea_retail_real, ism_mfg_inv, ism_mfg_orders, ism_mfg_supdel, orders_mfg, orders_mfg_w_unfilled, ...
	orders_mfg_dur, orders_mfg_nondur, orders_cap_goods_nondef, orders_unfilled_mfg, nom_major_dollar_nsa, djia_m, sp500_div_p_ratio_m, ...
	sp500_pe_ratio_m, euro_dollar_fx_m, swfranc_dollar_fx_m, yen_dollar_fx_m, pound_dollar_fx_m, cadollar_dollar_fx_m, cp_outstanding_m, ...
	ffr_m, treas_3mo_m, treas_6mo_m, treas_1yr_m, treas_5yr_m, treas_7yr_m, treas_10yr_m, corp_bond_aaa_m, corp_bond_baa_m, ...
	mtg_rate_30yr_m, m1_m, m2_m, monetary_base_m, reserves_total_m, reserves_nonbr_m, bank_credit_m, bank_credit_securities_m, ...
	bank_credit_securities_treas_m, bank_credit_loans_re_m, bank_credit_loans_ci_m, bank_credit_loans_cons_m, ...
	ppi, ppi_core, ppi_consumer_goods, ppi_int, ppi_crude, ppi_ex_food, ppi_crude_core, ...
	ppi_crude_ex_energy, cpi, cpi_food_bev, cpi_housing, cpi_apparel, cpi_transportation, cpi_medical, cpi_commodities, cpi_durables, ...
	cpi_services, cpi_ex_food, cpi_core, cpi_ex_shelter, cpi_ex_medical, p_gold_m, pcepm, pcepm_core, pcepm_goods_dur, pcepm_goods_nondur, ...
	pcepm_serv, hrly_earn_prod_total_pvt, hrly_earn_prod_const, hrly_earn_prod_mfg, hrly_earn_prod_trans, hrly_earn_prod_retail, ...
	hrly_earn_prod_wholesale, hrly_earn_prod_fin, hrly_earn_prod_prof_bus_serv, hrly_earn_prod_educ_health, hrly_earn_prod_other_serv, ...
	ex_census, im_census, im_goods_bop_nsa, consumer_confidence, consumer_sentiment, frbph_headline, frbph_new_orders, frbph_shipments, ...
	frbph_inventories, frbph_unfilled_orders, frbph_prices_paid, frbph_prices_received, frbph_employment, frbph_hours, fed_deficit_nsa, ...
	frbch_mfg, retail_total, orders_core_cap_goods, ship_dur, ship_cap_goods_nondef, ship_core_cap_goods, ship_nondur, retail_trade, ...
	retail_ex_mv, ...
	djtotstkmkt_whole_m, nysecomp_whole_m, djutil_whole_m, sp500_whole_m, p_oil_whole_m, cp_fin_30day_rate_whole_m, ...
	fm_gdp];
i1=find(date_m==1982.01);
fm_data_pce=fm_data; fm_data_inv_nrstr=fm_data; fm_data_inv_es=fm_data; fm_data_inv_ipp=fm_data; fm_data_ch_inv=fm_data; 
fm_data_inv_res = fm_data; fm_data_exports = fm_data; fm_data_imports = fm_data; fm_data_govt = fm_data; 
fm_data_pce(:,end)=fm_pce; fm_data_inv_nrstr(:,end) = fm_inv_nrstr; fm_data_inv_es(:,end)=fm_inv_es; fm_data_inv_ipp(:,end)=fm_inv_ipp; fm_data_inv_res(:,end)=fm_inv_res; 
fm_data_ch_inv(:,end)=fm_ch_inv; fm_data_exports(:,end)=fm_exports; fm_data_imports(:,end)=fm_imports; fm_data_govt(:,end) = fm_govt; 
fm_data=fm_data(i1:size(fm_data,1),:);
fm_data_pce=fm_data_pce(i1:size(fm_data_pce,1),:);
fm_data_inv_nrstr = fm_data_inv_nrstr(i1:size(fm_data_inv_nrstr,1),:); 
fm_data_inv_es  = fm_data_inv_es(i1:size(fm_data_inv_es,1),:);
fm_data_inv_ipp = fm_data_inv_ipp(i1:size(fm_data_inv_ipp,1),:); 
fm_data_inv_res = fm_data_inv_res(i1:size(fm_data_inv_res,1),:); 
fm_data_ch_inv = fm_data_ch_inv(i1:size(fm_data_ch_inv,1),:); 
fm_data_exports = fm_data_exports(i1:size(fm_data_exports,1),:); 
fm_data_imports = fm_data_imports(i1:size(fm_data_imports,1),:);
fm_data_govt    = fm_data_govt(i1:size(fm_data_govt,1),:); 
stop_flag=0;
while stop_flag==0;
	i1=size(fm_data,1);
	temp=fm_data(i1,:)~=junk_nos; 
	if sum(temp)==0;
		fm_data=fm_data(1:i1-1,:);
	    fm_data_pce=fm_data_pce(1:i1-1,:);
        fm_data_inv_nrstr=fm_data_inv_nrstr(1:i1-1,:); 
        fm_data_inv_es = fm_data_inv_es(1:i1-1,:);
        fm_data_inv_ipp = fm_data_inv_ipp(1:i1-1,:); 
        fm_data_inv_res = fm_data_inv_res(1:i1-1,:);
        fm_data_ch_inv  = fm_data_ch_inv(1:i1-1,:);
        fm_data_exports = fm_data_exports(1:i1-1,:);
        fm_data_imports = fm_data_imports(1:i1-1,:);
        fm_data_govt    = fm_data_govt(1:i1-1,:); 
        stop_flag=0;
	else;
		stop_flag=1;
	end;
end;
clear stop_flag;
i1=fm_data==junk_nos;
fm_data(i1)=NaN;
fm_data_pce(i1)=NaN; 
fm_data_inv_nrstr(i1)=NaN;
fm_data_inv_es(i1)=NaN;
fm_data_inv_ipp(i1) = NaN; 
fm_data_inv_res(i1) = NaN;
fm_data_ch_inv(i1) = NaN;
fm_data_exports(i1) = NaN;
fm_data_imports(i1) = NaN;
fm_data_govt(i1)  = NaN; 


%---------------------------------------------------------------------
% Determine whether saving data or not
%---------------------------------------------------------------------
if save_date_dummy==2 & loop_no_last_q_and_this_q==run_last_q_and_this_q; % save data using today's date
	qtxt=['data_',num2str(date_txt)];
	eval(['save ',qtxt,';']);
end;

%---------------------------------------------------------------------
% Determine whether using new data or old data
%---------------------------------------------------------------------
end;











%---------------------------------------------------------------------
% Convert current quarter to months
%---------------------------------------------------------------------
dy=round(current_quarter);
dm=round(10*current_quarter)-10*round(current_quarter);
if dm==1; start_month=dy+.01; end;
if dm==2; start_month=dy+.04; end;
if dm==3; start_month=dy+.07; end;
if dm==4; start_month=dy+.10; end;
ff=find(date_m==start_month);
no_months_total=length(date_m);
junk_nos_m=junk_nos*ones(no_months_total,1);











redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Inflation');
disp('----------------------------------------------------------------------------------');
% display 4 most recent quarterly inflation readings
disp('Most recent quarterly inflation readings, SAAR:');
disp('           Total PCE     Core PCE');
disp(num2str([date_q(no_quarters-3:no_quarters),g_pcep(no_quarters-3:no_quarters),...
	g_pcep_core(no_quarters-3:no_quarters)],'%10.1f %10.2f %13.2f\n'));
end;
% previous PCE price level last quarter
pcepm_last_q=mean(pcepm(ff-3:ff-1));
% previous core PCE price level last quarter
pcepm_core_last_q=mean(pcepm_core(ff-3:ff-1));
% monthly price levels
f_pcepm=pcepm;
f_g_pcepm=g_pcepm;
f_pcepm_core=pcepm_core;
f_g_pcepm_core=g_pcepm_core;

% Modified by Linmei Amaya, April 15th 2020
% Generating f_cpi for total retail sales deflator due to COVID-19
% f_cpi=cpi;
f_cpi_ex_energy=cpi_ex_energy;
f_g_cpi_ex_energy=g_cpi_ex_energy;
f_g_cpi=g_cpi;
f_g_cpi_core=g_cpi_core;
% check to see which data release is most recent: PCEP or CPI
f1=max(find(pcepm~=junk_nos));
f2=max(find(cpi~=junk_nos));
f3=max(find(g_p_gasoline_m_sa~=junk_nos));
if display_text;
% display monthly inflation readings, last 6 months for which have PCE data
disp('Monthly inflation readings, SA (m/m pct. ch.):');
disp('Date       Total CPI  Core CPI  CPI ex energy  ||  Total PCE   Core PCE');
disp(num2str([date_m(f1-5:f2),g_cpi(f1-5:f2),g_cpi_core(f1-5:f2),g_cpi_ex_energy(f1-5:f2),...
		[g_pcepm(f1-5:f1);NaN*ones(f2-f1,1)],[g_pcepm_core(f1-5:f1);NaN*ones(f2-f1,1)]],...
		'%9.2f %10.2f %9.2f %11.2f %16.2f %11.2f\n'));
end;
missing_no_months=3-(f1-ff)-1;
%-------------------------------------------------------------------------------
% for missing CPI ex energy inflation, convert from core and total PCE inflation
%-------------------------------------------------------------------------------
mos_to_use=12;
b_cpi_ex_energy=regress(g_cpi_ex_energy(f1-mos_to_use+1:f1),[ones(mos_to_use,1),g_pcepm(f1-mos_to_use+1:f1),g_pcepm_core(f1-mos_to_use+1:f1)]);
%
%--------------------------
% start with core inflation
%--------------------------
if display_text;
disp('--------------------------------------------');
disp('1. Core inflation.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE inflation data.']);
end;
mos_to_use=12;
b_core_inf=regress(g_pcepm_core(f1-mos_to_use+1:f1),[ones(mos_to_use,1),g_cpi_core(f1-mos_to_use+1:f1)]);
%
%---------------------------------
% case: have one extra CPI reading
%---------------------------------
if f1<f2;
extra_mos=f2-f1;
if display_text;
disp(['Have ',num2str(extra_mos),' more month(s) of core CPI data than core PCE inflation data.']);
disp('CPI readings for the available month(s) would predict:');
end;
for i1=1:extra_mos;
	f_g_pcepm_core(f1+i1)=b_core_inf'*[1;g_cpi_core(f1+i1)];
	if display_text;
	disp(['For ',num2str(date_m(f1+i1),'%7.2f'),', core CPI inflation of ',num2str(g_cpi_core(f1+i1),'%4.2f'),...
		' translates to core PCE inflation of ',num2str(f_g_pcepm_core(f1+i1),'%4.2f'),'.']);
	end;
end;
[f_g_pcepm_core,txt]=fn_make_forecast(f_g_pcepm_core);
if missing_no_months>0;
	if display_text;
	disp(['If use CPI conversions, missing ',num2str(missing_no_months-extra_mos),' month(s) of PCE inflation data.']);
	end;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Use core inflation ',txt,',']);
	disp(['including CPI conversions.']);
	end;
	else;
	disp('Options to fill in missing month(s) for core inflation:');			
	disp(['1. Use core inflation ',txt,', including CPI conversions (default)']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': core PCE inflation = ',num2str(f_g_pcepm_core(i1),'%4.2f')]);
	end;
	disp(['2. Use ',txt,', including CPI conversions, and show range from 6-month max/min']);
	disp('3. Enter data for missing month(s) for core PCE inflation, CPI conversions not automatically accepted');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end;
	if in1==3;
		for i1=f1+1:ff+2;
			f_g_pcepm_core(i1)=input(['Core PCE inflation rate for ',num2str(date_m(i1),'%7.2f'),' = ']);
		end;
	end;
	% if selected case with max and min values from last 6 months
	if in1==2;
		[f_pcepm_core_max_this_q,f_pcepm_core_min_this_q]=fn_max_min_6(pcepm_core,g_pcepm_core,f1,ff);
		f_g_pcepm_core_max_this_q=100*((f_pcepm_core_max_this_q/pcepm_core_last_q)^4-1);
		f_g_pcepm_core_min_this_q=100*((f_pcepm_core_min_this_q/pcepm_core_last_q)^4-1);
		disp(['  Estimated max. core PCE inflation = ',num2str(f_g_pcepm_core_max_this_q,'%4.2f')]);
		disp(['  Estimated min. core PCE inflation = ',num2str(f_g_pcepm_core_min_this_q,'%4.2f')]);		
	end;
end;
end;
%--------------------------------------
% case: monthly PCE reading most recent
%--------------------------------------
if f1>=f2;
[f_g_pcepm_core,txt]=fn_make_forecast(f_g_pcepm_core);
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Use core inflation ',txt,'.']);
	end;
	else;
	disp('Options to fill in missing month(s) for core inflation:');	
	disp(['1. Use core inflation ',txt,' (default).']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': core PCE inflation = ',num2str(f_g_pcepm_core(i1),'%4.2f')]);
	end;
	disp(['2. Use ',txt,' and show range from 6-month max/min.']);
	disp('3. Enter data for missing month(s) for core PCE inflation.');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end;
	if in1==3;
		for i1=f1+1:ff+2;
			f_g_pcepm_core(i1)=input(['Core PCE inflation rate for ',num2str(date_m(i1),'%7.2f'),' = ']);
		end;
	end;
	% if selected case with max and min values from last 6 months
	if in1==2;
		[f_pcepm_core_max_this_q,f_pcepm_core_min_this_q]=fn_max_min_6(pcepm_core,g_pcepm_core,f1,ff);
		f_g_pcepm_core_max_this_q=100*((f_pcepm_core_max_this_q/pcepm_core_last_q)^4-1);
		f_g_pcepm_core_min_this_q=100*((f_pcepm_core_min_this_q/pcepm_core_last_q)^4-1);
		disp(['  Estimated max. core PCE inflation = ',num2str(f_g_pcepm_core_max_this_q,'%4.2f')]);
		disp(['  Estimated min. core PCE inflation = ',num2str(f_g_pcepm_core_min_this_q,'%4.2f')]);		
	end;
end;
end;
%
%---------------------------
% move on to total inflation
%---------------------------
if display_text;
disp('--------------------------------------------');
disp('2. Total (headline) inflation.');
disp(['Missing ',num2str(missing_no_months),' month(s) of total PCE inflation data.']);
end;
mos_to_use=12;
b_total_inf=regress(g_pcepm(f1-mos_to_use+1:f1),[ones(mos_to_use,1),g_cpi(f1-mos_to_use+1:f1)]);
%
% In general, for a missing month will have:
% (1) gasoline prices for the month and neither CPI nor PCEP, but forecasts of core PCEP made earlier; 
% (2) gasoline and CPI for the month and not PCEP, but forecasts of core PCEP made earlier; 
% (3) nothing for the month, but forecasts of core PCEP made earlier.
% For case 1, use gasoline prices, core PCEP forecast, and food forecasts.
% For case 2, use CPI and convert to PCEP.
% For case 3, make univariate forecasts of PCEP based on own past.
%
%---------------------------------------------------------------------
% make forecasts of food prices to pair with gasoline prices as needed
%---------------------------------------------------------------------
f_g_pcepm_goods_food=fn_make_forecast(g_pcepm_goods_food);
%--------------------
% gasoline price data
%--------------------
for i1=1:missing_no_months;
	if g_p_gasoline_m_sa(f1+i1)~=junk_nos;
		if display_text;
		disp(['Have some gasoline data for ',num2str(date_m(f1+i1),'%7.2f\n'),'.']);
		end;
	end;
end;
%---------------------------------
% case: have one extra CPI reading
%---------------------------------
if f1<f2;
extra_mos=f2-f1;
if display_text;
disp(['Have ',num2str(extra_mos),' more month(s) of total CPI data than total PCE inflation data.']);
end;
if display_text;
disp('CPI readings for the available month(s) would predict:');
end;
for i1=1:extra_mos;
	f_g_pcepm(f1+i1)=b_total_inf'*[1;g_cpi(f1+i1)];
	if display_text;
	disp(['For ',num2str(date_m(f1+i1),'%7.2f'),', CPI inflation of ',num2str(g_cpi(f1+i1),'%4.2f'),...
		' translates to PCE inflation of ',num2str(f_g_pcepm(f1+i1),'%4.2f'),'.']);
	end;
end;
mos_to_use=12;
[f_g_pcepm]=fn_make_forecast_pcepm(f_g_pcepm,f_g_p_gasoline_m_sa,f_g_pcepm_core,f_g_pcepm_goods_food,mos_to_use);
if missing_no_months>0;
	if display_text;
	disp(['If use CPI conversions, missing ',num2str(missing_no_months-extra_mos),' month(s) of PCE inflation data.']);
	end;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Use CPI conversions, gasoline prices, core inflation forecasts, and univariate']);
	disp(['forecasts.']);
	end;
	else;
	disp('Options to fill in missing month(s) for headline inflation:');		
	disp(['1. Use CPI conversions, gasoline prices, core inflation forecasts, and univariate forecasts (default).']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': total PCE inflation = ',num2str(f_g_pcepm(i1),'%4.2f')]);
	end;
	disp(['2. Use CPI conversions, gas prices, core inf. forecasts, and univariate forecasts, and show range from 6-month max/min.']);
	disp('3. Enter data for missing month(s) for total PCE inflation, CPI conversions not automatically accepted.');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end
	if in1==3;
		for i1=f1+1:ff+2;
			f_g_pcepm(i1)=input(['Total PCE inflation rate for ',num2str(date_m(i1),'%7.2f'),' = ']);
		end;
	end;
	% if selected case with max and min values from last 6 months
	if in1==2;
		[f_pcepm_max_this_q,f_pcepm_min_this_q]=fn_max_min_6(pcepm,g_pcepm,f1,ff);
		f_g_pcepm_max_this_q=100*((f_pcepm_max_this_q/pcepm_last_q)^4-1);
		f_g_pcepm_min_this_q=100*((f_pcepm_min_this_q/pcepm_last_q)^4-1);
		disp(['  Estimated max. total PCE inflation = ',num2str(f_g_pcepm_max_this_q,'%4.2f')]);
		disp(['  Estimated min. total PCE inflation = ',num2str(f_g_pcepm_min_this_q,'%4.2f')]);		
	end;
end;
end;
%------------------------------------------------
% case: monthly PCE reading just as recent as CPI
%------------------------------------------------
if f1>=f2;
mos_to_use=12;
f_g_pcepm=fn_make_forecast_pcepm(f_g_pcepm,f_g_p_gasoline_m_sa,f_g_pcepm_core,f_g_pcepm_goods_food,mos_to_use);
if missing_no_months>0;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Use gasoline prices, core inflation forecasts, and univariate forecasts.']);
	end;
	else;
	disp('Options to fill in missing month(s) for headline inflation:');		
	disp(['1. Use gasoline prices, core inflation forecasts, and univariate forecasts (default).']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': total PCE inflation = ',num2str(f_g_pcepm(i1),'%4.2f')]);
	end;
	disp(['2. Use gas prices, core inflation forecasts, and univariate forecasts, and show range from 6-month max/min.']);
	disp('3. Enter data for missing month(s) for total PCE inflation.');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end;
	if in1==3;
		for i1=f1+1:ff+2;
			f_g_pcepm(i1)=input(['Total PCE inflation rate for ',num2str(date_m(i1),'%7.2f'),' = ']);
		end;
	end;
	% if selected case with max and min values from last 6 months
	if in1==2;
		[f_pcepm_max_this_q,f_pcepm_min_this_q]=fn_max_min_6(pcepm,g_pcepm,f1,ff);
		f_g_pcepm_max_this_q=100*((f_pcepm_max_this_q/pcepm_last_q)^4-1);
		f_g_pcepm_min_this_q=100*((f_pcepm_min_this_q/pcepm_last_q)^4-1);
		disp(['  Estimated max. total PCE inflation = ',num2str(f_g_pcepm_max_this_q,'%4.2f')]);
		disp(['  Estimated min. total PCE inflation = ',num2str(f_g_pcepm_min_this_q,'%4.2f')]);		
	end;
end;
end;
% Fill in price levels
for i1=f1+1:ff+5;
	f_pcepm_core(i1)=f_pcepm_core(i1-1)*(1+f_g_pcepm_core(i1)/100);
	f_pcepm(i1)=f_pcepm(i1-1)*(1+f_g_pcepm(i1)/100);
end;
% For any cases: fill in missing CPI readings based on choices
for i1=f2+1:ff+5;
	f_g_cpi_ex_energy(i1)=b_cpi_ex_energy'*[1;f_g_pcepm(i1);f_g_pcepm_core(i1)];
	f_cpi_ex_energy(i1)=f_cpi_ex_energy(i1-1)*(1+f_g_cpi_ex_energy(i1)/100);
	f_g_cpi(i1)=(f_g_pcepm(i1)-b_total_inf(1))/b_total_inf(2);
	f_g_cpi_core(i1)=(f_g_pcepm_core(i1)-b_core_inf(1))/b_core_inf(2);
end;
% display forecasts
if display_text & (f1+1<=ff+2);
disp('--------------------------------------------');
disp('Forecasts for monthly inflation readings, SA (m/m pct. ch.):');
disp('Date       Total CPI  Core CPI  CPI ex energy  ||  Total PCE   Core PCE');
disp(num2str([date_m(f1+1:ff+2),f_g_cpi(f1+1:ff+2),f_g_cpi_core(f1+1:ff+2),f_g_cpi_ex_energy(f1+1:ff+2),...
		f_g_pcepm(f1+1:ff+2),f_g_pcepm_core(f1+1:ff+2)],...
		'%9.2f %10.2f %9.2f %11.2f %16.2f %11.2f\n'));
end;
%
[f_pcep_q,f_g_pcep_q,f_pcep_next_q,f_g_pcep_next_q]=fn_convert_mtoqavg(f_pcepm,date_m,date_q);
[f_pcep_core_q,f_g_pcep_core_q,f_pcep_core_next_q,f_g_pcep_core_next_q]=fn_convert_mtoqavg(f_pcepm_core,date_m,date_q);
f_g_pcep_this_q=f_g_pcep_q(find(date_q==current_quarter));
f_g_pcep_core_this_q=f_g_pcep_core_q(find(date_q==current_quarter));
if display_text;
disp('**********************************************************************************');
disp(['Estimated total PCE inflation for ',num2str(current_quarter),', SAAR = ',num2str(f_g_pcep_this_q,'%5.2f')]);
disp(['Estimated core PCE inflation for ',num2str(current_quarter),', SAAR = ',num2str(f_g_pcep_core_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
if run_quietly==0;
	redo2=input('To recompute inflation, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;











redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Consumption');
disp('----------------------------------------------------------------------------------');
end;
% display 4 most recent quarterly consumption growth readings
if display_text;
disp('Most recent quarterly consumption growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_pce(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
end;
% check to see which data release is most recent: monthly PCE, retail 
% sales, industrial production, consumer price index, or vehicle sales
f1=max(find(pce_real~=junk_nos));
f2=max(find(mv_sales~=junk_nos));
f2a=max(find(retail_mv~=junk_nos));
f3=max(find(retail_core~=junk_nos));
f4=max(find(retail_food_serv~=junk_nos));
f4a=max(find(cpi_food_away_home~=junk_nos));
f4b=max(find(ip_util~=junk_nos));
f5=max(find(retail_home_furn_appli~=junk_nos));
f6=max(find(retail_gasoline_other~=junk_nos));
f7=max(find(retail_recreation~=junk_nos));
f8=max(find(retail_food_bev_goods~=junk_nos));
f9=max(find(retail_apparel~=junk_nos));


% display monthly real consumption growth, last 6 months for which have data
if display_text;
disp('Monthly consumption readings, all real, SA (m/m pct. ch.):');
disp('Date       PCE growth    Dur.    Nondur.  Goods(dur+nondur)  Services');
for i1=5:-1:0;
	disp(num2str([date_m(f1-i1),g_pce_real(f1-i1),g_pce_real_goods_dur(f1-i1),g_pce_real_goods_nondur(f1-i1),...
		g_pce_real_goods(f1-i1),g_pce_real_serv(f1-i1)],'%10.2f %10.2f %9.1f %9.1f %13.2f %13.2f\n'));
end;
end;

    

% 2/15/2021 by sungil kim
% 5/10/2022 by sungil kim
% change the share structure, as we reform the consumption part. 
% compute consumption shares
f1a=min(max(find(pce_nom_goods~=junk_nos)),max(find(pce_nom~=junk_nos)));
share_pce_goods=pce_nom_goods(f1a)/pce_nom(f1a);

f1a=min(max(find(pce_nom_goods_dur~=junk_nos)),max(find(pce_nom~=junk_nos)));
share_pce_goods_dur=pce_nom_goods_dur(f1a)/pce_nom_goods(f1a);
f1a=min(max(find(pce_nom_goods_nondur~=junk_nos)),max(find(pce_nom~=junk_nos)));
share_pce_goods_nondur=pce_nom_goods_nondur(f1a)/pce_nom_goods(f1a);

f1a=min(max(find(pce_nom_goods_dur_mv~=junk_nos)),max(find(pce_nom_goods_dur~=junk_nos)));
share_pce_goods_dur_mv=pce_nom_goods_dur_mv(f1a)/pce_nom_goods_dur(f1a);
share_pce_goods_ex_mv=1-share_pce_goods_dur_mv;
f1a=min(max(find(pce_nom_home_furn_appli~=junk_nos)),max(find(pce_nom_goods_dur~=junk_nos)));
share_pce_home_furn_appl=pce_nom_home_furn_appli(f1a)/pce_nom_goods_dur(f1a);
f1a=min(max(find(pce_nom_recreation~=junk_nos)),max(find(pce_nom_goods_dur~=junk_nos)));
share_pce_recreation=pce_nom_recreation(f1a)/pce_nom_goods_dur(f1a);
f1a=min(max(find(pce_nom_other_dur~=junk_nos)),max(find(pce_nom_goods_dur~=junk_nos)));
share_pce_other_dur=pce_nom_other_dur(f1a)/pce_nom_goods_dur(f1a);

f1a=min(max(find(pce_nom_food_bev~=junk_nos)),max(find(pce_nom_goods_nondur~=junk_nos)));
share_pce_food_bev=pce_nom_food_bev(f1a)/pce_nom_goods_nondur(f1a);
f1a=min(max(find(pce_nom_apparel~=junk_nos)),max(find(pce_nom_goods_nondur~=junk_nos)));
share_pce_apparel=pce_nom_apparel(f1a)/pce_nom_goods_nondur(f1a);
f1a=min(max(find(pce_nom_gasoline_other~=junk_nos)),max(find(pce_nom_goods_nondur~=junk_nos)));
share_pce_gasoline_other=pce_nom_gasoline_other(f1a)/pce_nom_goods_nondur(f1a);
f1a=min(max(find(pce_nom_other_nondur~=junk_nos)),max(find(pce_nom_goods_nondur~=junk_nos)));
share_pce_other_nondur=pce_nom_other_nondur(f1a)/pce_nom_goods_nondur(f1a);

f1a=min(max(find(pce_nom_serv~=junk_nos)),max(find(pce_nom~=junk_nos)));
share_pce_serv=pce_nom_serv(f1a)/pce_nom(f1a);
% forecasts for total PCE
f_pce_real=pce_real;
f_g_pce_real=g_pce_real;




% jbae 
% function created (fn_convert_mtoqavg_for_display)

% forecast PCE growth for durables (computed in its own section)
% skim 05/10/2022
% we are not anymore using univariate regression for durable/nondurable goods
% forecast.
%[f_g_pce_real_goods_dur,txt]=fn_make_forecast(g_pce_real_goods_dur);
% f_pce_real_goods_dur=pce_real_goods_dur;
% 
% for i1=f1+1:ff+5
%     f_pce_real_goods_dur(i1)=f_pce_real_goods_dur(i1-1)*(1+f_g_pce_real_goods_dur(i1)/100);
% end
% 
% [f_pce_real_goods_dur_q,f_g_pce_real_goods_dur_q,f_pce_real_goods_dur_next_q,f_g_pce_real_goods_dur_next_q] = fn_convert_mtoqavg_for_display(f_pce_real_goods_dur,date_m,date_q);
% 
% f_g_pce_real_goods_dur_this_q=f_g_pce_real_goods_dur_q(find(date_q==current_quarter));
% 
% % forecast PCE growth for nondurables(computed in its own section)
% [f_g_pce_real_goods_nondur,txt]=fn_make_forecast(g_pce_real_goods_nondur);
% f_pce_real_goods_nondur=pce_real_goods_nondur;
% 
% for i1=f1+1:ff+5
%     f_pce_real_goods_nondur(i1)=f_pce_real_goods_nondur(i1-1)*(1+f_g_pce_real_goods_nondur(i1)/100);
% end
% 
% [f_pce_real_goods_nondur_q, f_g_pce_real_goods_nondur_q,f_pce_real_goods_nondur_next_q,f_g_pce_real_goods_nondur_next_q]=fn_convert_mtoqavg_for_display(f_pce_real_goods_nondur,date_m,date_q);
%                                       
% f_g_pce_real_goods_nondur_this_q=f_g_pce_real_goods_nondur_q(find(date_q==current_quarter));

% forecast PCE growth for services (computed in its own section)
%[f_g_pce_real_serv,txt]=fn_make_forecast(g_pce_real_serv);
%f_pce_real_serv=pce_real_serv;

%[f_pce_real_serv_q, f_g_pce_real_serv_q,f_pce_real_serv_next_q,f_g_pce_real_serv_next_q]=fn_convert_mtoqavg_for_display(f_pce_real_serv,date_m,date_q);
                                      
%f_g_pce_real_serv_this_q=f_g_pce_real_serv_q(find(date_q==current_quarter));



%Sungil Kim Jan 22, 2021
%Modified the reporting content and format. We now report by Durables,
%Non-durables, Services.
%----------------------------------------
% PCE on durable goods
%----------------------------------------
if display_text;
disp('----------------------------------------------------------------------------------');
disp('Consumption: Durable Goods');
disp('----------------------------------------------------------------------------------');
disp('1. Motor vehicles');
end;
missing_no_months=3-(f2-ff)-1;
f_real_retail_mv=junk_nos_m;
f_g_cpi_mv=fn_make_forecast(g_cpi_mv);
f_cpi_mv=cpi_mv;
for i1=f4a+1:ff+5;
	f_cpi_mv(i1)=f_cpi_mv(i1-1)*(1+f_g_cpi_mv(i1)/100);
end;
i1=retail_mv~=junk_nos & f_cpi_mv~=junk_nos;
f_real_retail_mv(i1)=retail_mv(i1)./f_cpi_mv(i1);
f_g_real_retail_mv=fn_compute_g_monthly(f_real_retail_mv);
if display_text;
if f2==f1 | f2>f1 & f2>f2a;
	% display last 6 months of total light vehicles data
	disp('Monthly total light vehicle sales:');
	disp('Date       Level (mil.)  Growth rate (m/m)');
	disp(num2str([date_m(f2-5:f2),mv_sales(f2-5:f2),g_mv_sales(f2-5:f2)],'%13.2f %11.2f %13.1f\n'));
else;
	% display last 6 months of total light vehicles data and motor vehicles retail sales data
	disp('Monthly total light vehicle sales and motor vehicle retail sales:');
	disp('           Total light vehicle sales   ||   Retail sales motor vehicles');
	disp('Date       Level (mil.)  Growth (m/m)  ||   Nom. (m/m)    Real (m/m)');
	disp(num2str([date_m(f2-5:f2),mv_sales(f2-5:f2),g_mv_sales(f2-5:f2),g_retail_mv(f2a-5:f2a),f_g_real_retail_mv(f2a-5:f2a)],...
		'%13.2f %11.2f %13.1f %15.1f %13.1f\n'));
    
end;
end;
%
if f2==f1; % PCE data as recent as motor vehicles data
%
if display_text;
disp('No additional light vehicles data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and light vehicles data.']);
end;
% forecast PCE growth for durables--motor vehicles
[f_g_pce_real_goods_dur_mv,txt]=fn_make_forecast(g_pce_real_goods_dur_mv);
f_pce_real_goods_dur_mv=pce_real_goods_dur_mv;
% translate that to motor vehicles--assume both grow at the same rate
f_mv_sales=mv_sales;
f_g_mv_sales=g_mv_sales;
f_g_mv_sales(f1+1:ff+5)=f_g_pce_real_goods_dur_mv(f1+1:ff+5);
for i1=f1+1:ff+5;
	f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
	f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real motor vehicle durable goods PCE and total']);
	disp(['light vehicles using ',txt,'.'])
	end;
	for i1=f2+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
		end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real motor vehicle durable goods PCE growth rate ',txt,' (default).']);
	for i1=f2+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
	end;	
	disp('2. Enter light vehicle sales levels (mil.) for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f2+1:ff+2;
			f_mv_sales(i1)=input(['Light vehicle sales level (mil.) for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_mv_sales(i1)=100*(f_mv_sales(i1)/f_mv_sales(i1-1)-1);
			f_g_pce_real_goods_dur_mv(i1)=f_g_mv_sales(i1);
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on motor vehicles = ',...
				num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);			
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
	end;
else;
	if display_text;
	disp(['     For ',num2str(date_m(f2),'%7.2f'),': real PCE growth on motor vehicles = ',...
			num2str(f_g_pce_real_goods_dur_mv(f2),'%5.1f')]);
	end;	
end;
%
end;
%
if f2>f1 & f2>f2a; % have motor vehicles data but no retail sales--motor vehicles data
%
if display_text;
disp('Have more recent light vehicles data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of light vehicles data.']);
end;
% fill in missing real PCE--motor vehicles data with available
% readings from light motor vehicles
f_g_pce_real_goods_dur_mv=g_pce_real_goods_dur_mv;
f_g_pce_real_goods_dur_mv(f1+1:f2)=g_mv_sales(f1+1:f2);
f_pce_real_goods_dur_mv=pce_real_goods_dur_mv;
for i1=f1+1:f2;
	f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
end;
% forecast PCE growth for durables--motor vehicles
[f_g_pce_real_goods_dur_mv,txt]=fn_make_forecast(f_g_pce_real_goods_dur_mv);
% translate that to motor vehicles--assume both grow at the same rate
f_mv_sales=mv_sales;
f_g_mv_sales=g_mv_sales;
f_g_mv_sales(f2+1:ff+5)=f_g_pce_real_goods_dur_mv(f2+1:ff+5);
for i1=f2+1:ff+5;
	f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
	f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real motor vehicle durable goods PCE and total']);
	disp(['light vehicles using ',txt,'.'])
	end;
	for i1=f2+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
		end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real motor vehicle durable goods PCE growth rate ',txt,' (default).']);
	for i1=f2+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
	end;	
	disp('2. Enter light vehicle sales levels (mil.) for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f2+1:ff+2;
			f_mv_sales(i1)=input(['Light vehicle sales level (mil.) for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_mv_sales(i1)=100*(f_mv_sales(i1)/f_mv_sales(i1-1)-1);
			f_g_pce_real_goods_dur_mv(i1)=f_g_mv_sales(i1);
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on motor vehicles = ',...
				num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);			
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
	end;
else;
	if display_text;
	disp(['     For ',num2str(date_m(f2),'%7.2f'),': real PCE growth on motor vehicles = ',...
			num2str(f_g_pce_real_goods_dur_mv(f2),'%5.1f')]);
	end;
end;
%
end;
%
if f2>f1 & f2==f2a; % have motor vehicles data and retail sales--motor vehicles data
%
% if for some weird reason have one less CPI reading than retail sales, use nominal 
% growth rate instead of real
if f_g_real_retail_mv(f2a)==junk_nos;
	f_g_real_retail_mv(f2a)=g_retail_mv(f2a);
end;	
if display_text;
disp('Have more recent light vehicles data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of light vehicles data.']);
disp(['Also using data on retail motor vehicle sales for ',num2str(date_m(f2a),'%7.2f')]);
disp(['to inform PCE on motor vehicles in that month.']);
end;
% fill in missing real PCE--motor vehicles data with available
% readings from light motor vehicles and motor vehicles retail sales
f_g_pce_real_goods_dur_mv=g_pce_real_goods_dur_mv;



% delete upon pce release
%f_g_pce_real_goods_dur_mv(f2-1)=0.5*(g_mv_sales(f2-1)+f_g_real_retail_mv(f2-1));



f_g_pce_real_goods_dur_mv(f2)=0.5*(g_mv_sales(f2)+f_g_real_retail_mv(f2));
f_pce_real_goods_dur_mv=pce_real_goods_dur_mv;
for i1=f1+1:f2;
	f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
end;
if display_text;
disp(['     For ',num2str(date_m(f2),'%7.2f'),': real PCE growth on motor vehicles = ',...
	num2str(f_g_pce_real_goods_dur_mv(f2),'%5.1f')]);
end;
% forecast PCE growth for durables--motor vehicles
[f_g_pce_real_goods_dur_mv,txt]=fn_make_forecast(f_g_pce_real_goods_dur_mv);
% translate that to motor vehicles--assume both grow at the same rate
f_mv_sales=mv_sales;
f_g_mv_sales=g_mv_sales;
f_g_mv_sales(f2+1:ff+5)=f_g_pce_real_goods_dur_mv(f2+1:ff+5);
for i1=f2+1:ff+5;
	f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
	f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real motor vehicle durable goods PCE and total']);
	disp(['light vehicles using ',txt,'.'])
	end;
	for i1=f2+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
		end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real motor vehicle durable goods PCE growth rate ',txt,' (default).']);
	for i1=f2+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': light vehicles level (mil.) = ',num2str(f_mv_sales(i1),'%5.1f')]);
		disp(['      and light vehicles growth (assumed to be equal to real PCE growth on']);
		disp(['      motor vehicles) = ',num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);
	end;	
	disp('2. Enter light vehicle sales levels (mil.) for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f2+1:ff+2;
			f_mv_sales(i1)=input(['Light vehicle sales level (mil.) for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_mv_sales(i1)=100*(f_mv_sales(i1)/f_mv_sales(i1-1)-1);
			f_g_pce_real_goods_dur_mv(i1)=f_g_mv_sales(i1);
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on motor vehicles = ',...
				num2str(f_g_pce_real_goods_dur_mv(i1),'%5.1f')]);			
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_mv_sales(i1)=f_mv_sales(i1-1)*(1+f_g_mv_sales(i1)/100);
			f_pce_real_goods_dur_mv(i1)=f_pce_real_goods_dur_mv(i1-1)*(1+f_g_pce_real_goods_dur_mv(i1)/100);
		end;
	end;
end;
end;
%sungilkim
[f_pce_real_goods_dur_mv_q,f_g_pce_real_goods_dur_mv_q,f_pce_real_goods_dur_mv_next_q,...
    f_g_pce_real_goods_dur_mv_next_q]=fn_convert_mtoqavg(f_pce_real_goods_dur_mv,date_m,date_q);
f_g_pce_real_goods_dur_mv_this_q=f_g_pce_real_goods_dur_mv_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on motor vehicles = ',num2str(f_g_pce_real_goods_dur_mv_this_q,'%5.1f')]);
%sungilkim
disp('--------------------------------------------');
disp('2. Furnishings and durable household equipment');
end;
missing_no_months=3-(f5-ff)-1;

f_pce_real_home_furn_appli=pce_real_home_furn_appli;
f_g_pce_real_home_furn_appli=fn_compute_g_monthly(f_pce_real_home_furn_appli);

f_real_retail_home_furn_appli=junk_nos_m;
f_g_cpi_home_furn_appli=fn_make_forecast(g_cpi_home_furn_appli);
f_cpi_home_furn_appli=cpi_home_furn_appli;
for i1=f4a+1:ff+5;
	f_cpi_home_furn_appli(i1)=f_cpi_home_furn_appli(i1-1)*(1+f_g_cpi_home_furn_appli(i1)/100);
end;
i1=retail_home_furn_appli~=junk_nos & f_cpi_home_furn_appli~=junk_nos;
f_real_retail_home_furn_appli(i1)=retail_home_furn_appli(i1)./f_cpi_home_furn_appli(i1);
f_g_real_retail_home_furn_appli=fn_compute_g_monthly(f_real_retail_home_furn_appli);


if display_text;
% display last 6 months of nominal retail sales data
disp('Monthly household furnishings and appliances retail sales:');
disp('Date        Growth rate (m/m)   ');
disp(num2str([date_m(f5-5:f5),g_retail_home_furn_appli(f5-5:f5)],'%10.2f %13.2f\n'));
end;
%
if f1==f5; %pce data as recent as furn and other appl retail sales data
%
if display_text;
disp('No additional furnishings and appliances retail sales data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and furnishings and appliances retail sales data.']);
end;
%forecast PCE growth for home furniture and appliances
[f_g_pce_real_home_furn_appli,txt]=fn_make_forecast_mov_avg(g_pce_real_home_furn_appli);
f_pce_real_home_furn_appli=pce_real_home_furn_appli;
%translate that to retail sales--assume both growh at the same rate
f_retail_home_furn_appli=retail_home_furn_appli;
f_g_retail_home_furn_appli=g_retail_home_furn_appli;
f_g_real_retail_home_furn_appli(f1+1:ff+5)=f_g_pce_real_home_furn_appli(f1+1:ff+5);


for i1=f1+1:ff+5;
	f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
	f_real_retail_home_furn_appli(i1)=f_real_retail_home_furn_appli(i1-1)*(1+f_g_real_retail_home_furn_appli(i1)/100);
	f_retail_home_furn_appli(i1)=f_real_retail_home_furn_appli(i1)*f_cpi_home_furn_appli(i1);
	f_g_retail_home_furn_appli(i1)=100*(f_retail_home_furn_appli(i1)/f_retail_home_furn_appli(i1-1)-1);
end;

if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real PCE on furnishings and durable household equip using']);
	disp([txt,'.'])
	end;
	for i1=f5+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal furnishings and appliances retail sales growth = ',num2str(f_g_retail_home_furn_appli(i1),'%5.1f')]);
		disp(['      and real PCE growth on furnishings and durable household equip = ',num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);			
		end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real PCE on furnishings and durable household equip growth rate ',txt,' (default).']);
	for i1=f5+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal furnishings and appliances retail sales growth = ',num2str(f_g_retail_home_furn_appli(i1),'%5.1f')]);
		disp(['      and real PCE growth on furnishings and durable household equip = ',num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);			
	end;	
	disp('2. Enter nominal growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f5+1:ff+2;
			f_g_retail_home_furn_appli(i1)=input(['Nominal furnishings and appliances retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_retail_home_furn_appli(i1)=f_retail_home_furn_appli(i1-1)*(1+f_g_retail_home_furn_appli(i1)/100);
			f_real_retail_home_furn_appli(i1)=f_retail_home_furn_appli(i1)/f_cpi_home_furn_appli(i1);
			f_g_real_retail_home_furn_appli(i1)=100*(f_real_retail_home_furn_appli(i1)/f_real_retail_home_furn_appli(i1-1)-1);
			f_g_pce_real_home_furn_appli(i1)=f_g_real_retail_home_furn_appli(i1);
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on furnishings and durable household equip = ',...
				num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);				
			f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
		end;
	end;
else;
	if display_text;
	disp(['     For ',num2str(date_m(f5),'%7.2f'),': real PCE growth on furnishings and durable household equip = ',...
			num2str(f_g_pce_real_home_furn_appli(f5),'%5.1f')]);
	end;
end;
%
end;

if f5>f1; % retail sales data more recent than PCE data
%
if display_text;
disp('Have more recent furnishings and appliances retail sales data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of furnishings and appliances retail sales data.']);
end;

% fill in missing real PCE with real retail sales growth
f_g_pce_real_home_furn_appli(f1+1:f5)=f_g_real_retail_home_furn_appli(f1+1:f5);
f_pce_real_home_furn_appli=pce_real_home_furn_appli;
for i1=f1+1:f5;
	f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
end;

[f_g_pce_real_home_furn_appli,txt]=fn_make_forecast_mov_avg(f_g_pce_real_home_furn_appli);

% translate to real retail sales--assume both grow at the same rate--then
% to nominal core retail sales
f_g_real_retail_home_furn_appli(f5+1:ff+5)=f_g_pce_real_home_furn_appli(f5+1:ff+5);
f_retail_home_furn_appli=retail_home_furn_appli;
f_g_retail_home_furn_appli=g_retail_home_furn_appli;
for i1=f1+1:ff+5;
	f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
	f_real_retail_home_furn_appli(i1)=f_real_retail_home_furn_appli(i1-1)*(1+f_g_real_retail_home_furn_appli(i1)/100);
	f_retail_home_furn_appli(i1)=f_real_retail_home_furn_appli(i1)*f_cpi_home_furn_appli(i1);
	f_g_retail_home_furn_appli(i1)=100*(f_retail_home_furn_appli(i1)/f_retail_home_furn_appli(i1-1)-1);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Use implied forecasts for retail sales from real PCE growth rate']);
	disp([txt,'.'])
	end;
	for i1=f5+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal furnishings and appliances retail sales growth = ',num2str(f_g_retail_home_furn_appli(i1),'%5.1f')]);
		disp(['      and real PCE growth on furnishings and durable household equip = ',num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);			
		end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use implied forecasts for retail sales from real PCE growth rate ',txt,' (default).']);
	for i1=f5+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal furnishings and appliances retail sales growth = ',num2str(f_g_retail_home_furn_appli(i1),'%5.1f')]);
		disp(['      and real PCE growth on furnishings and durable household equip = ',num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);			
	end;	
	disp('2. Enter nominal growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f5+1:ff+2;
			f_g_retail_home_furn_appli(i1)=input(['Nominal furnishings and appliances retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_retail_home_furn_appli(i1)=f_retail_home_furn_appli(i1-1)*(1+f_g_retail_home_furn_appli(i1)/100);
			f_real_retail_home_furn_appli(i1)=f_retail_home_furn_appli(i1)/f_cpi_home_furn_appli(i1);
			f_g_real_retail_home_furn_appli(i1)=100*(f_real_retail_home_furn_appli(i1)/f_real_retail_home_furn_appli(i1-1)-1);
			f_g_pce_real_home_furn_appli(i1)=f_g_real_retail_home_furn_appli(i1);
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on furnishings and durable household equip = ',...
				num2str(f_g_pce_real_home_furn_appli(i1),'%5.1f')]);				
			f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_home_furn_appli(i1)=f_pce_real_home_furn_appli(i1-1)*(1+f_g_pce_real_home_furn_appli(i1)/100);
		end;
	end;
else;
	if display_text;
	disp(['     For ',num2str(date_m(f5),'%7.2f'),': real PCE growth on furnishings and durable household equip = ',...
			num2str(f_g_pce_real_home_furn_appli(f5),'%5.1f')]);
	end;
end;
%
end;
  
%sungilkim
[f_pce_real_home_furn_appli_q,f_g_pce_real_home_furn_appli_q,f_pce_real_home_furn_appli_next_q,...
    f_g_pce_real_home_furn_appli_next_q]=fn_convert_mtoqavg(f_pce_real_home_furn_appli,date_m,date_q);
f_g_pce_real_home_furn_appli_this_q=f_g_pce_real_home_furn_appli_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on furnishings and durable household equip = ',num2str(f_g_pce_real_home_furn_appli_this_q,'%5.1f')]);
%sungilkim 

disp('--------------------------------------------');
disp('3. Recreation goods');
end;

missing_no_months=3-(f7-ff)-1;
 
f_pce_real_recreation=pce_real_recreation;
f_g_pce_real_recreation=fn_compute_g_monthly(f_pce_real_recreation);
 
f_real_retail_recreation=junk_nos_m;
f_g_cpi_recreation=fn_make_forecast(g_cpi_recreation);
f_cpi_recreation=cpi_recreation;
for i1=f4a+1:ff+5;
    f_cpi_recreation(i1)=f_cpi_recreation(i1-1)*(1+f_g_cpi_recreation(i1)/100);
end;
i1=retail_recreation~=junk_nos & f_cpi_recreation~=junk_nos;
f_real_retail_recreation(i1)=retail_recreation(i1)./f_cpi_recreation(i1);
f_g_real_retail_recreation=fn_compute_g_monthly(f_real_retail_recreation);
 
 
if display_text;
% display last 6 months of nominal retail sales data
disp('Monthly recreational goods retail sales:');
disp('Date        Growth rate (m/m)');
disp(num2str([date_m(f7-5:f7),g_retail_recreation(f7-5:f7)],'%10.2f %13.2f\n'));
end;
%
if f1==f7; %pce data as recent as recreational goods retail sales data
%
if display_text;
disp('No additional recreational goods retail sales data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and recreational goods retail sales data.']);
end;
%forecast PCE growth for recreational goods
[f_g_pce_real_recreation,txt]=fn_make_forecast_mov_avg(g_pce_real_recreation);
f_pce_real_recreation=pce_real_recreation;
%translate that to retail sales--assume both growh at the same rate
f_retail_recreation=retail_recreation;
f_g_retail_recreation=g_retail_recreation;
f_g_real_retail_recreation(f1+1:ff+5)=f_g_pce_real_recreation(f1+1:ff+5);
 
 
for i1=f1+1:ff+5;
    f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
    f_real_retail_recreation(i1)=f_real_retail_recreation(i1-1)*(1+f_g_real_retail_recreation(i1)/100);
    f_retail_recreation(i1)=f_real_retail_recreation(i1)*f_cpi_recreation(i1);
    f_g_retail_recreation(i1)=100*(f_retail_recreation(i1)/f_retail_recreation(i1-1)-1);
end;
 
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Forecasting missing data on real PCE on recreational goods using']);
    disp([txt,'.'])
    end;
    for i1=f7+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal recreational goods retail sales growth = ',num2str(f_g_retail_recreation(i1),'%5.1f')]);
        disp(['      and real PCE growth on recreational goods = ',num2str(f_g_pce_real_recreation(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use real PCE on recreational goods growth rate ',txt,' (default).']);
    for i1=f7+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal recreational goods retail sales growth = ',num2str(f_g_retail_recreation(i1),'%5.1f')]);
        disp(['      and real PCE growth on recreational goods = ',num2str(f_g_pce_real_recreation(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f7+1:ff+2;
            f_g_retail_recreation(i1)=input(['Nominal recreational goods retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_recreation(i1)=f_retail_recreation(i1-1)*(1+f_g_retail_recreation(i1)/100);
            f_real_retail_recreation(i1)=f_retail_recreation(i1)/f_cpi_recreation(i1);
            f_g_real_retail_recreation(i1)=100*(f_real_retail_recreation(i1)/f_real_retail_recreation(i1-1)-1);
            f_g_pce_real_recreation(i1)=f_g_real_retail_recreation(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on recreational goods = ',...
                num2str(f_g_pce_real_recreation(i1),'%5.1f')]);                
            f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f7),'%7.2f'),': real PCE growth on recreational goods = ',...
            num2str(f_g_pce_real_recreation(f7),'%5.1f')]);
    end;
end;
%
end;
 
if f7>f1; % retail sales data more recent than PCE data
%
if display_text;
disp('Have more recent recreational goods retail sales data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of recreational goods retail sales data.']);
end;
 
% fill in missing real PCE with real retail sales growth
f_g_pce_real_recreation(f1+1:f7)=f_g_real_retail_recreation(f1+1:f7);
f_pce_real_recreation=pce_real_recreation;
for i1=f1+1:f7;
    f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
end;
 
[f_g_pce_real_recreation,txt]=fn_make_forecast_mov_avg(f_g_pce_real_recreation);
 
% translate to real retail sales--assume both grow at the same rate--then
% to nominal core retail sales
f_g_real_retail_recreation(f7+1:ff+5)=f_g_pce_real_recreation(f7+1:ff+5);
f_retail_recreation=retail_recreation;
f_g_retail_recreation=g_retail_recreation;
for i1=f1+1:ff+5;
    f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
    f_real_retail_recreation(i1)=f_real_retail_recreation(i1-1)*(1+f_g_real_retail_recreation(i1)/100);
    f_retail_recreation(i1)=f_real_retail_recreation(i1)*f_cpi_recreation(i1);
    f_g_retail_recreation(i1)=100*(f_retail_recreation(i1)/f_retail_recreation(i1-1)-1);
end;
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Use implied forecasts for retail sales from real PCE growth rate']);
    disp([txt,'.'])
    end;
    for i1=f7+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal recreational goods retail sales growth = ',num2str(f_g_retail_recreation(i1),'%5.1f')]);
        disp(['      and real PCE growth on recreational goods = ',num2str(f_g_pce_real_recreation(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use implied forecasts for retail sales from real PCE growth rate ',txt,' (default).']);
    for i1=f7+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal recreational goods retail sales growth = ',num2str(f_g_retail_recreation(i1),'%5.1f')]);
        disp(['      and real PCE growth on recreational goods = ',num2str(f_g_pce_real_recreation(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f7+1:ff+2;
            f_g_retail_recreation(i1)=input(['Nominal recreational goods retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_recreation(i1)=f_retail_recreation(i1-1)*(1+f_g_retail_recreation(i1)/100);
            f_real_retail_recreation(i1)=f_retail_recreation(i1)/f_cpi_recreation(i1);
            f_g_real_retail_recreation(i1)=100*(f_real_retail_recreation(i1)/f_real_retail_recreation(i1-1)-1);
            f_g_pce_real_recreation(i1)=f_g_real_retail_recreation(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on recreational goods = ',...
                num2str(f_g_pce_real_recreation(i1),'%5.1f')]);                
            f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_recreation(i1)=f_pce_real_recreation(i1-1)*(1+f_g_pce_real_recreation(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f7),'%7.2f'),': real PCE growth on recreational goods = ',...
            num2str(f_g_pce_real_recreation(f7),'%5.1f')]);
    end;
end;
%
end;
  
%sungilkim
[f_pce_real_recreation_q,f_g_pce_real_recreation_q,f_pce_real_recreation_next_q,...
    f_g_pce_real_recreation_next_q]=fn_convert_mtoqavg(f_pce_real_recreation,date_m,date_q);
f_g_pce_real_recreation_this_q=f_g_pce_real_recreation_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on recreational goods = ',num2str(f_g_pce_real_recreation_this_q,'%5.1f')]);
end;

if display_text;
disp('--------------------------------------------');
disp('4. Other Durable Goods');
end;

% forecast PCE growth for other durables
[f_g_pce_real_other_dur,txt]=fn_make_forecast_mov_avg(g_pce_real_other_dur);
f_pce_real_other_dur=pce_real_other_dur;

for i1=f1+1:ff+5
    f_pce_real_other_dur(i1)=f_pce_real_other_dur(i1-1)*(1+f_g_pce_real_other_dur(i1)/100);
end

[f_pce_real_other_dur_q, f_g_pce_real_other_dur_q,f_pce_real_other_dur_next_q,f_g_pce_real_other_dur_next_q]=fn_convert_mtoqavg_for_display(f_pce_real_other_dur,date_m,date_q);
                                      
f_g_pce_real_other_dur_this_q=f_g_pce_real_other_dur_q(find(date_q==current_quarter));

if display_text;
disp(['Estimated quarterly PCE growth on other durable goods = ',num2str(f_g_pce_real_other_dur_this_q,'%5.1f')]);
end;

%----------------------------------------e
% PCE growth for durables
%----------------------------------------
f_g_pce_real_goods_dur=g_pce_real_goods_dur;
f_pce_real_goods_dur=pce_real_goods_dur;
for i1=f1+1:ff+5;
	f_g_pce_real_goods_dur(i1)= share_pce_goods_dur_mv*f_g_pce_real_goods_dur_mv(i1) +share_pce_home_furn_appl*f_g_pce_real_home_furn_appli(i1) +share_pce_recreation*f_g_pce_real_recreation(i1) +share_pce_other_dur*f_g_pce_real_other_dur(i1); 
    f_pce_real_goods_dur(i1)=f_pce_real_goods_dur(i1-1)*(1+f_g_pce_real_goods_dur(i1)/100);
end;

[f_pce_real_goods_dur_q,f_g_pce_real_goods_dur_q,f_pce_real_goods_dur_next_q,f_g_pce_real_goods_dur_next_q]=fn_convert_mtoqavg(f_pce_real_goods_dur,date_m,date_q);
f_g_pce_real_goods_dur_this_q=f_g_pce_real_goods_dur_q(find(date_q==current_quarter));


if display_text;
disp('**********************************************************************************');
disp(['Estimated PCE growth on durable goods for ',num2str(current_quarter),', SAAR = ',num2str(f_g_pce_real_goods_dur_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;

%sungilkim
%----------------------------------------
% PCE on nondurable goods
%----------------------------------------
if display_text;
disp('----------------------------------------------------------------------------------');
disp('Consumption: Nondurable Goods');
disp('----------------------------------------------------------------------------------');
disp('1. Food and beverages');
end;

missing_no_months=3-(f8-ff)-1;
 
f_pce_real_food_bev=pce_real_food_bev;
f_g_pce_real_food_bev=fn_compute_g_monthly(f_pce_real_food_bev);
 
f_real_retail_food_bev_goods=junk_nos_m;
f_g_cpi_food_bev=fn_make_forecast(g_cpi_food_bev);
f_cpi_food_bev=cpi_food_bev;
for i1=f4a+1:ff+5;
    f_cpi_food_bev(i1)=f_cpi_food_bev(i1-1)*(1+f_g_cpi_food_bev(i1)/100);
end;
i1=retail_food_bev_goods~=junk_nos & f_cpi_food_bev~=junk_nos;
f_real_retail_food_bev_goods(i1)=retail_food_bev_goods(i1)./f_cpi_food_bev(i1);
f_g_real_retail_food_bev_goods=fn_compute_g_monthly(f_real_retail_food_bev_goods);
 
 
if display_text;
% display last 6 months of nominal retail sales data
disp('Monthly food and beverage retail sales:');
disp('Date        Growth rate (m/m)');
disp(num2str([date_m(f8-5:f8),g_retail_food_bev_goods(f8-5:f8)],'%10.2f %13.2f\n'));
end;
%
if f1==f8; %pce data as recent as food and beverage retail sales data
%
if display_text;
disp('No additional food and beverage retail sales data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and food and beverage retail sales data.']);
end;
%forecast PCE growth for food and beverage
[f_g_pce_real_food_bev,txt]=fn_make_forecast_mov_avg(g_pce_real_food_bev);
f_pce_real_food_bev=pce_real_food_bev;
%translate that to retail sales--assume both growh at the same rate
f_retail_food_bev_goods=retail_food_bev_goods;
f_g_retail_food_bev_goods=g_retail_food_bev_goods;
f_g_real_retail_food_bev_goods(f1+1:ff+5)=f_g_pce_real_food_bev(f1+1:ff+5);
 
 
for i1=f1+1:ff+5;
    f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
    f_real_retail_food_bev_goods(i1)=f_real_retail_food_bev_goods(i1-1)*(1+f_g_real_retail_food_bev_goods(i1)/100);
    f_retail_food_bev_goods(i1)=f_real_retail_food_bev_goods(i1)*f_cpi_food_bev(i1);
    f_g_retail_food_bev_goods(i1)=100*(f_retail_food_bev_goods(i1)/f_retail_food_bev_goods(i1-1)-1);
end;
 
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Forecasting missing data on real PCE on food and beverage using']);
    disp([txt,'.'])
    end;
    for i1=f8+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal food and beverage retail sales growth = ',num2str(f_g_retail_food_bev_goods(i1),'%5.1f')]);
        disp(['      and real PCE growth on food and beverage = ',num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use real PCE on food and beverage growth rate ',txt,' (default).']);
    for i1=f8+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal food and beverage retail sales growth = ',num2str(f_g_retail_food_bev_goods(i1),'%5.1f')]);
        disp(['      and real PCE growth on food and beverage = ',num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f8+1:ff+2;
            f_g_retail_food_bev_goods(i1)=input(['Nominal food and beverage retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_food_bev_goods(i1)=f_retail_food_bev_goods(i1-1)*(1+f_g_retail_food_bev_goods(i1)/100);
            f_real_retail_food_bev_goods(i1)=f_retail_food_bev_goods(i1)/f_cpi_food_bev(i1);
            f_g_real_retail_food_bev_goods(i1)=100*(f_real_retail_food_bev_goods(i1)/f_real_retail_food_bev_goods(i1-1)-1);
            f_g_pce_real_food_bev(i1)=f_g_real_retail_food_bev_goods(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on food and beverage = ',...
                num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);                
            f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f8),'%7.2f'),': real PCE growth on food and beverage = ',...
            num2str(f_g_pce_real_food_bev(f8),'%5.1f')]);
    end;
end;
%
end;
 
if f8>f1; % retail sales data more recent than PCE data
%
if display_text;
disp('Have more recent food and beverage retail sales data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of food and beverage retail sales data.']);
end;
 
% fill in missing real PCE with real retail sales growth
f_g_pce_real_food_bev(f1+1:f8)=f_g_real_retail_food_bev_goods(f1+1:f8);
f_pce_real_food_bev=pce_real_food_bev;
for i1=f1+1:f8;
    f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
end;
 
[f_g_pce_real_food_bev,txt]=fn_make_forecast_mov_avg(f_g_pce_real_food_bev);
 
% translate to real retail sales--assume both grow at the same rate--then
% to nominal core retail sales
f_g_real_retail_food_bev_goods(f8+1:ff+5)=f_g_pce_real_food_bev(f8+1:ff+5);
f_retail_food_bev_goods=retail_food_bev_goods;
f_g_retail_food_bev_goods=g_retail_food_bev_goods;
for i1=f1+1:ff+5;
    f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
    f_real_retail_food_bev_goods(i1)=f_real_retail_food_bev_goods(i1-1)*(1+f_g_real_retail_food_bev_goods(i1)/100);
    f_retail_food_bev_goods(i1)=f_real_retail_food_bev_goods(i1)*f_cpi_food_bev(i1);
    f_g_retail_food_bev_goods(i1)=100*(f_retail_food_bev_goods(i1)/f_retail_food_bev_goods(i1-1)-1);
end;
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Use implied forecasts for retail sales from real PCE growth rate']);
    disp([txt,'.'])
    end;
    for i1=f8+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal food and beverage retail sales growth = ',num2str(f_g_retail_food_bev_goods(i1),'%5.1f')]);
        disp(['      and real PCE growth on food and beverage = ',num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use implied forecasts for retail sales from real PCE growth rate ',txt,' (default).']);
    for i1=f8+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal food and beverage retail sales growth = ',num2str(f_g_retail_food_bev_goods(i1),'%5.1f')]);
        disp(['      and real PCE growth on food and beverage = ',num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f8+1:ff+2;
            f_g_retail_food_bev_goods(i1)=input(['Nominal food and beverage retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_food_bev_goods(i1)=f_retail_food_bev_goods(i1-1)*(1+f_g_retail_food_bev_goods(i1)/100);
            f_real_retail_food_bev_goods(i1)=f_retail_food_bev_goods(i1)/f_cpi_food_bev(i1);
            f_g_real_retail_food_bev_goods(i1)=100*(f_real_retail_food_bev_goods(i1)/f_real_retail_food_bev_goods(i1-1)-1);
            f_g_pce_real_food_bev(i1)=f_g_real_retail_food_bev_goods(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on food and beverage = ',...
                num2str(f_g_pce_real_food_bev(i1),'%5.1f')]);                
            f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_food_bev(i1)=f_pce_real_food_bev(i1-1)*(1+f_g_pce_real_food_bev(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f8),'%7.2f'),': real PCE growth on food and beverage = ',...
            num2str(f_g_pce_real_food_bev(f8),'%5.1f')]);
    end;
end;
%
end;
  
%sungilkim
[f_pce_real_food_bev_q,f_g_pce_real_food_bev_q,f_pce_real_food_bev_next_q,...
    f_g_pce_real_food_bev_next_q]=fn_convert_mtoqavg(f_pce_real_food_bev,date_m,date_q);
f_g_pce_real_food_bev_this_q=f_g_pce_real_food_bev_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on food and beverage = ',num2str(f_g_pce_real_food_bev_this_q,'%5.1f')]);
end;

if display_text;
disp('--------------------------------------------');
disp('2. Apparel');
end;
missing_no_months=3-(f9-ff)-1;
 
f_pce_real_apparel=pce_real_apparel;
f_g_pce_real_apparel=fn_compute_g_monthly(f_pce_real_apparel);
 
f_real_retail_apparel=junk_nos_m;
f_g_cpi_apparel=fn_make_forecast(g_cpi_apparel);
f_cpi_apparel=cpi_apparel;
for i1=f4a+1:ff+5;
    f_cpi_apparel(i1)=f_cpi_apparel(i1-1)*(1+f_g_cpi_apparel(i1)/100);
end;
i1=retail_apparel~=junk_nos & f_cpi_apparel~=junk_nos;
f_real_retail_apparel(i1)=retail_apparel(i1)./f_cpi_apparel(i1);
f_g_real_retail_apparel=fn_compute_g_monthly(f_real_retail_apparel);
 
 
if display_text;
% display last 6 months of nominal retail sales data
disp('Monthly apparel retail sales:');
disp('Date        Growth rate (m/m)');
disp(num2str([date_m(f9-5:f9),g_retail_apparel(f9-5:f9)],'%10.2f %13.2f\n'));
end;
%
if f1==f9; %pce data as recent as apparel retail sales data
%
if display_text;
disp('No additional apparel retail sales data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and apparel retail sales data.']);
end;
%forecast PCE growth for apparel
[f_g_pce_real_apparel,txt]=fn_make_forecast_mov_avg(g_pce_real_apparel);
f_pce_real_apparel=pce_real_apparel;
%translate that to retail sales--assume both growh at the same rate
f_retail_apparel=retail_apparel;
f_g_retail_apparel=g_retail_apparel;
f_g_real_retail_apparel(f1+1:ff+5)=f_g_pce_real_apparel(f1+1:ff+5);
 
 
for i1=f1+1:ff+5;
    f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
    f_real_retail_apparel(i1)=f_real_retail_apparel(i1-1)*(1+f_g_real_retail_apparel(i1)/100);
    f_retail_apparel(i1)=f_real_retail_apparel(i1)*f_cpi_apparel(i1);
    f_g_retail_apparel(i1)=100*(f_retail_apparel(i1)/f_retail_apparel(i1-1)-1);
end;
 
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Forecasting missing data on real PCE on apparel using']);
    disp([txt,'.'])
    end;
    for i1=f9+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal apparel retail sales growth = ',num2str(f_g_retail_apparel(i1),'%5.1f')]);
        disp(['      and real PCE growth on apparel = ',num2str(f_g_pce_real_apparel(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use real PCE on apparel growth rate ',txt,' (default).']);
    for i1=f9+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal apparel retail sales growth = ',num2str(f_g_retail_apparel(i1),'%5.1f')]);
        disp(['      and real PCE growth on apparel = ',num2str(f_g_pce_real_apparel(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f9+1:ff+2;
            f_g_retail_apparel(i1)=input(['Nominal apparel retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_apparel(i1)=f_retail_apparel(i1-1)*(1+f_g_retail_apparel(i1)/100);
            f_real_retail_apparel(i1)=f_retail_apparel(i1)/f_cpi_apparel(i1);
            f_g_real_retail_apparel(i1)=100*(f_real_retail_apparel(i1)/f_real_retail_apparel(i1-1)-1);
            f_g_pce_real_apparel(i1)=f_g_real_retail_apparel(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on apparel = ',...
                num2str(f_g_pce_real_apparel(i1),'%5.1f')]);                
            f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f9),'%7.2f'),': real PCE growth on apparel = ',...
            num2str(f_g_pce_real_apparel(f9),'%5.1f')]);
    end;
end;
%
end;
 
if f9>f1; % retail sales data more recent than PCE data
%
if display_text;
disp('Have more recent apparel retail sales data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of apparel retail sales data.']);
end;
 
% fill in missing real PCE with real retail sales growth
f_g_pce_real_apparel(f1+1:f9)=f_g_real_retail_apparel(f1+1:f9);
f_pce_real_apparel=pce_real_apparel;
for i1=f1+1:f9;
    f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
end;
 
[f_g_pce_real_apparel,txt]=fn_make_forecast_mov_avg(f_g_pce_real_apparel);
 
% translate to real retail sales--assume both grow at the same rate--then
% to nominal core retail sales
f_g_real_retail_apparel(f9+1:ff+5)=f_g_pce_real_apparel(f9+1:ff+5);
f_retail_apparel=retail_apparel;
f_g_retail_apparel=g_retail_apparel;
for i1=f1+1:ff+5;
    f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
    f_real_retail_apparel(i1)=f_real_retail_apparel(i1-1)*(1+f_g_real_retail_apparel(i1)/100);
    f_retail_apparel(i1)=f_real_retail_apparel(i1)*f_cpi_apparel(i1);
    f_g_retail_apparel(i1)=100*(f_retail_apparel(i1)/f_retail_apparel(i1-1)-1);
end;
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Use implied forecasts for retail sales from real PCE growth rate']);
    disp([txt,'.'])
    end;
    for i1=f9+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal apparel retail sales growth = ',num2str(f_g_retail_apparel(i1),'%5.1f')]);
        disp(['      and real PCE growth on apparel = ',num2str(f_g_pce_real_apparel(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use implied forecasts for retail sales from real PCE growth rate ',txt,' (default).']);
    for i1=f9+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal apparel retail sales growth = ',num2str(f_g_retail_apparel(i1),'%5.1f')]);
        disp(['      and real PCE growth on apparel = ',num2str(f_g_pce_real_apparel(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f9+1:ff+2;
            f_g_retail_apparel(i1)=input(['Nominal apparel retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_apparel(i1)=f_retail_apparel(i1-1)*(1+f_g_retail_apparel(i1)/100);
            f_real_retail_apparel(i1)=f_retail_apparel(i1)/f_cpi_apparel(i1);
            f_g_real_retail_apparel(i1)=100*(f_real_retail_apparel(i1)/f_real_retail_apparel(i1-1)-1);
            f_g_pce_real_apparel(i1)=f_g_real_retail_apparel(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on apparel = ',...
                num2str(f_g_pce_real_apparel(i1),'%5.1f')]);                
            f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_apparel(i1)=f_pce_real_apparel(i1-1)*(1+f_g_pce_real_apparel(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f9),'%7.2f'),': real PCE growth on apparel = ',...
            num2str(f_g_pce_real_apparel(f9),'%5.1f')]);
    end;
end;
%
end;
  
%sungilkim
[f_pce_real_apparel_q,f_g_pce_real_apparel_q,f_pce_real_apparel_next_q,...
    f_g_pce_real_apparel_next_q]=fn_convert_mtoqavg(f_pce_real_apparel,date_m,date_q);
f_g_pce_real_apparel_this_q=f_g_pce_real_apparel_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on apparel = ',num2str(f_g_pce_real_apparel_this_q,'%5.1f')]);
end;

if display_text;
disp('--------------------------------------------');
disp('3. Gasoline and energy goods');
end;

missing_no_months=3-(f6-ff)-1;
 
f_pce_real_gasoline_other=pce_real_gasoline_other;
f_g_pce_real_gasoline_other=fn_compute_g_monthly(f_pce_real_gasoline_other);
 
f_real_retail_gasoline_other=junk_nos_m;
f_g_cpi_gasoline_other=fn_make_forecast(g_cpi_gasoline_other);
f_cpi_gasoline_other=cpi_gasoline_other;
for i1=f4a+1:ff+5;
    f_cpi_gasoline_other(i1)=f_cpi_gasoline_other(i1-1)*(1+f_g_cpi_gasoline_other(i1)/100);
end;
i1=retail_gasoline_other~=junk_nos & f_cpi_gasoline_other~=junk_nos;
f_real_retail_gasoline_other(i1)=retail_gasoline_other(i1)./f_cpi_gasoline_other(i1);
f_g_real_retail_gasoline_other=fn_compute_g_monthly(f_real_retail_gasoline_other);
 
 
if display_text;
% display last 6 months of nominal retail sales data
disp('Monthly gasoline and other energy goods retail sales:');
disp('Date        Growth rate (m/m)');
disp(num2str([date_m(f6-5:f6),g_retail_gasoline_other(f6-5:f6)],'%10.2f %13.2f\n'));
end;
%
if f1==f6; %pce data as recent as gasoline and other energy goods retail sales data
%
if display_text;
disp('No additional gasoline and other energy goods retail sales data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and gasoline and other energy goods retail sales data.']);
end;
%forecast PCE growth for apparel
[f_g_pce_real_gasoline_other,txt]=fn_make_forecast_mov_avg(g_pce_real_gasoline_other);
f_pce_real_gasoline_other=pce_real_gasoline_other;
%translate that to retail sales--assume both growh at the same rate
f_retail_gasoline_other=retail_gasoline_other;
f_g_retail_gasoline_other=g_retail_gasoline_other;
f_g_real_retail_gasoline_other(f1+1:ff+5)=f_g_pce_real_gasoline_other(f1+1:ff+5);
 
 
for i1=f1+1:ff+5;
    f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
    f_real_retail_gasoline_other(i1)=f_real_retail_gasoline_other(i1-1)*(1+f_g_real_retail_gasoline_other(i1)/100);
    f_retail_gasoline_other(i1)=f_real_retail_gasoline_other(i1)*f_cpi_gasoline_other(i1);
    f_g_retail_gasoline_other(i1)=100*(f_retail_gasoline_other(i1)/f_retail_gasoline_other(i1-1)-1);
end;
 
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Forecasting missing data on real PCE on gasoline and other energy goods using']);
    disp([txt,'.'])
    end;
    for i1=f6+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal gasoline and other energy goods retail sales growth = ',num2str(f_g_retail_gasoline_other(i1),'%5.1f')]);
        disp(['      and real PCE growth on gasoline and other energy goods = ',num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use real PCE on gasoline and other energy goods growth rate ',txt,' (default).']);
    for i1=f6+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal gasoline and other energy goods retail sales growth = ',num2str(f_g_retail_gasoline_other(i1),'%5.1f')]);
        disp(['      and real PCE growth on gasoline and other energy goods = ',num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f6+1:ff+2;
            f_g_retail_gasoline_other(i1)=input(['Nominal gasoline and other energy goods retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_gasoline_other(i1)=f_retail_gasoline_other(i1-1)*(1+f_g_retail_gasoline_other(i1)/100);
            f_real_retail_gasoline_other(i1)=f_retail_gasoline_other(i1)/f_cpi_gasoline_other(i1);
            f_g_real_retail_gasoline_other(i1)=100*(f_real_retail_gasoline_other(i1)/f_real_retail_gasoline_other(i1-1)-1);
            f_g_pce_real_gasoline_other(i1)=f_g_real_retail_gasoline_other(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on gasoline and other energy goods = ',...
                num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);                
            f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f6),'%7.2f'),': real PCE growth on gasoline and other energy goods = ',...
            num2str(f_g_pce_real_gasoline_other(f6),'%5.1f')]);
    end;
end;
%
end;
 
if f6>f1; % retail sales data more recent than PCE data
%
if display_text;
disp('Have more recent gasoline and other energy goods retail sales data than PCE data.');
disp(['Missing ',num2str(missing_no_months),' month(s) of gasoline and other energy goods retail sales data.']);
end;
 
% fill in missing real PCE with real retail sales growth
f_g_pce_real_gasoline_other(f1+1:f6)=f_g_real_retail_gasoline_other(f1+1:f6);
f_pce_real_gasoline_other=pce_real_gasoline_other;
for i1=f1+1:f6;
    f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
end;
 
[f_g_pce_real_gasoline_other,txt]=fn_make_forecast_mov_avg(f_g_pce_real_gasoline_other);
 
% translate to real retail sales--assume both grow at the same rate--then
% to nominal core retail sales
f_g_real_retail_gasoline_other(f6+1:ff+5)=f_g_pce_real_gasoline_other(f6+1:ff+5);
f_retail_gasoline_other=retail_gasoline_other;
f_g_retail_gasoline_other=g_retail_gasoline_other;
for i1=f1+1:ff+5;
    f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
    f_real_retail_gasoline_other(i1)=f_real_retail_gasoline_other(i1-1)*(1+f_g_real_retail_gasoline_other(i1)/100);
    f_retail_gasoline_other(i1)=f_real_retail_gasoline_other(i1)*f_cpi_gasoline_other(i1);
    f_g_retail_gasoline_other(i1)=100*(f_retail_gasoline_other(i1)/f_retail_gasoline_other(i1-1)-1);
end;
if missing_no_months>0;
    if run_quietly==1; in1=1;
    if display_text;
    disp(['Use implied forecasts for retail sales from real PCE growth rate']);
    disp([txt,'.'])
    end;
    for i1=f6+1:ff+2;
        if display_text;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal gasoline and other energy goods retail sales growth = ',num2str(f_g_retail_gasoline_other(i1),'%5.1f')]);
        disp(['      and real PCE growth on gasoline and other energy goods = ',num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);            
        end;
    end;    
    else;
    disp('Options to fill in missing month(s):');
    disp(['1. Use implied forecasts for retail sales from real PCE growth rate ',txt,' (default).']);
    for i1=f6+1:ff+2;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal gasoline and other energy goods retail sales growth = ',num2str(f_g_retail_gasoline_other(i1),'%5.1f')]);
        disp(['      and real PCE growth on gasoline and other energy goods = ',num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);            
    end;    
    disp('2. Enter nominal growth rate data for missing month(s).');
    in1=input('--> Select 1 (or enter blank) or 2. ');
    end;
    if in1==2;
        for i1=f6+1:ff+2;
            f_g_retail_gasoline_other(i1)=input(['Nominal gasoline and other energy goods retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_retail_gasoline_other(i1)=f_retail_gasoline_other(i1-1)*(1+f_g_retail_gasoline_other(i1)/100);
            f_real_retail_gasoline_other(i1)=f_retail_gasoline_other(i1)/f_cpi_gasoline_other(i1);
            f_g_real_retail_gasoline_other(i1)=100*(f_real_retail_gasoline_other(i1)/f_real_retail_gasoline_other(i1-1)-1);
            f_g_pce_real_gasoline_other(i1)=f_g_real_retail_gasoline_other(i1);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on gasoline and other energy goods = ',...
                num2str(f_g_pce_real_gasoline_other(i1),'%5.1f')]);                
            f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
        end;
        for i1=ff+3:ff+5;
            f_pce_real_gasoline_other(i1)=f_pce_real_gasoline_other(i1-1)*(1+f_g_pce_real_gasoline_other(i1)/100);
        end;
    end;
else;
    if display_text;
    disp(['     For ',num2str(date_m(f6),'%7.2f'),': real PCE growth on gasoline and other energy goods = ',...
            num2str(f_g_pce_real_gasoline_other(f6),'%5.1f')]);
    end;
end;
%
end;
  
%sungilkim
[f_pce_real_gasoline_other_q,f_g_pce_real_gasoline_other_q,f_pce_real_gasoline_other_next_q,...
    f_g_pce_real_gasoline_other_next_q]=fn_convert_mtoqavg(f_pce_real_gasoline_other,date_m,date_q);
f_g_pce_real_gasoline_other_this_q=f_g_pce_real_gasoline_other_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly PCE growth on gasoline and other energy goods = ',num2str(f_g_pce_real_gasoline_other_this_q,'%5.1f')]);
end;

if display_text;
disp('--------------------------------------------');
disp('4. Other Nondurable Goods');
end;

% forecast PCE growth for other nondurables
[f_g_pce_real_other_nondur,txt]=fn_make_forecast_mov_avg(g_pce_real_other_nondur);
f_pce_real_other_nondur=pce_real_other_nondur;

for i1=f1+1:ff+5
    f_pce_real_other_nondur(i1)=f_pce_real_other_nondur(i1-1)*(1+f_g_pce_real_other_nondur(i1)/100);
end

[f_pce_real_other_nondur_q, f_g_pce_real_other_nondur_q,f_pce_real_other_nondur_next_q,f_g_pce_real_other_nondur_next_q]=fn_convert_mtoqavg_for_display(f_pce_real_other_nondur,date_m,date_q);
                                      
f_g_pce_real_other_nondur_this_q=f_g_pce_real_other_nondur_q(find(date_q==current_quarter));

if display_text;
disp(['Estimated quarterly PCE growth on other nondurable goods = ',num2str(f_g_pce_real_other_nondur_this_q,'%5.1f')]);
end;

%----------------------------------------
% PCE growth for nondurables
%----------------------------------------
f_g_pce_real_goods_nondur=g_pce_real_goods_nondur;
f_pce_real_goods_nondur=pce_real_goods_nondur;
for i1=f1+1:ff+5;
	f_g_pce_real_goods_nondur(i1)= share_pce_food_bev*f_g_pce_real_food_bev(i1) +share_pce_apparel*f_g_pce_real_apparel(i1) +share_pce_gasoline_other*f_g_pce_real_gasoline_other(i1) +share_pce_other_nondur*f_g_pce_real_other_nondur(i1); 
    f_pce_real_goods_nondur(i1)=f_pce_real_goods_nondur(i1-1)*(1+f_g_pce_real_goods_nondur(i1)/100);
end;

[f_pce_real_goods_nondur_q,f_g_pce_real_goods_nondur_q,f_pce_real_goods_nondur_next_q,f_g_pce_real_goods_nondur_next_q]=fn_convert_mtoqavg(f_pce_real_goods_nondur,date_m,date_q);
f_g_pce_real_goods_nondur_this_q=f_g_pce_real_goods_nondur_q(find(date_q==current_quarter));


if display_text;
disp('**********************************************************************************');
disp(['Estimated PCE growth on nondurable goods for ',num2str(current_quarter),', SAAR = ',num2str(f_g_pce_real_goods_nondur_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;


%----------------------------------------
% PCE on goods -- durables ex. motor vehicles and nondurables
%----------------------------------------
%if display_text;
%disp('--------------------------------------------');
%disp('2. PCE on goods -- durables ex. motor vehicles and nondurables.');
%end;
missing_no_months=3-(f3-ff)-1;
% create pseudo real PCE on goods excluding motor vehicles
%
% In FAME version if have data on chain-weighted pce_real_goods_dur_ex_mv:
%f_pce_real_goods_ex_mv=junk_nos_m; i1=pce_real_goods_dur_ex_mv~=junk_nos &
%pce_real_goods_nondur~=junk_nos;
%f_pce_real_goods_ex_mv(i1)=pce_real_goods_dur_ex_mv(i1)+pce_real_goods_nondur(i1);
%
% Haver/FAME compatible version if don't have pce_real_goods_dur_ex_mv:
f_pce_real_goods_ex_mv=fn_chain_weighting_alt(pce_nom_goods,pce_real_goods,pce_nom_goods_dur_mv,pce_real_goods_dur_mv);
%
f_g_pce_real_goods_ex_mv=fn_compute_g_monthly(f_pce_real_goods_ex_mv);
% create real core retail sales
f_real_retail_core=junk_nos_m;
i1=retail_core~=junk_nos & f_cpi_ex_energy~=junk_nos;

% Modified by Linmei Amaya, April 15th 2020 Changed core retail sales to
% total retail sales for PCE estimation; See above modification about
% COVID-19
 f_real_retail_core(i1)=retail_core(i1)./f_cpi_ex_energy(i1);
% f_real_retail_core(i1)=retail_core(i1)./f_cpi(i1);



f_g_real_retail_core=fn_compute_g_monthly(f_real_retail_core);
%if display_text;
% display last 6 months of nominal retail sales data
%disp('Monthly core nominal retail sales:');
%disp('Date        Growth rate (m/m)');
%disp(num2str([date_m(f3-5:f3),g_retail_core(f3-5:f3)],'%10.2f %13.2f\n'));
%end;
%
if f1==f3; % PCE data as recent as core retail sales data
%
%if display_text;
%disp('No additional core retail sales data beyond PCE.');
%disp(['Missing ',num2str(missing_no_months),' month(s) of PCE and core retail sales data.']);
%end;
[f_g_pce_real_goods_ex_mv,txt]=fn_make_forecast(f_g_pce_real_goods_ex_mv);
% translate to real core retail sales growth--assume both grow at the same
% rate--then back out nominal growth of core retail sales
f_g_real_retail_core(f1+1:ff+5)=f_g_pce_real_goods_ex_mv(f1+1:ff+5);
f_g_retail_core=g_retail_core;
f_retail_core=retail_core;
for i1=f1+1:ff+5;
	f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
	f_real_retail_core(i1)=f_real_retail_core(i1-1)*(1+f_g_real_retail_core(i1)/100);
	f_retail_core(i1)=f_real_retail_core(i1)*f_cpi_ex_energy(i1);
	f_g_retail_core(i1)=100*(f_retail_core(i1)/f_retail_core(i1-1)-1);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1;
	%if display_text;
	%disp(['Forecasting missing data on (pseudo) real goods PCE excluding motor vehicles using']);
	%disp([txt,'.'])
	%end;
	for i1=f3+1:ff+2;
		%if display_text;
		%disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core retail sales growth = ',num2str(f_g_retail_core(i1),'%5.1f')]);
		%disp(['      and real PCE growth on goods excluding motor vehicles = ',num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);			
		%end;
	end;	
	else;
	%disp('Options to fill in missing month(s):');
	%disp(['1. Use (pseudo) real goods PCE ex. motor vehicles growth rate ',txt,' (default).']);
	for i1=f3+1:ff+2;
		%disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core retail sales growth = ',num2str(f_g_retail_core(i1),'%5.1f')]);
		%disp(['      and real PCE growth on goods excluding motor vehicles = ',num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);			
	end;	
	%disp('2. Enter nominal core growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f3+1:ff+2;
			f_g_retail_core(i1)=input(['Nominal core retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_retail_core(i1)=f_retail_core(i1-1)*(1+f_g_retail_core(i1)/100);
			f_real_retail_core(i1)=f_retail_core(i1)/f_cpi_ex_energy(i1);
			f_g_real_retail_core(i1)=100*(f_real_retail_core(i1)/f_real_retail_core(i1-1)-1);
			f_g_pce_real_goods_ex_mv(i1)=f_g_real_retail_core(i1);
			%disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on goods excluding motor vehicles = ',...
			%	num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);				
			f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
		end;
	end;
else;
	if display_text;
	%disp(['     For ',num2str(date_m(f2),'%7.2f'),': real PCE growth on goods excluding motor vehicles = ',...
	%		num2str(f_g_pce_real_goods_ex_mv(f2),'%5.1f')]);
	end;
end;
%
end;
%
if f3>f1; % retail sales data more recent than PCE data
%
%if display_text;
%disp('Have more recent core retail sales data than PCE data.');
%disp(['Missing ',num2str(missing_no_months),' month(s) of core retail sales data.']);
%end;
% update past consumption readings based on revisions to retail sales: old
% vintage data
f_g_real_retail_core_old=junk_nos_m;
f_real_retail_core_old=junk_nos_m;
for i1=ff-4:f3-1;
	if retail_core_old(i1)~=junk_nos & f_cpi_ex_energy(i1)~=junk_nos;
		f_real_retail_core_old(i1)=retail_core_old(i1)/f_cpi_ex_energy(i1);
		if f_real_retail_core_old(i1-1)~=junk_nos;
			f_g_real_retail_core_old(i1)=100*(f_real_retail_core_old(i1)/f_real_retail_core_old(i1-1)-1);
			% revise past data on pseudo real PCE on goods excluding motor
			% vehicles
			f_g_pce_real_goods_ex_mv(i1)=f_g_pce_real_goods_ex_mv(i1)+(f_g_real_retail_core(i1)-f_g_real_retail_core_old(i1));
			f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
			% revise past data on real PCE (total)
			share_temp=(pce_nom_goods(i1)-pce_nom_goods_dur_mv(i1))/pce_nom(i1); % share of total PCE
			f_g_pce_real(i1)=f_g_pce_real(i1)+share_temp*(f_g_real_retail_core(i1)-f_g_real_retail_core_old(i1));
			f_pce_real(i1)=f_pce_real(i1-1)*(1+f_g_pce_real(i1)/100);
		end;
	end;
end;
% fill in missing psuedo real goods PCE excluding motor vehicles with real
% core retail sales growth
f_g_pce_real_goods_ex_mv(f1+1:f3)=f_g_real_retail_core(f1+1:f3);




for i1=f1+1:f3;
	f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
end;
% forecast pseudo real goods PCE excluding motor vehicles Modifed by Linmei
% Amaya, May 15 2020 Changed to moving average due to COVID-19
% [f_g_pce_real_goods_ex_mv,txt]=fn_make_forecast(f_g_pce_real_goods_ex_mv);
[f_g_pce_real_goods_ex_mv,txt]=fn_make_forecast_mov_avg(f_g_pce_real_goods_ex_mv);

% translate to real core retail sales--assume both grow at the same
% rate--then to nominal core retail sales
f_g_real_retail_core(f3+1:ff+5)=f_g_pce_real_goods_ex_mv(f3+1:ff+5);
f_retail_core=retail_core;
f_g_retail_core=g_retail_core;
for i1=f3+1:ff+5;
	f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
	f_real_retail_core(i1)=f_real_retail_core(i1-1)*(1+f_g_real_retail_core(i1)/100);
	f_retail_core(i1)=f_real_retail_core(i1)*f_cpi_ex_energy(i1);
	f_g_retail_core(i1)=100*(f_retail_core(i1)/f_retail_core(i1-1)-1);
end;
if missing_no_months>0;
	if run_quietly==1; in1=1; 
	%if display_text;
	%disp(['Use implied forecasts for core retail sales from pseudo real PCE goods']);
	%disp(['excluding motor vehicles growth rate']);
	%disp([txt,'.']);
	%end;
	for i1=f3+1:ff+2;
		%if display_text;
		%disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core retail sales growth = ',num2str(f_g_retail_core(i1),'%5.1f')]);
		%disp(['      and real PCE growth on goods excluding motor vehicles = ',num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);			
		%end;
	end;
	else;
	%disp('Options to fill in missing month(s):');
	%disp(['1. Use implied forecasts for core retail sales from pseudo real PCE goods excluding motor vehicles']);
	%%disp(['   growth rate ',txt,' (default).']);
	for i1=f3+1:ff+2;
		%disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core retail sales growth = ',num2str(f_g_retail_core(i1),'%5.1f')]);
		%disp(['      and real PCE growth on goods excluding motor vehicles = ',num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);			
	end;
	%disp('2. Enter nominal core growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f3+1:ff+2;
			f_g_retail_core(i1)=input(['Nominal core retail sales growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_retail_core(i1)=f_retail_core(i1-1)*(1+f_g_retail_core(i1)/100);
			f_real_retail_core(i1)=f_retail_core(i1)/f_cpi_ex_energy(i1);
			f_g_real_retail_core(i1)=100*(f_real_retail_core(i1)/f_real_retail_core(i1-1)-1);
			f_g_pce_real_goods_ex_mv(i1)=f_g_real_retail_core(i1);
			%disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE growth on goods excluding motor vehicles = ',...
			%	num2str(f_g_pce_real_goods_ex_mv(i1),'%5.1f')]);				
			f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_goods_ex_mv(i1)=f_pce_real_goods_ex_mv(i1-1)*(1+f_g_pce_real_goods_ex_mv(i1)/100);
		end;
	end;
else;
	%if display_text;
	%disp(['     For ',num2str(date_m(f2),'%7.2f'),': real PCE growth on goods excluding motor vehicles = ',...
			%num2str(f_g_pce_real_goods_ex_mv(f2),'%5.1f')]);
	%end;	
end;
%
end;
%




%----------------------------------------
% PCE on services
%----------------------------------------
if display_text;
disp('--------------------------------------------');
disp('3. PCE on services.');
end;
missing_no_months=3-(f1-ff)-1;
% create real retail sales on food services

% Modified by Linmei Amaya, May 15
% Changed to moving average due to COVID-19
% f_g_cpi_food_away_home=fn_make_forecast(g_cpi_food_away_home);
f_g_cpi_food_away_home=fn_make_forecast_mov_avg(g_cpi_food_away_home);

f_cpi_food_away_home=cpi_food_away_home;
for i1=f4a+1:ff+5;
	f_cpi_food_away_home(i1)=f_cpi_food_away_home(i1-1)*(1+f_g_cpi_food_away_home(i1)/100);
end;
i1=retail_food_serv~=junk_nos & f_cpi_food_away_home~=junk_nos;
f_real_retail_food_serv=junk_nos_m;
f_real_retail_food_serv(i1)=retail_food_serv(i1)./f_cpi_food_away_home(i1);
f_g_real_retail_food_serv=fn_compute_g_monthly(f_real_retail_food_serv);

% jbae
f_g_hc_exp = hc_forecast_mod(g_hc_hours_worked, hc_hours_worked, g_hc_earning, hc_earning, g_hc_employment, hc_employment, g_hc_expenditure, hc_expenditure, junk_nos, length(f_g_real_retail_food_serv));
% Modified by Linmei Amaya April 30, 2020
% Moving Average Model Selection
f_g_hc_exp = fn_make_forecast_mov_avg(f_g_hc_exp);



%
if f1==f4 & f1==f4b; % PCE data as recent as retail food services and IP data

%
if display_text;
disp('No additional services data beyond PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE services data.']);
end;

% Modified by Linmei Amaya, April 30 2020
% Moving Average Model Selection
[f_g_pce_real_serv,txt]=fn_make_forecast_mov_avg(g_pce_real_serv);
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real services PCE using']);
	disp([txt,'.']);
	end;
	for i1=f1+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
		% jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
        
        end;
	end;	
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real services PCE growth rate ',txt,' (default).']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
		% jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
        
	end;	
	disp('2. Enter real services PCE growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_pce_real_serv(i1)=input(['Real PCE services growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
	end;
end;
%
end;
%
if f4>f1 & f4>f4b; % have more retail food services data than PCE but no extra IP data
%
% use retail food services sales for that month's PCE services on food, use forecast for the remainder
% of services
f_g_pce_real_serv=g_pce_real_serv;

% Modified by Linmei Amaya, May 15
% Changed to moving average forecast due to COVID-19
% f_g_pce_real_serv_temp=fn_make_forecast(g_pce_real_serv);
f_g_pce_real_serv_temp=fn_make_forecast_mov_avg(g_pce_real_serv);

share_serv_food=pce_nom_serv_food(f1)/pce_nom_serv(f1);
f_g_pce_real_serv(f4)=(1-share_serv_food)*f_g_pce_real_serv_temp(f4)+share_serv_food*f_g_real_retail_food_serv(f4);
if display_text;
disp('Have more recent real retail sales on food services than PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE services data.']);
disp(['Have ',num2str(f4-f1),' more month(s) of retail food services data than PCE.']);
disp(['For ',num2str(date_m(f4),'%7.2f'),', real retail sales on food services growth of ',num2str(f_g_real_retail_food_serv(f4),'%3.1f')]);
disp(['  plus forecast from past services translate to PCE services growth of ',num2str(f_g_pce_real_serv(f4),'%3.1f'),'.']);
end;

% Modified by Linmei Amaya, May 15 2020
% Changed to moving average due to COVID-19
% [f_g_pce_real_serv,txt]=fn_make_forecast(f_g_pce_real_serv);
[f_g_pce_real_serv,txt]=fn_make_forecast_mov_avg(f_g_pce_real_serv);
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real services PCE using real retail sales on']);
	disp(['food services for ',num2str(f4-f1),' month(s), previous real services, and ']);
	disp([txt,'.']);
	end;
	for i1=f4+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
		% jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
        end;
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real retail sales on food services for ',num2str(f4-f1),' month(s) and real']);
	disp(['   services PCE growth rate ',txt,' (default).']);
	for i1=f4+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
        % jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
    end;	
	disp('2. Enter real services PCE growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
            

            
            
            
			f_g_pce_real_serv(i1)=input(['Real PCE services growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
	end;
end;
%
end;
%
if f4>f1 & f4b==f4; % have more retail food services and IP data than PCE

%
% translate the extra data on real retail food services to real PCE on food services
% and utilities industrial production to real PCE on housing and utilities, then 
% combine with previous forecast of PCE on services for that month, then forecast
f_g_pce_real_serv=g_pce_real_serv;

% Modifed by Linmei Amaya, May 15 2020
% Changed to moving average due to COVID-19
% f_g_pce_real_serv_temp=fn_make_forecast(g_pce_real_serv);
f_g_pce_real_serv_temp=fn_make_forecast_mov_avg(g_pce_real_serv);

share_serv_food=pce_nom_serv_food(f1)/pce_nom_serv(f1);
share_serv_house_util=pce_nom_serv_house_util(f1)/pce_nom_serv(f1);
w=12;
b=regress(g_pce_real_serv_house_util(f1-w+1:f1),[ones(w,1),g_ip_util(f1-w+1:f1)]);
f_g_pce_real_serv_house_util=b'*[1;g_ip_util(f4)];



% delete upon pce relase and reactivated the commented block below 
%f_g_pce_real_serv(f4-1)=(1-share_serv_food-share_serv_house_util)*f_g_pce_real_serv_temp(f4-1)+...
%	share_serv_food*f_g_real_retail_food_serv(f4-1)+share_serv_house_util*f_g_pce_real_serv_house_util;
%f_g_pce_real_serv(f4)=(1-share_serv_food-share_serv_house_util)*f_g_pce_real_serv_temp(f4-1)+...
%	share_serv_food*f_g_real_retail_food_serv(f4)+share_serv_house_util*f_g_pce_real_serv_house_util;



f_g_pce_real_serv(f4)=(1-share_serv_food-share_serv_house_util)*f_g_pce_real_serv_temp(f4)+...
	share_serv_food*f_g_real_retail_food_serv(f4)+share_serv_house_util*f_g_pce_real_serv_house_util;


if display_text;        
disp('Have more recent real retail sales on food services & utilities IP data than PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE services data.']);
disp(['Have ',num2str(f4-f1),' more month(s) of retail food services data than PCE.']);
disp(['Have ',num2str(f4-f1),' more month(s) of utilities IP data than PCE.']);
disp(['For ',num2str(date_m(f4),'%7.2f'),', real retail sales on food services growth of ',num2str(f_g_real_retail_food_serv(f4),'%3.1f'),' and']);
disp(['  utilities IP growth of ',num2str(g_ip_util(f4),'%4.1f'),' along with previous services growth']);
disp(['  translate to PCE services growth of ',num2str(f_g_pce_real_serv(f4),'%3.1f'),'.']);
end;

% Modified by Linmei Amaya, May 15 2020
% Change to moving average due to COVID-19
%[f_g_pce_real_serv,txt]=fn_make_forecast(f_g_pce_real_serv);
[f_g_pce_real_serv,txt]=fn_make_forecast_mov_avg(f_g_pce_real_serv);
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real services PCE using real retail sales on']);
	disp(['food services and utilities IP for ',num2str(f4-f1),' month(s) plus previous services']);
	disp(['and ',txt,'.']);
	end;
	for i1=f4+1:ff+2;       
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
		% jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
        end;
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real retail sales on food services and utilities IP for ',num2str(f4-f1),' month(s) and real']);
	disp(['   services PCE growth rate ',txt,' (default).']);
	for i1=f4+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
        % jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
    end;	
	disp('2. Enter real services PCE growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
            
           
            
			f_g_pce_real_serv(i1)=input(['Real PCE services growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
	end;
end;
%
end;
%

if f4==f1 & f4b>f4; % have more IP data than PCE and retail food services
    
%
% translate the extra data on real retail food services to real PCE on food services
% and utilities industrial production to real PCE on housing and utilities, then 
% combine with previous forecast of PCE on services for that month, then forecast
f_g_pce_real_serv=g_pce_real_serv;
f_g_pce_real_serv_temp=fn_make_forecast(g_pce_real_serv);
share_serv_food=pce_nom_serv_food(f1)/pce_nom_serv(f1);
share_serv_house_util=pce_nom_serv_house_util(f1)/pce_nom_serv(f1);
w=12;
b=regress(g_pce_real_serv_house_util(f1-w+1:f1),[ones(w,1),g_ip_util(f1-w+1:f1)]);
f_g_pce_real_serv_house_util=b'*[1;g_ip_util(f4)];
f_g_pce_real_serv(f4)=(1-share_serv_food-share_serv_house_util)*f_g_pce_real_serv_temp(f4)+...
	share_serv_food*f_g_real_retail_food_serv(f4)+share_serv_house_util*f_g_pce_real_serv_house_util;
if display_text;
disp('Have more recent real retail sales on food services & utilities IP data than PCE.');
disp(['Missing ',num2str(missing_no_months),' month(s) of PCE services data.']);
disp(['Have ',num2str(f4-f1),' more month(s) of retail food services data than PCE.']);
disp(['Have ',num2str(f4-f1),' more month(s) of utilities IP data than PCE.']);
disp(['For ',num2str(date_m(f4),'%7.2f'),', real retail sales on food services growth of ',num2str(f_g_real_retail_food_serv(f4),'%3.1f'),' and']);
disp(['  utilities IP growth of ',num2str(g_ip_util(f4),'%4.1f'),' along with previous services growth']);
disp(['  translate to PCE services growth of ',num2str(f_g_pce_real_serv(f4),'%3.1f'),'.']);
end;

% Change to moving average due to COVID-19
% [f_g_pce_real_serv,txt]=fn_make_forecast(f_g_pce_real_serv);
[f_g_pce_real_serv,txt]=fn_make_forecast_mov_avg(f_g_pce_real_serv);
if missing_no_months>0;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Forecasting missing data on real services PCE using real retail sales on']);
	disp(['food services and utilities IP for ',num2str(f4-f1),' month(s) plus previous services']);
	disp(['and ',txt,'.']);
	end;
	for i1=f4+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
        % jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
        end;
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use real retail sales on food services and utilities IP for ',num2str(f4-f1),' month(s) and real']);
	disp(['   services PCE growth rate ',txt,' (default).']);
	for i1=f4+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real PCE services growth = ',num2str((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1),'%5.1f')]); % jbae
        % jbae
        f_g_pce_real_serv(i1) = (1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1);
    end;	
	disp('2. Enter real services PCE growth rate data for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_pce_real_serv(i1)=input(['Real PCE services growth for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
		for i1=ff+3:ff+5;
			f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
		end;
	end;
end;
%
end;
%


% jbae 
% compute quaerterly growth rate for service sector (separate from goods) 

f_pce_real_serv = pce_real_serv;

for i1=f1+1:ff+5
    f_pce_real_serv(i1)=f_pce_real_serv(i1-1)*(1+f_g_pce_real_serv(i1)/100);
end

[f_pce_real_serv_q, f_g_pce_real_serv_q,f_pce_real_serv_next_q,f_g_pce_real_serv_next_q]=fn_convert_mtoqavg_for_display(f_pce_real_serv,date_m,date_q);
                                      
f_g_pce_real_serv_this_q=f_g_pce_real_serv_q(find(date_q==current_quarter));



%----------------------------------------
% total PCE
%----------------------------------------
f_g_pce_real_goods=g_pce_real_goods;
for i1=f1+1:ff+5;
	f_g_pce_real_goods(i1)=share_pce_goods_dur*f_g_pce_real_goods_dur(i1)+...
		share_pce_goods_nondur*f_g_pce_real_goods_nondur(i1);
	f_g_pce_real(i1)=share_pce_goods*f_g_pce_real_goods(i1)+...
		(share_pce_serv)*((1-0.164) * f_g_pce_real_serv(i1) + 0.164 * f_g_hc_exp(i1));
	f_pce_real(i1)=f_pce_real(i1-1)*(1+f_g_pce_real(i1)/100);
end;
if display_text & f1<ff+2;
disp('--------------------------------------------');
disp('Forecasted growth rates, all real, SA (m/m pct. ch.):');
disp('Date       PCE growth    Services      Goods ');




disp(num2str([date_m(f1+1:ff+2),f_g_pce_real(f1+1:ff+2),f_g_pce_real_serv(f1+1:ff+2),...
	f_g_pce_real_goods(f1+1:ff+2)],...
	'%10.2f %10.2f %12.2f %12.2f\n'));
end;

% jbae 
if display_text;
disp('               Services-hc     Goods-Dur.-MV     Goods ex. MV     Goods-Dur.     Goods-Nondur.  ');

disp(num2str([date_m(f1+1:ff+2),f_g_hc_exp(f1+1:ff+2),f_g_pce_real_goods_dur_mv(f1+1:ff+2),f_g_pce_real_goods_ex_mv(f1+1:ff+2),f_g_pce_real_goods_dur(f1+1:ff+2),f_g_pce_real_goods_nondur(f1+1:ff+2)],'%10.2f %15.2f%17.2f %17.2f%17.2f%18.2f\n'));
end;

if display_text
disp('--------------------------------------------');
disp(['Estimated growth rates for ',num2str(current_quarter),' (SAAR):']);
disp('Goods-Dur.  Goods-Nondur.     Services');
disp(num2str([f_g_pce_real_goods_dur_this_q ,f_g_pce_real_goods_nondur_this_q, f_g_pce_real_serv_this_q], '%14.1f %14.1f %14.1f\n'));
end




[f_pce_real_q,f_g_pce_real_q,f_pce_real_next_q,f_g_pce_real_next_q]=fn_convert_mtoqavg(f_pce_real,date_m,date_q);
f_g_pce_real_this_q=f_g_pce_real_q(find(date_q==current_quarter));
if display_text;
disp('**********************************************************************************');
disp(['Estimated consumption growth for ',num2str(current_quarter),', SAAR = ',num2str(f_g_pce_real_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
if run_quietly==0;
	redo2=input('To recompute consumption, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;


redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Investment: Nonresidential Structures');
disp('----------------------------------------------------------------------------------');
end;
% set shares
share_inv_nrstr_mining=inv_nrstr_mining_n(no_quarters_for_weights)/inv_nrstr_n(no_quarters_for_weights);
share_inv_nrstr_ex_mining=1-share_inv_nrstr_mining;
% display 4 most recent quarterly nonresidential structures investment growth readings
if display_text;
disp('Most recent quarterly nonresidential structures investment growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_inv_nrstr(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
% need monthly growth rates for 2 variables:
% 1. nonresidential construction put-in-place
% 2. mining and drilling rigs
%
disp('--------------------------------------------');
disp('1. Nonresidential construction put-in-place.');
end;
f1=max(find(const_nonres~=junk_nos));
f1a=max(find(ppi_industrial_bldg~=junk_nos));
missing_no_months=3-(f1-ff)-1;
f_const_nonres=const_nonres;
f_g_const_nonres=g_const_nonres;
% g_const_nonres_man=junk_nos_m; % already done earlier
const_nonres_commercial_health_office=junk_nos_m;
g_const_nonres_commercial_health_office=const_nonres_commercial_health_office;
const_nonres_power_comm=junk_nos_m;
g_const_nonres_power_comm=const_nonres_power_comm;
const_nonres_other=junk_nos_m;
g_const_nonres_other=const_nonres_other;
ind1=const_nonres~=junk_nos;
const_nonres_commercial_health_office(ind1)=const_nonres_commercial(ind1)+const_nonres_health(ind1)+const_nonres_office(ind1);
const_nonres_power_comm(ind1)=const_nonres_power(ind1)+const_nonres_comm(ind1);
const_nonres_other(ind1)=const_nonres(ind1)-const_nonres_commercial_health_office(ind1)-...
	const_nonres_man(ind1)-const_nonres_power_comm(ind1);
temp=fn_compute_g_monthly([const_nonres_commercial_health_office,const_nonres_man,const_nonres_power_comm,const_nonres_other]);
g_const_nonres_commercial_health_office=temp(:,1);
g_const_nonres_man=temp(:,2);
g_const_nonres_power_comm=temp(:,3);
g_const_nonres_other=temp(:,4);
% display last 6 months of data on nonresidential construction put in place
if display_text;
disp(['Monthly growth of construction put-in-place, SA (m/m pct. ch.):']);
disp(['            All    ||   Commercial/                      Power/']);
disp(['Date      nonres.  ||  health/office  Manufacturing  communication  Other']);
disp(num2str([date_m(f1-5:f1),g_const_nonres(f1-5:f1),g_const_nonres_commercial_health_office(f1-5:f1),...
	g_const_nonres_man(f1-5:f1),g_const_nonres_power_comm(f1-5:f1),g_const_nonres_other(f1-5:f1)],...
	'%13.2f %7.1f %15.1f %14.1f %14.1f %10.1f\n'));
end;
[f_g_const_nonres,txt]=fn_make_forecast(f_g_const_nonres);
if f1<ff+2;
	if display_text;
	disp(['Missing ',num2str(missing_no_months),' month(s) of construction data.']);
	end;
	if run_quietly==1; in1=1;
	if display_text;
	disp(['Use nominal nonresidential construction growth rate ']);
	disp([txt,'.']);
	end;
	for i1=f1+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nonresidential construction growth = ',num2str(f_g_const_nonres(i1),'%5.1f')]);
		end;
		f_const_nonres(i1)=f_const_nonres(i1-1)*(1+f_g_const_nonres(i1)/100);
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use nonresidential construction growth rate ',txt,' (default).']);
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nonresidential construction growth = ',num2str(f_g_const_nonres(i1),'%5.1f')]);
		f_const_nonres(i1)=f_const_nonres(i1-1)*(1+f_g_const_nonres(i1)/100);
	end;
	disp('2. Enter data (nonresidential construction growth rates) for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_const_nonres(i1)=input(['Growth in nonresidential construction for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_const_nonres(i1)=f_const_nonres(i1-1)*(1+f_g_const_nonres(i1)/100);
		end;
	end;
end;
for i1=ff+3:ff+5;
	f_const_nonres(i1)=f_const_nonres(i1-1)*(1+f_g_const_nonres(i1)/100);
end;
f_g_ppi_industrial_bldg=fn_make_forecast(g_ppi_industrial_bldg);
f_g_ppi_warehouse_bldg=fn_make_forecast(g_ppi_warehouse_bldg);
f_g_ppi_office_bldg=fn_make_forecast(g_ppi_office_bldg);
f_ppi_industrial_bldg=ppi_industrial_bldg;
f_ppi_warehouse_bldg=ppi_warehouse_bldg;
f_ppi_office_bldg=ppi_office_bldg;
for i1=f1a+1:ff+5;
	f_ppi_industrial_bldg(i1)=f_ppi_industrial_bldg(i1-1)*(1+f_g_ppi_industrial_bldg(i1)/100);
	f_ppi_warehouse_bldg(i1)=f_ppi_warehouse_bldg(i1-1)*(1+f_g_ppi_warehouse_bldg(i1)/100);
	f_ppi_office_bldg(i1)=f_ppi_office_bldg(i1-1)*(1+f_g_ppi_office_bldg(i1)/100);
end;
%
% FAME version has inv_nrstr_ex_mining_n, inv_nrstr_ex_mining, g_inv_nrstr_ex_mining,
% so no need for computing these
%
% Haver/FAME compatible version:
inv_nrstr_ex_mining_n=junk_nos*ones(length(inv_nrstr),1);
inv_nrstr_ex_mining=junk_nos*ones(length(inv_nrstr),1);
g_inv_nrstr_ex_mining=junk_nos*ones(length(inv_nrstr),1);
i1=inv_nrstr_n~=junk_nos & inv_nrstr_mining_n~=junk_nos;
inv_nrstr_ex_mining_n(i1)=inv_nrstr_n(i1)-inv_nrstr_mining_n(i1);
i1=inv_nrstr~=junk_nos & inv_nrstr_mining~=junk_nos;
inv_nrstr_ex_mining(i1)=inv_nrstr(i1)-inv_nrstr_mining(i1);
for i1=2:length(inv_nrstr);
	if inv_nrstr_ex_mining(i1)~=junk_nos & inv_nrstr_ex_mining(i1-1)~=junk_nos;
		g_inv_nrstr_ex_mining(i1)=100*((inv_nrstr_ex_mining(i1)/inv_nrstr_ex_mining(i1-1))^4-1);
	end;
end;
%
[f_g_inv_nrstr_ex_mining,f_g_inv_nrstr_ex_mining_next_q]=fn_inv_nrstr_const(date_q, ...
	g_inv_nrstr_ex_mining,inv_nrstr_ex_mining_n,inv_nrstr_ex_mining, ...
	date_m,f_const_nonres,[f_ppi_industrial_bldg,f_ppi_warehouse_bldg,f_ppi_office_bldg],ff);
f_g_inv_nrstr_ex_mining_this_q=f_g_inv_nrstr_ex_mining(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly nonresidential construction growth = ',num2str(f_g_inv_nrstr_ex_mining_this_q,'%5.1f')]);
%
disp('--------------------------------------------');
disp('2. Mining and drilling.');
end;

f2=max(find(rigs_m_sa~=junk_nos));
f3 = min(max(find(rigs_m_sa~=junk_nos)), max(find(drilled_wells_m_sa~=junk_nos)));

missing_no_months=3-(f2-ff)-1;
% display last 6 months of data on rigs
if display_text;
disp(['Monthly mining indicators:']);
disp(['        Mining and drilling rigs	||	Drilled wells']);
disp(['Date    Level (avg.)  Growth (m/m)		Level (avg.)  Growth (m/m)']	);
disp(num2str([date_m(f2-5:f3),rigs_m_sa(f2-5:f3),g_rigs_m_sa(f2-5:f3),drilled_wells_m_sa(f2-5:f3),g_drilled_wells_m_sa(f2-5:f3)], ...
	'%13.2f %12.1f %12.1f %25.1f %14.1f\n'));
end;


 % for the moment, we will use Haver's seasonal adjustment for the drilled wells data
 % bc the model's seasonal adjustment cuts off the first twelve months of data -- giving us even less data
 % there is not enough data to run fn_make_forecast
 % this should be changed once we have 40 quarters of data -- this will be in 2024, although Haver uses a seasonal adjustment that is very similar to ours
g_rigs2 = [g_rigs_m_sa, g_drilled_wells_m]; 
rigs2 = [rigs_m_sa, drilled_wells_m];

[f_g_inv_nrstr_mining,f_g_inv_nrstr_mining_next_q, f_g_rigs2_q]=fn_inv_nrstr_mining(date_q,g_inv_nrstr_mining,inv_nrstr,inv_nrstr_ex_mining, ...
	date_m,ff,g_rigs2,rigs2);

f_g_inv_nrstr_mining_this_q=f_g_inv_nrstr_mining(find(date_q==current_quarter));
f_g_drilled_wells_this_q=f_g_rigs2_q(find(date_q==current_quarter),2);

if display_text;
disp(['Estimated quarterly mining and drilling growth = ',num2str(f_g_inv_nrstr_mining_this_q,'%5.1f')]);
disp(['Estimated quarterly drilled wells growth = ',num2str(f_g_drilled_wells_this_q,'%5.1f')]);
end;
%


% compute quarterly nonresidential structures investment growth
inv_nrstr_last_q=inv_nrstr(find(date_q==current_quarter)-1);
inv_nrstr_mining_this_q=inv_nrstr_mining(find(date_q==current_quarter)-1)*(1+f_g_inv_nrstr_mining_this_q/100)^0.25;
inv_nrstr_ex_mining_this_q=inv_nrstr_ex_mining(find(date_q==current_quarter)-1)*(1+f_g_inv_nrstr_ex_mining_this_q/100)^0.25;
f_g_inv_nrstr_this_q=100*(((inv_nrstr_ex_mining_this_q+inv_nrstr_mining_this_q)/inv_nrstr_last_q)^4-1);
if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in investment in nonres. structures for ',num2str(current_quarter),', SAAR = ',num2str(f_g_inv_nrstr_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
if run_quietly==0;
	redo2=input('To recompute nonresidential structures investment, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;













redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Investment: Equipment');
disp('----------------------------------------------------------------------------------');
end;
% set shares
if inv_es_tn_autos_n(no_quarters_for_weights)~=junk_nos;
	share_inv_es_tn_autos=inv_es_tn_autos_n(no_quarters_for_weights)/inv_es_n(no_quarters_for_weights);
	share_inv_es_tn_lt=inv_es_tn_lt_n(no_quarters_for_weights)/inv_es_n(no_quarters_for_weights);
	% share_inv_es_software=inv_es_ip_software_n(no_quarters_for_weights)/inv_es_n(no_quarters_for_weights);
	share_inv_es_aircraft=inv_es_tn_air_n(no_quarters_for_weights)/inv_es_n(no_quarters_for_weights);
	% share_inv_es_rest=1-share_inv_es_tn_autos-share_inv_es_tn_lt-share_inv_es_software-share_inv_es_aircraft;
share_inv_es_rest=1-share_inv_es_tn_autos-share_inv_es_tn_lt-share_inv_es_aircraft;
else;
	nqw=max(find(inv_es_tn_autos_n~=junk_nos));
	share_inv_es_tn_autos=inv_es_tn_autos_n(nqw)/inv_es_n(nqw);
	share_inv_es_tn_lt=inv_es_tn_lt_n(nqw)/inv_es_n(nqw);
	% share_inv_es_software=inv_es_ip_software_n(nqw)/inv_es_n(nqw);
	share_inv_es_aircraft=inv_es_tn_air_n(nqw)/inv_es_n(nqw);
	% share_inv_es_rest=1-share_inv_es_tn_autos-share_inv_es_tn_lt-share_inv_es_software-share_inv_es_aircraft;
	share_inv_es_rest=1-share_inv_es_tn_autos-share_inv_es_tn_lt-share_inv_es_aircraft;
end;
% display 4 most recent quarterly equipment and software growth readings
if display_text;
disp('Most recent quarterly equipment growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_inv_es(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
% need monthly growth rates for 5 variables:
% 1. shipments of core capital goods
% 2. software purchases - NO LONGER USED FOLLOWING THE JULY 2013 NIPA REVISIONS
% 3. auto and light truck purchases (separately)
% 4. aircraft
% note: light motor vehicle purchases may have been computed earlier in consumption
%
disp('--------------------------------------------');
disp('1. Shipments of core capital goods.');
disp('Note: the formula uses shipments of core capital goods (nondefense capital goods');
disp('excluding aircraft) and deflates by the PPI for capital equipment.');
end;
f1=max(find(ship_core_cap_goods~=junk_nos));
f1a=max(find(ppi_cap_equipment~=junk_nos));
missing_no_months=3-(f1-ff)-1;
f_real_ship_core_cap_goods=junk_nos_m;
i1=ship_core_cap_goods~=junk_nos & ppi_cap_equipment~=junk_nos;
f_real_ship_core_cap_goods(i1)=ship_core_cap_goods(i1)./ppi_cap_equipment(i1);
if f1>f1a
    f1_real_ship_core_cap_goods = fn_make_forecast(f_real_ship_core_cap_goods);
    f_real_ship_core_cap_goods=f1_real_ship_core_cap_goods;
end;
f_g_real_ship_core_cap_goods=fn_compute_g_monthly(f_real_ship_core_cap_goods);
f_ship_core_cap_goods=ship_core_cap_goods;
f_g_ship_core_cap_goods=g_ship_core_cap_goods;
% display last 6 months of data on shipments and orders
if display_text;
disp('Monthly core capital goods shipments (Ship.) and orders (Ord.) data:');
disp('            Levels (bil. $)     ||  Growth rates (m/m)');
disp('Date        Ship.        Ord.   ||  Ship.        Ord.      Real ship.');
disp([num2str([date_m(f1-5:f1),ship_core_cap_goods(f1-5:f1)/1000,orders_core_cap_goods(f1-5:f1)/1000,...
		g_ship_core_cap_goods(f1-5:f1),g_orders_core_cap_goods(f1-5:f1),f_g_real_ship_core_cap_goods(f1-5:f1)],...
		'%10.2f %8.1f %12.1f %10.1f %12.1f %11.1f\n')]);
end;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of core capital goods shipments data.']);
if f1a>f1;
	disp(['Have ',num2str(f1a-f1),' extra month(s) of producer price index data; making forecasts of other']);
	disp(['missing producer price data. For month(s) with producer price data but no nominal']);
	disp(['core capital goods data, the default uses forecast averaging to fill in nominal']);
	disp(['core shipments.']);
end;
end;
% make forecasts of capital equipment ppi
f_g_ppi_cap_equipment=fn_make_forecast(g_ppi_cap_equipment);
f_ppi_cap_equipment=ppi_cap_equipment;
for i1=f1a+1:ff+5;
	f_ppi_cap_equipment(i1)=f_ppi_cap_equipment(i1-1)*(1+f_g_ppi_cap_equipment(i1)/100);
end;
% for month(s) where have producer price index but not nominal core shipments,
% use forecast averaging to come up with nominal core shipments forecast
[f_ship_core_cap_goods,f_g_ship_core_cap_goods,f_real_ship_core_cap_goods,f_g_real_ship_core_cap_goods]=...
	fn_fcast_avg(f_ship_core_cap_goods,f_g_ship_core_cap_goods,f_real_ship_core_cap_goods,f_g_real_ship_core_cap_goods,f_ppi_cap_equipment,f1,f1a);
[f_g_real_ship_core_cap_goods,txt]=fn_make_forecast(f_g_real_ship_core_cap_goods);
if missing_no_months>0;
	if run_quietly==1; in1=1; 
	if display_text;
	if f1a>f1;
	disp(['Using forecast averaging when producer price index data are available']);
	disp(['and real core capital goods shipments growth rate']);
	disp([txt,',']);
	disp(['then backing out nominal core capital goods shipments from PPI capital']);
	disp(['equipment forecast(s) as needed.']);
	else;
	disp(['Using real core capital goods shipments growth rate']);
	disp([txt,',']);
	disp(['then backing out nominal core capital goods shipments from PPI capital']);
	disp(['equipment forecast(s) as needed.']);
	end;
	end;
	for i1=f1+1:ff+2;
		f_real_ship_core_cap_goods(i1)=f_real_ship_core_cap_goods(i1-1)*(1+f_g_real_ship_core_cap_goods(i1)/100);
		f_ship_core_cap_goods(i1)=f_ppi_cap_equipment(i1)*f_real_ship_core_cap_goods(i1);
		f_g_ship_core_cap_goods(i1)=100*(f_ship_core_cap_goods(i1)/f_ship_core_cap_goods(i1-1)-1);
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core cap. goods shipments growth = ',num2str(f_g_ship_core_cap_goods(i1),'%4.1f')]);
		disp(['      and real core cap. goods shipments growth = ',num2str(f_g_real_ship_core_cap_goods(i1),'%4.1f')]);
		end;
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use forecast averaging when producer price index data are available and real']);
	disp(['   core cap. goods shipments growth rate ',txt,' (default),']);
	disp(['   then back out nominal core capital goods shipments growth rate.']);
	for i1=f1+1:ff+2;
		f_real_ship_core_cap_goods(i1)=f_real_ship_core_cap_goods(i1-1)*(1+f_g_real_ship_core_cap_goods(i1)/100);
		f_ship_core_cap_goods(i1)=f_ppi_cap_equipment(i1)*f_real_ship_core_cap_goods(i1);
		f_g_ship_core_cap_goods(i1)=100*(f_ship_core_cap_goods(i1)/f_ship_core_cap_goods(i1-1)-1);
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal core cap. goods shipments growth = ',num2str(f_g_ship_core_cap_goods(i1),'%4.1f')]);
		disp(['      and real core cap. goods shipments growth = ',num2str(f_g_real_ship_core_cap_goods(i1),'%4.1f')]);
		end;
	end;
	disp('2. Enter nominal core capital goods shipments growth rates for missing month(s) then convert to real.');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_ship_core_cap_goods(i1)=input(['Growth in nominal core capital goods shipments for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_ship_core_cap_goods(i1)=f_ship_core_cap_goods(i1-1)*(1+f_g_ship_core_cap_goods(i1)/100);
			f_real_ship_core_cap_goods(i1)=f_ship_core_cap_goods(i1)/f_ppi_cap_equipment(i1);
			f_g_real_ship_core_cap_goods(i1)=100*(f_real_ship_core_cap_goods(i1)/f_real_ship_core_cap_goods(i1-1)-1);
		end;
	end;
end;
for i1=ff+3:ff+5;
	f_real_ship_core_cap_goods(i1)=f_real_ship_core_cap_goods(i1-1)*(1+f_g_real_ship_core_cap_goods(i1)/100);
	f_ship_core_cap_goods(i1)=f_ppi_cap_equipment(i1)*f_real_ship_core_cap_goods(i1);
	f_g_ship_core_cap_goods(i1)=100*(f_ship_core_cap_goods(i1)/f_ship_core_cap_goods(i1-1)-1);
end;
[f_real_ship_core_cap_goods_q,f_g_real_ship_core_cap_goods_q,f_real_ship_core_cap_goods_next_q,...
	f_g_real_ship_core_cap_goods_next_q]=fn_convert_mtoqavg(f_real_ship_core_cap_goods,date_m,date_q);
f_g_real_ship_core_cap_goods_this_q=f_g_real_ship_core_cap_goods_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly real core capital goods growth = ',num2str(f_g_real_ship_core_cap_goods_this_q,'%5.1f')]);
%

% NOTE THIS SECTION IS COMMENTED OUT AS SOFTWARE PURCHASES ARE NO LONGER PART OF THE 
% EQUIPMENT COMPONENT. THIS SECTION HAS BEEN MOVED TO THE INTELLECTUAL PROPERTY COMPONENT BELOW. 

% disp('--------------------------------------------');
% disp('2. Software purchases.');
% end;
% % take the average of quarterly annualized growth in three components:
% % i. IP for computers and electronic products
% % ii. real retail software sales
% % iii. real wholesale software sales
% % 
% % i. IP for computers and electronic components
% f_ip_computers=ip_computers;
% f2i=max(find(ip_computers~=junk_nos));
% missing_no_months=3-(f2i-ff)-1;
% if display_text;
% disp(['Missing ',num2str(missing_no_months),' month(s) of IP for computers and electronic components data.']);
% end;
% f_g_ip_computers=fn_make_forecast(g_ip_computers);
% for i1=f2i+1:ff+5;
% 	f_ip_computers(i1)=f_ip_computers(i1-1)*(1+f_g_ip_computers(i1)/100);
% end;
% [f_ip_computers_q,f_g_ip_computers_q,f_ip_computers_next_q,f_g_ip_computers_next_q]=...
% 	fn_convert_mtoqavg(f_ip_computers,date_m,date_q);
% % ii. real retail software sales
% f_retail_software_real=junk_nos_m;
% f2r=max(find(retail_software~=junk_nos));
% i1=retail_software~=junk_nos & cpi_software~=junk_nos;
% f_retail_software_real(i1)=retail_software(i1)./cpi_software(i1);
% f_g_retail_software_real=fn_compute_g_monthly(f_retail_software_real);
% missing_no_months=3-(f2r-ff)-1;
% if display_text;
% disp(['Missing ',num2str(missing_no_months),' month(s) of retail software sales data.']);
% end;
% f_g_retail_software_real=fn_make_forecast(f_g_retail_software_real);
% for i1=f2r+1:ff+5;
% 	f_retail_software_real(i1)=f_retail_software_real(i1-1)*(1+f_g_retail_software_real(i1)/100);
% end;
% [f_retail_software_real_q,f_g_retail_software_real_q,f_retail_software_real_next_q,f_g_retail_software_real_next_q]=...
% 	fn_convert_mtoqavg(f_retail_software_real,date_m,date_q);
% % iii. real wholesale software sales
% f_sales_wholesale_software_real=sales_wholesale_software_real;
% f2w=max(find(sales_wholesale_software_real~=junk_nos));
% missing_no_months=3-(f2w-ff)-1;
% if display_text;
% disp(['Missing ',num2str(missing_no_months),' month(s) of wholesale software sales data.']);
% end;
% f_g_sales_wholesale_software_real=fn_make_forecast(g_sales_wholesale_software_real);
% for i1=f2w+1:ff+5;
% 	f_sales_wholesale_software_real(i1)=f_sales_wholesale_software_real(i1-1)*(1+f_g_sales_wholesale_software_real(i1)/100);
% end;
% [f_sales_wholesale_software_real_q,f_g_sales_wholesale_software_real_q,f_sales_wholesale_software_real_next_q,f_g_sales_wholesale_software_real_next_q]=...
% 	fn_convert_mtoqavg(f_sales_wholesale_software_real,date_m,date_q);
% % average
% f_g_software_q=[f_g_ip_computers_q,f_g_retail_software_real_q,f_g_sales_wholesale_software_real_q];
% f_g_software_avg_q=junk_nos*ones(size(date_q));
% for i1=1:size(date_q,1);
% 	temp=f_g_software_q(i1,:);
% 	temp=temp(temp~=junk_nos);
% 	if isempty(temp)==0;
% 		f_g_software_avg_q(i1)=mean(temp);
% 	end;
% end;
% f_g_software_avg_this_q=f_g_software_avg_q(find(date_q==current_quarter));
% f_g_software_avg_next_q=mean([f_g_ip_computers_next_q,f_g_retail_software_real_next_q,f_g_sales_wholesale_software_real_next_q]);
% if display_text;
% disp(['Estimated quarterly software growth = ',num2str(f_g_software_avg_this_q,'%5.1f')]);
% %
disp('--------------------------------------------');
disp('2. Auto and light truck purchases.');
end;
% forecasts of total light vehicle sales are made in the consumption block;
% split total vehicle sales into autos and light trucks
share_mv_sales_autos=junk_nos_m;
i1=mv_sales~=junk_nos & mv_sales_autos~=junk_nos;
share_mv_sales_autos(i1)=mv_sales_autos(i1)./mv_sales(i1);
f_share_mv_sales_autos=share_mv_sales_autos;
f3=max(find(share_mv_sales_autos~=junk_nos));
[b1,stde1,varb1,f_share_mv_sales_autos(f3+1:ff+5)]=fn_ar_p_forecast(share_mv_sales_autos(f3-36:f3),1,1,(ff+5)-f3);
f_share_mv_sales_lt=junk_nos_m;
i1=f_share_mv_sales_autos~=junk_nos;
f_share_mv_sales_lt(i1)=1-f_share_mv_sales_autos(i1);
% split auto sales into business and other
share_mv_sales_autos_bus=junk_nos_m;
i1=mv_sales_autos~=junk_nos & mv_sales_autos_bus~=junk_nos;
share_mv_sales_autos_bus(i1)=(mv_sales_autos_bus(i1)/1000)./mv_sales_autos(i1);
f_share_mv_sales_autos_bus=share_mv_sales_autos_bus;
f3a=max(find(share_mv_sales_autos_bus~=junk_nos));
[b1,stde1,varb1,f_share_mv_sales_autos_bus(f3a+1:ff+5)]=fn_ar_p_forecast(share_mv_sales_autos_bus(f3a-36:f3a),1,1,(ff+5)-f3a);
% split light truck sales into consumer and other (business is not a
% separate category, so assume govt is small)
share_mv_sales_lt_bus=junk_nos_m;
i1=mv_sales_lt~=junk_nos & mv_sales_lt_cons~=junk_nos;
share_mv_sales_lt_bus(i1)=1-(mv_sales_lt_cons(i1)/1000)./mv_sales_lt(i1);
f_share_mv_sales_lt_bus=share_mv_sales_lt_bus;
f3lt=max(find(share_mv_sales_lt_bus~=junk_nos));
[b1,stde1,varb1,f_share_mv_sales_lt_bus(f3lt+1:ff+5)]=fn_ar_p_forecast(share_mv_sales_lt_bus(f3lt-36:f3lt),1,1,(ff+5)-f3lt);
f_mv_sales_autos=mv_sales_autos;
f_mv_sales_lt=mv_sales_lt;
for i1=f3+1:ff+5;
	f_mv_sales_autos(i1)=f_share_mv_sales_autos(i1)*f_mv_sales(i1);
	f_mv_sales_lt(i1)=f_share_mv_sales_lt(i1)*f_mv_sales(i1);
end;
i1=mv_sales_autos_bus~=junk_nos;
f_mv_sales_autos_bus=mv_sales_autos_bus;
f_mv_sales_autos_bus(i1)=mv_sales_autos_bus(i1)/1000;
i1=mv_sales_lt_cons~=junk_nos & mv_sales_lt~=junk_nos;
f_mv_sales_lt_bus=junk_nos_m;
f_mv_sales_lt_bus(i1)=mv_sales_lt(i1)-mv_sales_lt_cons(i1)/1000;
for i1=f3a+1:ff+5;
	f_mv_sales_autos_bus(i1)=f_share_mv_sales_autos_bus(i1)*f_mv_sales_autos(i1);
end;
for i1=f3lt+1:ff+5;
	f_mv_sales_lt_bus(i1)=f_share_mv_sales_lt_bus(i1)*f_mv_sales_lt(i1);
end;
% display last 6 months of data
if display_text;
disp('Monthly light vehicle sales data, levels (mil. SAAR):');
disp('            Total    ||      Autos     ||  Light trucks');
disp('Date       lt. veh.  ||  Total   Bus.  ||  Total   Bus.');
disp(num2str([date_m(f3-5:f3),mv_sales(f3-5:f3),f_mv_sales_autos(f3-5:f3),...
	[f_mv_sales_autos_bus(f3-5:f3a);NaN*ones(f3-f3a,1)],f_mv_sales_lt(f3-5:f3),[f_mv_sales_lt_bus(f3-5:f3lt);NaN*ones(f3-f3lt,1)]],...
	'%10.2f %9.2f %11.1f %6.1f %10.1f %6.1f\n'));
end;
missing_no_months=3-(f3a-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of business auto and business light truck purchases data.']);
disp(['Have ',num2str(f3-f3a),' extra month(s) of total light vehicle sales data.']);
disp(['Estimates are based on forecasts of total light vehicles sales data made earlier']);
disp(['and forecasts of shares going to business autos and business light truck sales.']);
end;
[f_mv_sales_autos_bus_q,f_g_mv_sales_autos_bus_q,f_mv_sales_autos_bus_next_q,f_g_mv_sales_autos_bus_next_q]=...
	fn_convert_mtoqavg(f_mv_sales_autos_bus,date_m,date_q);
[f_mv_sales_lt_bus_q,f_g_mv_sales_lt_bus_q,f_mv_sales_lt_bus_next_q,f_g_mv_sales_lt_bus_next_q]=...
	fn_convert_mtoqavg(f_mv_sales_lt_bus,date_m,date_q);
f_g_mv_sales_autos_bus_this_q=f_g_mv_sales_autos_bus_q(find(date_q==current_quarter));
f_g_mv_sales_lt_bus_this_q=f_g_mv_sales_lt_bus_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly business auto purchases growth = ',num2str(f_g_mv_sales_autos_bus_this_q,'%5.1f')]);
disp(['Estimated quarterly business light truck purchases growth = ',num2str(f_g_mv_sales_lt_bus_this_q,'%5.1f')]);
%
disp('--------------------------------------------');
disp('3. Aircraft.');
end;
% use shipments of nondefense aircraft engine and parts manufacturing; it isn't
% clear whether these come out with the advance report, but there appears to be a 
% workaround
f4=max(find(ship_trans_air_parts_nondef~=junk_nos));
f4a=max(find(ship_cap_goods_nondef~=junk_nos));
f4b=max(find(ship_core_cap_goods~=junk_nos));
f4c=max(find(ship_trans_air_nondef~=junk_nos));
f4d=min([f4a,f4b,f4c]);
if f4>=f4d;
	f_ship_trans_air_parts_nondef=ship_trans_air_parts_nondef;
else;
	f_ship_trans_air_parts_nondef=junk_nos_m;
	i1=ship_trans_air_nondef~=junk_nos & ship_cap_goods_nondef~=junk_nos & ship_core_cap_goods~=junk_nos;
	f_ship_trans_air_parts_nondef(i1)=ship_trans_air_nondef(i1)-(ship_cap_goods_nondef(i1)-ship_core_cap_goods(i1));
end;
f4=max(find(f_ship_trans_air_parts_nondef~=junk_nos));
missing_no_months=3-(f4-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of nondefense aircraft engine and parts shipments data.']);
end;
% convert nominal shipments of aircraft into real by deflating by ppi for aircraft
f_real_aircraft=junk_nos_m;
i1=f_ship_trans_air_parts_nondef~=junk_nos & ppi_aircraft~=junk_nos;
f_real_aircraft(i1)=f_ship_trans_air_parts_nondef(i1)./ppi_aircraft(i1);
f_g_real_aircraft=fn_compute_g_monthly(f_real_aircraft);
% fill in missing data
f_g_real_aircraft=fn_make_forecast(f_g_real_aircraft);
f4e=max(find(f_real_aircraft ~= junk_nos));
for i1=f4e+1:ff+5;
	f_real_aircraft(i1)=f_real_aircraft(i1-1)*(1+f_g_real_aircraft(i1)/100);
end;
[f_real_aircraft_q,f_g_real_aircraft_q,f_real_aircraft_next_q,f_g_real_aircraft_next_q]=...
	fn_convert_mtoqavg(f_real_aircraft,date_m,date_q);
f_g_real_aircraft_this_q=f_g_real_aircraft_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly real aircraft growth = ',num2str(f_g_real_aircraft_this_q,'%5.1f')]);
end;
%
% compute quarterly equipment and software investment growth
% NOTE SOFTWARE HAS BEEN REMOVED DUE TO THE NIPA REVISIONS
f_g_inv_es_this_q=share_inv_es_rest*f_g_real_ship_core_cap_goods_this_q+...
	share_inv_es_tn_autos*f_g_mv_sales_autos_bus_this_q+...
	share_inv_es_tn_lt*f_g_mv_sales_lt_bus_this_q+...
	share_inv_es_aircraft*f_g_real_aircraft_this_q;
if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in investment in equipment for ',num2str(current_quarter),', SAAR = ',num2str(f_g_inv_es_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
if run_quietly==0;
	redo2=input('To recompute equipment and software investment, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;

redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Investment: Intellectual Property ');
disp('----------------------------------------------------------------------------------');
end;

% display 4 most recent quarterly intellectual property growth readings
if display_text;
disp('Most recent quarterly intellectual property growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_inv_ipp(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
end; 

% Intellectual has three components:
% 1. Software Purchases 
% 2. Research & Development 
% 3. Entertainment, literary, & artistic originals 

% Setting Shares
share_inv_ipp_software=inv_es_ip_software_n(no_quarters_for_weights)/inv_ipp_n(no_quarters_for_weights);
share_inv_ipp_rd=inv_ipp_rd_n(no_quarters_for_weights)/inv_ipp_n(no_quarters_for_weights);
share_inv_ipp_ela = 1 - share_inv_ipp_software - share_inv_ipp_rd;


% Fill in forecast for intellectual property 
if display_text;
disp('--------------------------------------------');
disp('1. Software purchases.');
end;
% take the average of quarterly annualized growth in three components:
% i. IP for computers and electronic products
% ii. real retail software sales. * Has been removed/commented out.
% iii. real wholesale software sales
% 
% i. IP for computers and electronic components
f_ip_computers=ip_computers;
f2i=max(find(ip_computers~=junk_nos));
missing_no_months=3-(f2i-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of IP for computers and electronic components data.']);
end;
f_g_ip_computers=fn_make_forecast(g_ip_computers);
for i1=f2i+1:ff+5;
	f_ip_computers(i1)=f_ip_computers(i1-1)*(1+f_g_ip_computers(i1)/100);
end;
[f_ip_computers_q,f_g_ip_computers_q,f_ip_computers_next_q,f_g_ip_computers_next_q]=...
	fn_convert_mtoqavg(f_ip_computers,date_m,date_q);
% ii. real retail software sales

%% Updated on May 13, 2014. Census Bureau stopped releasing software data. 
%f_retail_software_real=junk_nos_m;
%f2r=max(find(retail_software~=junk_nos));
%i1=retail_software~=junk_nos & cpi_software~=junk_nos;
%f_retail_software_real(i1)=retail_software(i1)./cpi_software(i1);
%f_g_retail_software_real=fn_compute_g_monthly(f_retail_software_real);
%missing_no_months=3-(f2r-ff)-1;
%if display_text;
%disp(['Missing ',num2str(missing_no_months),' month(s) of retail software sales data.']);
%end;
%f_g_retail_software_real=fn_make_forecast(f_g_retail_software_real);
%for i1=f2r+1:ff+5;
%	f_retail_software_real(i1)=f_retail_software_real(i1-1)*(1+f_g_retail_software_real(i1)/100);
%end;
%[f_retail_software_real_q,f_g_retail_software_real_q,f_retail_software_real_next_q,f_g_retail_software_real_next_q]=...
%	fn_convert_mtoqavg(f_retail_software_real,date_m,date_q);
% iii. real wholesale software sales
f_sales_wholesale_software_real=sales_wholesale_software_real;
f2w=max(find(sales_wholesale_software_real~=junk_nos));
missing_no_months=3-(f2w-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of wholesale software sales data.']);
end;
[f_x_mov,f_g_sales_wholesale_software_real,f_x_exp, min_pos,text_software]=fn_make_forecast_software_wholesale(g_sales_wholesale_software_real);
for i1=f2w+1:ff+5;
	f_sales_wholesale_software_real(i1)=f_sales_wholesale_software_real(i1-1)*(1+f_g_sales_wholesale_software_real(i1)/100);
end;
[f_sales_wholesale_software_real_q,f_g_sales_wholesale_software_real_q,f_sales_wholesale_software_real_next_q,f_g_sales_wholesale_software_real_next_q]=...
	fn_convert_mtoqavg(f_sales_wholesale_software_real,date_m,date_q);
% average
%f_g_software_q=[f_g_ip_computers_q,f_g_retail_software_real_q,f_g_sales_wholesale_software_real_q];
f_g_software_q=[f_g_ip_computers_q,f_g_sales_wholesale_software_real_q];
f_g_software_avg_q=junk_nos*ones(size(date_q));
for i1=1:size(date_q,1);
	temp=f_g_software_q(i1,:);
	temp=temp(temp~=junk_nos);
	if isempty(temp)==0;
		f_g_software_avg_q(i1)=mean(temp);
	end;
end;
f_g_software_avg_this_q=f_g_software_avg_q(find(date_q==current_quarter));
%f_g_software_avg_next_q=mean([f_g_ip_computers_next_q,f_g_retail_software_real_next_q,f_g_sales_wholesale_software_real_next_q]);
f_g_software_avg_next_q=mean([f_g_ip_computers_next_q,f_g_sales_wholesale_software_real_next_q]);

if display_text;
disp(['Estimated quarterly software growth = ',num2str(f_g_software_avg_this_q,'%5.1f')]);
end; 
% Research & Deveopment 
if display_text;
disp('--------------------------------------------');
disp('2.Research & Development');
end;
% Research & Development is forecasted using a univariate forecast 
% A junk_nos is added to g_inv_ipp_rd to have a forecast into the next
% quarter 
g_inv_ipp_rd = [g_inv_ipp_rd;junk_nos];
[f_g_inv_ipp_rd,txt_q] = fn_make_forecast_q(g_inv_ipp_rd);
f_g_inv_ipp_rd_this_q = f_g_inv_ipp_rd(find(date_q==current_quarter));
xx = find(date_q==current_quarter);
f_g_inv_ipp_rd_next_q = f_g_inv_ipp_rd(xx+1);

if display_text;
disp(['Estimated using ',txt_q]);        
disp(['Estimated quarterly Research & Development growth = ',num2str(f_g_inv_ipp_rd_this_q,'%5.1f')]);
end; 
% Entertainment, literary & artistic originals 
if display_text;
disp('--------------------------------------------');
disp('3. Entertainment, literary & artistic originals (ELA).');
end;
% Entertainment, literary & artistic originals is forecasted using a univariate forecast 
% A junk_nos is added to g_inv_ipp_ela to have a forecast into the next
% quarter 
g_inv_ipp_ela = [g_inv_ipp_ela;junk_nos];
[f_g_inv_ipp_ela,txt_q] = fn_make_forecast_q(g_inv_ipp_ela);
f_g_inv_ipp_ela_this_q = f_g_inv_ipp_ela(find(date_q==current_quarter));
xx = find(date_q==current_quarter);
f_g_inv_ipp_ela_next_q = f_g_inv_ipp_ela(xx+1);
if display_text;
disp(['Estimating using ',txt_q]);    
disp(['Estimated quarterly entertainment, literary & artistic originals = ',num2str(f_g_inv_ipp_ela_this_q,'%5.1f')]);
end; 

% Compute quartery intellectual property investment growth 

f_g_inv_ipp_this_q = share_inv_ipp_software*f_g_software_avg_this_q + ...
    share_inv_ipp_rd*f_g_inv_ipp_rd_this_q + share_inv_ipp_ela*f_g_inv_ipp_ela_this_q;

if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in intellectual property for ',num2str(current_quarter),', SAAR = ',num2str(f_g_inv_ipp_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;

if run_quietly==0;
	redo2=input('To recompute equipment and software investment, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;
 








redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Investment: Residential Structures');
disp('----------------------------------------------------------------------------------');
end;
% sum of spending trying to match
% Need to find last quarter with data for all four variables
x = [inv_res_struc_other_improve_n,inv_res_struc_other_comm_n,inv_res_struc_perm_1fam_n,inv_res_struc_perm_mult_n];
x1 = max(x,[],2);
xx = max(find(x1 ~= junk_nos));

inv_res_to_match=inv_res_struc_other_improve_n(xx)+inv_res_struc_other_comm_n(xx)+...
	inv_res_struc_perm_1fam_n(xx)+inv_res_struc_perm_mult_n(xx);
% set shares
share_inv_res_struc_perm_1fam=inv_res_struc_perm_1fam_n(xx)/inv_res_to_match;
share_inv_res_struc_perm_mult=inv_res_struc_perm_mult_n(xx)/inv_res_to_match;
share_inv_res_other_comm=inv_res_struc_other_comm_n(xx)/inv_res_to_match;
share_inv_res_other_improve=inv_res_struc_other_improve_n(xx)/inv_res_to_match;
% display 4 most recent quarterly residential structures investment growth readings
if display_text;
disp('Most recent quarterly residential structures investment growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_inv_res(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
% need monthly growth rates for 4 variables:
% 1. single-family home construction
% 2. multi-family home construction
% 3. improvements
% 4. brokers' commissions
%


% disp('--------------------------------------------');
% disp('1. Single-family home construction.');
% end;
% f1=max(find(const_put_in_place_1fam~=junk_nos));
% f1b=max(find(housing_starts_1fam~=junk_nos));
% missing_no_months=3-(f1-ff)-1;
% f_const_put_in_place_1fam=const_put_in_place_1fam;
% f_g_const_put_in_place_1fam=g_const_put_in_place_1fam;
% f_g_housing_starts_1fam=g_housing_starts_1fam;
% % display last 6 months of data on single-family home construction
% if display_text;
% disp(['Monthly single-family residential construction:']);
% disp(['          New 1-family housing starts:   || Const. put-in-place:']);
% disp(['Date     Level (th., SAAR)  Growth (m/m) ||     Growth (m/m)']);
% if f1b >= f1;
% disp(num2str([date_m(f1b-6:f1b),housing_starts_1fam(f1b-6:f1b),g_housing_starts_1fam(f1b-6:f1b),...
% 	[g_const_put_in_place_1fam(f1b-6:f1);NaN*ones(f1b-f1,1)]],...
% 	'%10.2f %10.0f %15.1f %20.1f\n'));
% end;
% if f1> f1b;
%   disp(num2str([date_m(f1-6:f1),[housing_starts_1fam(f1-6:f1)],g_housing_starts_1fam(f1-6:f1),...
% 	[g_const_put_in_place_1fam(f1-6:f1)]],...
% 	'%10.2f %10.0f %15.1f %20.1f\n'));  
% end;
% end;
% % single-family housing starts have some predictive power over future single-family
% % construction put-in-place; use these, and forecasts of them, to fill in missing
% % data on construction put-in-place
% 
% 
% if f1b>f1;
% w=36;
% b_1fam=regress(g_const_put_in_place_1fam(f1-w+1:f1),[ones(w,1),g_housing_starts_1fam(f1-w+1:f1),...
% 	g_housing_starts_1fam(f1-w:f1-1),g_const_put_in_place_1fam(f1-w:f1-1)]);
% [f_g_housing_starts_1fam,txt]=fn_make_forecast(g_housing_starts_1fam);
% f_housing_starts_1fam=housing_starts_1fam;
% f_g_const_put_in_place_1fam=g_const_put_in_place_1fam;
% f_const_put_in_place_1fam=const_put_in_place_1fam;
% for i1=f1+1:ff+5;
% 	f_g_const_put_in_place_1fam(i1)=b_1fam'*[1;f_g_housing_starts_1fam(i1);f_g_housing_starts_1fam(i1-1);...
% 		f_g_const_put_in_place_1fam(i1-1)];
% 	f_housing_starts_1fam(i1)=f_housing_starts_1fam(i1-1)*(1+f_g_housing_starts_1fam(i1)/100);
% 	f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
% end;
% if f1<ff+2 & f1<f1b; % have one more reading on single-family housing starts than construction put-in-place, fill in
% 	if display_text;
% 	disp(['Have ',num2str(f1b-f1),' more month(s) single-family housing starts than construction put-in-place.']);
% 	for i1=f1+1:f1b;
% 		disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
% 			num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
% 		disp(['      to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);		
% 	end;
% 	end;
% end;
% if f1b<ff+2;
% 	if display_text;
% 	disp(['Missing ',num2str(3-(f1b-ff)-1),' month(s) of single-family housing starts.']);
% 	end;
% 	if run_quietly==1; in1=1; 
% 	if display_text;
% 	disp(['Use single-family housing starts ',txt,'.']);
% 	for i1=f1b+1:ff+2;
% 		disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
% 			num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
% 		disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);
% 	end;
% 	end;
% 	else;
% 	disp('Options to fill in missing month(s):');
% 	disp(['1. Use single-family housing starts ',txt,' (default).']);
% 	for i1=f1b+1:ff+2;
% 		disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
% 			num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
% 		disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);	
% 	end;
% 	disp('2. Enter single-family housing starts (thousands, SAAR) for missing month(s).');
% 	in1=input('--> Select 1 (or enter blank) or 2. ');
% 	end;
% 	if in1==2;
% 		for i1=f1b+1:ff+2;
% 			f_housing_starts_1fam(i1)=input(['Single-family housing starts for ',num2str(date_m(i1),'%7.2f'),' = ']);
% 			f_g_housing_starts_1fam(i1)=100*(f_housing_starts_1fam(i1)/f_housing_starts_1fam(i1-1)-1);
% 			f_g_const_put_in_place_1fam(i1)=b_1fam'*[1;f_g_housing_starts_1fam(i1);f_g_housing_starts_1fam(i1-1);...
% 				f_g_const_put_in_place_1fam(i1-1)];
% 			f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
% 			disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
% 				num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
% 			disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);	
% 		end;
% 		for i1=ff+3:ff+5;
% 			f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
% 		end;
% 	end;
% end;
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %{
% [f_const_put_in_place_1fam_q,f_g_const_put_in_place_1fam_q,f_const_put_in_place_1fam_next_q,f_g_const_put_in_place_1fam_next_q]=...
% 	fn_convert_mtoqavg(f_const_put_in_place_1fam,date_m,date_q);
% f_g_const_put_in_place_1fam_this_q=f_g_const_put_in_place_1fam_q(find(date_q==current_quarter));
% if display_text;
% disp(['Estimated quarterly single-family residential construction growth = ',num2str(f_g_const_put_in_place_1fam_this_q,'%5.1f')]);
% end;
% end;
% %}
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %load in the price index for house under construction and use that as SF price index
% f_pi_house_under_constr = pi_house_under_constr;
% f_pi_house_under_constr = fn_make_forecast(f_pi_house_under_constr);
% 
% %now compute real const_put_in_place by deflating the nominal levels by the price index
% i1=f_const_put_in_place_1fam~=junk_nos & f_pi_house_under_constr~=junk_nos;
% f_real_const_put_in_place_1fam = junk_nos_m;
% f_real_const_put_in_place_1fam(i1) = f_const_put_in_place_1fam(i1)./f_pi_house_under_constr(i1);
% 
% [f_real_const_put_in_place_1fam_q,f_g_real_const_put_in_place_1fam_q,f_real_const_put_in_place_1fam_next_q,f_g_real_const_put_in_place_1fam_next_q]=...
% 	fn_convert_mtoqavg(f_real_const_put_in_place_1fam,date_m,date_q);
% f_g_real_const_put_in_place_1fam_this_q=f_g_real_const_put_in_place_1fam_q(find(date_q==current_quarter));
% if display_text;
% disp(['Estimated quarterly single-family residential construction growth = ',num2str(f_g_real_const_put_in_place_1fam_this_q,'%5.1f')]);
% end;
% 
% end;
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %{
% %}
% 
% % Note this case is rare and only occured after the government shutdown
% % This is the case of having more construction put in place data than
% % housing starts
% 
% if f1>=f1b;
% % Fill in forecasts of construction put in place and housing starts univariately
% % First for construction put in place 
%  f_const_put_in_place_1fam_new = fn_make_forecast(f_const_put_in_place_1fam);
% 
%  %load in the price index for house under construction and use that as SF price index
% f_pi_house_under_constr = pi_house_under_constr;
% f_pi_house_under_constr = fn_make_forecast(f_pi_house_under_constr);
% 
% 
% %now compute real const_put_in_place by deflating the nominal levels by the price index
% i1=f_const_put_in_place_1fam_new~=junk_nos & f_pi_house_under_constr~=junk_nos;
% f_real_const_put_in_place_1fam = junk_nos_m;
% f_real_const_put_in_place_1fam(i1) = f_const_put_in_place_1fam_new(i1)./f_pi_house_under_constr(i1);
% 
% [f_real_const_put_in_place_1fam_q,f_g_real_const_put_in_place_1fam_q,f_real_const_put_in_place_1fam_next_q,f_g_real_const_put_in_place_1fam_next_q]=...
% 	fn_convert_mtoqavg(f_real_const_put_in_place_1fam,date_m,date_q);
% f_g_real_const_put_in_place_1fam_this_q=f_g_real_const_put_in_place_1fam_q(find(date_q==current_quarter));
% if display_text;
% disp(['Estimated quarterly single-family residential construction growth = ',num2str(f_g_real_const_put_in_place_1fam_this_q,'%5.1f')]);
% end;
% 
% % Fill in housing starts
% % Note that we need to forecast housing starts forward for the judgment program
% f_housing_starts_1fam = fn_make_forecast(housing_starts_1fam);
% 
% % Finally for the judgment program we also need to estiamte the historical
% % linear relationship between housing starts and construciton put in place.
% % Again note this is only done for the judgment program. We also need a
% % univarite forecast of single family construction put in place.
% 
% w=36;
% b_1fam=regress(g_const_put_in_place_1fam(f1b-w+1:f1b),[ones(w,1),g_housing_starts_1fam(f1b-w+1:f1b),...
% 	g_housing_starts_1fam(f1b-w:f1b-1),g_const_put_in_place_1fam(f1b-w:f1b-1)]);
% 
% f_const_put_in_place_1fam(f1+1:ff+5)=f_const_put_in_place_1fam_new(f1+1:ff+5);
% 
% 
% 
% end;
% 

    %%
    disp('--------------------------------------------');
    disp('1. Single-family home construction.');
end;

f1=max(find(const_put_in_place_1fam~=junk_nos));
f1b=max(find(housing_starts_1fam~=junk_nos));
missing_no_months=3-(f1-ff)-1;

% display last 6 months of data on single-family home construction
if display_text;
    disp(['Monthly single-family residential construction:']);
    disp(['          New 1-family housing starts:   || Const. put-in-place:']);
    disp(['Date     Level (th., SAAR)  Growth (m/m) ||     Growth (m/m)']);
    if f1b >= f1;
        disp(num2str([date_m(f1b-6:f1b),housing_starts_1fam(f1b-6:f1b),g_housing_starts_1fam(f1b-6:f1b),...
            [g_const_put_in_place_1fam(f1b-6:f1);NaN*ones(f1b-f1,1)]],...
            '%10.2f %10.0f %15.1f %20.1f\n'));
    end;
    if f1> f1b;
        disp(num2str([date_m(f1-6:f1),[housing_starts_1fam(f1-6:f1)],g_housing_starts_1fam(f1-6:f1),...
            [g_const_put_in_place_1fam(f1-6:f1)]],...
            '%10.2f %10.0f %15.1f %20.1f\n'));  
    end;
end;

% single-family housing starts have some predictive power over future single-family
% construction put-in-place; use these, and forecasts of them, to fill in missing
% data on construction put-in-place
 
% use data from past three years to estimate:
% pip_t = alpha + beta_0*starts +
% beta_1*starts(-1) + beta_2*starts(-2) + beta_3*starts(-3) +
% beta_4*starts(-4) + beta_5*starts(-5)
w=36;
b_1fam=regress(g_const_put_in_place_1fam(f1-w+1:f1),[ones(w,1),g_housing_starts_1fam(f1-w+1:f1),...
    g_housing_starts_1fam(f1-w:f1-1),g_housing_starts_1fam(f1-w-1:f1-2), g_housing_starts_1fam(f1-w-2:f1-3),...
    g_housing_starts_1fam(f1-w-3:f1-4),g_housing_starts_1fam(f1-w-4:f1-5)]);

% forecast starts data, then project forecasts into pip growth using 
% regression results
[f_g_housing_starts_1fam,txt]=fn_make_forecast(g_housing_starts_1fam);
    
% create vectors to store forecasts
f_housing_starts_1fam=housing_starts_1fam;
f_g_const_put_in_place_1fam=g_const_put_in_place_1fam;
f_const_put_in_place_1fam=const_put_in_place_1fam;

for i1=f1+1:ff+5;
	f_g_const_put_in_place_1fam(i1)=b_1fam'*[1;f_g_housing_starts_1fam(i1);f_g_housing_starts_1fam(i1-1);...
        f_g_housing_starts_1fam(i1-2); f_g_housing_starts_1fam(i1-3); f_g_housing_starts_1fam(i1-4);...
        f_g_housing_starts_1fam(i1-5)];
	% compute levels from growth rates
	f_housing_starts_1fam(i1)=f_housing_starts_1fam(i1-1)*(1+f_g_housing_starts_1fam(i1)/100);
	f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
end;

if display_text;
    disp(['Have ',num2str(f1b-f1),' more month(s) single-family housing starts than construction put-in-place.']);
    for i1=f1+1:f1b;
        disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
            num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
        disp(['      to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);		
	end;
end;


if f1b<ff+2; % this should always be the case
    if display_text;
        disp(['Missing ',num2str(3-(f1b-ff)-1),' month(s) of single-family housing starts.']);
	end;
    
	% if run_quietly is on, automatically choose option 1 -- this will
	% leave the forecast as-is
	if run_quietly==1; in1=1; 
	
        if display_text;
            disp(['Use single-family housing starts ',txt,'.']);
            for i1=f1b+1:ff+2;
                disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
                      num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
                disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);
            end;
        end;	
        
	% if run_quietly is not on, the model will give the option to leave
	% the forecast as-is or to enter the level of starts in thousands
	% for missing months (option 2)
	else;
        disp('Options to fill in missing month(s):');
        disp(['1. Use single-family housing starts ',txt,' (default).']);
        for i1=f1b+1:ff+2;
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
                num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
                disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);	
        end;
        disp('2. Enter single-family housing starts (thousands, SAAR) for missing month(s).');
            in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
        for i1=f1b+1:ff+2;
            f_housing_starts_1fam(i1)=input(['Single-family housing starts for ',num2str(date_m(i1),'%7.2f'),' = ']);
            f_g_housing_starts_1fam(i1)=100*(f_housing_starts_1fam(i1)/f_housing_starts_1fam(i1-1)-1);
            f_g_const_put_in_place_1fam(i1)=b_1fam'*[1;f_g_housing_starts_1fam(i1);f_g_housing_starts_1fam(i1-1);...
                f_g_housing_starts_1fam(i1-2);f_g_housing_starts_1fam(i1-3);f_g_housing_starts_1fam(i1-4);...
                f_g_housing_starts_1fam(i1-5)];
            f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
            disp(['     For ',num2str(date_m(i1),'%7.2f'),': single-family housing starts of ',...
                num2str(f_housing_starts_1fam(i1),'%5.0f'),' thousand translate']);
            disp(['       to growth of single-family construction put-in-place of ',num2str(f_g_const_put_in_place_1fam(i1),'%5.1f'),'.']);	
        end;
        for i1=ff+3:ff+5;
            f_const_put_in_place_1fam(i1)=f_const_put_in_place_1fam(i1-1)*(1+f_g_const_put_in_place_1fam(i1)/100);
        end;
	end;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load in the price index for house under construction and use that as SF price index
f_pi_house_under_constr = pi_house_under_constr;

% univariate forecast the price index
f_pi_house_under_constr = fn_make_forecast(f_pi_house_under_constr);    

% now compute real const_put_in_place by deflating the nominal levels by the price index
i1=f_const_put_in_place_1fam~=junk_nos & f_pi_house_under_constr~=junk_nos;
f_real_const_put_in_place_1fam = junk_nos_m;
f_real_const_put_in_place_1fam(i1) = f_const_put_in_place_1fam(i1)./f_pi_house_under_constr(i1);
    
% convert real construction put in place from monthly to quarterly
% values for this q and next q
[f_real_const_put_in_place_1fam_q,f_g_real_const_put_in_place_1fam_q,f_real_const_put_in_place_1fam_next_q,f_g_real_const_put_in_place_1fam_next_q]=...
fn_convert_mtoqavg(f_real_const_put_in_place_1fam,date_m,date_q);
f_g_real_const_put_in_place_1fam_this_q=f_g_real_const_put_in_place_1fam_q(find(date_q==current_quarter));
    
% display results -- growth in real 1fam construction pip for this q
if display_text;
    disp(['Estimated quarterly single-family residential construction growth = ',num2str(f_g_real_const_put_in_place_1fam_this_q,'%5.1f')]);
end;


if display_text;
%
disp('--------------------------------------------');
disp('2. Multi-family home construction.');
end;
f2=max(find(const_put_in_place_1fam~=junk_nos));
missing_no_months=3-(f2-ff)-1;
f_const_put_in_place_mult=const_put_in_place_mult;
f_g_const_put_in_place_mult=g_const_put_in_place_mult;
% display last 6 months of data on multi-family home construction
if display_text;
disp(['Monthly multi-family residential construction put-in-place:']);
disp(['Date      Growth rate (m/m)']);
disp(num2str([date_m(f2-5:f2),g_const_put_in_place_mult(f2-5:f2)],'%10.2f %11.1f\n'));
end;
[f_g_const_put_in_place_mult,txt]=fn_make_forecast(f_g_const_put_in_place_mult);
if f2<ff+2;
	if display_text;
	disp(['Missing ',num2str(missing_no_months),' month(s) of multi-family construction data.']);
	end;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Use multi-family construction growth rate ']);
	disp([txt,'.']);
	end;
	for i1=f2+1:ff+2;
		if display_text;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': multi-family res. construction put-in-place growth = ',num2str(f_g_const_put_in_place_mult(i1),'%4.1f')]);
		end;
		f_const_put_in_place_mult(i1)=f_const_put_in_place_mult(i1-1)*(1+f_g_const_put_in_place_mult(i1)/100);
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use multi-family construction growth rate ',txt,' (default).']);
	for i1=f2+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': multi-family res. construction put-in-place growth = ',num2str(f_g_const_put_in_place_mult(i1),'%4.1f')]);
		f_const_put_in_place_mult(i1)=f_const_put_in_place_mult(i1-1)*(1+f_g_const_put_in_place_mult(i1)/100);
	end;
	disp('2. Enter data (multi-family res. construction put-in-place growth rates) for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f2+1:ff+2;
			f_g_const_put_in_place_mult(i1)=input(['Growth in 1-family res. construction put-in-place for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_const_put_in_place_mult(i1)=f_const_put_in_place_mult(i1-1)*(1+f_g_const_put_in_place_mult(i1)/100);
		end;
	end;
end;
for i1=ff+3:ff+5;
	f_const_put_in_place_mult(i1)=f_const_put_in_place_mult(i1-1)*(1+f_g_const_put_in_place_mult(i1)/100);
end;
%{
[f_const_put_in_place_mult_q,f_g_const_put_in_place_mult_q,f_const_put_in_place_mult_next_q,f_g_const_put_in_place_mult_next_q]=...
	fn_convert_mtoqavg(f_const_put_in_place_mult,date_m,date_q);
f_g_const_put_in_place_mult_this_q=f_g_const_put_in_place_mult_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly multi-family residential construction growth = ',num2str(f_g_const_put_in_place_mult_this_q,'%5.1f')]);
end
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%load in the price index for house under construction and use that as SF price index
f_pi_mf_resid_struc = pi_mf_resid_struc;
f_pi_mf_resid_struc = fn_make_forecast(f_pi_mf_resid_struc);


%now compute real const_put_in_place by deflating the nominal levels by the price index
i1=f_const_put_in_place_mult~=junk_nos & f_pi_mf_resid_struc~=junk_nos;
f_real_const_put_in_place_mult = junk_nos_m;
f_real_const_put_in_place_mult(i1) = f_const_put_in_place_mult(i1)./f_pi_mf_resid_struc(i1);


[f_real_const_put_in_place_mult_q,f_g_real_const_put_in_place_mult_q,f_real_const_put_in_place_mult_next_q,f_g_real_const_put_in_place_mult_next_q]=...
	fn_convert_mtoqavg(f_real_const_put_in_place_mult,date_m,date_q);
f_g_real_const_put_in_place_mult_this_q=f_g_real_const_put_in_place_mult_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly multi-family residential construction growth = ',num2str(f_g_real_const_put_in_place_mult_this_q,'%5.1f')]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%
disp('--------------------------------------------');
disp('3. Residential improvements.');
end;
%{
f3a=max(find(retail_building_mats~=junk_nos));
f3b=max(find(ppi_repair_const~=junk_nos));
f_real_res_improvements=junk_nos_m;
f_g_real_res_improvements=f_real_res_improvements;
i1=retail_building_mats~=junk_nos & ppi_repair_const~=junk_nos;
f_real_res_improvements(i1)=retail_building_mats(i1)./ppi_repair_const(i1);
f_g_real_res_improvements=fn_compute_g_monthly(f_real_res_improvements);
f_g_real_res_improvements=fn_make_forecast(f_g_real_res_improvements);
f3c = max(find(f_real_res_improvements~=junk_nos));
for i1=f3c+1:ff+5;
	f_real_res_improvements(i1)=f_real_res_improvements(i1-1)*(1+f_g_real_res_improvements(i1)/100);
end;
missing_no_months=3-(f3a-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of real residential improvements data.']);
end;
[f_real_res_improvements_q,f_g_real_res_improvements_q,f_real_res_improvements_next_q,f_g_real_res_improvements_next_q]=...
	fn_convert_mtoqavg(f_real_res_improvements,date_m,date_q);
f_g_real_res_improvements_this_q=f_g_real_res_improvements_q(find(date_q==current_quarter));
%}


%Revised improvements code starts here
%Forecast nominal improvements level using retail sales and average hourly earnings
%First, fill in any missing observations for the two regressors by forecasting their respective growth rates
lobs1=max(find(retail_building_mats~=junk_nos));
lobs2=max(find(ahe_contractors~=junk_nos));
f_retail_building_mats = retail_building_mats;
f_g_retail_building_mats = g_retail_building_mats;
f_g_retail_building_mats = fn_make_forecast(f_g_retail_building_mats);
for i1 = lobs1+1:ff+5;
	f_retail_building_mats(i1) = f_retail_building_mats(i1-1)*(1+f_g_retail_building_mats(i1)/100);
end;

f_ahe_contractors = ahe_contractors;
f_g_ahe_contractors = fn_compute_g_monthly(f_ahe_contractors);
f_g_ahe_contractors = fn_make_forecast(f_g_ahe_contractors);
for i1 = lobs2+1:ff+5;
	f_ahe_contractors(i1) = f_ahe_contractors(i1-1)*(1+f_g_ahe_contractors(i1)/100);
end;

%regress nominal improvement growth on growth in retail sales and earnings to forecast nominal improvement growth
%compute monthly inprovement investment by taking 3mma of the disaggregate quarterly series and dividing it by 12 to get the monthly rate
w = 36;
lobs3 = max(find(res_improvements_q~=junk_nos));
fobs = min(find(res_improvements_q~=junk_nos));
f_res_improvements = junk_nos_m;
f_res_improvements(fobs:lobs3) = movingmean(res_improvements_q(fobs:lobs3),3)/12;

f_g_res_improvements = fn_compute_g_monthly(f_res_improvements);

b_improve_g = regress(f_g_res_improvements(lobs3-w:lobs3-1),[ones(w,1),f_g_res_improvements(lobs3-w-1:lobs3-2),...
f_g_res_improvements(lobs3-w-2:lobs3-3),f_g_retail_building_mats(lobs3-w:lobs3-1),f_g_ahe_contractors(lobs3-w:lobs3-1)]);

for i1 = lobs3:ff+5;
f_g_res_improvements(i1)=b_improve_g'*[1;f_g_res_improvements(i1-1);f_g_res_improvements(i1-2);f_g_retail_building_mats(i1);...
		f_g_ahe_contractors(i1)];
end;

%comupte implied nominal improvement investment based on forecasted growth
f_res_improvements_greg = f_res_improvements;
for i1 = lobs3:ff+5;
f_res_improvements_greg(i1) = f_res_improvements_greg(i1-1)*(1+f_g_res_improvements(i1)/100);
end;

%now, forecast nominal improvement investment with a log linear regression
ln_res_improvements = log(f_res_improvements);
ln_retail_building_mats = log(f_retail_building_mats);
ln_ahe_contractors = log(f_ahe_contractors);
w = 36;
b_lnimprove = regress(ln_res_improvements(lobs3-w:lobs3-1),[ones(w,1),ln_retail_building_mats(lobs3-w-1:lobs3-2),...
ln_ahe_contractors(lobs3-w:lobs3-1)]);
f_res_improvements_lnreg = f_res_improvements;
for i1 = lobs3:ff+5;
f_res_improvements_lnreg(i1)=exp(b_lnimprove'*[1;ln_retail_building_mats(i1-1);ln_ahe_contractors(i1)]);
end;

% use the simple average of the two forecasts for final nominal improvement investment
for i1 = lobs3:ff+5;
f_res_improvements(i1) = 1/2*(f_res_improvements_greg(i1)+f_res_improvements_lnreg(i1));
end;

%for i1 = lobs3:ff+5;
%f_res_improvements(i1) = f_res_improvements_greg(i1);
%end;

%for i1 = lobs3:ff+5;
%f_res_improvements(i1) = f_res_improvements_lnreg(i1);
%end;

% now compute the corresponding price index to deflate improvements investment
% take centered 3mma of the disaggregated quarterly price index of improvements to get a proxy for the monthly equivalent
f_pi_res_improvements = junk_nos_m;
f_pi_res_improvements(fobs:lobs3) = movingmean(pi_res_improvements_q(fobs:lobs3),3);

f_g_pi_res_improvements = fn_compute_g_monthly(f_pi_res_improvements);

lobs4 = max(find(eci_comp_constr~=junk_nos));
fobs2 = min(find(eci_comp_constr~=junk_nos));
f_eci_comp_constr = junk_nos_m;
f_eci_comp_constr(fobs2:lobs4) = movingmean(eci_comp_constr(fobs2:lobs4),3);
f_g_eci_comp_constr = fn_compute_g_monthly(f_eci_comp_constr);
f_g_eci_comp_constr(lobs4) = junk_nos;
[f_g_eci_comp_constr,method] = fn_make_forecast(f_g_eci_comp_constr);

f_g_pi_house_under_constr = g_pi_house_under_constr;
f_g_pi_house_under_constr = fn_make_forecast(f_g_pi_house_under_constr);

f_g_ppi_res_maint_input = g_ppi_res_maint_input_combine;
[f_g_ppi_res_maint_input, text_res_maint_input] = fn_make_forecast(f_g_ppi_res_maint_input);

%Regress res improvements on first 2 lags of itself, current and lagged eci, house under construction pi, and maintenance input pi
b_pi_improve = regress(f_g_pi_res_improvements(lobs3-w+1:lobs3),[ones(w,1),f_g_pi_res_improvements(lobs3-w:lobs3-1),...
f_g_pi_res_improvements(lobs3-w-1:lobs3-2),f_g_eci_comp_constr(lobs3-w+1:lobs3),f_g_eci_comp_constr(lobs3-w:lobs3-1),...
f_g_pi_house_under_constr(lobs3-w+1:lobs3),f_g_ppi_res_maint_input(lobs3-w+1:lobs3)]);

%Use regression coefficients to impute growth in res improvements pi starting with current month
lobs5 = max(find(f_g_pi_res_improvements~=junk_nos));
for i1 = lobs5:ff+5;
f_g_pi_res_improvements(i1)=b_pi_improve'*[1;f_g_pi_res_improvements(i1-1);f_g_pi_res_improvements(i1-2);...
f_g_eci_comp_constr(i1);f_g_eci_comp_constr(i1-1);f_g_pi_house_under_constr(i1);f_g_ppi_res_maint_input(i1)];
end;

%set price index to disaggregated quarterly price index for res improvements; convert to 3mma
f_pi_res_improvements = pi_res_improvements_q;
f_pi_res_improvements(fobs:lobs3) = movingmean(f_pi_res_improvements(fobs:lobs3),3);

%forecast price index levels using imputed growth rate
for i1 = lobs5:ff+5;
f_pi_res_improvements(i1) = f_pi_res_improvements(i1-1)*(1+f_g_pi_res_improvements(i1)/100);
end;


%now compute real improvement investment by deflating the nominal levels by the price index
i1=f_res_improvements~=junk_nos & f_pi_res_improvements~=junk_nos;
f_real_res_improvements = junk_nos_m;
f_real_res_improvements(i1) = f_res_improvements(i1)./f_pi_res_improvements(i1);

% calculate monthly equivalent of the SAAR series
%f_real_res_improvements_m = f_real_res_improvements/12;

[f_real_res_improvements_q,f_g_real_res_improvements_q,f_real_res_improvements_next_q,f_g_real_res_improvements_next_q]=...
	fn_convert_mtoqavg(f_real_res_improvements,date_m,date_q);
f_g_real_res_improvements_this_q=f_g_real_res_improvements_q(find(date_q==current_quarter));

if display_text;
disp(['Estimated quarterly residential improvements growth = ',num2str(f_g_real_res_improvements_this_q,'%5.1f')]);
%
disp('--------------------------------------------');
disp('4. Brokers commissions.');
disp('Separating into existing and new single-family home sales.');
end;
f4a=max(find(house_sales_1fam_ex~=junk_nos));
f4b=max(find(house_p_ex~=junk_nos));
f4c=max(find(house_sales_1fam_new~=junk_nos));
f4d=max(find(house_p_new~=junk_nos));
f4e=max(find(ppi_brokerage_fees~=junk_nos));
% note: ordering should be: ppi, existing homes, new homes
f_ppi_brokerage_fees=ppi_brokerage_fees;
f_g_ppi_brokerage_fees=g_ppi_brokerage_fees;
% fill in missing ppi readings
f_g_ppi_brokerage_fees=fn_make_forecast(f_g_ppi_brokerage_fees);
for i1=f4e+1:ff+2;
	f_ppi_brokerage_fees(i1)=f_ppi_brokerage_fees(i1-1)*(1+f_g_ppi_brokerage_fees(i1-1)/100);
end;
% start with existing home sales
missing_no_months=3-(f4a-ff)-1;
f_house_sales_1fam_ex=house_sales_1fam_ex;
f_g_house_sales_1fam_ex=g_house_sales_1fam_ex;
f_house_p_ex=house_p_ex;
f_g_house_p_ex=g_house_p_ex;
% display last 6 months of data on existing home sales and prices
if display_text;
disp(['Monthly existing single-family home market:']);
disp(['                   Sales:                ||          Prices:']);
disp(['Date     Level (mil.,SAAR)  Growth (m/m) || Level (th. $)  Growth (m/m)']);
disp(num2str([date_m(f4a-5:f4a),house_sales_1fam_ex(f4a-5:f4a)/1000000,g_house_sales_1fam_ex(f4a-5:f4a),...
	house_p_ex(f4a-5:f4a)/1000,g_house_p_ex(f4a-5:f4a)],'%13.2f %9.2f %17.1f %16.1f %13.1f\n'));
end;
% in case missing house prices for some reason (shouldn't, but just in case)
if f4b<f4a;
	[f_g_house_p_ex,txt]=fn_make_forecast(f_g_house_p_ex);
	f_g_house_p_ex(f4a+1:length(f_g_house_p_ex))=junk_nos;
	for i1=f4b:f4a;
		f_house_p_ex(i1)=f_house_p_ex(i1-1)*(1+f_g_house_p_ex(i1)/100);
	end;
end;
f_g_house_sales_1fam_ex=fn_make_forecast(f_g_house_sales_1fam_ex);
f_g_house_p_ex=fn_make_forecast(f_g_house_p_ex);
if f4a<ff+2;
	if display_text;
	disp(['Missing ',num2str(missing_no_months),' month(s) of existing single-family home sales data.']);
	end;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Separately find growth rates for existing home sales and prices.']);
	end;
	for i1=f4a+1:ff+2;
		f_house_sales_1fam_ex(i1)=f_house_sales_1fam_ex(i1-1)*(1+f_g_house_sales_1fam_ex(i1)/100);
		f_house_p_ex(i1)=f_house_p_ex(i1-1)*(1+f_g_house_p_ex(i1)/100);
	end;	
	else;	
	disp('Options to fill in missing month(s):');
	disp(['1. Separately find growth rates for existing home sales and prices (default).']);
	for i1=f4a+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': existing single-family home sales growth = ',num2str(f_g_house_sales_1fam_ex(i1))]);
		f_house_sales_1fam_ex(i1)=f_house_sales_1fam_ex(i1-1)*(1+f_g_house_sales_1fam_ex(i1)/100);
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': existing single-family home prices growth = ',num2str(f_g_house_p_ex(i1))]);
		f_house_p_ex(i1)=f_house_p_ex(i1-1)*(1+f_g_house_p_ex(i1)/100);
	end;
	disp('2. Enter data in LEVELS for sales and prices for missing month(s).');
	disp('3. Enter data in GROWTH RATES for sales and prices for missing month(s).');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end;
	if in1==2;
		for i1=f4a+1:ff+2;
			f_house_sales_1fam_ex(i1)=input(['Level of single-family existing home sales, in millions, for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_house_sales_1fam_ex(i1)=f_house_sales_1fam_ex(i1)*1000000;
			f_g_house_sales_1fam_ex(i1)=100*(f_house_sales_1fam_ex(i1)/f_house_sales_1fam_ex(i1-1)-1);
			f_house_p_ex(i1)=input(['Level of single-family existing home prices, in dollars, for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_house_p_ex(i1)=100*(f_house_p_ex(i1)/f_house_p_ex(i1-1)-1);
		end;
	end;
	if in1==3;
		for i1=f4a+1:ff+2;
			f_g_house_sales_1fam_ex(i1)=input(['Growth rate of single-family existing home sales for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_house_sales_1fam_ex(i1)=f_house_sales_1fam_ex(i1-1)*(1+f_g_house_sales_1fam_ex(i1)/100);
			f_g_house_p_ex(i1)=input(['Growth rate of single-family existing home prices for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_house_p_ex(i1)=f_house_p_ex(i1-1)*(1+f_g_house_p_ex(i1)/100);
		end;
	end;
end;	
if display_text;
if f4a<ff+2;
disp(['Forecasts for monthly existing single-family home market:']);
disp(['                   Sales:                ||          Prices:']);
disp(['Date     Level (mil.,SAAR)  Growth (m/m) || Level (th. $)  Growth (m/m)']);
disp(num2str([date_m(f4a+1:ff+2),f_house_sales_1fam_ex(f4a+1:ff+2)/1000000,f_g_house_sales_1fam_ex(f4a+1:ff+2),...
	f_house_p_ex(f4a+1:ff+2)/1000,f_g_house_p_ex(f4a+1:ff+2)],'%13.2f %9.2f %17.1f %16.1f %13.1f\n'));
end;
end;
% next do new home sales
missing_no_months=3-(f4c-ff)-1;
f_house_sales_1fam_new=house_sales_1fam_new;
f_g_house_sales_1fam_new=g_house_sales_1fam_new;
f_house_p_new=house_p_new;
f_g_house_p_new=g_house_p_new;
% display last 6 months of data on new home sales and prices
if display_text;
disp(['Monthly new single-family home market:']);
disp(['                   Sales:                ||          Prices:']);
disp(['Date     Level (th.,SAAR)   Growth (m/m) || Level (th. $)  Growth (m/m)']);
disp(num2str([date_m(f4c-5:f4c),house_sales_1fam_new(f4c-5:f4c),g_house_sales_1fam_new(f4c-5:f4c),...
	house_p_new(f4c-5:f4c)/1000,g_house_p_new(f4c-5:f4c)],'%13.2f %9.0f %17.1f %16.1f %13.1f\n'));
end;
% in case missing house prices for some reason (shouldn't, but just in case)
if f4d<f4c;
	f_g_house_p_new=fn_make_forecast(f_g_house_p_new);
	f_g_house_p_new(f4a+1:length(f_g_house_p_new))=junk_nos;
	for i1=f4d:f4c;
		f_house_p_new(i1)=f_house_p_new(i1-1)*(1+f_g_house_p_new(i1)/100);
	end;
end;
f_g_house_sales_1fam_new=fn_make_forecast(f_g_house_sales_1fam_new);
f_g_house_p_new=fn_make_forecast(f_g_house_p_new);
if f4c<ff+2;
	if display_text;
	disp(['Missing ',num2str(missing_no_months),' month(s) of new single-family home sales data.']);
	end;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Separately find growth rates for new home sales and prices.']);
	end;
	for i1=f4c+1:ff+2;
		f_house_sales_1fam_new(i1)=f_house_sales_1fam_new(i1-1)*(1+f_g_house_sales_1fam_new(i1)/100);
		f_house_p_new(i1)=f_house_p_new(i1-1)*(1+f_g_house_p_new(i1)/100);
	end;
	else;	
	disp('Options to fill in missing month(s):');
	disp(['1. Separately find growth rates for new home sales and prices (default).']);
	for i1=f4c+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': new single-family home sales growth = ',num2str(f_g_house_sales_1fam_new(i1))]);
		f_house_sales_1fam_new(i1)=f_house_sales_1fam_new(i1-1)*(1+f_g_house_sales_1fam_new(i1)/100);
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': new single-family home prices growth = ',num2str(f_g_house_p_new(i1))]);
		f_house_p_new(i1)=f_house_p_new(i1-1)*(1+f_g_house_p_new(i1)/100);
	end;
	disp('2. Enter data in LEVELS for missing month(s).');
	disp('3. Enter data in GROWTH RATES for missing month(s).');
	in1=input('--> Select 1 (or enter blank), 2, or 3. ');
	end;
	if in1==2;
		for i1=f4c+1:ff+2;
			f_house_sales_1fam_new(i1)=input(['Level of single-family new home sales, in thousands, for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_house_sales_1fam_new(i1)=100*(f_house_sales_1fam_new(i1)/f_house_sales_1fam_new(i1-1)-1);
			f_house_p_new(i1)=input(['Level of single-family new home prices, in dollars, for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_g_house_p_new(i1)=100*(f_house_p_new(i1)/f_house_p_new(i1-1)-1);
		end;
	end;
	if in1==3;
		for i1=f4c+1:ff+2;
			f_g_house_sales_1fam_new(i1)=input(['Growth rate of single-family new home sales for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_house_sales_1fam_new(i1)=f_house_sales_1fam_new(i1-1)*(1+f_g_house_sales_1fam_new(i1)/100);
			f_g_house_p_new(i1)=input(['Growth rate of single-family new home prices for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_house_p_new(i1)=f_house_p_new(i1-1)*(1+f_g_house_p_new(i1)/100);
		end;
	end;
end;
if display_text;
if f4c<ff+2;
disp(['Forecasts for monthly new single-family home market:']);
disp(['                   Sales:                ||          Prices:']);
disp(['Date     Level (th.,SAAR)   Growth (m/m) || Level (th. $)  Growth (m/m)']);
disp(num2str([date_m(f4c+1:ff+2),f_house_sales_1fam_new(f4c+1:ff+2),f_g_house_sales_1fam_new(f4c+1:ff+2),...
	f_house_p_new(f4c+1:ff+2)/1000,f_g_house_p_new(f4c+1:ff+2)],'%13.2f %9.0f %17.1f %16.1f %13.1f\n'));
end;
end;
f_real_commissions=junk_nos_m;
for i1=ff-3:ff+2;
	f_real_commissions(i1)=0.06*(f_house_sales_1fam_ex(i1)/12*f_house_p_ex(i1)+...
		f_house_sales_1fam_new(i1)*1000/12*f_house_p_new(i1))/f_ppi_brokerage_fees(i1);
end;
f_real_commissions_last_q=mean(f_real_commissions(ff-3:ff-1));
f_real_commissions_this_q=mean(f_real_commissions(ff:ff+2));
f_g_real_commissions_this_q=100*((f_real_commissions_this_q/f_real_commissions_last_q)^4-1);
if display_text;
disp(['Estimated quarterly residential commissions growth = ',num2str(f_g_real_commissions_this_q,'%5.1f')]);
end;
%
% compute quarterly residential structures investment growth
f_g_inv_res_this_q=share_inv_res_struc_perm_1fam*f_g_real_const_put_in_place_1fam_this_q+...
	share_inv_res_struc_perm_mult*f_g_real_const_put_in_place_mult_this_q+...
	share_inv_res_other_improve*f_g_real_res_improvements_this_q+...
	share_inv_res_other_comm*f_g_real_commissions_this_q;
if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in investment in residential structures for ',num2str(current_quarter),', SAAR = ',num2str(f_g_inv_res_this_q,'%6.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
if run_quietly==0;
	redo2=input('To recompute residential investment, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;















%redo1=0;
%while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Investment: Inventories');
disp('----------------------------------------------------------------------------------');
% display 4 most recent inventory change readings
disp('Most recent quarterly change in inventories readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),inv_ch_inv(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));

%
% Inventory data are similar to consumption.  BEA publishes a monthly series on
% real manufacturing and trade inventories, seasonally adjusted, end of period,
% in the list of underlying detail tables.
% This series is in levels for manufacturing industries, merchant wholesale 
% industries, and retail trade industries.  Taking first differences and multiplying
% by 12 gives the monthly real change in inventories series that is used to compute
% quarterly change in inventories for manufacturing and retail trade; note that 
% the monthly series is for merchant wholesale trade, which differs from (total)
% wholesale trade.  Additionally, the series comes out with a considerable lag.
% Prior to the first GDP estimate, there is typically one estimate of these real
% levels.  As soon as the first GDP estimate is released, BEA also releases the
% imputed monthly real values for the missing months; these are noted by an "est"
% in the code.  Revisions subsequently muddy the picture as well.
%
disp('--------------------------------------------');
disp('1. Manufacturing inventories.');
end;
% order for manufacturing inventories
% 1. Advance durables report, contains advance data on durable goods inventories, 
% plus revisions to previous months for durable goods inventories; at this point,
% have durable inventories for month t, nondurable inventories for month t-1, BEA
% estimate of manufacturing inventories for month t-2
% 2. BEA releases GDP and monthly detail on manufacturing inventories for month t-1
% (presumably the BEA incorporates revisions to durable goods); at this point, have
% durable inventories for month t, nondurable inventories for month t-1, BEA estimate
% of manufacturing inventories for month t-1
% 3. Factory Orders report, contains further revisions to durable goods inventories
% and new data for nondurable goods inventories; at this point, have durable and 
% nondurable inventories for month t, BEA estimate for month t-1
%
% determine which case in
f1a=max(find(inv_census_mfg_dur~=junk_nos)); % durable goods inventories come out with the advance report
f1b=max(find(inv_census_mfg_nondur~=junk_nos)); % nondurable goods inventories come out with the factory orders (full) report
f2a=max(find(inv_bea_mfg_real~=junk_nos));
f2b=max(find(ch_inv_bea_mfg_real_est~=junk_nos));
f_ch_inv_mfg_real=junk_nos_m;
missing_no_months=3-(f1b-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of Census total mfg. inventories data.']);
if f1a>f1b;
	disp(['Have ',num2str(f1a-f1b),' extra month(s) of Census durable mfg. inventories than nondurables.']);
end;
disp(['Missing ',num2str(3-(f2a-ff)-1),' month(s) of BEA mfg. inventories data.']);
end;
% compute total mfg. inventories based on durables and nondurables
i1=inv_census_mfg_dur~=junk_nos & inv_census_mfg_nondur~=junk_nos;
f_inv_census_mfg=junk_nos_m;
f_g_inv_census_mfg=junk_nos_m;
f_inv_census_mfg(i1)=inv_census_mfg_dur(i1)+inv_census_mfg_nondur(i1);
f_g_inv_census_mfg=fn_compute_g_monthly(f_inv_census_mfg);
%
% Case 1: advance durables report most recent release
if f1a>f1b & f1b>f2a;
%
if display_text;
disp('Advance Report on Durable Goods is the most recent release.');
end;
% compute as-reported BEA inventories
f_inv_mfg_real=junk_nos_m;
i1=inv_bea_mfg_real~=junk_nos;
f_inv_mfg_real(i1)=12*inv_bea_mfg_real(i1);
f_g_inv_mfg_real=g_inv_bea_mfg_real;
% Census inventories, current, real
f_inv_c_mfg_real=junk_nos_m;
i1=f_inv_census_mfg~=junk_nos & f_ppi_cap_equipment~=junk_nos;
f_inv_c_mfg_real(i1)=f_inv_census_mfg(i1)./f_ppi_cap_equipment(i1);
f_g_inv_c_mfg_real=fn_compute_g_monthly(f_inv_c_mfg_real);
% Census inventories, old, real, note: use current ppi for capital equipment, so ignore ppi revisions
f_inv_c_mfg_real_old=junk_nos_m;
for i1=2:f1b;
	if inv_census_mfg_dur_old(i1)~=junk_nos & inv_census_mfg_nondur_old(i1)~=junk_nos & f_ppi_cap_equipment(i1)~=junk_nos;
		f_inv_c_mfg_real_old(i1)=(inv_census_mfg_dur_old(i1)+inv_census_mfg_nondur_old(i1))/f_ppi_cap_equipment(i1);
	end;
end;
f_g_inv_c_mfg_real_old=fn_compute_g_monthly(f_inv_c_mfg_real_old);
% compute changes and make revisions to as-reported BEA numbers
for i1=2:f2a;
	if f_g_inv_mfg_real(i1)~=junk_nos;
		if f_g_inv_c_mfg_real(i1)~=junk_nos & f_g_inv_c_mfg_real_old(i1)~=junk_nos & f_g_inv_c_mfg_real(i1)~=f_g_inv_c_mfg_real_old(i1);
			f_g_inv_mfg_real(i1)=f_g_inv_mfg_real(i1)+(f_g_inv_c_mfg_real(i1)-f_g_inv_c_mfg_real_old(i1));
		end;
		f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
		f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
	end;
end;
% fill in entries where have extra Census data, durables and nondurables
for i1=f2a+1:f1b;
	f_ch_inv_mfg_real(i1)=f_inv_c_mfg_real(i1)-f_inv_c_mfg_real(i1-1);
	f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)+f_ch_inv_mfg_real(i1);
	f_g_inv_mfg_real(i1)=100*(f_inv_mfg_real(i1)/f_inv_mfg_real(i1-1)-1);
end;
% forecast nondurables to match data on durables
f_inv_census_mfg_nondur=inv_census_mfg_nondur;
f_g_inv_census_mfg_nondur=fn_make_forecast(g_inv_census_mfg_nondur);
for i1=f1b+1:f1a;
	f_inv_census_mfg_nondur(i1)=f_inv_census_mfg_nondur(i1-1)*(1+f_g_inv_census_mfg_nondur(i1)/100);
	f_inv_census_mfg(i1)=f_inv_census_mfg_nondur(i1)+inv_census_mfg_dur(i1);
	f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);
	f_inv_c_mfg_real(i1)=f_inv_census_mfg(i1)/f_ppi_cap_equipment(i1);
	f_ch_inv_mfg_real(i1)=f_inv_c_mfg_real(i1)-f_inv_c_mfg_real(i1-1);
	f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)+f_ch_inv_mfg_real(i1);
	f_g_inv_mfg_real(i1)=100*(f_inv_mfg_real(i1)/f_inv_mfg_real(i1-1)-1);
end;
% make forecast
f_g_inv_mfg_real=fn_make_forecast(f_g_inv_mfg_real);
% fill in missing observations
for i1=f1a+1:ff+5;
	f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
	f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
	f_inv_census_mfg(i1)=f_ppi_cap_equipment(i1)*(f_ch_inv_mfg_real(i1)+f_inv_census_mfg(i1-1)/f_ppi_cap_equipment(i1-1));
	f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);	
end;
if display_text;
if f2b==ff+2;
	disp(['BEA monthly estimates and new forecasts (bil. $):']);
	disp(['Date       Change, BEA      Change, new ']);
	disp(num2str([date_m(ff:ff+2),ch_inv_bea_mfg_real_est(ff:ff+2),f_ch_inv_mfg_real(ff:ff+2)],'%13.2f %10.1f %17.1f\n'));
else;
	disp(['Monthly estimates and forecasts:']);
	disp(['             BEA         Census, total mfg. industries']);
	disp(['Date     Change (bil. $)     Growth rate (m/m)']);
	disp(num2str([date_m(ff-3:ff+2),f_ch_inv_mfg_real(ff-3:ff+2),f_g_inv_census_mfg(ff-3:ff+2)],'%7.2f %9.1f %20.1f\n'))
end;
end;
%
end;
%
% Case 2: BEA monthly detail most recent release
if f1a>f1b & f1b==f2a;
%
if display_text;
disp('BEA monthly detail is the most recent release.');
end;
if f2b>=ff+2; % BEA estimates are available for all months
	if display_text; 
		disp(['BEA monthly estimates for all months:']);
		disp(['Date       Change (bil. $)']);
		disp(num2str([date_m(ff:ff+2),ch_inv_bea_mfg_real_est(ff:ff+2)],'%13.2f %10.1f\n'));
	end;
	f_ch_inv_mfg_real=ch_inv_bea_mfg_real_est;
else; % BEA estimates are not available for all months
	f_inv_mfg_real=junk_nos_m;
	i1=inv_bea_mfg_real~=junk_nos;
	f_inv_mfg_real(i1)=12*inv_bea_mfg_real(i1);
	f_g_inv_mfg_real=g_inv_bea_mfg_real;
	for i1=2:f2a;
		if inv_bea_mfg_real(i1)~=junk_nos & inv_bea_mfg_real(i1-1)~=junk_nos;
			f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
		end;
	end;
	% have durables inventories for one extra month; forecast nondurables inventories
	f_inv_census_mfg_nondur=inv_census_mfg_nondur;
	f_g_inv_census_mfg_nondur=fn_make_forecast(g_inv_census_mfg_nondur);
	for i1=f1b+1:f1a;
		% compute total Census manufacturing inventories		
		f_inv_census_mfg_nondur(i1)=f_inv_census_mfg_nondur(i1-1)*(1+f_g_inv_census_mfg_nondur(i1)/100);
		f_inv_census_mfg(i1)=inv_census_mfg_dur(i1)+f_inv_census_mfg_nondur(i1);
		f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);
		% fill in BEA estimates for months with durable inventories data
		f_ch_inv_mfg_real(i1)=f_inv_census_mfg(i1)/f_ppi_cap_equipment(i1)-f_inv_census_mfg(i1-1)/f_ppi_cap_equipment(i1-1);
		f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)+f_ch_inv_mfg_real(i1);
		f_g_inv_mfg_real(i1)=100*(f_inv_mfg_real(i1)/f_inv_mfg_real(i1-1)-1);
	end;
	% forecast months with no data available yet
	f_g_inv_mfg_real=fn_make_forecast(f_g_inv_mfg_real);
	for i1=f1a+1:ff+5;
		f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
		f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
		f_inv_census_mfg(i1)=f_ppi_cap_equipment(i1)*(f_ch_inv_mfg_real(i1)+f_inv_census_mfg(i1-1)/f_ppi_cap_equipment(i1-1));
		f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);		
	end;
	if display_text; 
		disp(['Monthly estimates and forecasts:']);
		disp(['             BEA         Census, total mfg. industries']);
		disp(['Date     Change (bil. $)     Growth rate (m/m)']);
		disp(num2str([date_m(ff-3:ff+2),f_ch_inv_mfg_real(ff-3:ff+2),f_g_inv_census_mfg(ff-3:ff+2)],'%7.2f %9.1f %20.1f\n'))
	end;
end;
%
end;
%
% Case 3: factory orders most recent release
if f1a==f1b & f1a>f2a;
%
if display_text;
disp('Factory Orders is the most recent release.');
end;
% compute as-reported BEA inventories
f_inv_mfg_real=junk_nos_m;
i1=inv_bea_mfg_real~=junk_nos;
f_inv_mfg_real(i1)=12*inv_bea_mfg_real(i1);
f_g_inv_mfg_real=g_inv_bea_mfg_real;
% Census inventories, current, real
f_inv_c_mfg_real=junk_nos_m;
i1=f_inv_census_mfg~=junk_nos & f_ppi_cap_equipment~=junk_nos;
f_inv_c_mfg_real(i1)=f_inv_census_mfg(i1)./f_ppi_cap_equipment(i1);
f_g_inv_c_mfg_real=fn_compute_g_monthly(f_inv_c_mfg_real);
% Census inventories, old, real, note: use current ppi for capital equipment, so ignore ppi revisions
f_inv_c_mfg_real_old=junk_nos_m;
for i1=2:f1a;
	if inv_census_mfg_dur_old(i1)~=junk_nos & inv_census_mfg_nondur_old(i1)~=junk_nos & f_ppi_cap_equipment(i1)~=junk_nos;
		f_inv_c_mfg_real_old(i1)=(inv_census_mfg_dur_old(i1)+inv_census_mfg_nondur_old(i1))/f_ppi_cap_equipment(i1);
	end;
end;
f_g_inv_c_mfg_real_old=fn_compute_g_monthly(f_inv_c_mfg_real_old);
% compute changes and make revisions to as-reported BEA numbers
for i1=2:f2a;
	if f_g_inv_mfg_real(i1)~=junk_nos;
		if f_g_inv_c_mfg_real(i1)~=junk_nos & f_g_inv_c_mfg_real_old(i1)~=junk_nos & f_g_inv_c_mfg_real(i1)~=f_g_inv_c_mfg_real_old(i1);
			f_g_inv_mfg_real(i1)=f_g_inv_mfg_real(i1)+(f_g_inv_c_mfg_real(i1)-f_g_inv_c_mfg_real_old(i1));
		end;
		f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
		f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
	end;
end;
% fill in entries where have extra Census data
for i1=f2a+1:f1a;
	f_ch_inv_mfg_real(i1)=f_inv_c_mfg_real(i1)-f_inv_c_mfg_real(i1-1);
	f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)+f_ch_inv_mfg_real(i1);
	f_g_inv_mfg_real(i1)=100*(f_inv_mfg_real(i1)/f_inv_mfg_real(i1-1)-1);
end;
% make forecast
f_g_inv_mfg_real=fn_make_forecast(f_g_inv_mfg_real);
% fill in missing observations
for i1=f1a+1:ff+5;
	f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
	f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
	f_inv_census_mfg(i1)=f_ppi_cap_equipment(i1)*(f_ch_inv_mfg_real(i1)+f_inv_census_mfg(i1-1)/f_ppi_cap_equipment(i1-1));
	f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);	
end;
if display_text;
if f2b==ff+2;
	disp(['BEA monthly estimates and new forecasts (bil. $):']);
	disp(['Date       Change, BEA      Change, new ']);
	disp(num2str([date_m(ff:ff+2),ch_inv_bea_mfg_real_est(ff:ff+2),f_ch_inv_mfg_real(ff:ff+2)],'%13.2f %10.1f %17.1f\n'));
else;
	disp(['Monthly estimates and forecasts:']);
	disp(['             BEA         Census, total mfg. industries']);
	disp(['Date     Change (bil. $)     Growth rate (m/m)']);
	disp(num2str([date_m(ff-3:ff+2),f_ch_inv_mfg_real(ff-3:ff+2),f_g_inv_census_mfg(ff-3:ff+2)],'%7.2f %9.1f %20.1f\n'))
end;
end;
%
end;

% Case 4: BEA monthly detail comes out before advanced durables
% Note this is a rare case occuring after the government shutdown.
if f1a==f1b & f1b==f2a;
%
if display_text;
disp('BEA monthly detail is the most recent release, but no advanced durables yet released');
end;
if f2b>=ff+2; % BEA estimates are available for all months
	if display_text; 
		disp(['BEA monthly estimates for all months:']);
		disp(['Date       Change (bil. $)']);
		disp(num2str([date_m(ff:ff+2),ch_inv_bea_mfg_real_est(ff:ff+2)],'%13.2f %10.1f\n'));
	end;
	f_ch_inv_mfg_real=ch_inv_bea_mfg_real_est;
else; % BEA estimates are not available for all months
	f_inv_mfg_real=junk_nos_m;
	i1=inv_bea_mfg_real~=junk_nos;
	f_inv_mfg_real(i1)=12*inv_bea_mfg_real(i1);
	f_g_inv_mfg_real=g_inv_bea_mfg_real;
	for i1=2:f2a;
		if inv_bea_mfg_real(i1)~=junk_nos & inv_bea_mfg_real(i1-1)~=junk_nos;
			f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
		end;
	end;
	% forecast months with no data available yet
	f_g_inv_mfg_real=fn_make_forecast(f_g_inv_mfg_real);
	for i1=f1a+1:ff+5;
		f_inv_mfg_real(i1)=f_inv_mfg_real(i1-1)*(1+f_g_inv_mfg_real(i1)/100);
		f_ch_inv_mfg_real(i1)=f_inv_mfg_real(i1)-f_inv_mfg_real(i1-1);
		f_inv_census_mfg(i1)=f_ppi_cap_equipment(i1)*(f_ch_inv_mfg_real(i1)+f_inv_census_mfg(i1-1)/f_ppi_cap_equipment(i1-1));
		f_g_inv_census_mfg(i1)=100*(f_inv_census_mfg(i1)/f_inv_census_mfg(i1-1)-1);		
	end;
	if display_text; 
		disp(['Monthly estimates and forecasts:']);
		disp(['             BEA         Census, total mfg. industries']);
		disp(['Date     Change (bil. $)     Growth rate (m/m)']);
		disp(num2str([date_m(ff-3:ff+2),f_ch_inv_mfg_real(ff-3:ff+2),f_g_inv_census_mfg(ff-3:ff+2)],'%7.2f %9.1f %20.1f\n'))
	end;
end;
end;

%
f_ch_inv_mfg_real_this_q=mean(f_ch_inv_mfg_real(ff:ff+2));
if display_text;
disp(['Estimated quarterly change in manufacturing inventories = ',num2str(f_ch_inv_mfg_real_this_q,'%4.1f')]);
% modifed by Linmei Amaya Feburary 10, 2020
disp(['Estimated using ',txt]);        



%
disp('--------------------------------------------');
disp('2. Wholesale trade inventories.');
end;
% determine whether BEA or Census data are the most recent
f1a=max(find(inv_census_wholesale~=junk_nos));
f2a=max(find(inv_bea_wholesale_merchant_real~=junk_nos));
f2b=max(find(ch_inv_bea_wholesale_real_est~=junk_nos));
missing_no_months=3-(f1a-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of Census total wholesale trade inventories data.']);
disp(['Missing ',num2str(3-(f2a-ff)-1),' month(s) of BEA merchant wholesale inventories data.']);
end;
f_ch_inv_wholesale_real=junk_nos_m;
f_inv_census_wholesale=inv_census_wholesale;
f_g_inv_census_wholesale=g_inv_census_wholesale;
%
if f1a==f2a; % BEA data are the most recent
%
if display_text;
	disp(['BEA data are the most recent.']);
end;
if f2b>=ff+2; % BEA estimates are available for all months
	if display_text; 
		disp(['BEA monthly inventory estimates for all months:']);
		disp(['Date       Change (bil. $)']);
		disp(num2str([date_m(ff:ff+2),ch_inv_bea_wholesale_real_est(ff:ff+2)],'%13.2f %10.1f\n'));
	end;
	f_ch_inv_wholesale_real=ch_inv_bea_wholesale_real_est;
else; % BEA estimates are not available for all months
	% compute changes in nonmerchant wholesale inventories
	f_ch_inv_wholesale_nonmerchant_real=junk_nos_m;
	for i1=ff:-3:7;
		ch_inv_wholesale_nonmerchant_real_last6mo=ch_inv_bea_wholesale_nonmerchant_real_est(i1-6:i1-1);
		if sum(ch_inv_wholesale_nonmerchant_real_last6mo==junk_nos)==0;
			f_ch_inv_wholesale_nonmerchant_real(i1:i1+2)=mean(ch_inv_wholesale_nonmerchant_real_last6mo);
		end;
	end;
	% compute changes in merchant wholesale inventories
	f_inv_wholesale_merchant_real=junk_nos_m;
	i1=inv_bea_wholesale_merchant_real~=junk_nos;
	f_inv_wholesale_merchant_real(i1)=12*inv_bea_wholesale_merchant_real(i1);
	f_g_inv_wholesale_merchant_real=g_inv_bea_wholesale_merchant_real;
	f_ch_inv_wholesale_merchant_real=junk_nos_m;
	for i1=2:f2a;
		if inv_bea_wholesale_merchant_real(i1)~=junk_nos & inv_bea_wholesale_merchant_real(i1-1)~=junk_nos;
			f_ch_inv_wholesale_merchant_real(i1)=f_inv_wholesale_merchant_real(i1)-f_inv_wholesale_merchant_real(i1-1);
		end;
	end;
	f_g_inv_wholesale_merchant_real=fn_make_forecast(f_g_inv_wholesale_merchant_real);
	for i1=f2a+1:ff+2;
		f_inv_wholesale_merchant_real(i1)=f_inv_wholesale_merchant_real(i1-1)*(1+f_g_inv_wholesale_merchant_real(i1)/100);
		f_ch_inv_wholesale_merchant_real(i1)=f_inv_wholesale_merchant_real(i1)-f_inv_wholesale_merchant_real(i1-1);
	end;
	% combine for total wholesale inventories
	f_ch_inv_wholesale_real=junk_nos_m;
	i1=(f_ch_inv_wholesale_nonmerchant_real~=junk_nos)&(f_ch_inv_wholesale_merchant_real~=junk_nos);
	f_ch_inv_wholesale_real(i1)=f_ch_inv_wholesale_nonmerchant_real(i1)+f_ch_inv_wholesale_merchant_real(i1);
	% fill in additional forecasts
	[f_ch_inv_wholesale_real,txt]=fn_make_forecast(f_ch_inv_wholesale_real);
  
    
    
	% later, if don't have data on f_ch_inv_wholesale_real, use f_ch_inv_c_wholesale_real
	% instead; reverse to back out the path for nominal Census (total) wholesale inventories
	for i1=f2a+1:ff+5;
		f_inv_census_wholesale(i1)=f_pcepm(i1)*(f_ch_inv_wholesale_real(i1)+f_inv_census_wholesale(i1-1)/f_pcepm(i1-1));
		f_g_inv_census_wholesale(i1)=100*(f_inv_census_wholesale(i1)/f_inv_census_wholesale(i1-1)-1);
	end;
	if display_text; 
		disp(['Monthly inventory estimates and forecasts:']);
		disp(['          BEA, change    Census, total wholesale trade']);
		disp(['Date      Bil. real $        Nom. growth rate (m/m)']);
		disp(num2str([date_m(ff-3:ff+2),f_ch_inv_wholesale_real(ff-3:ff+2),f_g_inv_census_wholesale(ff-3:ff+2)],'%7.2f %9.1f %22.1f\n'))
	end;
end;
%	
else; % more recent Census data than BEA data
%
if display_text;
	disp(['Census data are the most recent.']);
end;	
% compute changes in nonmerchant wholesale inventories; if the BEA hasn't 
% released any data for the current quarter, use the average of the last
% two quarters
f2c=max(find(ch_inv_bea_wholesale_nonmerchant_real_est~=junk_nos));
if f2c<ff+2;
	f_ch_inv_wholesale_nonmerchant_real=junk_nos_m;
	for i1=ff:-3:7;
		ch_inv_wholesale_nonmerchant_real_last6mo=ch_inv_bea_wholesale_nonmerchant_real_est(i1-6:i1-1);
		if sum(ch_inv_wholesale_nonmerchant_real_last6mo==junk_nos)==0;
			f_ch_inv_wholesale_nonmerchant_real(i1:i1+2)=mean(ch_inv_wholesale_nonmerchant_real_last6mo);
		end;
	end;
% if the BEA has released data for the current quarter, use what has been 
% released
else;
	f_ch_inv_wholesale_nonmerchant_real=ch_inv_bea_wholesale_nonmerchant_real_est;
end;
% deflate monthly Census wholesale trade data by monthly PCE deflator; inventory data 
% come out after PCE deflator data
f_inv_c_wholesale_real=junk_nos_m;
f_ch_inv_c_wholesale_real=f_inv_c_wholesale_real;
f_g_inv_c_wholesale_real=f_inv_c_wholesale_real;
f_inv_c_wholesale_real_old=junk_nos_m;
f_g_inv_c_wholesale_real_old=f_inv_c_wholesale_real_old;
for i1=2:f1a;
	if inv_census_wholesale(i1)~=junk_nos & pcepm(i1)~=junk_nos; % remove upon PCE release (Q1 GDP release)
        
        % remove upon PCE release (Q1 GDP release)
        %if pcepm(i1)==junk_nos
        %   pcepm(i1)=pcepm(i1-1);
        %end 
        
        f_inv_c_wholesale_real(i1)=inv_census_wholesale(i1)/pcepm(i1);
		if f_inv_c_wholesale_real(i1-1)~=junk_nos;
			f_ch_inv_c_wholesale_real(i1)=f_inv_c_wholesale_real(i1)-f_inv_c_wholesale_real(i1-1);
			f_g_inv_c_wholesale_real(i1)=100*(f_inv_c_wholesale_real(i1)/f_inv_c_wholesale_real(i1-1)-1);
		end;
	end;
	% note: for the old series, deflate by the most recent pce price index,
	% so essentially ignore revisions to that but allow revisions to the inventory data
	if inv_census_wholesale_old(i1)~=junk_nos & pcepm(i1)~=junk_nos;
		f_inv_c_wholesale_real_old(i1)=inv_census_wholesale_old(i1)/pcepm(i1);
		if f_inv_c_wholesale_real_old(i1-1)~=junk_nos;
			f_g_inv_c_wholesale_real_old(i1)=100*(f_inv_c_wholesale_real_old(i1)/f_inv_c_wholesale_real_old(i1-1)-1);
		end;
	end;
end;
% compute as-reported BEA merchant wholesale inventory growth;
% assume revisions only to it
f_inv_wholesale_merchant_real=junk_nos_m;
i1=inv_bea_wholesale_merchant_real~=junk_nos;
f_inv_wholesale_merchant_real(i1)=12*inv_bea_wholesale_merchant_real(i1);
f_g_inv_wholesale_merchant_real=g_inv_bea_wholesale_merchant_real;
% compute revised BEA inventory growth based on Census revisions
f_ch_inv_wholesale_merchant_real=junk_nos_m;
for i1=2:f2a;
	if f_g_inv_wholesale_merchant_real(i1)~=junk_nos;
		if f_g_inv_c_wholesale_real(i1)~=junk_nos & f_g_inv_c_wholesale_real_old(i1)~=junk_nos & ...
			f_g_inv_c_wholesale_real(i1)~=f_g_inv_c_wholesale_real_old(i1);
			f_g_inv_wholesale_merchant_real(i1)=f_g_inv_wholesale_merchant_real(i1)+(f_g_inv_c_wholesale_real(i1)-f_g_inv_c_wholesale_real_old(i1));
		end;
		f_inv_wholesale_merchant_real(i1)=f_inv_wholesale_merchant_real(i1-1)*(1+f_g_inv_wholesale_merchant_real(i1)/100);
		f_ch_inv_wholesale_merchant_real(i1)=f_inv_wholesale_merchant_real(i1)-f_inv_wholesale_merchant_real(i1-1);
	end;
end;
% combine nonmerchant and merchant wholesale inventories
i1=(f_ch_inv_wholesale_nonmerchant_real~=junk_nos)&(f_ch_inv_wholesale_merchant_real~=junk_nos);
f_ch_inv_wholesale_real(i1)=f_ch_inv_wholesale_nonmerchant_real(i1)+f_ch_inv_wholesale_merchant_real(i1);
% use additional Census data to help fill in missing observations

for i1=f2a+1:f1a;
	f_ch_inv_wholesale_real(i1)=f_ch_inv_c_wholesale_real(i1);
end;
% note: do not have data on real level of total wholesale inventories,
% thus cannot compute growth rates; make forecast using changes

[f_ch_inv_wholesale_real,text]=fn_make_forecast(f_ch_inv_wholesale_real);






% back out the implied path for Census wholesale inventories
for i1=f1a+1:ff+5;
	f_inv_census_wholesale(i1)=f_pcepm(i1)*(f_ch_inv_wholesale_real(i1)+f_inv_census_wholesale(i1-1)/f_pcepm(i1-1));
	f_g_inv_census_wholesale(i1)=100*(f_inv_census_wholesale(i1)/f_inv_census_wholesale(i1-1)-1);
end;
if display_text; 
	if f2b==ff+2;
	disp(['BEA monthly estimates and new forecasts (bil. $):']);
	disp(['Date       Change, BEA      Change, new ']);
	disp(num2str([date_m(ff:ff+2),ch_inv_bea_wholesale_real_est(ff:ff+2),f_ch_inv_wholesale_real(ff:ff+2)],'%13.2f %10.1f %17.1f\n'));
	else;	
	disp(['Monthly inventory estimates and forecasts:']);
	disp(['          BEA, change    Census, total wholesale trade']);
	disp(['Date      Bil. real $        Nom. growth rate (m/m)']);
	disp(num2str([date_m(ff-3:ff+2),f_ch_inv_wholesale_real(ff-3:ff+2),f_g_inv_census_wholesale(ff-3:ff+2)],'%7.2f %9.1f %22.1f\n'))
	end;	
end;
end;
f_ch_inv_wholesale_real_this_q=mean(f_ch_inv_wholesale_real(ff:ff+2));
if display_text;
disp(['Estimated quarterly change in wholesale inventories = ',num2str(f_ch_inv_wholesale_real_this_q,'%4.1f')]);
disp(['Estimated using ',txt]);        

%
disp('3. Retail inventories.');
end;
% determine whether BEA or Census data are the most recent
f1a=max(find(inv_census_retail~=junk_nos));
f1b=max(find(inv_census_retail_mv~=junk_nos));
f1c=max(find(inv_census_retail_exmv~=junk_nos));
f2a=max(find(inv_bea_retail_real~=junk_nos));
f2b=max(find(ch_inv_bea_retail_real_est~=junk_nos));
missing_no_months=3-(f1a-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of Census retail trade inventories data.']);
disp(['Missing ',num2str(3-(f2a-ff)-1),' month(s) of BEA retail trade inventories data.']);
end;
f_ch_inv_retail_real=junk_nos_m;
f_inv_census_retail=inv_census_retail;
f_g_inv_census_retail=g_inv_census_retail;
%
if f1a==f2a; % BEA data are the most recent
%
if display_text;
	disp(['BEA data are the most recent.']);
end;
if f2b>=ff+2; % BEA estimates are available for all months
	if display_text; 
		disp(['BEA monthly estimates for all months:']);
		disp(['Date       Change (bil. $)']);
		disp(num2str([date_m(ff:ff+2),ch_inv_bea_retail_real_est(ff:ff+2)],'%13.2f %10.1f\n'));
	end;
	f_ch_inv_retail_real=ch_inv_bea_retail_real_est;
else; % BEA estimates are not available for all months
	missing_no_months=3-(f2a-ff)-1;
	f_inv_retail_real=junk_nos_m;
	i1=inv_bea_retail_real~=junk_nos;
	f_inv_retail_real(i1)=12*inv_bea_retail_real(i1);
	f_g_inv_retail_real=g_inv_bea_retail_real;
	for i1=2:f2a;
		if inv_bea_retail_real(i1)~=junk_nos & inv_bea_retail_real(i1-1)~=junk_nos;
			f_ch_inv_retail_real(i1)=f_inv_retail_real(i1)-f_inv_retail_real(i1-1);
		end;
	end;
	% fill in missing observations
	f_g_inv_retail_real=fn_make_forecast(f_g_inv_retail_real);
	% while the program typically splits retail inventories into motor vehicles and
	% non-motor vehicles, just back out the implied path for total retail inventories; the
	% fit is poor regardless of the method used
	for i1=f2a+1:ff+5;
		f_inv_retail_real(i1)=f_inv_retail_real(i1-1)*(1+f_g_inv_retail_real(i1)/100);
		f_ch_inv_retail_real(i1)=f_inv_retail_real(i1)-f_inv_retail_real(i1-1);
		f_inv_census_retail(i1)=f_pcepm_core(i1)*(f_ch_inv_retail_real(i1)+f_inv_census_retail(i1-1)/f_pcepm_core(i1-1));
		f_g_inv_census_retail(i1)=100*(f_inv_census_retail(i1)/f_inv_census_retail(i1-1)-1);
	end;
	if display_text; 
		disp(['Monthly inventory estimates and forecasts:']);
		disp(['          BEA, change    Census, total retail trade']);
		disp(['Date      Bil. real $        Nom. growth rate (m/m)']);
		disp(num2str([date_m(ff-3:ff+2),f_ch_inv_retail_real(ff-3:ff+2),f_g_inv_census_retail(ff-3:ff+2)],'%7.2f %9.1f %22.1f\n'))
	end;
end;
%	
else; % more recent Census data than BEA data
%
if display_text;
	disp(['Census data are the most recent.']);
end;
% split retail inventories into motor vehicles and excluding motor vehicles; deflate 
% motor vehicle inventories by CPI for new motor vehicles (inventory data
% come out well after CPI); deflate ex-motor vehicle inventories by core PCE
% price index (inventory data come out well after core PCE price index)
f_inv_c_retail_mv_real=junk_nos_m;
f_ch_inv_c_retail_mv_real=f_inv_c_retail_mv_real;
f_g_inv_c_retail_mv_real=f_inv_c_retail_mv_real;
f_inv_c_retail_exmv_real=junk_nos_m;
f_ch_inv_c_retail_exmv_real=f_inv_c_retail_exmv_real;
f_g_inv_c_retail_exmv_real=f_inv_c_retail_exmv_real;
f_inv_c_retail_real=junk_nos_m;
f_ch_inv_c_retail_real=f_inv_c_retail_real;
f_g_inv_c_retail_real=f_inv_c_retail_real;
f_inv_c_retail_mv_real_old=f_inv_c_retail_mv_real;
f_g_inv_c_retail_mv_real_old=f_inv_c_retail_mv_real_old;
f_inv_c_retail_exmv_real_old=f_inv_c_retail_exmv_real;
f_g_inv_c_retail_exmv_real_old=f_inv_c_retail_exmv_real_old;
for i1=2:f1b;
	if inv_census_retail_mv(i1)~=junk_nos & cpi_new_mv(i1)~=junk_nos;
		f_inv_c_retail_mv_real(i1)=inv_census_retail_mv(i1)/cpi_new_mv(i1);
		if f_inv_c_retail_mv_real(i1-1)~=junk_nos;
			f_g_inv_c_retail_mv_real(i1)=100*(f_inv_c_retail_mv_real(i1)/f_inv_c_retail_mv_real(i1-1)-1);
			f_ch_inv_c_retail_mv_real(i1)=f_inv_c_retail_mv_real(i1)-f_inv_c_retail_mv_real(i1-1);
		end;
	end;
	if inv_census_retail_exmv(i1)~=junk_nos & pcepm_core(i1)~=junk_nos;
		f_inv_c_retail_exmv_real(i1)=inv_census_retail_exmv(i1)/pcepm_core(i1);
		if f_inv_c_retail_exmv_real(i1-1)~=junk_nos;
			f_g_inv_c_retail_exmv_real(i1)=100*(f_inv_c_retail_exmv_real(i1)/f_inv_c_retail_exmv_real(i1-1)-1);
			f_ch_inv_c_retail_exmv_real(i1)=f_inv_c_retail_exmv_real(i1)-f_inv_c_retail_exmv_real(i1-1);
		end;
	elseif inv_census_retail_exmv(i1)~=junk_nos & pcepm_core(i1)==junk_nos;  %%% note: if census has advanced report, core pce is not out yet. Therefore just use the pce of month earlier for the last data point
		f_inv_c_retail_exmv_real(i1)=inv_census_retail_exmv(i1)/pcepm_core(i1-1);
		if f_inv_c_retail_exmv_real(i1-1)~=junk_nos;
			f_g_inv_c_retail_exmv_real(i1)=100*(f_inv_c_retail_exmv_real(i1)/f_inv_c_retail_exmv_real(i1-1)-1);
			f_ch_inv_c_retail_exmv_real(i1)=f_inv_c_retail_exmv_real(i1)-f_inv_c_retail_exmv_real(i1-1);
		end;
	end;
	% note: for the old series, deflate by the most recent price indices,
	% so essentially ignore revisions to that but allow revisions to the inventory data
	if inv_census_retail_mv_old(i1)~=junk_nos & cpi_new_mv(i1)~=junk_nos;
		f_inv_c_retail_mv_real_old(i1)=inv_census_retail_mv_old(i1)/cpi_new_mv(i1);
		if f_inv_c_retail_mv_real_old(i1-1)~=junk_nos;
			f_g_inv_c_retail_mv_real_old(i1)=100*(f_inv_c_retail_mv_real_old(i1)/f_inv_c_retail_mv_real_old(i1-1)-1);
		end;
	end;
	if inv_census_retail_exmv_old(i1)~=junk_nos & pcepm_core(i1)~=junk_nos;
		f_inv_c_retail_exmv_real_old(i1)=inv_census_retail_exmv_old(i1)/pcepm_core(i1);
		if f_inv_c_retail_exmv_real_old(i1-1)~=junk_nos;
			f_g_inv_c_retail_exmv_real_old(i1)=100*(f_inv_c_retail_exmv_real_old(i1)/f_inv_c_retail_exmv_real_old(i1-1)-1);
		end;
	end;
end;
% compute as-reported BEA inventory growth
f_inv_retail_mv_real=junk_nos_m;
i1=inv_bea_retail_mv_real~=junk_nos;
f_inv_retail_mv_real(i1)=12*inv_bea_retail_mv_real(i1);
f_inv_retail_real=junk_nos_m;
i1=inv_bea_retail_real~=junk_nos;
f_inv_retail_real(i1)=12*inv_bea_retail_real(i1);
f_inv_retail_exmv_real=junk_nos_m;
i1=(f_inv_retail_mv_real~=junk_nos)&(f_inv_retail_real~=junk_nos);
f_inv_retail_exmv_real(i1)=f_inv_retail_real(i1)-f_inv_retail_mv_real(i1);
f_g_inv_retail_mv_real=g_inv_bea_retail_mv_real;
f_g_inv_retail_real=g_inv_bea_retail_real;
f_g_inv_retail_exmv_real=junk_nos_m;
for i1=2:f2a;
	if f_inv_retail_exmv_real(i1)~=junk_nos & f_inv_retail_exmv_real(i1-1)~=junk_nos;
		f_g_inv_retail_exmv_real(i1)=100*(f_inv_retail_exmv_real(i1)/f_inv_retail_exmv_real(i1-1)-1);
	end;
end;
% compute revised BEA inventory growth based on Census revisions
f_ch_inv_retail_mv_real=junk_nos_m;
f_ch_inv_retail_exmv_real=f_ch_inv_retail_mv_real;
update1=0;
for i1=2:f2a;
	if f_g_inv_retail_mv_real(i1)~=junk_nos;
		if f_g_inv_c_retail_mv_real(i1)~=junk_nos & f_g_inv_c_retail_mv_real_old(i1)~=junk_nos & ...
			f_g_inv_c_retail_mv_real(i1)~=f_g_inv_c_retail_mv_real_old(i1);
			f_g_inv_retail_mv_real(i1)=f_g_inv_retail_mv_real(i1)+(f_g_inv_c_retail_mv_real(i1)-f_g_inv_c_retail_mv_real_old(i1));
			update1=1;
		end;
		f_inv_retail_mv_real(i1)=f_inv_retail_mv_real(i1-1)*(1+f_g_inv_retail_mv_real(i1)/100);
		f_ch_inv_retail_mv_real(i1)=f_inv_retail_mv_real(i1)-f_inv_retail_mv_real(i1-1);
	end;
	if f_g_inv_retail_exmv_real(i1)~=junk_nos;
		if f_g_inv_c_retail_exmv_real(i1)~=junk_nos & f_g_inv_c_retail_exmv_real_old(i1)~=junk_nos & ...
			f_g_inv_c_retail_exmv_real(i1)~=f_g_inv_c_retail_exmv_real_old(i1);
			f_g_inv_retail_exmv_real(i1)=f_g_inv_retail_exmv_real(i1)+(f_g_inv_c_retail_exmv_real(i1)-f_g_inv_c_retail_exmv_real_old(i1));
			update1=1;
		end;
		f_inv_retail_exmv_real(i1)=f_inv_retail_exmv_real(i1-1)*(1+f_g_inv_retail_exmv_real(i1)/100);
		f_ch_inv_retail_exmv_real(i1)=f_inv_retail_exmv_real(i1)-f_inv_retail_exmv_real(i1-1);
	end;
	if update1==0; % no updates were made to this point
		if f_inv_retail_real(i1)~=junk_nos & f_inv_retail_real(i1-1)~=junk_nos;
			f_ch_inv_retail_real(i1)=f_inv_retail_real(i1)-f_inv_retail_real(i1-1);
		end;
	else; % at least one update was made to motor vehicle or ex-motor vehicle inventories
		if f_inv_retail_mv_real(i1)~=junk_nos & f_inv_retail_exmv_real(i1)~=junk_nos;
			f_inv_retail_real(i1)=f_inv_retail_mv_real(i1)+f_inv_retail_exmv_real(i1);
			f_ch_inv_retail_real(i1)=f_inv_retail_real(i1)-f_inv_retail_real(i1-1);
			f_g_inv_retail_real(i1)=100*(f_inv_retail_real(i1)/f_inv_retail_real(i1-1)-1);
		end;
	end;
end;
% for retail motor vehicle inventories, use a bridging equation for the Census 
% series deflated by CPI for new motor vehicles
no_obs=8;
s1=min(find(f_ch_inv_c_retail_mv_real~=junk_nos));
e1=max(find(f_ch_inv_c_retail_mv_real~=junk_nos));
f_ch_inv_c_retail_mv_real_bridge=junk_nos_m;
o=ones(no_obs,1);

data_diff=e1-max(find(f_ch_inv_retail_mv_real~=junk_nos));
if data_diff>=2 %%normally census and bea series difference is only 1, but when advance report is out, census outnumbers bea by 2 datapoints.
	for i1=s1+no_obs+1:e1-1;
		b=regress(f_ch_inv_retail_mv_real(i1-no_obs:i1-1),[o,f_ch_inv_c_retail_mv_real(i1-no_obs:i1-1)]);
		f_ch_inv_c_retail_mv_real_bridge(i1)=b'*[1;f_ch_inv_c_retail_mv_real(i1)];
	end;
		f_ch_inv_c_retail_mv_real_bridge(e1)=b'*[1;f_ch_inv_c_retail_mv_real(e1)]; %%for the last census data point, don't regress on the bea's junk number; use previous T-1 regression results
else 
	for i1=s1+no_obs+1:e1;
		b=regress(f_ch_inv_retail_mv_real(i1-no_obs:i1-1),[o,f_ch_inv_c_retail_mv_real(i1-no_obs:i1-1)]);
		f_ch_inv_c_retail_mv_real_bridge(i1)=b'*[1;f_ch_inv_c_retail_mv_real(i1)];
	end;
end

% for retail inventories excluding motor vehicles, use the average of two 
% measures: (1) Census non-motor vehicle inventories deflated by core PCE price
% index, and (2) use BEA data to come up with an implicit "deflator" to roll 
% forward and deflate Census data
f_ch_inv_retail_exmv_real_avg=junk_nos_m;
bea_census_retail_exmv_real=junk_nos*ones(size(f_inv_retail_exmv_real,1),4);
for i1=2:f1c;
	if inv_census_retail_exmv(i1)~=junk_nos & f_inv_retail_exmv_real(i1)~=junk_nos;
		bea_census_retail_exmv_real(i1,1)=inv_census_retail_exmv(i1)/f_inv_retail_exmv_real(i1);
	end;
	if i1>12 & bea_census_retail_exmv_real(i1,1)~=junk_nos & bea_census_retail_exmv_real(i1-12,1)~=junk_nos;
		bea_census_retail_exmv_real(i1,2)=bea_census_retail_exmv_real(i1,1)/bea_census_retail_exmv_real(i1-12,1)-1;
	end;
	if inv_census_retail_exmv(i1)~=junk_nos & bea_census_retail_exmv_real(i1-1,1)~=junk_nos & bea_census_retail_exmv_real(i1-1,2)~=junk_nos;
		bea_census_retail_exmv_real(i1,3)=inv_census_retail_exmv(i1)/(bea_census_retail_exmv_real(i1-1,1)*(1+bea_census_retail_exmv_real(i1-1,2)/12));
	end;
	if bea_census_retail_exmv_real(i1,3)~=junk_nos & bea_census_retail_exmv_real(i1-1,3)~=junk_nos;
		bea_census_retail_exmv_real(i1,4)=bea_census_retail_exmv_real(i1,3)-bea_census_retail_exmv_real(i1-1,3);
	end;
	if f_ch_inv_c_retail_exmv_real(i1)~=junk_nos & bea_census_retail_exmv_real(i1,4)~=junk_nos;
		f_ch_inv_retail_exmv_real_avg(i1)=0.5*(f_ch_inv_c_retail_exmv_real(i1)+bea_census_retail_exmv_real(i1,4));
	end;
	if f_ch_inv_c_retail_exmv_real(i1)~=junk_nos & f_ch_inv_c_retail_exmv_real(i1+1)==junk_nos & bea_census_retail_exmv_real(i1,4)==junk_nos;
		f_ch_inv_retail_exmv_real_avg(i1)=f_ch_inv_c_retail_exmv_real(i1);
	end;
end;
% combine motor vehicle and ex-motor vehicle inventories
for i1=f2a+1:f1b;
	f_ch_inv_retail_real(i1)=f_ch_inv_c_retail_mv_real_bridge(i1)+f_ch_inv_retail_exmv_real_avg(i1);
	f_inv_retail_real(i1)=f_inv_retail_real(i1-1)+f_ch_inv_retail_real(i1);
	f_g_inv_retail_real(i1)=100*(f_inv_retail_real(i1)/f_inv_retail_real(i1-1)-1);
end;
% if had more retail inventories than the breakdown between motor vehicle and non-mv,
% deflate by core PCE; the fit is poor regardless of the method used
for i1=f1b+1:f1a;
	f_ch_inv_retail_real(i1)=(f_inv_census_retail(i1)/f_pcepm_core(i1))-(f_inv_census_retail(i1-1)/f_pcepm_core(i1-1));
	f_inv_retail_real(i1)=f_inv_retail_real(i1-1)+f_ch_inv_retail_real(i1);
end;
% fill in missing observations
f_g_inv_retail_real=fn_make_forecast(f_g_inv_retail_real);
% back out future Census retail trade inventories as well
for i1=f1a+1:ff+5;
	f_inv_retail_real(i1)=f_inv_retail_real(i1-1)*(1+f_g_inv_retail_real(i1)/100);
	f_ch_inv_retail_real(i1)=f_inv_retail_real(i1)-f_inv_retail_real(i1-1);
	f_inv_census_retail(i1)=f_pcepm_core(i1)*(f_ch_inv_retail_real(i1)+f_inv_census_retail(i1-1)/f_pcepm_core(i1-1));
	f_g_inv_census_retail(i1)=100*(f_inv_census_retail(i1)/f_inv_census_retail(i1-1)-1);
end;
if display_text; 
	if f2b==ff+2;
	disp(['BEA monthly estimates and new forecasts (bil. $):']);
	disp(['Date       Change, BEA      Change, new ']);
	disp(num2str([date_m(ff:ff+2),ch_inv_bea_retail_real_est(ff:ff+2),f_ch_inv_retail_real(ff:ff+2)],'%13.2f %10.1f %17.1f\n'));
	else;	
	disp(['Monthly inventory estimates and forecasts:']);
	disp(['          BEA, change     Census, total retail trade']);
	disp(['Date      Bil. real $        Nom. growth rate (m/m)']);
	disp(num2str([date_m(ff-3:ff+2),f_ch_inv_retail_real(ff-3:ff+2),f_g_inv_census_retail(ff-3:ff+2)],'%7.2f %9.1f %22.1f\n'))
	end;
end;
end;
%
f_ch_inv_retail_real_this_q=mean(f_ch_inv_retail_real(ff:ff+2));
if display_text;
disp(['Estimated quarterly change in retail inventories = ',num2str(f_ch_inv_retail_real_this_q,'%4.1f')]);
disp(['Estimated using ',txt]);        

%
disp('--------------------------------------------');
disp('4. Farm inventories and discrepancy.');
end;
% if BEA already put out an estimate of inventories, use that
if date_q(no_quarters)==current_quarter;
	f_inv_ch_inv_other_this_q=inv_ch_inv(no_quarters)-(inv_ch_inv_mfg(no_quarters)+inv_ch_inv_retail(no_quarters)+...
		inv_ch_inv_wholesale(no_quarters));
% if not, estimate the change in farm inventories and the discrepancy
% based on past quarters
else;
	inv_ch_inv_other=junk_nos*ones(size(inv_ch_inv));
	f1=inv_ch_inv~=junk_nos;
	f2=inv_ch_inv_mfg~=junk_nos;
	f3=inv_ch_inv_retail~=junk_nos;
	f4=inv_ch_inv_wholesale~=junk_nos;
	f5=(f1&f2&f3&f4);
	inv_ch_inv_other(f5)=inv_ch_inv(f5)-(inv_ch_inv_mfg(f5)+inv_ch_inv_retail(f5)+inv_ch_inv_wholesale(f5));
	no_quarters_to_use=12;
	b=regress(inv_ch_inv_other(no_quarters-no_quarters_to_use+1:no_quarters),[ones(no_quarters_to_use,1),...
		inv_ch_inv_other(no_quarters-no_quarters_to_use:no_quarters-1)]);
	f_inv_ch_inv_other_this_q=b'*[1;inv_ch_inv_other(no_quarters)];
	f_inv_ch_inv_other_next_q=b'*[1;f_inv_ch_inv_other_this_q];
end;
if display_text;
disp(['Estimated quarterly change in farm inventories and discrepancy = ',num2str(f_inv_ch_inv_other_this_q,'%4.1f')]);
end;
%
f_inv_ch_inv_this_q=f_ch_inv_mfg_real_this_q...
					+f_ch_inv_wholesale_real_this_q...
					+f_ch_inv_retail_real_this_q...
					+f_inv_ch_inv_other_this_q;
if display_text;
disp('**********************************************************************************');
disp(['Estimated change in private inventories for ',num2str(current_quarter),', SAAR = ',num2str(f_inv_ch_inv_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
%
%---------------------------------------------------------------------
% Inventory revision to reported number
%---------------------------------------------------------------------
% When tracking the current quarter, if you revised the previous quarter's
% change in inventories, you need to keep track of this when computing GDP.
if isempty(forecast_all_last_q);
	inv_ch_inv_last_q_revision=0;
else;
	inv_ch_inv_last_q_revision=forecast_all_last_q(10)-inv_ch_inv(find(current_quarter==date_q)-1);
end;
%
%if run_quietly==0;
%	redo2=input('To recompute inflation, enter 1; to go on, hit enter or 0.... ');
%	if redo2==1;
%		redo1=0;
%	else;
%		redo1=1;
%	end;
%else;
%	redo1=1;
%end;
%end;












redo1=0;
while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('International Trade: Exports and Imports');
disp('----------------------------------------------------------------------------------');
% display 4 most recent balance of trade readings
disp('Most recent quarterly trade data, SAAR:');
disp('(Growth rates except for trade balance, which is real net exports level, bil. $)');
disp('                 || Exports:              || Imports:');
disp('          Trade  ||        |              ||        |      Goods');
disp('         Balance || Total  | Goods  Serv. || Total  | Ex. oil   Oil   Serv.');
disp(num2str([date_q(no_quarters-3:no_quarters),nx(no_quarters-3:no_quarters),g_exports(no_quarters-3:no_quarters),...
	g_exports_goods_r(no_quarters-3:no_quarters),g_exports_serv_r(no_quarters-3:no_quarters),...
	g_imports(no_quarters-3:no_quarters),g_imports_goods_exoil_r(no_quarters-3:no_quarters),...
	g_imports_goods_oil_r(no_quarters-3:no_quarters),g_imports_serv_r(no_quarters-3:no_quarters)],...
	'%10.1f %8.1f %8.1f %8.1f %6.1f %8.1f %9.1f %7.1f %6.1f\n'));
end;
% compute trade deficit
trade_balance=junk_nos_m;
i1=im_bop~=junk_nos & ex_bop~=junk_nos;
trade_balance(i1)=(ex_bop(i1)-im_bop(i1))/1000;
f1=max(find(trade_balance~=junk_nos));
% compute nominal imports less oil/petroleum
i1=im_bop~=junk_nos & im_petrol_value_census~=junk_nos;
im_exoil=junk_nos_m;
im_exoil(i1)=im_bop(i1)-im_petrol_value_census(i1);
g_im_exoil=fn_compute_g_monthly(im_exoil);
% display 6 most recent monthly trade readings
if display_text;
disp('Most recent monthly trade readings:');
disp('(Growth rates m/m except for trade balance, which is nominal level, bil. $;');
disp(' seasonally adjusted except for oil volume data)');

disp('                 || Exports:              || Imports:');
disp('          Trade  ||        |              ||        |      Goods');
disp('         Balance || Total  | Goods  Serv. || Total  | Ex. oil   Oil volumes    Serv.');
%{
disp('          Trade  ||  Exports:  || Imports:');
disp('         Balance || Nom. total || Nom. total | Nom. ex. oil   Oil volumes');
%}
disp(num2str([date_m(f1-5:f1),trade_balance(f1-5:f1),g_ex_bop(f1-5:f1),g_ex_goods_bop(f1-5:f1),g_ex_serv_bop(f1-5:f1)...
	g_im_bop(f1-5:f1),g_im_goods_exoil_bop(f1-5:f1),g_im_petrol_volume_nsa(f1-5:f1),g_im_serv_bop(f1-5:f1)],...
	'%10.2f %8.1f %8.1f %8.1f %6.1f %8.1f %9.1f %12.1f %10.1f\n'));
% Note: Volumes are not seasonally adjusted, and because of oil price movements
% there is no guarantee that total nominal imports movements will be a convex
% combination of nominal non-oil import movements and oil volume movements!
end;
%













if display_text;
disp('-------');
disp('Exports');
disp('-------');
end;


%{

%% -- Exports of Goods -- %%

f1=max(find(ex_bop~=junk_nos));
f1a=max(find(expi_total_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;
f_ex_bop=ex_bop;
f_g_ex_bop=g_ex_bop;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of nominal exports data.']);
disp('Deflating nominal exports (total goods and services) by the export price index.');
disp(['Have ',num2str(f1a-f1),' extra month(s) of export price index data; making forecasts of other']);
disp(['missing export price data.']);
if f1a>f1;
	disp(['For month(s) with export price data but no nominal exports data, the']);
	disp(['default uses forecast averaging to fill in nominal exports.']);
end;
end;
% make forecasts of the export price index
f_g_expi_total_nsa=fn_make_forecast(g_expi_total_nsa);
f_expi_total_nsa=expi_total_nsa;
for i1=f1a+1:ff+5;
	f_expi_total_nsa(i1)=f_expi_total_nsa(i1-1)*(1+f_g_expi_total_nsa(i1)/100);
end;
% compute real exports
f_ex_real=junk_nos_m;
i1=ex_bop~=junk_nos & f_expi_total_nsa~=junk_nos;
f_ex_real(i1)=ex_bop(i1)./f_expi_total_nsa(i1);
f_g_ex_real=fn_compute_g_monthly(f_ex_real);
% for month(s) where have export price index but not exports, use
% forecast averaging to come up with nominal exports forecast
[f_ex_bop,f_g_ex_bop,f_ex_real,f_g_ex_real]=...
	fn_fcast_avg(f_ex_bop,f_g_ex_bop,f_ex_real,f_g_ex_real,f_expi_total_nsa,f1,f1a);
% forecast real exports, then back out the nominal forecast
[f_g_ex_real,txt]=fn_make_forecast(f_g_ex_real);
for i1=f1a+1:ff+5;
	f_ex_real(i1)=f_ex_real(i1-1)*(1+f_g_ex_real(i1)/100);
	f_ex_bop(i1)=f_ex_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_bop(i1)=100*(f_ex_bop(i1)/f_ex_bop(i1-1)-1);
end;


if missing_no_months>0;
	if run_quietly==1; in1=1; 
	if display_text;
	if f1a>f1;
		disp(['Using forecast averaging when export price index data are available and real']);
		disp(['total exports growth rate ',txt,',']);
		disp(['then backing out nominal total exports growth rate.']);
	else;
		disp(['Using real total exports growth rate ']);
		disp([txt,',']);
		disp(['then backing out nominal total exports growth rate.']);
	end;		
	end;
	else;
	disp('Options to fill in missing month(s):');
	if f1a>f1;
		disp(['1. Use forecast averaging when export price index data are available and real']);
		disp(['   total exports growth rate ',txt,' (default),']);
		disp(['   then back out nominal total exports growth rate.']);
	else;
		disp(['1. Use real total exports growth rate ']);
		disp(['   ',txt,' (default),']);
		disp(['   then back out nominal total exports growth rate.']);
	end;	
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real exports growth = ',num2str(f_g_ex_real(i1),'%4.1f')]);
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal exports growth = ',num2str(f_g_ex_bop(i1),'%4.1f')]);		
	end;
	disp('2. Enter nominal total exports growth rates for missing month(s), then convert to real.');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_ex_bop(i1)=input(['Growth in nominal total exports for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_ex_bop(i1)=f_ex_bop(i1-1)*(1+f_g_ex_bop(i1)/100);
			f_ex_real(i1)=f_ex_bop(i1)/f_expi_total_nsa(i1);
			f_g_ex_real(i1)=100*(f_ex_real(i1)/f_ex_real(i1-1)-1);			
		end;
	end;
end;


for i1=ff+3:ff+5;
	f_ex_real(i1)=f_ex_real(i1-1)*(1+f_g_ex_real(i1)/100);
	f_ex_bop(i1)=f_ex_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_bop(i1)=100*(f_ex_bop(i1)/f_ex_bop(i1-1)-1);
end;
[f_exports_q,f_g_exports_q,f_exports_next_q,f_g_exports_next_q]=fn_convert_mtoqavg(f_ex_real,date_m,date_q);
f_g_exports_this_q=f_g_exports_q(find(date_q==current_quarter));
%
%}

% Create series of goods/services share and forecast
%share_ex_goods=exports_goods_n(no_quarters_for_weights)/exports_n(no_quarters_for_weights);
share_ex_goods=ex_goods_bop./ex_bop;
share_ex_services=1-share_ex_goods;
share_ex_goods(share_ex_goods==1)=junk_nos;

f_share_ex_goods=fn_make_forecast(share_ex_goods);
f_share_ex_services=1-f_share_ex_goods;
[f_share_ex_goods_q,~,~,~]=fn_convert_mtoqavg(f_share_ex_goods,date_m,date_q);
f_share_ex_services_q=1-f_share_ex_goods_q;

% Need monthly growth rates for 2 variables:
% 1. Exports of Goods
% 2. Exports of Services



%% -- Exports of Goods -- %%

f1_reg=max(find(ex_goods_bop~=junk_nos));
f1_adv=max(find(adv_ex_goods_bop~=junk_nos));

f1a=max(find(expi_total_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;

if f1_adv>f1_reg
	f_g_ex_goods_bop=g_ex_goods_bop;
	f_g_ex_goods_bop(f1_adv)=g_adv_ex_goods_bop(f1_adv);
	
	f_ex_goods_bop=ex_goods_bop;
	f_ex_goods_bop(f1_adv)=f_ex_goods_bop(f1_adv-1)*(1+f_g_ex_goods_bop(f1_adv)/100);
else
	f_ex_goods_bop=ex_goods_bop;
	f_g_ex_goods_bop=g_ex_goods_bop;
end
	
f1=max(find(f_ex_goods_bop~=junk_nos));

if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of nominal goods exports data.']);
disp('Deflating nominal goods exports by the export commomdities price index.');
disp(['Have ',num2str(f1a-f1),' extra month(s) of export commomdities price index data; making forecasts of other']);
disp(['missing export price data.']);
if f1a>f1;
	disp(['For month(s) with export commomdities price data but no nominal goods exports data, the']);
	disp(['default uses forecast averaging to fill in nominal goods exports.']);
end;
end;
% make forecasts of the export price index
f_g_expi_total_nsa=fn_make_forecast(g_expi_total_nsa);
f_expi_total_nsa=expi_total_nsa;
for i1=f1a+1:ff+5;
	f_expi_total_nsa(i1)=f_expi_total_nsa(i1-1)*(1+f_g_expi_total_nsa(i1)/100);
end;
% compute real goods exports
f_ex_goods_real=junk_nos_m;
i1=f_ex_goods_bop~=junk_nos & f_expi_total_nsa~=junk_nos;
f_ex_goods_real(i1)=f_ex_goods_bop(i1)./f_expi_total_nsa(i1);
f_g_ex_goods_real=fn_compute_g_monthly(f_ex_goods_real);
% for month(s) where have export price index but not exports, use
% forecast averaging to come up with nominal exports forecast
[f_ex_goods_bop,f_g_ex_goods_bop,f_ex_goods_real,f_g_ex_goods_real]=...
	fn_fcast_avg(f_ex_goods_bop,f_g_ex_goods_bop,f_ex_goods_real,f_g_ex_goods_real,f_expi_total_nsa,f1,f1a);
% forecast real goods exports, then back out the nominal forecast
[f_g_ex_goods_real,txt]=fn_make_forecast(f_g_ex_goods_real);
for i1=f1a+1:ff+5;
	f_ex_goods_real(i1)=f_ex_goods_real(i1-1)*(1+f_g_ex_goods_real(i1)/100);
	f_ex_goods_bop(i1)=f_ex_goods_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_goods_bop(i1)=100*(f_ex_goods_bop(i1)/f_ex_goods_bop(i1-1)-1);
end;


for i1=ff+3:ff+5;
	f_ex_goods_real(i1)=f_ex_goods_real(i1-1)*(1+f_g_ex_goods_real(i1)/100);
	f_ex_goods_bop(i1)=f_ex_goods_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_goods_bop(i1)=100*(f_ex_goods_bop(i1)/f_ex_goods_bop(i1-1)-1);
end;
[f_exports_goods_q,f_g_exports_goods_q,f_exports_goods_next_q,f_g_exports_goods_next_q]=fn_convert_mtoqavg(f_ex_goods_real,date_m,date_q);
f_g_exports_goods_this_q=f_g_exports_goods_q(find(date_q==current_quarter));
%

%% -- Exports of Services -- %%

f1=max(find(ex_serv_bop~=junk_nos));
f1a=max(find(expi_serv~=junk_nos));
missing_no_months=3-(f1-ff)-1;
f_ex_serv_bop=ex_serv_bop;
f_g_ex_serv_bop=g_ex_serv_bop;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of nominal services exports data.']);
disp('Deflating nominal services exports by the export services price index.');
disp(['Have ',num2str(f1a-f1),' extra month(s) of export price index data; making forecasts of other']);
disp(['missing export price data.']);
if f1a>f1;
	disp(['For month(s) with export price data but no nominal exports data, the']);
	disp(['default uses forecast averaging to fill in nominal exports.']);
end;
end;
% make forecasts of the export price index
f_g_expi_serv=fn_make_forecast(g_expi_serv);
f_expi_serv=expi_serv;
for i1=f1a+1:ff+5;
	f_expi_serv(i1)=f_expi_serv(i1-1)*(1+f_g_expi_serv(i1)/100);
end;
% compute real services exports
f_ex_serv_real=junk_nos_m;
i1=ex_serv_bop~=junk_nos & f_expi_serv~=junk_nos;
f_ex_serv_real(i1)=ex_serv_bop(i1)./f_expi_serv(i1);
f_g_ex_serv_real=fn_compute_g_monthly(f_ex_serv_real);
% for month(s) where have export price index but not exports, use
% forecast averaging to come up with nominal exports forecast
[f_ex_serv_bop,f_g_ex_serv_bop,f_ex_serv_real,f_g_ex_serv_real]=...
	fn_fcast_avg(f_ex_serv_bop,f_g_ex_serv_bop,f_ex_serv_real,f_g_ex_serv_real,f_expi_serv,f1,f1a);
% forecast real services exports, then back out the nominal forecast
[f_g_ex_serv_real,txt]=fn_make_forecast(f_g_ex_serv_real);
for i1=f1a+1:ff+5;
	f_ex_serv_real(i1)=f_ex_serv_real(i1-1)*(1+f_g_ex_serv_real(i1)/100);
	f_ex_serv_bop(i1)=f_ex_serv_real(i1)*f_expi_serv(i1);
	f_g_ex_serv_bop(i1)=100*(f_ex_serv_bop(i1)/f_ex_serv_bop(i1-1)-1);
end;


for i1=ff+3:ff+5;
	f_ex_serv_real(i1)=f_ex_serv_real(i1-1)*(1+f_g_ex_serv_real(i1)/100);
	f_ex_serv_bop(i1)=f_ex_serv_real(i1)*f_expi_serv(i1);
	f_g_ex_serv_bop(i1)=100*(f_ex_serv_bop(i1)/f_ex_serv_bop(i1-1)-1);
end;
[f_exports_serv_q,f_g_exports_serv_q,f_exports_serv_next_q,f_g_exports_serv_next_q]=fn_convert_mtoqavg(f_ex_serv_real,date_m,date_q);
f_g_exports_serv_this_q=f_g_exports_serv_q(find(date_q==current_quarter));
%







%f_ex_real=junk_nos_m;
%i1=f_ex_goods_real~=junk_nos & f_share_ex_goods~=junk_nos;
%f_ex_real(i1)=f_share_ex_goods(i1).*f_ex_goods_real(i1)+f_share_ex_services(i1).*f_ex_serv_real(i1);
%f_ex_real(i1)=f_ex_goods_real(i1)+f_ex_serv_real(i1);

%f_g_ex_real=fn_compute_g_monthly(f_ex_real);
%
% compute quarterly export growth
%f_g_exports_this_q=share_ex_goods()*f_g_exports_goods_this_q+ share_ex_services*f_g_exports_serv_this_q;

%[f_exports_q,f_g_exports_q,f_exports_next_q,f_g_exports_next_q]=fn_convert_mtoqavg(f_ex_real,date_m,date_q);
%f_g_exports_this_q=f_g_exports_q(find(date_q==current_quarter));

f_g_exports_q=f_share_ex_goods_q.*f_g_exports_goods_q+f_share_ex_services_q.*f_g_exports_serv_q;

f_g_ex_bop=f_share_ex_goods.*f_g_ex_goods_bop+f_share_ex_services.*f_g_ex_serv_bop;


f_g_exports_this_q=f_g_exports_q(find(date_q==current_quarter));

f_g_exports_next_q=f_share_ex_goods_q(end)*f_g_exports_goods_next_q...
				  +f_share_ex_services_q(end)*f_g_exports_serv_next_q;

%{
f1=max(find(ex_serv_bop~=junk_nos));
%f1a=max(find(expi_total_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;
f_ex_serv_bop=ex_serv_bop;
f_g_ex_serv_bop=g_ex_serv_bop;
%{
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of nominal exports data.']);
disp('Deflating nominal exports (total goods and services) by the export price index.');
disp(['Have ',num2str(f1a-f1),' extra month(s) of export price index data; making forecasts of other']);
disp(['missing export price data.']);
if f1a>f1;
	disp(['For month(s) with export price data but no nominal exports data, the']);
	disp(['default uses forecast averaging to fill in nominal exports.']);
end;
end;
% make forecasts of the export price index
f_g_expi_total_nsa=fn_make_forecast(g_expi_total_nsa);
f_expi_total_nsa=expi_total_nsa;
for i1=f1a+1:ff+5;
	f_expi_total_nsa(i1)=f_expi_total_nsa(i1-1)*(1+f_g_expi_total_nsa(i1)/100);
end;
%}
% compute real exports
i1=ex_serv_bop~=junk_nos;
f_ex_serv_bop(i1)=ex_bop(i1);
f_g_ex_serv_bop=fn_compute_g_monthly(f_ex_serv_bop);

% for month(s) where have export price index but not exports, use
% forecast averaging to come up with nominal exports forecast
%[f_ex_bop,f_g_ex_bop,f_ex_real,f_g_ex_real]=...
%	fn_fcast_avg(f_ex_bop,f_g_ex_bop,f_ex_real,f_g_ex_real,f_expi_total_nsa,f1,f1a);
% forecast real exports, then back out the nominal forecast

% forecast out growth in nominal services export on itself
[f_g_ex_serv_bop,txt]=fn_make_forecast(f_g_ex_serv_bop);

% forecast out nominal services export using the growth forecast above (need the level series for trade balance calculations)
f1a=max(find(f_ex_serv_bop~=junk_nos));
for i1=f1a+1:length(f_ex_serv_bop);
	f_ex_serv_bop(i1)=f_ex_serv_bop(i1-1)*(1+f_g_ex_serv_bop(i1)/100);
end;

% forecast out quarterly services export price index on itself
f_impi_serv_q=impi_serv_q;
[f_impi_serv_q,txt]=fn_make_forecast(f_impi_serv_q);

%{
for i1=f1a+1:ff+5;
	f_ex_real(i1)=f_ex_real(i1-1)*(1+f_g_ex_real(i1)/100);
	f_ex_bop(i1)=f_ex_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_bop(i1)=100*(f_ex_bop(i1)/f_ex_bop(i1-1)-1);
end;


for i1=ff+3:ff+5;
	f_ex_real(i1)=f_ex_real(i1-1)*(1+f_g_ex_real(i1)/100);
	f_ex_bop(i1)=f_ex_real(i1)*f_expi_total_nsa(i1);
	f_g_ex_bop(i1)=100*(f_ex_bop(i1)/f_ex_bop(i1-1)-1);
end;
%}

[f_nm_exports_serv_q,f_g_nm_exports_serv_q,f_nm_exports_serv_next_q,f_g_nm_exports_serv_next_q]=fn_convert_mtoqavg(f_ex_serv_bop,date_m,date_q);

f_exports_serv_q=f_nm_exports_serv_q./f_impi_serv_q;
f_g_exports_serv_q=fn_compute_g_monthly(f_exports_serv_q);

f_g_exports_serv_this_q=f_g_exports_serv_q(find(date_q==current_quarter));
%}



%{
%}









if display_text;
disp('-------');
disp('Imports');
disp('-------');
end;

% Create series of goods/services share and forecast
share_im_goods_non_oil=(im_goods_bop-im_petrol_value_census)./im_bop;
share_im_goods_oil=(im_petrol_value_census)./im_bop;
share_im_services=1-share_im_goods_non_oil-share_im_goods_oil;

share_im_goods_non_oil(share_im_goods_non_oil==0)=junk_nos;
share_im_goods_oil(share_im_goods_oil==1)=junk_nos;
share_im_services(share_im_services==0)=junk_nos;

f_share_im_goods_non_oil=fn_make_forecast(share_im_goods_non_oil);
f_share_im_goods_oil=fn_make_forecast(share_im_goods_oil);
f_share_im_services=1-f_share_im_goods_non_oil-f_share_im_goods_oil;

[f_share_im_goods_non_oil_q,~,~,~]=fn_convert_mtoqavg(f_share_im_goods_non_oil,date_m,date_q);
[f_share_im_goods_oil_q,~,~,~]=fn_convert_mtoqavg(f_share_im_goods_oil,date_m,date_q);
f_share_im_services_q=1-f_share_im_goods_non_oil_q-f_share_im_goods_oil_q;

% need monthly growth rates for 3 variables:
% 1. imports of goods excluding oil/petroleum
% 2. oil/petroleum goods imports (volumes)
% 3. imports of services
%
if display_text;
disp('--------------------------------------------');
disp('1. Non-oil imports (goods only excluding oil and services).');
end;
% Note: FAME does not update data on oil volumes and oil values on a balance
% of payments basis on the day of the release.  In fact, these values do not
% appear in the release, so it is not clear where they come from in FAME. 
% Instead, the release has imports of total goods and services (BOP basis, sa); 
% imports of petroleum (Census basis, sa); and petroleum import data on 
% quantities (barrels) and values (both nsa).  Subtract imports of petroleum
% (Census basis) from total imports (BOP basis) to get ex-oil imports.
%

f1_reg=max(find(im_goods_exoil_bop~=junk_nos));
f1_adv=max(find(adv_im_goods_bop~=junk_nos));

f1a=max(find(expi_total_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;

if f1_adv>f1_reg
	f_g_im_goods_exoil_bop=g_im_goods_exoil_bop;
	f_g_im_goods_exoil_bop(f1_adv)=g_adv_im_goods_bop(f1_adv);
	
	f_im_goods_exoil_bop=im_goods_exoil_bop;
	f_im_goods_exoil_bop(f1_adv)=f_im_goods_exoil_bop(f1_adv-1)*(1+f_g_im_goods_exoil_bop(f1_adv)/100);
else
	f_im_goods_exoil_bop=im_goods_exoil_bop;
	f_g_im_goods_exoil_bop=g_im_goods_exoil_bop;
end
	
	
f1=max(find(im_goods_exoil_bop~=junk_nos));
%f1b=max(find(im_petrol_value_census~=junk_nos));
f1a=max(find(impi_exoil_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;
if display_text;
disp(['Have ',num2str(f1a-f1),' extra month(s) of import price index data; making forecasts of other']);
disp(['missing import price data.']);

%{
if f1b>f1;
	disp(['For month(s) with import price data but no nominal imports data, the']);
	disp(['default uses forecast averaging to fill in nominal imports.']);
end;
%}
end;
%{
% if for some reason have total imports but not petroleum values (perhaps
% because of data updating delays)
if f1>f1b;
	for i1=f1b+1:f1;
		f_g_im_goods_exoil_bop(i1)=g_im_goods_exoil_bop(i1);
		f_im_goods_exoil_bop(i1)=f_im_goods_exoil_bop(i1-1)*(1+f_g_im_goods_exoil_bop(i1)/100);
	end;
end;

f_im_goods_exoil_bop=im_goods_exoil_bop;
f_g_im_goods_exoil_bop=g_im_goods_exoil_bop;
%}
% make forecasts of the import price index
f_g_impi_exoil_nsa=fn_make_forecast(g_impi_exoil_nsa);
f_impi_exoil_nsa=impi_exoil_nsa;
for i1=f1a+1:ff+5;
	f_impi_exoil_nsa(i1)=f_impi_exoil_nsa(i1-1)*(1+f_g_impi_exoil_nsa(i1)/100);
end;
% compute real nonoil imports
f_im_goods_exoil_real=junk_nos_m;
i1=f_im_goods_exoil_bop~=junk_nos & f_impi_exoil_nsa~=junk_nos;
f_im_goods_exoil_real(i1)=f_im_goods_exoil_bop(i1)./f_impi_exoil_nsa(i1);
f_g_im_goods_exoil_real=fn_compute_g_monthly(f_im_goods_exoil_real);
% for month(s) where have import price index but not imports, use
% forecast averaging to come up with nominal imports forecast
[f_im_goods_exoil_bop,f_g_im_goods_exoil_bop,f_im_goods_exoil_real,f_g_im_goods_exoil_real]=...
	fn_fcast_avg(f_im_goods_exoil_bop,f_g_im_goods_exoil_bop,f_im_goods_exoil_real,f_g_im_goods_exoil_real,f_impi_exoil_nsa,f1,f1a);
% forecast real nonoil imports, then back out the nominal forecast
[f_g_im_goods_exoil_real,txt]=fn_make_forecast(f_g_im_goods_exoil_real);
for i1=f1a+1:ff+5;
	f_im_goods_exoil_real(i1)=f_im_goods_exoil_real(i1-1)*(1+f_g_im_goods_exoil_real(i1)/100);
	f_im_goods_exoil_bop(i1)=f_im_goods_exoil_real(i1)*f_impi_exoil_nsa(i1);
	f_g_im_goods_exoil_bop(i1)=100*(f_im_goods_exoil_bop(i1)/f_im_goods_exoil_bop(i1-1)-1);
end;

%{
if missing_no_months>0;
	if run_quietly==1; in1=1; 
	if display_text;
	if f1b>f1;
		disp(['Using forecast averaging when import price index data are available and real']);
		disp(['non-oil imports growth rate ',txt,',']);
		disp(['then backing out nominal non-oil imports growth rate.']);
	else;
		disp(['Using real non-oil imports growth rate']);
		disp([txt,',']);
		disp(['then backing out nominal non-oil imports growth rate.']);
	end;
	end;
	else;
	disp('Options to fill in missing month(s):');
	if f1b>f1;
		disp(['1. Use forecast averaging when import price index data are available and real']);
		disp(['   non-oil imports growth rate ',txt,' (default),']);
		disp(['   then back out nominal non-oil imports growth rate.']);
	else;
		disp(['1. Use real non-oil imports growth rate ']);
		disp(['   ',txt,' (default),']);
		disp(['   then back out nominal non-oil imports growth rate.']);
	end;	
	for i1=f1+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': real non-oil import growth = ',num2str(f_g_im_exoil_real(i1),'%4.1f')]);
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': nominal non-oil import growth = ',num2str(f_g_im_exoil(i1),'%4.1f')]);		
	end;
	disp('2. Enter nominal non-oil imports growth rates for missing month(s) then convert to real.');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f1+1:ff+2;
			f_g_im_exoil(i1)=input(['Growth in nominal non-oil imports for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_im_exoil(i1)=f_im_exoil(i1-1)*(1+f_g_im_exoil(i1)/100);
			f_im_exoil_real(i1)=f_im_exoil(i1)/f_impi_exoil_nsa(i1);
			f_g_im_exoil_real(i1)=100*(f_im_exoil_real(i1)/f_im_exoil_real(i1-1)-1);
		end;
	end;
end;
%}

for i1=ff+3:ff+5;
	f_im_goods_exoil_real(i1)=f_im_goods_exoil_real(i1-1)*(1+f_g_im_goods_exoil_real(i1)/100);
	f_im_goods_exoil_bop(i1)=f_im_goods_exoil_real(i1)*f_impi_exoil_nsa(i1);
	f_g_im_goods_exoil(i1)=100*(f_im_goods_exoil_bop(i1)/f_im_goods_exoil_bop(i1-1)-1);
end;
[f_imports_goods_exoil_q,f_g_imports_goods_exoil_q,f_imports_goods_exoil_next_q,f_g_imports_goods_exoil_next_q]=fn_convert_mtoqavg(f_im_goods_exoil_real,date_m,date_q);
f_g_imports_goods_exoil_this_q=f_g_imports_goods_exoil_q(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly real non-oil imports growth (SAAR) = ',num2str(f_g_imports_goods_exoil_this_q,'%5.1f')]);
%




disp('--------------------------------------------');
disp('2. Oil/petroleum goods imports.');
end;
f2=max(find(im_petrol_volume_nsa~=junk_nos));
f2a=max(find(im_oil_eia_wtom_nsa~=junk_nos));
missing_no_months=3-(f2-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of petroleum import volumes data.']);
disp('Using data on import volumes of petroleum products (quantity, thousands');
disp('of barrels, nsa) from Census trade report.  Seasonal adjustment occurs');
disp('later to make consistent with BEA NIPA data.');
end;
f_g_im_petrol_volume_nsa=g_im_petrol_volume_nsa;
f_im_petrol_volume_nsa=im_petrol_volume_nsa;
%
if f2a>f2;
	for i1=f2+1:f2a;
		f_im_petrol_volume_nsa(i1)=(im_oil_eia_wtom_nsa(i1)/im_oil_eia_wtom_nsa(i1-12))*im_petrol_volume_nsa(i1-12);
		f_g_im_petrol_volume_nsa(i1)=100*(f_im_petrol_volume_nsa(i1)/f_im_petrol_volume_nsa(i1-1)-1);
	end;
	if display_text;
		disp(['Have ',num2str(f2a-f2),' extra month(s) of Dept. of Energy/EIA oil import data.']);
		disp(['DOE/EIA data suggest:']);
		for i1=f2+1:f2a;
			disp(['     For ',num2str(date_m(i1),'%7.2f'),': petroleum import volume growth = ',num2str(f_g_im_petrol_volume_nsa(i1),'%4.1f')]);
		end;
	end;
end;
%
[f_g_im_petrol_volume_nsa,txt]=fn_make_forecast(f_g_im_petrol_volume_nsa);
if missing_no_months>0;
	if run_quietly==1; in1=1; 
	if display_text;
	disp(['Using projections based on Dept. of Energy data and petroleum']);
	disp(['import volume growth rate ',txt,'.']);
	end;
	for i1=f2a+1:ff+2;
		f_im_petrol_volume_nsa(i1)=f_im_petrol_volume_nsa(i1-1)*(1+f_g_im_petrol_volume_nsa(i1)/100);
	end;
	else;
	disp('Options to fill in missing month(s):');
	disp(['1. Use combination of Dept. of Energy data and petroleum import volume growth rate']);
	disp(['   ',txt,' (default).']);
	for i1=f2+1:ff+2;
		disp(['     For ',num2str(date_m(i1),'%7.2f'),': petroleum import volume growth  = ',num2str(f_g_im_petrol_volume_nsa(i1),'%4.1f')]);
		f_im_petrol_volume_nsa(i1)=f_im_petrol_volume_nsa(i1-1)*(1+f_g_im_petrol_volume_nsa(i1)/100);
	end;
	disp('2. Enter petroleum import volume growth rates for missing month(s).');
	in1=input('--> Select 1 (or enter blank) or 2. ');
	end;
	if in1==2;
		for i1=f2+1:ff+2;
			f_g_im_petrol_volume_nsa(i1)=input(['Petroleum import volume growth rate for ',num2str(date_m(i1),'%7.2f'),' = ']);
			f_im_petrol_volume_nsa(i1)=f_im_petrol_volume_nsa(i1-1)*(1+f_g_im_petrol_volume_nsa(i1)/100);
		end;
	end;
end;
for i1=ff+3:ff+5;
	f_im_petrol_volume_nsa(i1)=f_im_petrol_volume_nsa(i1-1)*(1+f_g_im_petrol_volume_nsa(i1)/100);
end;
[f_g_imports_oil_r,f_g_imports_oil_r_next_q]= ...
	fn_imports_oil(date_q,g_imports_goods_oil_r,f_im_petrol_volume_nsa,date_m,ff);
f_g_imports_oil_r_this_q=f_g_imports_oil_r(find(date_q==current_quarter));
if display_text;
disp(['Estimated quarterly real oil import growth = ',num2str(f_g_imports_oil_r_this_q,'%5.1f')]);
end;




if display_text;
disp('--------------------------------------------');
disp('3. Imports of Services (No oil/non-oil goods).');
end;

f1=max(find(im_serv_bop~=junk_nos));
f1b=max(find(im_petrol_value_census~=junk_nos));
f1a=max(find(impi_serv~=junk_nos));
missing_no_months=3-(f1-ff)-1;
if display_text;
disp(['Have ',num2str(f1a-f1),' extra month(s) of import price index data; making forecasts of other']);
disp(['missing import price data.']);
if f1b>f1;
	disp(['For month(s) with import price data but no nominal imports data, the']);
	disp(['default uses forecast averaging to fill in nominal imports.']);
end;
end;
f_im_serv_bop=im_serv_bop;
f_g_im_serv_bop=g_im_serv_bop;
% if for some reason have total imports but not petroleum values (perhaps
% because of data updating delays)
if f1>f1b;
	for i1=f1b+1:f1;
		f_g_im_serv_bop(i1)=g_im_serv_bop(i1);
		f_im_serv_bop(i1)=f_im_serv_bop(i1-1)*(1+f_g_im_serv_bop(i1)/100);
	end;
end;
% make forecasts of the import price index
f_g_impi_serv=fn_make_forecast(g_impi_serv);
f_impi_serv=impi_serv;
for i1=f1a+1:ff+5;
	f_impi_serv(i1)=f_impi_serv(i1-1)*(1+f_g_impi_serv(i1)/100);
end;
% compute real nonoil imports
f_im_serv_real=junk_nos_m;
i1=f_im_serv_bop~=junk_nos & f_impi_serv~=junk_nos;
f_im_serv_real(i1)=f_im_serv_bop(i1)./f_impi_serv(i1);
f_g_im_serv_real=fn_compute_g_monthly(f_im_serv_real);
% for month(s) where have import price index but not imports, use
% forecast averaging to come up with nominal imports forecast
[f_im_serv_bop,f_g_im_serv_bop,f_im_serv_real,f_g_im_serv_real]=...
	fn_fcast_avg(f_im_serv_bop,f_g_im_serv_bop,f_im_serv_real,f_g_im_serv_real,f_impi_serv,f1,f1a);
% forecast real nonoil imports, then back out the nominal forecast
[f_g_im_serv_real,txt]=fn_make_forecast(f_g_im_serv_real);
for i1=f1a+1:ff+5;
	f_im_serv_real(i1)=f_im_serv_real(i1-1)*(1+f_g_im_serv_real(i1)/100);
	f_im_serv_bop(i1)=f_im_serv_real(i1)*f_impi_serv(i1);
	f_g_im_serv_bop(i1)=100*(f_im_serv_bop(i1)/f_im_serv_bop(i1-1)-1);
end;



for i1=ff+3:ff+5;
	f_im_serv_real(i1)=f_im_serv_real(i1-1)*(1+f_g_im_serv_real(i1)/100);
	f_im_serv_bop(i1)=f_im_serv_real(i1)*f_impi_serv(i1);
	f_g_im_serv_bop(i1)=100*(f_im_serv_bop(i1)/f_im_serv_bop(i1-1)-1);
end;
[f_imports_serv_q,f_g_imports_serv_q,f_imports_serv_next_q,f_g_imports_serv_next_q]=fn_convert_mtoqavg(f_im_serv_real,date_m,date_q);
f_g_imports_serv_this_q=f_g_imports_serv_q(find(date_q==current_quarter));






f_g_imports_q=f_share_im_goods_non_oil_q.*f_g_imports_goods_exoil_q...
			 +f_share_im_goods_oil_q.*f_g_imports_oil_r...
			 +f_share_im_services_q.*f_g_imports_serv_q;

f_g_imports_this_q=f_g_imports_q(find(date_q==current_quarter));

f_g_imports_next_q=f_share_im_goods_non_oil_q(end)*f_g_imports_goods_exoil_next_q...
				  +f_share_im_goods_oil_q(end)*f_g_imports_oil_r_next_q...
				  +f_share_im_services_q(end)*f_g_imports_serv_next_q;





%{
% compute quarterly import growth
f_g_imports_this_q=share_im_goods_oil*f_g_imports_oil_r_this_q+ ...
	share_im_rest*f_g_imports_exoil_this_q;
%}
% convert NSA petrol volumes to SA for computing trade balance
f_im_petrol_volume_sa=fn_seasonal_adjust(f_im_petrol_volume_nsa);
% compute nominal trade balance
f_p_im_petrol=junk_nos_m;
i1=im_petrol_value_census~=junk_nos & im_petrol_volume_nsa~=junk_nos;
f_p_im_petrol(i1)=1000*im_petrol_value_census(i1)./im_petrol_volume_nsa(i1);
% assume a random walk in future Brent crude prices, i.e., a flat futures path
f_p_oil_brent_m_sa=fn_seasonal_adjust(p_oil_brent_m);
f1a=max(find(f_p_oil_brent_m_sa~=junk_nos));
f_p_oil_brent_m_sa(f1a+1:ff+5)=f_p_oil_brent_m_sa(f1a);
% assume that future imported petroleum prices are the average of Brent in the 
% previous month and the current month
f1=max(find(f_p_im_petrol~=junk_nos));
for i1=f1+1:ff+5;
	f_p_im_petrol(i1)=0.5*f_p_oil_brent_m_sa(i1)+0.5*f_p_oil_brent_m_sa(i1-1);
end;


f_im_bop=im_bop;
f1=max(find(f_im_bop~=junk_nos));
f_im_bop(f1+1:ff+5)=f_im_goods_exoil_bop(f1+1:ff+5)+f_im_serv_bop(f1+1:ff+5)+f_im_petrol_volume_sa(f1+1:ff+5).*f_p_im_petrol(f1+1:ff+5)/1000;
f_g_im_bop=g_im_bop;
for i1=f1+1:ff+5;
	f_g_im_bop(i1)=100*(f_im_bop(i1)/f_im_bop(i1-1)-1);
end;



f_trade_balance=trade_balance;
f1=max(find(f_trade_balance~=junk_nos));
f_trade_balance(f1+1:ff+5)=(f_ex_goods_bop(f1+1:ff+5)+f_ex_serv_bop(f1+1:ff+5)-f_im_bop(f1+1:ff+5))/1000;







% display forecasts for trade balance
if display_text & (f1+1<=ff+2);
%{
disp('--------------------------------------------');
disp('Forecasts for monthly trade readings:');
disp('(Growth rates m/m except for trade balance, which is nominal level, bil. $)');
disp('          Trade  ||  Exports:  || Imports:');
disp('         Balance || Nom. total || Nom. total | Nom. ex. oil   Oil volumes');
disp(num2str([date_m(f1+1:ff+2),f_trade_balance(f1+1:ff+2),f_g_ex_bop(f1+1:ff+2),...
	f_g_im_bop(f1+1:ff+2),f_g_im_exoil(f1+1:ff+2),f_g_im_petrol_volume_nsa(f1+1:ff+2)],...
	'%10.2f %7.1f %10.1f %13.1f %13.1f %14.1f\n'));
%}
disp('--------------------------------------------');	
disp('Forecasts for monthly trade readings:');
disp('(Growth rates m/m except for trade balance, which is nominal level, bil. $)');
disp('                 || Exports:              || Imports:');
disp('          Trade  ||        |              ||        |      Goods');
disp('         Balance || Total  | Goods  Serv. || Total  | Ex. oil   Oil volumes   Serv.');
disp(num2str([date_m(f1+1:ff+2),f_trade_balance(f1+1:ff+2),f_g_ex_bop(f1+1:ff+2),...
	f_g_ex_goods_bop(f1+1:ff+2),f_g_ex_serv_bop(f1+1:ff+2),...
	f_g_im_bop(f1+1:ff+2),f_g_im_goods_exoil_bop(f1+1:ff+2),...
	f_g_im_petrol_volume_nsa(f1+1:ff+2),f_g_im_serv_bop(f1+1:ff+2)],...
	'%10.2f %8.1f %8.1f %8.1f %6.1f %8.1f %9.1f %11.1f %10.1f\n'));
	
end;



if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in exports for ',num2str(current_quarter),', SAAR = ',num2str(f_g_exports_this_q,'%5.2f')]);
disp(['Estimated growth in imports for ',num2str(current_quarter),', SAAR = ',num2str(f_g_imports_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
%
if run_quietly==0;
	redo2=input('To recompute international trade, enter 1; to go on, hit enter or 0.... ');
	if redo2==1;
		redo1=0;
	else;
		redo1=1;
	end;
else;
	redo1=1;
end;
end;













%redo1=0;
%while redo1==0;
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('Government spending');
disp('----------------------------------------------------------------------------------');
end;
% set shares
share_govt_sl = govt_sl_n(no_quarters_for_weights)/govt_n(no_quarters_for_weights);
share_govt_fed = govt_fed_n(no_quarters_for_weights)/govt_n(no_quarters_for_weights);
% display 4 most recent quarterly government growth readings
if display_text;
disp('Most recent quarterly government growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_govt(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
end;
% determine whether to accept outside forecast for government spending or compute
% it based on available data
if run_quietly==1; in1=1; else;
disp('Allow for user to select one way to compute government spending:');
disp('1. Compute federal, state, and local spending based on data (default).');
disp('2. User supplies a forecast for total government spending.');
in1=input('--> Select 1 (or enter blank) or 2. ');
end;
if (isempty(in1) | in1==1);
if display_text;
disp('---------------');
disp('State and local');
disp('---------------');
end;
% set shares
share_govt_sl_cons = govt_sl_cons_n(no_quarters_for_weights)/govt_sl_n(no_quarters_for_weights);
share_govt_sl_inv = govt_sl_inv_n(no_quarters_for_weights)/govt_sl_n(no_quarters_for_weights);
% display 4 most recent quarterly state and local government growth readings
if display_text;
disp('Most recent quarterly state and local government growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_govt_sl_r(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
% need monthly growth rates for 2 variables:
% 1. state and local government consumption expenditures, using employment
% 2. state and local government investment expenditures, using real construction
%
% For now, run these silently in the background individually
%
% No user input required for state and local
%
disp('--------------------------------------------');
disp('1. State and local government consumption expenditures, based on employment.');
end;
payrolls_sl=junk_nos_m;
i1=payrolls_state_govt~=junk_nos & payrolls_local_govt~=junk_nos;
payrolls_sl(i1)=payrolls_state_govt(i1)+payrolls_local_govt(i1);
g_payrolls_sl=fn_compute_g_monthly(payrolls_sl);
f1=max(find(g_payrolls_sl~=junk_nos));
missing_no_months=3-(f1-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of state and local employment data.']);
end;

% Modified by Linmei Amaya, May 08
% Modified government payrolls forecast m file 
% to forecast using moving average given COVID-19
% effect on government payrolls
[f_g_payrolls_sl,txt]=fn_make_forecast_mov_avg(g_payrolls_sl);

f_payrolls_sl=payrolls_sl;
for i1=f1+1:ff+5;
	f_payrolls_sl(i1)=f_payrolls_sl(i1-1)*(1+f_g_payrolls_sl(i1)/100);
end;
[f_govt_sl_cons_r,f_g_govt_sl_cons_r,f_govt_sl_cons_r_next_q,f_g_govt_sl_cons_r_next_q]=fn_convert_mtoqavg(f_payrolls_sl,date_m,date_q);
f_g_govt_sl_cons_r_this_q=f_g_govt_sl_cons_r(date_q==current_quarter);
if display_text;
disp('--------------------------------------------');
disp('2. State and local government investment expenditures, based on construction ');
disp('   put-in-place.');
end;
f2a=max(find(const_put_in_place_state_local_govt~=junk_nos));
f2b=max(find(ppi_office_bldg~=junk_nos));
missing_no_months=3-(f2a-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of state and local construction put-in-place data.']);
end;
% deflating nominal construction spending by the PPI for new office building
% construction; PPI was forecasted earlier
f_real_sl_const=junk_nos_m;
f_g_real_sl_const=junk_nos_m;
i1=const_put_in_place_state_local_govt~=junk_nos & ppi_office_bldg~=junk_nos;
f_real_sl_const(i1)=const_put_in_place_state_local_govt(i1)./ppi_office_bldg(i1);
f_g_real_sl_const=fn_compute_g_monthly(f_real_sl_const);
% for month(s) where have PPI but not nominal construction, use 
% forecast averaging to come up with nominal construction forecast
[f_const_put_in_place_state_local_govt,f_g_const_put_in_place_state_local_govt,f_real_sl_const,f_g_real_sl_const]=...
	fn_fcast_avg(const_put_in_place_state_local_govt,g_const_put_in_place_state_local_govt,f_real_sl_const,f_g_real_sl_const,...
	ppi_office_bldg,f2a,f2b);
% make real forecasts, then back out future nominal
f_g_real_sl_const=fn_make_forecast(f_g_real_sl_const);
for i1=f2a+1:ff+5;
	f_real_sl_const(i1)=f_real_sl_const(i1-1)*(1+f_g_real_sl_const(i1)/100);
	f_const_put_in_place_state_local_govt(i1)=f_real_sl_const(i1)*f_ppi_office_bldg(i1);
	f_g_const_put_in_place_state_local_govt(i1)=100*(f_const_put_in_place_state_local_govt(i1)/f_const_put_in_place_state_local_govt(i1-1)-1);
end;
[f_govt_sl_inv_r,f_g_govt_sl_inv_r,f_govt_sl_inv_r_next_q,f_g_govt_sl_inv_r_next_q]=fn_convert_mtoqavg(f_real_sl_const,date_m,date_q);
f_g_govt_sl_inv_r_this_q=f_g_govt_sl_inv_r(date_q==current_quarter);
%
% compute quarterly state and local government growth
f_g_govt_sl_r_this_q=share_govt_sl_cons*f_g_govt_sl_cons_r_this_q+...
	share_govt_sl_inv*f_g_govt_sl_inv_r_this_q;
if display_text;
disp('--------------------------------------------');
disp('Monthly estimates and forecasts, state and local government (m/m pct. ch.):');
disp(['Date      Employment     Construction put-in-place']);
disp([num2str([date_m(ff-6:ff+2),f_g_payrolls_sl(ff-6:ff+2),f_g_const_put_in_place_state_local_govt(ff-6:ff+2)],'%7.2f %8.1f %21.1f\n')]);
disp(['Estimated quarterly state and local government growth = ',num2str(f_g_govt_sl_r_this_q,'%4.1f')]);
%
disp('-------');
disp('Federal');
disp('-------');
% display 4 most recent quarterly federal government growth readings
disp('Most recent quarterly federal government growth readings, SAAR:');
disp(num2str([date_q(no_quarters-3:no_quarters),g_govt_fed_r(no_quarters-3:no_quarters)],'%10.1f %13.2f\n'));
end;
% for the previous quarter, use the as-reported federal expenditures, but track
% revisions to state and local government spending
if g_govt_fed_r(date_q==current_quarter)~=junk_nos;
	f_g_govt_fed_r_this_q=g_govt_fed_r(date_q==current_quarter);
	if display_text;
	disp(['Using as-reported federal government spending growth of ',num2str(f_g_govt_fed_r_this_q,'%4.1f'),'.']);
	end;
%
else;
%
% use a regression on federal outlays, federal employment, and federal construction put-in-place
if display_text;
disp('--------------------------------------------');
disp('1. Federal expenditures from Treasury outlays.');
end;
f1=max(find(fed_expend_nsa~=junk_nos));
missing_no_months=3-(f1-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of federal expenditures data.']);
end;
fed_expend_nontransfers_nsa=junk_nos_m;
fed_expend_nontransfers_nondf_nsa=junk_nos_m;
ind1=fed_expend_ag_nsa~=junk_nos;

% Modified by Linmei Amaya, May 13 2020
% Muting April data, distorted from COVID-19 
% Continued on line 5713
% Modified by Thao Tran on June 11 2020 to unmute April data 
%ind1(1288) = false; 
fed_expend_nontransfers_nsa(ind1)=fed_expend_ag_nsa(ind1)+fed_expend_cr_nsa(ind1)+...
	fed_expend_df_nsa(ind1)+fed_expend_en_nsa(ind1)+fed_expend_gg_nsa(ind1)+...
	fed_expend_ia_nsa(ind1)+fed_expend_js_nsa(ind1)+fed_expend_re_nsa(ind1)+fed_expend_ss_nsa(ind1)+...
	fed_expend_tn_nsa(ind1);
fed_expend_nontransfers_nondf_nsa(ind1)=fed_expend_nontransfers_nsa(ind1)-fed_expend_df_nsa(ind1);
fed_expend_nontransfers=fn_seasonal_adjust(fed_expend_nontransfers_nsa);
fed_expend_nontransfers_nondf=fn_seasonal_adjust(fed_expend_nontransfers_nondf_nsa);
f_fed_expend_nontransfers=fed_expend_nontransfers;
f_fed_expend_nontransfers_nondf=fed_expend_nontransfers_nondf;
f_g_fed_expend_nontransfers=fn_compute_g_monthly(fed_expend_nontransfers);
f_g_fed_expend_nontransfers_nondf=fn_compute_g_monthly(fed_expend_nontransfers_nondf);

% Modified by Linmei Amaya May 13, 2020
% Changed to mov avg
f_g_fed_expend_nontransfers=fn_make_forecast_mov_avg(f_g_fed_expend_nontransfers);
f_g_fed_expend_nontransfers_nondf=fn_make_forecast_mov_avg(f_g_fed_expend_nontransfers_nondf);

%Below is the original code
for i1=f1+1:ff+5;
 f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100);
 f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100); 
end;
%%%%%%%%%%%%%%%%%%

% Below is the code while predicting 2020 Q2
% Adds 66.66 each month for Q2 2020; estimated gain from CARES Act
% for i1=f1:ff+2; 
% f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100)+66.66; 
% f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100)+66.66;
% end;

% Continued growth rate from Q1 2020 in absense of CARES Act
% f_fed_expend_nontransfers(f1+3)=f_fed_expend_nontransfers(i1-4)*(1+f_g_fed_expend_nontransfers(i1)/100);
% f_fed_expend_nontransfers_nondf(f1+3)=f_fed_expend_nontransfers_nondf(i1-4)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100);
% for i1=f1+4:ff+5; 
% f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100);
% f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100);
%end;
%%%%%%%%%%%%%%%%%%%%%
%Below is the code while predicting 2020 Q1(Discontinue after 04/28/2021)
%Sungil Kim 3/15/2021
% Add 10 to Mar 2021 and Add 20 to each month for Q2 2021; estimated gain
% from ARP (WE DO THIS UNTIL 4/28/2021)
% for i1=f1+1:ff+2; 
% f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100)+10; 
% f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100)+10;
% end;
% 
% for i1=ff+3:ff+5;
% f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100)+20; 
% f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100)+20;
% end;    
%%%%%%%%%%%%%%%%%%%%%

% %Sungil Kim 5/5/2021
% % Add 20 to each month for Q2 2021; estimated gain
% % from ARP 
%  for i1=f1+1:ff+2; 
%  f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100)+20; 
%  f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100)+20;
%  end;
%  
%  for i1=ff+3:ff+5;
%  f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100); 
%  f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100);
%  end;    
% %%%%%%%%%%%%%%%%%%%%%

%Sungil Kim 6/10/2021
% Add 20 to each month for Q2 2021; estimated gain
% from ARP ; We stop this on 7/29/2021 after Q2 adv estimate release
%  for i1=ff+2:ff+2
%  f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100)+20; 
%  f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100)+20;
%  end;
%  
%  for i1=ff+3:ff+5;
%  f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100); 
%  f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100);
%  end;    
% %%%%%%%%%%%%%%%%%%%%%




f_fed_expend_nontransfers_df=junk_nos_m;
f_fed_expend_nontransfers_df(ind1)=f_fed_expend_nontransfers(ind1)-f_fed_expend_nontransfers_nondf(ind1);
f_g_fed_expend_nontransfers_df=fn_compute_g_monthly(f_fed_expend_nontransfers_df);
f_real_fed_expend_nontransfers=junk_nos_m;
f_real_fed_expend_nontransfers_nondf=junk_nos_m;
i1=f_fed_expend_nontransfers~=junk_nos & f_pcepm~=junk_nos;
f_real_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1)./f_pcepm(i1);
f_real_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1)./f_pcepm(i1);

% f_g_fed_expend_nontransfers=fn_make_forecast(f_g_fed_expend_nontransfers);
% f_g_fed_expend_nontransfers_nondf=fn_make_forecast(f_g_fed_expend_nontransfers_nondf);
%
% for i1=f1+1:ff+5;
%	f_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1-1)*(1+f_g_fed_expend_nontransfers(i1)/100);
%	f_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1-1)*(1+f_g_fed_expend_nontransfers_nondf(i1)/100);
% end;
% 
% f_fed_expend_nontransfers_df=junk_nos_m;
% ind1=f_fed_expend_nontransfers~=junk_nos;
% f_fed_expend_nontransfers_df(ind1)=f_fed_expend_nontransfers(ind1)-f_fed_expend_nontransfers_nondf(ind1);
% f_g_fed_expend_nontransfers_df=fn_compute_g_monthly(f_fed_expend_nontransfers_df);
% f_real_fed_expend_nontransfers=junk_nos_m;
% f_real_fed_expend_nontransfers_nondf=junk_nos_m;
% i1=f_fed_expend_nontransfers~=junk_nos & f_pcepm~=junk_nos;
% f_real_fed_expend_nontransfers(i1)=f_fed_expend_nontransfers(i1)./f_pcepm(i1);
% f_real_fed_expend_nontransfers_nondf(i1)=f_fed_expend_nontransfers_nondf(i1)./f_pcepm(i1);


[f_real_fed_expend_nontransfers_q,f_g_real_fed_expend_nontransfers_q,f_real_fed_expend_nontransfers_next_q,...
	f_g_real_fed_expend_nontransfers_next_q]=fn_convert_mtoqavg(f_real_fed_expend_nontransfers,date_m,date_q);
[f_real_fed_expend_nontransfers_nondf_q,f_g_real_fed_expend_nontransfers_nondf_q,f_real_fed_expend_nontransfers_nondf_next_q,...
	f_g_real_fed_expend_nontransfers_nondf_next_q]=fn_convert_mtoqavg(f_real_fed_expend_nontransfers_nondf,date_m,date_q);
if display_text;
disp('--------------------------------------------');
disp('2. Federal employment.');
end;
f2=max(find(payrolls_fed_govt~=junk_nos));
missing_no_months=3-(f2-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of federal employment data.']);
end;
% adjust federal payrolls for Census effects
payrolls_fed_govt_adj=fn_payrolls_fed_govt_census(payrolls_fed_govt,date_m);
g_payrolls_fed_govt_adj=fn_compute_g_monthly(payrolls_fed_govt_adj);
f_g_payrolls_fed_govt_adj=fn_make_forecast(g_payrolls_fed_govt_adj);
f_payrolls_fed_govt_adj=payrolls_fed_govt_adj;
for i1=f2+1:ff+5;
	f_payrolls_fed_govt_adj(i1)=f_payrolls_fed_govt_adj(i1-1)*(1+f_g_payrolls_fed_govt_adj(i1)/100);
end;
[f_payrolls_fed_govt_adj_q,f_g_payrolls_fed_govt_adj_q,f_payrolls_fed_govt_adj_next_q,f_g_payrolls_fed_govt_adj_next_q]=...
	fn_convert_mtoqavg(f_payrolls_fed_govt_adj,date_m,date_q);
if display_text;
disp('--------------------------------------------');
disp('3. Federal construction put-in-place.');
end;
f3=max(find(const_put_in_place_fed_govt~=junk_nos));
missing_no_months=3-(f3-ff)-1;
if display_text;
disp(['Missing ',num2str(missing_no_months),' month(s) of federal construction put-in-place data.']);
end;
f_const_put_in_place_fed_govt=const_put_in_place_fed_govt;

% Modified by Linmei Amaya, May 13 2020
% Changed forecast to moving average due to COVID-19
 f_g_const_put_in_place_fed_govt=fn_make_forecast(g_const_put_in_place_fed_govt);
% f_g_const_put_in_place_fed_govt=fn_make_forecast_mov_avg(g_const_put_in_place_fed_govt);
for i1=f3+1:ff+5;
	f_const_put_in_place_fed_govt(i1)=f_const_put_in_place_fed_govt(i1-1)*(1+f_g_const_put_in_place_fed_govt(i1)/100);
end;
[f_const_put_in_place_fed_govt_q,f_g_const_put_in_place_fed_govt_q,f_const_put_in_place_fed_govt_next_q,...
	f_g_const_put_in_place_fed_govt_next_q]=fn_convert_mtoqavg(f_const_put_in_place_fed_govt,date_m,date_q);
%
% combine to forecast federal government spending, use forecast averaging among 3 techniques
f_g_govt_fed_r=junk_nos*ones(size(date_q));
%
% Technique 1
f_g_govt_fed_r1=junk_nos*ones(size(date_q));
i1=f_g_real_fed_expend_nontransfers_q~=junk_nos & f_g_payrolls_fed_govt_adj_q~=junk_nos ...
	& f_g_const_put_in_place_fed_govt_q~=junk_nos;
rule_threshold1=30;
rule_threshold2=40;
i2=i1 & f_g_const_put_in_place_fed_govt_q<=rule_threshold1;
f_g_govt_fed_r1(i2)=0.3*f_g_real_fed_expend_nontransfers_q(i2)+0.5*f_g_payrolls_fed_govt_adj_q(i2)+ ...
	0.2*f_g_const_put_in_place_fed_govt_q(i2);
i2=i1 & f_g_const_put_in_place_fed_govt_q>rule_threshold1 & f_g_const_put_in_place_fed_govt_q<=rule_threshold2;
f_g_govt_fed_r1(i2)=0.35*f_g_real_fed_expend_nontransfers_q(i2)+0.55*f_g_payrolls_fed_govt_adj_q(i2)+ ...
	0.1*f_g_const_put_in_place_fed_govt_q(i2);
i2=i1 & f_g_const_put_in_place_fed_govt_q>rule_threshold2;
f_g_govt_fed_r1(i2)=0.4*f_g_real_fed_expend_nontransfers_q(i2)+0.6*f_g_payrolls_fed_govt_adj_q(i2);
% next quarter
if f_g_const_put_in_place_fed_govt_next_q<=rule_threshold1;
	f_g_govt_fed_r_next_q1=0.3*f_g_real_fed_expend_nontransfers_next_q+0.5*f_g_payrolls_fed_govt_adj_next_q+ ...
		0.2*f_g_const_put_in_place_fed_govt_next_q;
elseif f_g_const_put_in_place_fed_govt_next_q>rule_threshold1 & f_g_const_put_in_place_fed_govt_next_q<=rule_threshold2;
	f_g_govt_fed_r_next_q1=0.35*f_g_real_fed_expend_nontransfers_next_q+0.55*f_g_payrolls_fed_govt_adj_next_q+ ...
		0.1*f_g_const_put_in_place_fed_govt_next_q;
else;
	f_g_govt_fed_r_next_q1=0.4*f_g_real_fed_expend_nontransfers_next_q+0.6*f_g_payrolls_fed_govt_adj_next_q;
end;
%
% Technique 2
f_g_govt_fed_r2=junk_nos*ones(size(date_q));
w=36;
temp1=[g_govt_fed_r,ones(size(g_govt_fed_r)),f_g_real_fed_expend_nontransfers_q,f_g_payrolls_fed_govt_adj_q,f_g_const_put_in_place_fed_govt_q];
f4=1;
for i1=1:size(temp1,2);
	f4=max(f4,min(find(temp1(:,i1)~=junk_nos)));
end;
for i1=f4+8:length(date_q);
	temp2=temp1(f4:i1-1,:);
	if size(temp2,1)>w;
		temp2=temp2(size(temp2,1)-w+1:size(temp2,1),:);
	end;
	if sum(sum(temp2==junk_nos))==0;
		b=regress(temp2(:,1),temp2(:,2:5));
		if sum(temp1(i1,2:5)==junk_nos)==0;
			f_g_govt_fed_r2(i1)=b'*temp1(i1,2:5)';
		end;
	end;
end;
f_g_govt_fed_r_next_q2=b'*[1;f_g_real_fed_expend_nontransfers_next_q;f_g_payrolls_fed_govt_adj_next_q;f_g_const_put_in_place_fed_govt_next_q];
%
% Technique 3
f_g_govt_fed_r3=junk_nos*ones(size(date_q));
w=8;
temp1=[g_govt_fed_r,ones(size(date_q)),f_g_real_fed_expend_nontransfers_nondf_q,[junk_nos;g_govt_fed_r(1:length(g_govt_fed_r)-1)]];
f4=1;
for i1=1:size(temp1,2);
	f4=max(f4,min(find(temp1(:,i1)~=junk_nos)));
end;
for i1=f4+w:length(date_q);
	temp2=temp1(i1-8:i1-1,:);
	if size(temp2,1)>w;
		temp2=temp2(size(temp2,1)-w+1:size(temp2,1),:);
	end;
	if sum(sum(temp2==junk_nos))==0;
		b=regress(temp2(:,1),temp2(:,2:4));
		if sum(temp1(i1,2:4)==junk_nos)==0;
			f_g_govt_fed_r3(i1)=b'*temp1(i1,2:4)';
		end;
	end;
end;
%
% Modified by Linmei Amaya May 13 2020
% saving results
temp1=[f_g_govt_fed_r1,f_g_govt_fed_r2,f_g_govt_fed_r3];
techs = temp1;
f4=1;
for i1=1:size(temp1,2);
	f4=max(f4,min(find(temp1(:,i1)~=junk_nos)));
end;
for i1=f4:length(date_q);
	temp2=temp1(i1,:);
	temp2=temp2(temp2~=junk_nos);
	f_g_govt_fed_r(i1)=mean(temp2);
end;
f_g_govt_fed_r_this_q=f_g_govt_fed_r(date_q==current_quarter);
f_g_govt_fed_r_next_q3=b'*[1;f_g_real_fed_expend_nontransfers_nondf_next_q;f_g_govt_fed_r_this_q];
temp2=[f_g_govt_fed_r_next_q1,f_g_govt_fed_r_next_q2,f_g_govt_fed_r_next_q3];
temp2=temp2(temp2~=junk_nos);
f_g_govt_fed_r_next_q=mean(temp2);
%
if display_text;
disp('--------------------------------------------');	
disp('Monthly estimates and forecasts, federal government (SA m/m pct. ch.):');
disp(['Date      Treasury outlays   Federal employment  Federal construction']);
disp([num2str([date_m(ff-6:ff+2),f_g_fed_expend_nontransfers(ff-6:ff+2),f_g_payrolls_fed_govt_adj(ff-6:ff+2),...
	f_g_const_put_in_place_fed_govt(ff-6:ff+2)],'%7.2f %11.1f %19.1f %20.1f\n')]);
disp(['Estimated quarterly federal government growth = ',num2str(f_g_govt_fed_r_this_q,'%4.1f')]);
end;
%
end;
%
% compute quarterly government growth
f_g_govt_this_q=share_govt_sl*f_g_govt_sl_r_this_q+...
	share_govt_fed*f_g_govt_fed_r_this_q;
end; % use data to compute government spending
%
if in1==2; % allow for user input for government spending (e.g., to incorporate outside estimate)
	f_g_govt_this_q=input(['Growth of total government spending = ']);
end;
%
if display_text;
disp('**********************************************************************************');
disp(['Estimated growth in government spending for ',num2str(current_quarter),', SAAR = ',num2str(f_g_govt_this_q,'%5.2f')]);
disp('**********************************************************************************');
disp(' ');
end;
%if run_quietly==0;
%	redo2=input('To recompute inflation, enter 1; to go on, hit enter or 0.... ');
%	if redo2==1;
%		redo1=0;
%	else;
%		redo1=1;
%	end;
%else;
%	redo1=1;
%end;
%end;














%---------------------------------------------------------------------
% Compute GDP growth
%---------------------------------------------------------------------
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('GDP Growth');
disp('----------------------------------------------------------------------------------');
end;
[f_g_gdp_this_q,f_g_inv_bfi_this_q,f_nx_this_q]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_pce_real_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,f_inv_ch_inv_this_q);
if display_text;
disp('**********************************************************************************');
disp(['Estimated GDP growth ',num2str(current_quarter),', SAAR = ',num2str(f_g_gdp_this_q,'%5.2f')]);
disp('**********************************************************************************');
end;

%[f_g_gdp_this_q_judgement,f_g_inv_bfi_this_q_judgement,f_nx_this_q_judgement]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
%	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
%	result(1), result(2), result(3),result(4),result(5),result(9),result(7),result(8),result(6));

% modified by Linmei Amaya Feb 18, 2020 (also see line 6378)
% Computes GDP growth using last quarter BEA inventory estimates instead of last quarter tracking
% for alternative tracking estimate
% modified by Thao Tran on June 8, 2020 to remove complex terms
% [f_g_gdp_this_q_alt_inv,f_g_inv_bfi_this_q_alt_inv,f_nx_this_q_alt_inv]=fn_compute_g_gdp_alt_inv_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
%	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
%	f_g_pce_real_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,f_inv_ch_inv_this_q);
	
%---------------------------------------------------------------------
% Recompute using outside forecast of government spending estimates
%---------------------------------------------------------------------
% do not do this for the last quarter
if loop_no_last_q_and_this_q==run_last_q_and_this_q;
%
if isempty(f_g_govt_outside);
	f_g_govt_outside=share_govt_sl*f_g_govt_sl_r_outside+...
		share_govt_fed*f_g_govt_fed_r_outside;
end;
[f_g_gdp_outside]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...f
	f_g_pce_real_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_outside,f_inv_ch_inv_this_q);
forecast_all_outside=[f_g_gdp_outside,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,...
	f_g_inv_res_this_q,f_inv_ch_inv_this_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_outside,0,...
	f_g_pcep_this_q,f_g_pcep_core_this_q]';
%if display_text;
%disp('**********************************************************************************');
%disp(['Using outside forecast for govt., estimated GDP growth ',num2str(current_quarter),', SAAR = ',num2str(f_g_gdp_outside)]);
%disp('**********************************************************************************');
%end;
%
end;

%---------------------------------------------------------------------
% find growth in final sales of domestic product
%---------------------------------------------------------------------
ind1=find(date_q==current_quarter);
% put in previous quarter's inventory numbers for the current quarter
% to abstract from inventory changes
inv_ch_inv_last_q=inv_ch_inv(ind1-1);
[f_g_final_sales_domestic_product]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_pce_real_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,inv_ch_inv_last_q);

%---------------------------------------------------------------------
% Put into a convenient format for exporting
%---------------------------------------------------------------------
if loop_no_last_q_and_this_q<run_last_q_and_this_q; % this is the forecast for the previous quarter
	forecast_all_last_q=[date_nos,current_quarter,f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,...
		f_g_inv_res_this_q,f_inv_ch_inv_this_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,NaN,...
		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
		f_g_final_sales_domestic_product,NaN,...
		NaN,NaN]';
	f_g_gdp_last_q=f_g_gdp_this_q;
	f_g_pce_real_last_q=f_g_pce_real_this_q;
	f_g_inv_bfi_last_q=f_g_inv_bfi_this_q;
	f_g_inv_nrstr_last_q=f_g_inv_nrstr_this_q;
	f_g_inv_es_last_q=f_g_inv_es_this_q;
    f_g_inv_ipp_last_q=f_g_inv_ipp_this_q;
	f_g_inv_res_last_q=f_g_inv_res_this_q;
	f_inv_ch_inv_last_q=f_inv_ch_inv_this_q;
	f_nx_last_q=f_nx_this_q;
	f_g_exports_last_q=f_g_exports_this_q;
	f_g_imports_last_q=f_g_imports_this_q;
	f_g_govt_last_q=f_g_govt_this_q;
else;
	forecast_all_this_q=[date_nos,current_quarter,f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,...
		f_g_inv_res_this_q,f_inv_ch_inv_this_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,NaN,...
		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
		f_g_final_sales_domestic_product,NaN,...
		f_g_govt_outside,f_g_gdp_outside]';	
end;
if run_last_q_and_this_q==1;
	forecast_all_last_q=zeros(size(forecast_all_this_q));
end;
%---------------------------------------------------------------------
% End the loop over the number of quarters to run the model
%---------------------------------------------------------------------
end;

%----------------------------------------------------------------------
% Next quarter tracking
%----------------------------------------------------------------------
% Inflation
% Consumption
% Investment: Equipment 
% NOTE SOFTWARE HAS BEEN REMOVED 
f_g_inv_es_next_q=share_inv_es_rest*f_g_real_ship_core_cap_goods_next_q+...
	share_inv_es_tn_autos*f_g_mv_sales_autos_bus_next_q+...
	share_inv_es_tn_lt*f_g_mv_sales_lt_bus_next_q+...
	share_inv_es_aircraft*f_g_real_aircraft_next_q;

% Inevestment: Intellectual property 
f_g_inv_ipp_next_q = share_inv_ipp_software*f_g_software_avg_next_q + ...
    share_inv_ipp_rd*f_g_inv_ipp_rd_next_q + share_inv_ipp_ela*f_g_inv_ipp_ela_next_q;
		
% Investment: Nonresidential structures
inv_nrstr_mining_next_q=inv_nrstr_mining_this_q*(1+f_g_inv_nrstr_mining_next_q/100)^0.25;
inv_nrstr_ex_mining_next_q=inv_nrstr_ex_mining_this_q*(1+f_g_inv_nrstr_ex_mining_next_q/100)^0.25;
f_g_inv_nrstr_next_q=100*(((inv_nrstr_mining_next_q+inv_nrstr_ex_mining_next_q)/...
	(inv_nrstr_mining_this_q+inv_nrstr_ex_mining_this_q))^4-1);
% Investment: Residential structures
f_g_house_sales_1fam_ex=fn_make_forecast(f_g_house_sales_1fam_ex);
f_g_house_p_ex=fn_make_forecast(f_g_house_p_ex);
f_g_house_sales_1fam_new=fn_make_forecast(f_g_house_sales_1fam_new);
f_g_house_p_new=fn_make_forecast(f_g_house_p_new);
for i1=ff+3:ff+5;
	f_ppi_brokerage_fees(i1)=f_ppi_brokerage_fees(i1-1)*(1+f_g_ppi_brokerage_fees(i1-1)/100);
	f_house_sales_1fam_ex(i1)=f_house_sales_1fam_ex(i1-1)*(1+f_g_house_sales_1fam_ex(i1)/100);
	f_house_p_ex(i1)=f_house_p_ex(i1-1)*(1+f_g_house_p_ex(i1)/100);
	f_house_sales_1fam_new(i1)=f_house_sales_1fam_new(i1-1)*(1+f_g_house_sales_1fam_new(i1)/100);
	f_house_p_new(i1)=f_house_p_new(i1-1)*(1+f_g_house_p_new(i1)/100);
	f_real_commissions(i1)=0.06*(f_house_sales_1fam_ex(i1)/12*f_house_p_ex(i1)+...
		f_house_sales_1fam_new(i1)*1000/12*f_house_p_new(i1))/f_ppi_brokerage_fees(i1);	
end;
f_real_commissions_next_q=mean(f_real_commissions(ff+3:ff+5));
f_g_real_commissions_next_q=100*((f_real_commissions_next_q/f_real_commissions_this_q)^4-1);
f_g_inv_res_next_q=share_inv_res_struc_perm_1fam*f_g_real_const_put_in_place_1fam_next_q+...
	share_inv_res_struc_perm_mult*f_g_real_const_put_in_place_mult_next_q+...
	share_inv_res_other_improve*f_g_real_res_improvements_next_q+...
	share_inv_res_other_comm*f_g_real_commissions_next_q;


% Investment: Inventories
f_ch_inv_mfg_real_next_q=mean(f_ch_inv_mfg_real(ff+3:ff+5));
f_ch_inv_wholesale_real_next_q=mean(f_ch_inv_wholesale_real(ff+3:ff+5));
f_ch_inv_retail_real_next_q=mean(f_ch_inv_retail_real(ff+3:ff+5));
f_inv_ch_inv_next_q=f_ch_inv_mfg_real_next_q+f_ch_inv_wholesale_real_next_q+f_ch_inv_retail_real_next_q+f_inv_ch_inv_other_next_q;
 
% Government 
f_g_govt_sl_next_q=share_govt_sl_cons*f_g_govt_sl_cons_r_next_q+...
	share_govt_sl_inv*f_g_govt_sl_inv_r_next_q;
f_g_govt_next_q=share_govt_sl*f_g_govt_sl_next_q+...
	share_govt_fed*f_g_govt_fed_r_next_q;


% Exports and imports
%{
f_g_imports_next_q=share_im_goods_oil*f_g_imports_oil_r_next_q+ ...
	share_im_rest*f_g_imports_exoil_next_q;
%}
%%
% Compute real GDP growth
[f_g_gdp_next_q,f_g_inv_bfi_next_q,f_nx_next_q]=fn_next_q_compute_g_gdp_new(date_q,...
	gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,f_inv_ch_inv_this_q,...
	f_g_pce_real_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q,f_g_inv_res_next_q,...
	f_g_exports_next_q,f_g_imports_next_q,f_g_govt_next_q,f_inv_ch_inv_next_q);
%
% Compute growth of real final sales
[f_g_final_sales_domestic_product_next_q]=fn_next_q_compute_g_gdp_new(date_q,...
	gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_next_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,f_g_govt_this_q,f_inv_ch_inv_this_q,...
	f_g_pce_real_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q,f_g_inv_res_next_q,...
	f_g_exports_next_q,f_g_imports_next_q,f_g_govt_next_q,f_inv_ch_inv_this_q);
%
i1=length(date_q);
current_q=date_q(i1);
current_q_no=round(10*(current_q-round(current_q)));
current_year=round(current_q);
if current_q_no==4; 
	current_q_no=1;
	current_year=current_year+1;
	next_quarter=current_year+current_q_no/10;
else;
	current_q_no=current_q_no+1;
	next_quarter=current_year+current_q_no/10;
end;
%
forecast_all_next_q=[date_nos,next_quarter,f_g_
    gdp_next_q,f_g_pce_real_next_q,f_g_inv_bfi_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q...
	f_g_inv_res_next_q,f_inv_ch_inv_next_q,f_nx_next_q,f_g_exports_next_q,f_g_imports_next_q,f_g_govt_next_q,NaN,...
	f_g_pcep_next_q,f_g_pcep_core_next_q,NaN,...
	f_g_final_sales_domestic_product_next_q,NaN,...
	NaN,NaN]';



%----------------------------------------------------------------------
% Run the bridging model
%----------------------------------------------------------------------

[bridging_forecast,bridging_labels1,bridging_labels2]=...
	fn_bridging_eqns(date_m,retail_less_bldg,g_retail_less_bldg,cpi,g_cpi,pce_nom,g_pce_nom,...
	pcepm,g_pcepm,const_nonres,g_const_nonres,rigs_m_bridge,g_rigs_m_bridge,ship_cap_goods_nondef,g_ship_cap_goods_nondef,...
	ppi_man,g_ppi_man,housing_starts,g_housing_starts,ex_bop,g_ex_bop,expi_total,g_expi_total,im_bop,g_im_bop,...
	impi_total,g_impi_total,fed_expend_sa,g_fed_expend_sa,payrolls_state_local_govt,g_payrolls_state_local_govt,...
	pce,g_pce,inv_nrstr,g_inv_nrstr,inv_es,g_inv_es,inv_res_n,inv_res_p,exports,g_exports,imports,g_imports,...
	govt,g_govt,date_q);
[f_g_gdp_bridging]=fn_compute_g_gdp(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	bridging_forecast(3),bridging_forecast(4),bridging_forecast(7),bridging_forecast(8),bridging_forecast(11),...
	bridging_forecast(14),bridging_forecast(15),f_inv_ch_inv_this_q);



%----------------------------------------------------------------------
% Run the employment-industrial production-GDP growth model
%----------------------------------------------------------------------
[fcast_emp_ip_gdp,fcast_emp_ip_gdp_details,fcast_emp_ip_gdp_all]= ...
	fn_nowcast_emp_ip_gdp(date_m,ff,payrolls_mining,g_payrolls_mining, ...
		payrolls_constr,g_payrolls_constr,payrolls_private_services,g_payrolls_private_services, ...
	  payrolls_mfg,g_payrolls_mfg,ip_mfg,g_ip_mfg,g_gdp,date_q);

%----------------------------------------------------------------------
% Run the ISM-GDP growth model
%----------------------------------------------------------------------
[fcast_ism_gdp,fcast_ism_gdp_details,fcast_ism_gdp_all]= ...
	fn_nowcast_ism_gdp(date_m,ff,ism_mfg,ism_mfg_prod,ism_nonmfg_comp, ...
		date_q,g_gdp);
		
%----------------------------------------------------------------------
% Run the GRS factor model 
%----------------------------------------------------------------------
[fcast_factor_model_gdp,fcast_factor_model_gdp_detail, fcast_factor_model_gdp_next]=fn_nowcast_factor_model_gdp(date_q,fm_data);

%-----------------------------------------------------------------------
% Run the GRS factor model for total PCE
%-----------------------------------------------------------------------

[fcast_factor_model_pce,fcast_factor_model_pce_detail, beta_pce, regressor_pce, fcast_factor_model_pce_next]=fn_nowcast_factor_model_pce(date_q,fm_data_pce);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: nonresidential structure 
%-----------------------------------------------------------------------
[fcast_factor_model_inv_nrstr,fcast_factor_model_inv_nrstar_detail,fcast_factor_model_inv_nrstr_next]=fn_nowcast_factor_model_inv_nrstr(date_q,fm_data_inv_nrstr);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: equipment  
%-----------------------------------------------------------------------
[fcast_factor_model_inv_es,fcast_factor_model_inv_es_detail,fcast_factor_model_inv_es_next]=fn_nowcast_factor_model_inv_es(date_q,fm_data_inv_es);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: IPP
%-----------------------------------------------------------------------
[fcast_factor_model_inv_ipp,fcast_factor_model_inv_ipp_detail,fcast_factor_model_inv_ipp_next]=fn_nowcast_factor_model_inv_ipp(date_q,fm_data_inv_ipp);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: CIPI  
%-----------------------------------------------------------------------
[fcast_factor_model_ch_inv,fcast_factor_model_ch_inv_detail, fcast_factor_model_ch_inv_next]=fn_nowcast_factor_model_ch_inv(date_q,fm_data_ch_inv);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: residential structure 
%-----------------------------------------------------------------------
[fcast_factor_model_inv_res,fcast_factor_model_inv_res_detail,fcast_factor_model_inv_res_next]=fn_nowcast_factor_model_inv_res(date_q,fm_data_inv_res);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: exports  
%-----------------------------------------------------------------------
[fcast_factor_model_exports,fcast_factor_model_exports_detail, Fq, fcast_factor_model_exports_next]=fn_nowcast_factor_model_exports(date_q,fm_data_exports);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: imports 
%-----------------------------------------------------------------------
[fcast_factor_model_imports,fcast_factor_model_imports_detail,fcast_factor_model_imports_next]=fn_nowcast_factor_model_imports(date_q,fm_data_imports);

%-----------------------------------------------------------------------
% Run the GRS factor model for investment: government spending   
%-----------------------------------------------------------------------
[fcast_factor_model_govt, fcast_factor_model_govt_detail, beta, regressor, fcast_factor_model_govt_next]=fn_nowcast_factor_model_govt(date_q,fm_data_govt);
% jbae 
% regressor values added (May 22, 2019)


%-----------------------------------------------------------------------
% Compute GDP growth using factor model estimates using GDP growth   
%-----------------------------------------------------------------------
% Added by Linmei Amaya Feb 14, 2020 to calculate GDP growth from factor estimates
[fcast_factor_model_gdp,fcast_factor_model_bfi,fcast_factor_model_nx]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
 gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
 fcast_factor_model_pce,fcast_factor_model_inv_nrstr,fcast_factor_model_inv_es,fcast_factor_model_inv_ipp,fcast_factor_model_inv_res,fcast_factor_model_exports,fcast_factor_model_imports,fcast_factor_model_govt,fcast_factor_model_ch_inv);

[fcast_factor_model_gdp_next,fcast_factor_model_bfi_next,fcast_factor_model_nx_next]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
 gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
 fcast_factor_model_pce_next,fcast_factor_model_inv_nrstr_next,fcast_factor_model_inv_es_next,fcast_factor_model_inv_ipp_next,fcast_factor_model_inv_res_next,fcast_factor_model_exports_next,fcast_factor_model_imports_next,fcast_factor_model_govt_next,fcast_factor_model_ch_inv_next);

% factor model nowcast for subcomponents 
fact_fr =[fcast_factor_model_pce;fcast_factor_model_inv_nrstr;fcast_factor_model_inv_es;fcast_factor_model_inv_ipp;fcast_factor_model_inv_res;fcast_factor_model_ch_inv;fcast_factor_model_exports;fcast_factor_model_imports;fcast_factor_model_govt];

% factor model forecast for next quarter subcomponents
% modified by Linmei Amaya Jan 10, 2020
fact_fr_next = [fcast_factor_model_pce_next;fcast_factor_model_inv_nrstr_next;fcast_factor_model_inv_es_next;fcast_factor_model_inv_ipp_next;fcast_factor_model_inv_res_next;fcast_factor_model_ch_inv_next;fcast_factor_model_exports_next;fcast_factor_model_imports_next;fcast_factor_model_govt_next];



%----------------------------------------------------------------------
% Run the GRS factor model for subcomponents of GDP
%----------------------------------------------------------------------





%----------------------------------------------------------------------
% Forecast labels
%----------------------------------------------------------------------
forecast_labels=char('Date','Quarter','GDP','Personal Consumption Expenditures','Business Fixed Investment',...
	'   Structures','   Equipment','   Intellectual Property','Residential Investment','Change in Inventories (Level)',...
	'Net Exports (Level)','   Exports','   Imports','Government Purchases','Unemployment Rate (Level)',...
	'PCE Inflation','Core PCE Inflation','empty','Final Sales of Domestic Product','empty',...
	'Outside Source for Government Purchases','GDP Growth with Alternative Govt.');
forecast_labels_this_q_plus=char('Date','Quarter','GDP','Personal Consumption Expenditures','Business Fixed Investment',...
	'   Structures','   Equipment','   Intellectual Property','Residential Investment','Change in Inventories (Level)',...
	'Net Exports (Level)','   Exports','   Imports','Government Purchases','Unemployment Rate (Level)',...
	'PCE Inflation','Core PCE Inflation','empty','Final Sales of Domestic Product','empty',...
	'Outside Source for Government Purchases','GDP Growth with Alternative Govt.','empty',...
	'Bridging Model','Consumption, with CPI','Consumption, without CPI','  Average','Business Investment: Structures',...
	'Business Investment: Equipment & Software, with PPI','Business Investment: Equipment & Software, without PPI',...
	'  Average','Residential Investment','Exports, with Export Price Index','Exports, without Export Price Index',...
  '  Average','Imports, with Import Price Index','Imports, without Import Price Inde','  Average',...
  'Government, Consumption and Gross Investment','GDP (using averages plus tracking inventories)','empty',...
  'Forecast from employment-IP-GDP growth model','Forecast from ISM-GDP growth model','Forecast from GRS Factor Model');

%----------------------------------------------------------------------
% Save vectors with estimates
%----------------------------------------------------------------------
disp(['Results for the current quarter, ',num2str(current_quarter),', saved in forecast_all_this_q;']);
disp(['results including additional models saved in forecast_all_this_q_plus.']);
forecast_all_this_q_plus=[forecast_all_this_q;NaN;NaN;bridging_forecast;f_g_gdp_bridging;NaN;fcast_emp_ip_gdp;fcast_ism_gdp;fcast_factor_model_gdp];
forecast_all_this_q_plus(forecast_all_this_q_plus==junk_nos)=NaN;
forecast_all_date=date_txt;
if save_date_dummy==2;
eval(['save data_tracking_forecasts_',forecast_all_date,' forecast_all_this_q forecast_all_last_q '...
	'forecast_all_next_q forecast_labels forecast_all_this_q_plus forecast_labels_this_q_plus '...
	'bridging_forecast bridging_labels1 bridging_labels2']);
end;

disp(' ');
disp('Results for the next quarter in forecast_all_next_q.');



% jbae

%% run once every data release (base_estimates subject to change)
% attain number of days and lambda to be implemented (distance_days,
% lambda)

% create vector containing baseline estimates (based on staff forecast)
% (order: PCE, nonres, equip, ipp, res, gv, exports, imports, cipi)
% (old) base_estimates =[2.6; 6.7; 4.2; 5.9; -1.8; 2.8; -0.3; 4.9; 17];
%base_estimates = [2.6, 1.5, 3.5, 5.0, 0.0, 1.5, 4.0, 3.5, 68];

% vector containing factor model estimates 
factor_estimates = [fcast_factor_model_pce; fcast_factor_model_inv_nrstr; fcast_factor_model_inv_es; fcast_factor_model_inv_ipp; ...
   fcast_factor_model_inv_res; fcast_factor_model_govt; fcast_factor_model_exports; fcast_factor_model_imports; fcast_factor_model_ch_inv];

% vector containing factor model estimates for the next quarter
% modified by Linmei Amaya Jan 10, 2020
factor_estimates_next = [fcast_factor_model_gdp_next; fcast_factor_model_pce_next; fcast_factor_model_inv_nrstr_next; fcast_factor_model_inv_es_next; fcast_factor_model_inv_ipp_next; ...
   fcast_factor_model_inv_res_next; fcast_factor_model_govt_next; fcast_factor_model_exports_next; fcast_factor_model_imports_next; fcast_factor_model_ch_inv_next];


% vector containing accounting estimates
ind = [4, 6, 7, 8, 9, 14, 12, 13, 10];
for i = 1:length(ind)
    account_estimates(i,1) = forecast_all_this_q_plus(ind(i));
end

% compute weight
%for i = 1:length(ind)
%    lambda(i,1) = (base_estimates(i) - account_estimates(i)) / (factor_estimates(i) - account_estimates(i));
%end

% set lambda (October 26, 2018) - can also run on console (96)
next_release = '27-Oct-2022';
%distance_days = daysact(datetime('30-Jul-2020'), next_release);
distance_days = datenum(next_release) - datenum('28-Jul-2022');

%daily_reduction = lambda ./ distance_days;
%%

% original lambda fixed
%lambda_fixed = [0.471883082714915;1.26038738893607;0.240464659519465;1.35260711702835;-0.0138828042414416;1.80877977117372;-1.95607972733712;-0.507675795823808;-0.321176448135867];

% modified for 09/04/2018
%lambda_fixed = [0.471883082714915;1.7;0.240464659519465;1.35260711702835;-0.0138828042414416;2.6;-1.95607972733712;-0.507675795823808;-0.321176448135867];

% modified for 09/05/2018
%lambda_fixed = [0.471883082714915;1.26038738893607;0.240464659519465;1.35260711702835;-0.0138828042414416;1.80877977117372;-0.4;-0.507675795823808;-0.321176448135867];


% with modified lambda for experiment
%lambda_fixed = [0.471883082714915;0.99;0.240464659519465;0.99;0.01;0.99;0.01;0.01;0.01];

% modified labda starting on 09/05/18
%lambda_fixed = [0.471883082714915;1.5;0.240464659519465;1.35260711702835;-0.0138828042414416;2.6;-0.4;-0.507675795823808;-0.321176448135867];

% lambda for sept 6 (structure and government)
%lambda_fixed = [0.471883082714915;1.29;0.240464659519465;1.35260711702835;-0.0138828042414416;1.95;-0.4;-0.507675795823808;-0.321176448135867];

% fixing lambda (original: [-0.186411006027214] [2.90699381265527][0.641980200315401][0.851429877558739][0.303052612926416]
% [6.96896265371661][-1.67486486662933][1.12884567818407][1.27756534831947]

lambda_fixed = [1; 1; 1; 1; 1; 1; 1; 1; 1];

% lambda used until Oct 25 (one day before GDP release for Q3 - GDP
% released on Oct. 26th)
%(old) lambda_fixed = [0.471883082714915;1;0.240464659519465;1;0;1;0;0;0];

% divided by the number of days left from today (-1; to make weight = 0 the day before GDP release) (distance from Apr 26
% to Jul 26 -1) 
daily_reduction = lambda_fixed ./ (distance_days - 1);

% compute distance from initial date (30-Jul-2020)
%distance_from_initial = daysact(datetime('30-Jul-2020'), datetime('Today'));

today = datetime('Today');
distance_from_initial = datenum(today) - datenum('28-Jul-2022');


% final weight assigned to the factor model
final_weight  = lambda_fixed - daily_reduction .* distance_from_initial;

% special case (April. 29, 2019) factor model for CIPI manually assigned 0
%final_weight(9) = 0;

% special case (Jan 31, 2019) weight fixed at 0 for all due to delay in gdp
% release
%for i = 1:8
%    final_weight(i,1) = 0;
%end


for i = 1:9
    result(i,1) = final_weight(i) * factor_estimates(i) + ...
        (1 - final_weight(i)) * account_estimates(i);
end


% Modifed by Linmei Amaya, Feb 18 2020 (see line 6154)
% Adds headline GDP estimate in the factor_estimates vector output
% after factor estimates used in judgement estimate 
factor_estimates = [fcast_factor_model_gdp; fcast_factor_model_pce; fcast_factor_model_inv_nrstr; fcast_factor_model_inv_es; fcast_factor_model_inv_ipp; ...
   fcast_factor_model_inv_res; fcast_factor_model_govt; fcast_factor_model_exports; fcast_factor_model_imports; fcast_factor_model_ch_inv];



% Note: The order in result and account_estimates is as follows:
% 1. PCE 
% 2. Nonresidential Investment
% 3. Equipment Investment
% 4. IPP Investment 
% 5. Residential Investment
% 6. Government
% 7. Exports 
% 8. Imports
% 9. CIPI (level)

% Note: The order in factor_estimate is as follows:
% 1. GDP
% 2. PCE 
% 3. Nonresidential Investment
% 4. Equipment Investment
% 5. IPP Investment 
% 6. Residential Investment
% 7. Government
% 8. Exports 
% 9. Imports
% 10. CIPI (level)




% 7/7/2012 Sungil Kim
% Alternative forecast for next quarter GDP estimate
% We don't regularly report this value.
% We use factor model govt spending estimate
%%
% Compute real GDP growth
[f_g_gdp_next_q_alt,f_g_inv_bfi_next_q,f_nx_next_q]=fn_next_q_compute_g_gdp_new(date_q,...
	gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_this_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,fcast_factor_model_govt ,f_inv_ch_inv_this_q,...
	f_g_pce_real_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q,f_g_inv_res_next_q,...
	f_g_exports_next_q,f_g_imports_next_q,fcast_factor_model_govt_next,f_inv_ch_inv_next_q);
%
% Compute growth of real final sales
[f_g_final_sales_domestic_product_next_q_alt]=fn_next_q_compute_g_gdp_new(date_q,...
	gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	f_g_gdp_this_q,f_g_pce_real_this_q,f_g_inv_bfi_this_q,f_g_inv_nrstr_this_q,f_g_inv_es_this_q,f_g_inv_ipp_this_q,f_g_inv_res_next_q,f_nx_this_q,f_g_exports_this_q,f_g_imports_this_q,fcast_factor_model_govt ,f_inv_ch_inv_this_q,...
	f_g_pce_real_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q,f_g_inv_res_next_q,...
	f_g_exports_next_q,f_g_imports_next_q,f_g_govt_next_q,f_inv_ch_inv_this_q);
%
i1=length(date_q);
current_q=date_q(i1);
current_q_no=round(10*(current_q-round(current_q)));
current_year=round(current_q);
if current_q_no==4; 
	current_q_no=1;
	current_year=current_year+1;
	next_quarter=current_year+current_q_no/10;
else;
	current_q_no=current_q_no+1;
	next_quarter=current_year+current_q_no/10;
end;
%
forecast_all_next_q_alt=[date_nos,next_quarter,f_g_gdp_next_q_alt,f_g_pce_real_next_q,f_g_inv_bfi_next_q,f_g_inv_nrstr_next_q,f_g_inv_es_next_q,f_g_inv_ipp_next_q...
	f_g_inv_res_next_q,f_inv_ch_inv_next_q,f_nx_next_q,f_g_exports_next_q,f_g_imports_next_q,fcast_factor_model_govt_next ,NaN,...
	f_g_pcep_next_q,f_g_pcep_core_next_q,NaN,...
	f_g_final_sales_domestic_product_next_q_alt,NaN,...
	NaN,NaN]';




%---------------------------------------------------------------------
% Compute GDP growth with judgement
%---------------------------------------------------------------------
if display_text;
disp(' ');
disp('----------------------------------------------------------------------------------');
disp('GDP Growth with Judgement');
disp('----------------------------------------------------------------------------------');
end;
[f_g_gdp_this_q_judgement,f_g_inv_bfi_this_q_judgement,f_nx_this_q_judgement]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	result(1), result(2), result(3),result(4),result(5),result(7),result(8),result(6),result(9));

forecast_all_this_q_judgement=[date_nos,current_quarter,f_g_gdp_this_q_judgement,result(1),f_g_inv_bfi_this_q_judgement,result(2),result(3),result(4),...
		result(5),result(9),f_nx_this_q_judgement,result(7),result(8),result(6),NaN,...
		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
		f_g_final_sales_domestic_product,NaN,...
		f_g_govt_outside,f_g_gdp_outside]';
    

% Modified by Linmei, May 14 2020
% alternative assumption: 0 weight given to accounting-model government 

%result_alt = account_estimates;
%result_alt(6) = factor_estimates(7);

[f_g_gdp_this_q_judgement_alt,f_g_inv_bfi_this_q_judgement,f_nx_this_q_judgement]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	result(1), result(2), result(3),result(4),result(5),result(7),result(8),factor_estimates(7),result(9));   
    
forecast_all_this_q_judgement_alt=[date_nos,current_quarter,f_g_gdp_this_q_judgement_alt,result(1),f_g_inv_bfi_this_q_judgement,result(2),result(3),result(4),...
		result(5),result(9),f_nx_this_q_judgement,result(7),result(8),factor_estimates(7),NaN,...
		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
		f_g_final_sales_domestic_product,NaN,...
		f_g_govt_outside,f_g_gdp_outside]';   
		
		
% 2/2/2022 Sungil Kim
% alternative assumption: use factor model estimate for net exports and CIPI.

[f_g_gdp_this_q_judgement_alt_2,f_g_inv_bfi_this_q_judgement_alt_2,f_nx_this_q_judgement_alt2]=fn_compute_g_gdp_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
	account_estimates(1), account_estimates(2), account_estimates(3),account_estimates(4),account_estimates(5),factor_estimates(8),factor_estimates(9),account_estimates(6),factor_estimates(10));   
    
forecast_all_this_q_judgement_alt_2=[date_nos,current_quarter,f_g_gdp_this_q_judgement_alt_2,account_estimates(1),f_g_inv_bfi_this_q_judgement_alt_2,account_estimates(2),account_estimates(3),account_estimates(4),...
		account_estimates(5),factor_estimates(10),f_nx_this_q_judgement_alt2,factor_estimates(8),factor_estimates(9),account_estimates(6),NaN,...
		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
		f_g_final_sales_domestic_product,NaN,...
		f_g_govt_outside,f_g_gdp_outside]';  
    
% alternative assumption: last quarter inventories from BEA instead of last quarter tracking  
% Modified by Linmei Amaya Feb 18, 2020 (also see line 5892)
% modified by Thao Tran on June 8, 2020 to remove complex terms
% removed on 7/7/2021
%[f_g_gdp_this_q_judgement_alt_inv,f_g_inv_bfi_this_q_judgement_alt_inv,f_nx_this_q_judgement_alt_inv]=fn_compute_g_gdp_alt_inv_new(date_q,gdp,pce,inv_bfi,inv_nrstr,inv_es,inv_ipp,inv_res,inv_ch_inv,nx,exports,imports,govt,...
%	gdp_p,pcep,inv_bfi_p,inv_nrstr_p,inv_es_p,inv_ipp_p,inv_res_p,inv_ch_inv_n,nx_n,exports_p,imports_p,govt_p,...
%	result(1), result(2), result(3),result(4),result(5),result(7),result(8),result(6),result(9));   
    
% forecast_all_this_q_judgement_alt_inv=[date_nos,current_quarter,f_g_gdp_this_q_judgement_alt_inv,result(1),f_g_inv_bfi_this_q_judgement_alt_inv,result(2),result(3),result(4),...
%		result(5),result(9),f_nx_this_q_judgement_alt_inv,result(7),result(8),result(6),NaN,...
%		f_g_pcep_this_q,f_g_pcep_core_this_q,NaN,...
%		f_g_final_sales_domestic_product,NaN,...
%		f_g_govt_outside,f_g_gdp_outside]';   
    

% Modified by Linmei Amaya April 06,2020
% Moved to below forecast judgement alternative estimates; displaying estimates using BEA, trying to figure out why not matching with BEA estimates of inventories
if display_text;
disp('**********************************************************************************');
disp(['Estimated GDP growth with Judgement ',num2str(current_quarter),', SAAR = ',num2str(f_g_gdp_this_q_judgement,'%5.2f')]);
disp('**********************************************************************************');
end;


    
fprintf('\n');  
disp(['Results with judgement for the current quarter, ',num2str(current_quarter),', saved in forecast_all_this_q_judgement.']);


if save_date_dummy==2;
eval(['save data_tracking_forecasts_',forecast_all_date,' forecast_all_this_q forecast_all_last_q '...
	'forecast_all_next_q forecast_labels forecast_all_this_q_plus forecast_labels_this_q_plus '...
	'bridging_forecast bridging_labels1 bridging_labels2 forecast_all_this_q_judgement']);
end;


% Modified by Linmei Amaya April 06, 2020
% removed 07/07/2021
% Changing to calculate ...alt_inv contributions because that is what we're reporting for the time being
% f_g_gdp_this_q_judgement = f_g_gdp_this_q_judgement_alt_inv;
% forecast_all_this_q_judgement = forecast_all_this_q_judgement_alt_inv;

% jbae 
% calculate contribution 
%gdp_cont = gdp_n(end);
%pce_cont = pce_n(end); 
%nonres_cont = inv_nrstr_n(end);
%equip_cont = inv_es_n(end);
%ipp_cont = inv_ipp_n(end);
%res_cont = inv_res_n(end);
%cipi_cont = cipi_n(end);
%exports_cont = exports_n(end);
%imports_cont = imports_n(end);
%govt_cont = govt_n(end);

% Note: The order in result is as follows (for annualized quarterly growth):
% 1. PCE 
% 2. Nonresidential Investment
% 3. Equipment Investment
% 4. IPP Investment 
% 5. Residential Investment
% 6. Government
% 7. Exports 
% 8. Imports
% 9. CIPI (level)

imputed_gdp = find_imputed(gdp_cont,f_g_gdp_this_q_judgement);

cont_pce = find_contribution( find_share( find_imputed(pce_cont, result(1)), pce_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);

%cont_nonres = find_contribution( find_share( find_imputed(nonres_cont, result(2)), nonres_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);
%cont_equip = find_contribution( find_share( find_imputed(equip_cont, result(3)), equip_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);
%cont_ipp = find_contribution( find_share( find_imputed(ipp_cont, result(1)), ipp_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);

cont_bfi = find_contribution( find_share( find_imputed(bfi_cont, f_g_inv_bfi_this_q_judgement), bfi_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);

cont_res = find_contribution( find_share( find_imputed(res_cont, result(5)), res_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);
cont_govt = find_contribution( find_share( find_imputed(govt_cont, result(6)), govt_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);
cont_exports = find_contribution( find_share( find_imputed(exports_cont, result(7)), exports_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);
cont_imports = -find_contribution( find_share( find_imputed(imports_cont, result(8)), imports_cont, imputed_gdp, gdp_cont), f_g_gdp_this_q_judgement);


% real_inv_level

ay83 = cipi_n(end-1);
az100 = real_inv_level(end-1) + result(9);
ay100 = real_inv_level(end-1);
ax100 = real_inv_level(end-2);
az118 = ay83 * (az100/ay100);
az117 = ay83 / (ay100/ax100);
az120 = az118 - ay83;
az119 = ay83 - az117;

cont_share = (az120 - az119) / (imputed_gdp - gdp_n(end-1));

cont_cipi = find_contribution(cont_share, f_g_gdp_this_q_judgement);


cont_sum = cont_pce + cont_bfi + cont_res + cont_govt + cont_exports + cont_imports + cont_cipi;



fprintf('\n'); 
disp('----------------------------------------------------------------------------------');
disp("Today's Data Updates");
disp('----------------------------------------------------------------------------------');
disp('**********************************************************************************');
if counter_q == 0
    disp('No Quarterly Updates')
else
    disp("Quarterly Updates:")
    for i = 1:length(quarterly_change_list)
        disp(['- ', data_names_q(quarterly_change_list(i) - 1,:)]);
    end
end
disp('----------------------------------------------------------------------------------');
if counter_m == 0
    disp('No Monthly Updates')
else
    disp("Monthly Updates:")
    for i = 1:length(monthly_change_list)
        disp(['- ', data_names_m(monthly_change_list(i)-1,:)]);
    end
end
disp('----------------------------------------------------------------------------------');
if counter_w == 0
    disp('No Weekly Updates')
else
    disp("Weekly Updates:")
    for i = 1:length(weekly_change_list)
        disp(['- ', data_names_w(weekly_change_list(i),:)]);
    end
end
disp('----------------------------------------------------------------------------------');
if counter_d == 0
    disp('No Daily Updates')
else
    disp("Daily Updates:")
    for i = 1:length(daily_change_list)
        disp(['- ', data_names_d(daily_change_list(i),:)]);
    end
end
disp('**********************************************************************************');










% normalize component contribution based on GDP growth (after judgement)
factor = f_g_gdp_this_q_judgement / cont_sum;


cont_pce_adj = cont_pce * factor;
cont_bfi_adj = cont_bfi * factor;
cont_res_adj = cont_res * factor;
cont_cipi_adj = cont_cipi * factor;
cont_nx_adj = (cont_exports + cont_imports) * factor;
cont_govt_adj = cont_govt * factor;

adjusted_component_contribution = [cont_pce_adj; cont_bfi_adj; cont_res_adj; cont_cipi_adj; cont_nx_adj; cont_govt_adj];




% jbae latest contribution
% contribution (May 29)

% convert to quarterly
f_g_gdp_this_q_judgement_quarterly = (1 + f_g_gdp_this_q_judgement) ^ 0.25 - 1;

f_gdp_this_q_judgement_quarterly = gdp(end-1) * (1 + f_g_gdp_this_q_judgement_quarterly);


difference_gdp = f_gdp_this_q_judgement_quarterly - gdp(end-1);




components = [pce, inv_nrstr, inv_es, inv_ipp, inv_res, govt, exports, imports];

% for i = 1:8
%     %Modified by Thao Tran on June 8 2020 to resolve complex terms
%     %quarterly_rates(i) = (1 + result(i)/100) ^ 0.25 - 1;
%     quarterly_rates(i) = max(0,(1 + result(i)/100)) ^ 0.25 - 1;
%     component = components(:,i);
%     quarterly_results(i) = (1 + quarterly_rates(i)) * component(end-1);
%     differences(i) = quarterly_results(i) - component(end-1);
%     ratios(i) = differences(i) / gdp(end-1);
%     
%     if i == 8
%         contribution(i) = - ((1 + ratios(i)) ^ 4 - 1);
%     else
%         contribution(i) = (1 + ratios(i)) ^ 4 - 1;
%     end
%     
% end
% 
% contribution(9) = f_g_gdp_this_q_judgement/100 - sum(contribution(1:8));
% 
% contribution_final = [contribution(1); sum(contribution(2:4)); contribution(5); ...
%     contribution(9); sum(contribution(7:8));  contribution(6)] * 100;

%Modified by Sungil Kim on 11/17/2020
%We now report accounting-based model results only, so change the component
%contribution accordingly.
for i = 1:8
    quarterly_rates(i) = max(0,(1 + account_estimates(i)/100)) ^ 0.25 - 1;
    component = components(:,i);
    quarterly_results(i) = (1 + quarterly_rates(i)) * component(end-1);
    differences(i) = quarterly_results(i) - component(end-1);
    ratios(i) = differences(i) / gdp(end-1);
    
    if i == 8
        contribution(i) = - ((1 + ratios(i)) ^ 4 - 1);
    else
        contribution(i) = (1 + ratios(i)) ^ 4 - 1;
    end
    
end

contribution(9) = f_g_gdp_this_q/100 - sum(contribution(1:8));

contribution_final = [contribution(1); sum(contribution(2:4)); contribution(5); ...
    contribution(9); sum(contribution(7:8));  contribution(6)] * 100;







% Modified by Sungil Kim on 02/08/2022
% GDP Growth Contributions of different components of alternative 2 forecasts

% alt2forecast = [account_estimates(1),account_estimates(2),account_estimates(3),account_estimates(4),...
% 		account_estimates(5),account_estimates(6),factor_estimates(8),factor_estimates(9), factor_estimates(10)];
% for i = 1:8
%     quarterly_rates(i) = max(0,(1 + alt2forecast(i)/100)) ^ 0.25 - 1;
%     component = components(:,i);
%     quarterly_results(i) = (1 + quarterly_rates(i)) * component(end-1);
%     differences(i) = quarterly_results(i) - component(end-1);
%     ratios(i) = differences(i) / gdp(end-1);
%     
%     if i == 8
%         contribution(i) = - ((1 + ratios(i)) ^ 4 - 1);
%     else
%         contribution(i) = (1 + ratios(i)) ^ 4 - 1;
%     end
%     
% end
% 
% contribution(9) = f_g_gdp_this_q_judgement_alt_2/100 - sum(contribution(1:8));
% 
% contribution_final_alt_2 = [contribution(1); sum(contribution(2:4)); contribution(5); ...
%     contribution(9); sum(contribution(7:8));  contribution(6)] * 100;


% Modified by Sungil Kim on 02/09/2022

% GDP Growth Contributions of different components of judgmental forecasts

for i = 1:8
    quarterly_rates(i) = max(0,(1 + result(i)/100)) ^ 0.25 - 1;
    component = components(:,i);
    quarterly_results(i) = (1 + quarterly_rates(i)) * component(end-1);
    differences(i) = quarterly_results(i) - component(end-1);
    ratios(i) = differences(i) / gdp(end-1);
    
    if i == 8
        contribution(i) = - ((1 + ratios(i)) ^ 4 - 1);
    else
        contribution(i) = (1 + ratios(i)) ^ 4 - 1;
    end
    
end

contribution(9) = f_g_gdp_this_q_judgement/100 - sum(contribution(1:8));

contribution_final_alt = [contribution(1); sum(contribution(2:4)); contribution(5); ...
    contribution(9); sum(contribution(7:8));  contribution(6)] * 100;






disp('**********************************************************************************');

fprintf('\n'); 
disp('----------------------------------------------------------------------------------');
disp("Subcomponent Conbtribution (percentage points)");
disp('----------------------------------------------------------------------------------');

disp(['Consumer Spending (PCE)               = ',num2str(contribution_final(1),'%+5.2f')]);
disp(['Nonresidential Fixed Investment (BFI) = ',num2str(contribution_final(2),'%+5.2f')]);
disp(['Residential Investment                = ',num2str(contribution_final(3),'%+5.2f')]);
disp(['Change in Private Inventories         = ',num2str(contribution_final(4),'%+5.2f')]);
disp(['Net Exports                           = ',num2str(contribution_final(5),'%+5.2f')]);
disp(['Government Spending                   = ',num2str(contribution_final(6),'%+5.2f')]);


disp('**********************************************************************************');

fprintf('\n'); 
disp('----------------------------------------------------------------------------------');
disp("Subcomponent Weight Assignment on Factor Model");
disp('----------------------------------------------------------------------------------');

disp(['Consumer Spending (PCE)               = ',num2str(final_weight(1),'%+5.2f')]);
disp(['Nonresidential Fixed Investment (BFI) = ',num2str(final_weight(2),'%+5.2f')]);
disp(['BFI - Equipment                       = ',num2str(final_weight(3),'%+5.2f')]);
disp(['BFI - IPP                             = ',num2str(final_weight(4),'%+5.2f')]);
disp(['Residential Investment                = ',num2str(final_weight(5),'%+5.2f')]);
disp(['Change in Private Inventories         = ',num2str(final_weight(9),'%+5.2f')]);
disp(['Exports                               = ',num2str(final_weight(7),'%+5.2f')]);
disp(['Imports                               = ',num2str(final_weight(8),'%+5.2f')]);
disp(['Government Spending                   = ',num2str(final_weight(6),'%+5.2f')]);

% 1. PCE 
% 2. Nonresidential Investment
% 3. Equipment Investment
% 4. IPP Investment 
% 5. Residential Investment
% 6. Government
% 7. Exports 
% 8. Imports
% 9. CIPI (level)
disp('**********************************************************************************');

% -----------------------------------------------------------------
% Saving the day's data a final time
% -----------------------------------------------------------------
qtxt=['data_',num2str(date_txt)];
eval(['save ',qtxt,';']);





















%----------------------------------------------------------------------
%----------------------------------------------------------------------
% Variables for judgmental tracking model
%----------------------------------------------------------------------
%----------------------------------------------------------------------

%----------------------------------------------------------------------
% Construction put-in-place, total
%----------------------------------------------------------------------
f1=max(find(const_put_in_place_total~=junk_nos));
f_const_put_in_place_total=const_put_in_place_total;
f_g_const_put_in_place_total=g_const_put_in_place_total;
% improvements from construction put-in-place data
const_put_in_place_res_other=junk_nos_m;
i1=const_put_in_place_res~=junk_nos & const_put_in_place_1fam~=junk_nos & const_put_in_place_mult~=junk_nos;
const_put_in_place_res_other(i1)=const_put_in_place_res(i1)-const_put_in_place_1fam(i1)-const_put_in_place_mult(i1);
g_const_put_in_place_res_other=fn_compute_g_monthly(const_put_in_place_res_other);
f_const_put_in_place_res_other=const_put_in_place_res_other;
f_g_const_put_in_place_res_other=fn_make_forecast(g_const_put_in_place_res_other);
for i1=f1+1:ff+5;
	f_const_put_in_place_res_other(i1)=f_const_put_in_place_res_other(i1-1)*(1+f_g_const_put_in_place_res_other(i1)/100);
end;
% construction put-in-place, other (residential improvements and federal government)
const_put_in_place_other=junk_nos_m;
i1=const_put_in_place_res_other~=junk_nos & const_put_in_place_fed_govt~=junk_nos;
const_put_in_place_other(i1)=const_put_in_place_res_other(i1)+const_put_in_place_fed_govt(i1);
g_const_put_in_place_other=fn_compute_g_monthly(const_put_in_place_other);
f_const_put_in_place_other=const_put_in_place_other;
f_g_const_put_in_place_other=g_const_put_in_place_other;
for i1=f1+1:ff+5;
	f_const_put_in_place_other(i1)=f_const_put_in_place_res_other(i1)+f_const_put_in_place_fed_govt(i1);
	f_g_const_put_in_place_other(i1)=100*(f_const_put_in_place_other(i1)/f_const_put_in_place_other(i1-1)-1);
end;
% sum up to find total construction put-in-place
f_const_put_in_place_total(f1+1:ff+5)=f_const_put_in_place_1fam(f1+1:ff+5)+f_const_put_in_place_mult(f1+1:ff+5)+...
	f_const_nonres(f1+1:ff+5)+f_const_put_in_place_state_local_govt(f1+1:ff+5)+f_const_put_in_place_other(f1+1:ff+5);
for i1=f1+1:ff+5;
	f_g_const_put_in_place_total(i1)=100*(f_const_put_in_place_total(i1)/f_const_put_in_place_total(i1-1)-1);
end;





%----------------------------------------------------------------------
% Positions for stacking
%----------------------------------------------------------------------	
% Monthly data
pos_date_m=1; % monthly date
% Monthly data, able to apply judgment to source data
pos_mv=2; % total light vehicle sales, level, millions, SAAR
pos_retail_core=3; % growth (m/m) of nominal core retail sales, percent
pos_ship_core_cap_goods=6; % growth (m/m) of nominal core capital goods shipments, percent
pos_house_starts_1fam=7; % new single-family housing starts, level, thousands, SAAR
pos_house_sales_1fam_ex=8; % existing single-family home sales, level, millions, SAAR
pos_const_nonres=9; % growth (m/m) of nonresidential construction put-in-place, percent
pos_const_put_in_place_mult=10; % growth (m/m) of residential multi-family construction put-in-place, percent
pos_const_put_in_place_state_local_govt=11; % growth (m/m) of state and local government construction put-in-place, percent
pos_inv_census_mfg=13; % growth (m/m) of total manufacturing industries inventories, percent
pos_inv_census_wholesale=14; % growth (m/m) of total wholesale trade inventories, percent
pos_inv_census_retail=15; % growth (m/m) of total retail trade inventories, percent

pos_ex_goods_bop=16; % growth (m/m) of nominal exports of goods, percent
pos_ex_serv_bop=17; % growth (m/m) of nominal exports of services, percent
pos_im_goods_exoil=18; % growth (m/m) of non-oil imports of goods, percent
pos_im_oil=19; % growth (m/m) of imported petroleum/oil volumes, NSA, percent
pos_im_serv_bop=20; % growth (m/m) of nominal imports of services, percent

% Monthly data, ad-factors
pos_pce_real_ad=4; % ad-factor to month-over-month real PCE growth rate computed from 
% Monthly data, updated within the program
pos_pce_real=5; % growth (m/m) of real PCE spending, percent
pos_const_put_in_place_total=12; % growth (m/m) of nominal total construction put-in-place, percent
pos_trade_balance=21; % nominal monthly trade balance, bil. $
% Monthly data, inflation
pos_pcepm=22; % monthly PCE inflation
pos_pcepm_core=23; % monthly core PCE inflation
% Quarterly data
pos_date_q=24;
% Quarterly data, ad-factors
pos_pce_q_ad=25; % PCE
pos_inv_nrstr_q_ad=26; % Nonresidential structures
pos_inv_es_q_ad=27; % E&S spending
pos_inv_ipp_q_ad=28; % E&S spending
pos_inv_res_q_ad=29; % Residential investment
pos_inv_ch_inv_q_ad=30; % Change in inventories
pos_ex_q_ad=31; % Exports
pos_im_q_ad=32; % Imports
pos_govt_q_ad=33; % Government spending
% Quarterly data, components, updating within the program
pos_gdp_q=34;
pos_pce_q=35;
pos_inv_bfi_q=36;
pos_inv_nrstr_q=37;
pos_inv_es_q=38;
pos_inv_ipp_q=39;
pos_inv_res_q=40;
pos_inv_ch_inv_q=41;
pos_nx_q=42;
pos_ex_q=43;
pos_im_q=44;
pos_govt_q=45;
pos_pcep_q=46;
pos_pcep_core_q=47;

%----------------------------------------------------------------------
% Stack data from tracking model
%----------------------------------------------------------------------	
td=NaN*ones(47,9);
tp=NaN*ones(47,9);
td(pos_date_m,:)=date_m(ff-3:ff+5);
tp(pos_date_m,:)=date_m(ff-3:ff+5);
[td(pos_mv,:),tp(pos_mv,:)]=fn_stack(mv_sales,f_mv_sales,ff);
[td(pos_retail_core,:),tp(pos_retail_core,:)]=fn_stack(g_retail_core,f_g_retail_core,ff);
[td(pos_house_starts_1fam,:),tp(pos_house_starts_1fam,:)]=fn_stack(housing_starts_1fam,f_housing_starts_1fam,ff);
[td(pos_house_sales_1fam_ex,:),tp(pos_house_sales_1fam_ex,:)]=fn_stack(house_sales_1fam_ex,f_house_sales_1fam_ex,ff);
td(pos_house_sales_1fam_ex,:)=td(pos_house_sales_1fam_ex,:)/1000000;
tp(pos_house_sales_1fam_ex,:)=tp(pos_house_sales_1fam_ex,:)/1000000;
[td(pos_ship_core_cap_goods,:),tp(pos_ship_core_cap_goods,:)]=fn_stack(g_ship_core_cap_goods,f_g_ship_core_cap_goods,ff);
[td(pos_const_nonres,:),tp(pos_const_nonres,:)]=fn_stack(g_const_nonres,f_g_const_nonres,ff);
[td(pos_const_put_in_place_mult,:),tp(pos_const_put_in_place_mult,:)]=fn_stack(g_const_put_in_place_mult,f_g_const_put_in_place_mult,ff);
[td(pos_const_put_in_place_state_local_govt,:),tp(pos_const_put_in_place_state_local_govt,:)]=...
	fn_stack(g_const_put_in_place_state_local_govt,f_g_const_put_in_place_state_local_govt,ff);
[td(pos_inv_census_mfg,:),tp(pos_inv_census_mfg,:)]=fn_stack(g_inv_census_mfg,f_g_inv_census_mfg,ff);
[td(pos_inv_census_wholesale,:),tp(pos_inv_census_wholesale,:)]=fn_stack(g_inv_census_wholesale,f_g_inv_census_wholesale,ff);
[td(pos_inv_census_retail,:),tp(pos_inv_census_retail,:)]=fn_stack(g_inv_census_retail,f_g_inv_census_retail,ff);

[td(pos_ex_goods_bop,:),tp(pos_ex_goods_bop,:)]=fn_stack(g_ex_goods_bop,f_g_ex_goods_bop,ff); %%
[td(pos_ex_serv_bop,:),tp(pos_ex_serv_bop,:)]=fn_stack(g_ex_serv_bop,f_g_ex_serv_bop,ff); %% 
[td(pos_im_goods_exoil,:),tp(pos_im_goods_exoil,:)]=fn_stack(g_im_goods_exoil_bop,f_g_im_goods_exoil_bop,ff);
[td(pos_im_oil,:),tp(pos_im_oil,:)]=fn_stack(g_im_petrol_volume_nsa,f_g_im_petrol_volume_nsa,ff);
[td(pos_im_serv_bop,:),tp(pos_im_serv_bop,:)]=fn_stack(g_im_serv_bop,f_g_im_serv_bop,ff);

td(pos_pce_real_ad,:)=NaN;
[td(pos_trade_balance,:),tp(pos_trade_balance,:)]=fn_stack(trade_balance,f_trade_balance,ff);
[td(pos_const_put_in_place_total,:),tp(pos_const_put_in_place_total,:)]=fn_stack(g_const_put_in_place_total,f_g_const_put_in_place_total,ff);
[td(pos_pce_real,:),tp(pos_pce_real,:)]=fn_stack(g_pce_real,f_g_pce_real,ff);
[td(pos_pcepm,:),tp(pos_pcepm,:)]=fn_stack(g_pcepm,f_g_pcepm,ff);
[td(pos_pcepm_core,:),tp(pos_pcepm_core,:)]=fn_stack(g_pcepm_core,f_g_pcepm_core,ff);
for i1=1:size(tp,2);
	if isnan(tp(pos_pce_real,i1))==0;
		tp(pos_pce_real_ad,i1)=0;
	end;
end;
f1=find(date_q==current_quarter);
f2=f1-1;
td(pos_date_q,2)=date_q(f2);
td(pos_date_q,5)=current_quarter;
td(pos_date_q,8)=next_quarter;
tp(pos_date_q,:)=td(pos_date_q,:);
td(pos_pce_q_ad:pos_govt_q_ad,[2])=0;
tp(pos_pce_q_ad:pos_govt_q_ad,[5,8])=0;
%
td(pos_gdp_q,2)=g_gdp(f2);
td(pos_pce_q,2)=g_pce(f2);
td(pos_inv_bfi_q,2)=g_inv_bfi(f2);
td(pos_inv_nrstr_q,2)=g_inv_nrstr(f2);
td(pos_inv_es_q,2)=g_inv_es(f2);
td(pos_inv_ipp_q,2)=g_inv_ipp(f2);
td(pos_inv_res_q,2)=g_inv_res(f2);
td(pos_inv_ch_inv_q,2)=inv_ch_inv(f2);
td(pos_nx_q,2)=nx(f2);
td(pos_ex_q,2)=g_exports(f2);
td(pos_im_q,2)=g_imports(f2);
td(pos_govt_q,2)=g_govt(f2);
td(pos_pcep_q,2)=g_pcep(f2);
td(pos_pcep_core_q,2)=g_pcep_core(f2);



tp(pos_gdp_q,2)=f_g_gdp_last_q;
tp(pos_pce_q,2)=f_g_pce_real_last_q;
tp(pos_inv_bfi_q,2)=f_g_inv_bfi_last_q;
tp(pos_inv_nrstr_q,2)=f_g_inv_nrstr_last_q;
tp(pos_inv_es_q,2)=f_g_inv_es_last_q;
tp(pos_inv_ipp_q,2)=f_g_inv_ipp_last_q;
tp(pos_inv_res_q,2)=f_g_inv_res_last_q;
tp(pos_inv_ch_inv_q,2)=f_inv_ch_inv_last_q;
tp(pos_nx_q,2)=f_nx_last_q;
tp(pos_ex_q,2)=f_g_exports_last_q;
tp(pos_im_q,2)=f_g_imports_last_q;
tp(pos_govt_q,2)=f_g_govt_last_q;
tp(pos_pcep_q,2)=g_pcep(f2);
tp(pos_pcep_core_q,2)=g_pcep_core(f2);
% automated ad-hoc judgment from factor model 
%lambda = 


% tp(pos_pec_q_ad,5) = lambda*(fcast_factor_model_pce-f_g_pce_real_this_q);
% tp(pos_inv_nrstr_q_ad,5) = lambda*(fcast_factor_model_inv_nrstr-f_g_inv_nrstr_this_q); 
% tp(pos_inv_es_q_ad,5) = lambda*(fcast_factor_model_inv_es-f_g_inv_es_this_q); 
% tp(pos_inv_ipp_q_ad,5) = lambda*(fcast_factor_model_inv_ipp-f_g_inv_ipp_this_q); 
% tp(pos_inv_res_q_ad,5) = lambda*(fcast_factor_model_inv_res-f_g_inv_res_this_q); 
% tp(pos_inv_ch_inv_q_ad,5)=lambda*(fcast_factor_model_ch_inv-f_inv_ch_inv_this_q); 
% tp(pos_ex_q_ad,5)=lambda*(fcast_factor_model_exports-f_g_exports_this_q); 
% tp(pos_im_q_ad,5)=lambda*(fcast_factor_model_imports-f_g_imports_this_q);
% tp(pos_gov_q_ad,5)=lambda*(fcast_factor_model_govt-f_g_govt_this_q); 




tp(pos_gdp_q,5)=f_g_gdp_this_q;
tp(pos_pce_q,5)=f_g_pce_real_this_q;
tp(pos_inv_bfi_q,5)=f_g_inv_bfi_this_q;
tp(pos_inv_nrstr_q,5)=f_g_inv_nrstr_this_q;
tp(pos_inv_es_q,5)=f_g_inv_es_this_q;
tp(pos_inv_ipp_q,5)=f_g_inv_ipp_this_q;
tp(pos_inv_res_q,5)=f_g_inv_res_this_q;
tp(pos_inv_ch_inv_q,5)=f_inv_ch_inv_this_q;
tp(pos_nx_q,5)=f_nx_this_q;
tp(pos_ex_q,5)=f_g_exports_this_q;
tp(pos_im_q,5)=f_g_imports_this_q;
tp(pos_govt_q,5)=f_g_govt_this_q;
tp(pos_pcep_q,5)=f_g_pcep_this_q;
tp(pos_pcep_core_q,5)=f_g_pcep_core_this_q;
%
tp(pos_gdp_q,8)=f_g_gdp_next_q;
tp(pos_pce_q,8)=f_g_pce_real_next_q;
tp(pos_inv_bfi_q,8)=f_g_inv_bfi_next_q;
tp(pos_inv_nrstr_q,8)=f_g_inv_nrstr_next_q;
tp(pos_inv_es_q,8)=f_g_inv_es_next_q;
tp(pos_inv_ipp_q,8)=f_g_inv_ipp_next_q;
tp(pos_inv_res_q,8)=f_g_inv_res_next_q;
tp(pos_inv_ch_inv_q,8)=f_inv_ch_inv_next_q;
tp(pos_nx_q,8)=f_nx_next_q;
tp(pos_ex_q,8)=f_g_exports_next_q;
tp(pos_im_q,8)=f_g_imports_next_q;
tp(pos_govt_q,8)=f_g_govt_next_q;
tp(pos_pcep_q,8)=f_g_pcep_next_q;
tp(pos_pcep_core_q,8)=f_g_pcep_core_next_q;


%----------------------------------------------------------------------
% Output
%----------------------------------------------------------------------	
tracking_data=td;
tracking_predictions=tp;



diary off;


%%%Forecast submission: generating XML file%%%
disp('----------------------------------------------------------------------------------');
disp('Generate xml file for forecast submission');

organization = 'Kansas City Fed';
model = 'Accounting-based Tracking Model';
run_date = datestr(now, 'yyyy-mm-dd'); 

% use when replication for other dates needed
%run_date = datestr('2-Apr-2020', 'yyyy-mm-dd'); 

docNode = start_xml_file(organization, model, run_date);

% Modified by Linmei Amaya, May 20
% Produces alternative XML file for 2020 Q2
% Using alternative estimate for weekly data summary and 
% reports to Board

% attrs.series_name = 'GDPH';
% attrs.transformation = 'difa%';
% attrs.frequency = 'quarterly';
% qdate = num2str(current_quarter);
% year = qdate(1:4);
% qtr = qdate(6);
% attrs.start_period = strcat(year,{'q'},qtr);
% attrs.density = 'point_forecast';
% observations = [f_g_gdp_this_q_judgement_alt, f_g_gdp_next_q];
% write_series(docNode, attrs, observations);
% 
% attrs.series_name = 'CH';
% observations = [result_alt(1), f_g_pce_real_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'FNH';
% observations = [f_g_inv_bfi_this_q_judgement, f_g_inv_bfi_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'FRH';
% observations = [result_alt(5), f_g_inv_res_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'VH';
% attrs.transformation = 'level';
% observations = [result_alt(9), f_inv_ch_inv_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'XNETH';
% attrs.transformation = 'level';
% observations = [f_nx_this_q_judgement, f_nx_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'XH';
% attrs.transformation = 'difa%';
% observations = [result_alt(7), f_g_exports_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'MH';
% attrs.transformation = 'difa%';
% observations = [result_alt(8), f_g_imports_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'GH';
% attrs.transformation = 'difa%';
% observations = [result_alt(6), f_g_govt_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'JCBM';
% attrs.transformation = 'difa%';
% observations = [f_g_pcep_this_q, f_g_pcep_next_q];
% write_series(docNode, attrs, observations); 
% 
% attrs.series_name = 'JCXFEBM';
% attrs.transformation = 'difa%';
% observations = [f_g_pcep_core_this_q, f_g_pcep_core_next_q];
% write_series(docNode, attrs, observations); 

%Feb 2021 by Sungil Kim
%Move back to reporting Judgemental Forecast
%Nov 2021 by Sungil Kim
%We report Accounting-based Forecast until further notice
%Feb 2022 by Sungil Kim
%Move back to reporting Judgemental Forecast
attrs.series_name = 'GDPH';
attrs.transformation = 'difa%';
attrs.frequency = 'quarterly';
qdate = num2str(current_quarter);
year = qdate(1:4);
qtr = qdate(6);
attrs.start_period = strcat(year,{'q'},qtr);
attrs.density = 'point_forecast';
observations = [f_g_gdp_this_q_judgement, f_g_gdp_next_q];
write_series(docNode, attrs, observations);

attrs.series_name = 'CH';
observations = [result(1), f_g_pce_real_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'FNH';
observations = [f_g_inv_bfi_this_q_judgement, f_g_inv_bfi_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'FRH';
observations = [result(5), f_g_inv_res_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'VH';
attrs.transformation = 'level';
observations = [result(9), f_inv_ch_inv_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'XNETH';
attrs.transformation = 'level';
observations = [f_nx_this_q_judgement, f_nx_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'XH';
attrs.transformation = 'difa%';
observations = [result(7), f_g_exports_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'MH';
attrs.transformation = 'difa%';
observations = [result(8), f_g_imports_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'GH';
attrs.transformation = 'difa%';
observations = [result(6), f_g_govt_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'JCBM';
attrs.transformation = 'difa%';
observations = [f_g_pcep_this_q, f_g_pcep_next_q];
write_series(docNode, attrs, observations); 

attrs.series_name = 'JCXFEBM';
attrs.transformation = 'difa%';
observations = [f_g_pcep_core_this_q, f_g_pcep_core_next_q];
write_series(docNode, attrs, observations); 


% Finish by writing the docNode to file.
%save_path = 'tracking.xml';
% Saving the file with a dated suffix may be helpful.
 save_path = [model, '-', run_date, '.xml'];
xmlwrite(save_path,docNode);
%type(save_path);

disp('----------------------------------------------------------------------------------');
disp(['File saved as ', '"', strcat(model, '-', run_date, '.xml'), '"']);



